<?php
/**
 * acoda shortcode includes
 *
 * @package acoda
 *
 */
 
/* ------------------------------------
:: VISUAL COMPOSER
------------------------------------ */
	
	if ( class_exists('WPBakeryVisualComposerAbstract') )
	{		
		update_option( 'wpb_js_row_css_class', 'row' );
		update_option( 'wpb_js_column_css_classes', '' );
		
		add_action( 'vc_before_init', 'acoda_vc_maps_before' );
		add_action( 'vc_after_init', 'acoda_vc_maps_after' );
		
		function acoda_vc_maps_after()
		{		
			$icon_params = array(
				vc_map_add_css_animation(),
				array(
					'type' => 'dropdown',
					'heading' => __( 'Add icon?', 'dynamix' ),
					'description' => __( 'Add icon for Column.', 'dynamix' ),
					'param_name' => 'add_icon',
					"admin_label" => "span",
					'value' => array(
						__( 'No', 'dynamix' ) => '',
						__( 'Top Center', 'dynamix' ) => 'top center',
						__( 'Top Left', 'dynamix' ) => 'top left',
						__( 'Top Right', 'dynamix' ) => 'top right',
						__( 'Middle Center', 'dynamix' ) => 'middle center',
						__( 'Middle Left', 'dynamix' ) => 'middle left',
						__( 'Middle Right', 'dynamix' ) => 'middle right',
						__( 'Bottom Center', 'dynamix' ) => 'bottom center',
						__( 'Bottom Left', 'dynamix' ) => 'bottom left',
						__( 'Bottom Right', 'dynamix' ) => 'bottom right',
					),
				),
				array(
					'type' => 'checkbox',
					'param_name' => 'i_on_border',
					'heading' => __( 'Place icon on border?', 'dynamix' ),
					'description' => __( 'Display icon on Column border.', 'dynamix' ),
					'group' => __( 'Icon', 'dynamix' ),
					'dependency' => array(
						'element' => 'add_icon',
						'not_empty' => true,
					),
				),
				array(
					'type' => 'dropdown',
					'heading' => esc_html__( 'Parallax', 'dynamix' ),
					'param_name' => 'paroller',
					'value' => array(
						esc_html__( 'Disable', 'dynamix' ) => 'disable',
						esc_html__( 'Vertical', 'dynamix' ) => 'vertical',
						esc_html__( 'Horizontal', 'dynamix' ) => 'horizontal',
					),
					'group' => esc_html__( 'Parallax', 'dynamix' )
				),
				array(
					'type' => 'textfield',
					'heading' => esc_html__( 'Factor', 'dynamix' ),
					'param_name' => 'paroller_factor',
					'description' => esc_html__( 'Enter a value between -0.3 & 0.3.', 'dynamix' ),
					'group' => esc_html__( 'Parallax', 'dynamix' ),
					'std' => '-0.1',
				),						
			);
	
			$icon_params = array_merge( 
				$icon_params, 
				(array) vc_map_integrate_shortcode( 'vc_icon', 'i_', __( 'Icon', 'dynamix' ), 
					array(
						'exclude' => array(
							'align',
							'css',
						),
					), 
					array(
						'element' => 'add_icon',
						'not_empty' => true,
					) 
				)
			);

			vc_add_params('vc_column',
				$icon_params
			);	
			
			vc_add_params('vc_column_inner',
				$icon_params
			);				
			
			
			$button_params = array(
				array(
					'type' => 'dropdown',
					'heading' => esc_html__( 'Parallax', 'dynamix' ),
					'param_name' => 'paroller',
					'value' => array(
						esc_html__( 'Disable', 'dynamix' ) => 'disable',
						esc_html__( 'Vertical', 'dynamix' ) => 'vertical',
						esc_html__( 'Horizontal', 'dynamix' ) => 'horizontal',
					),
					'group' => esc_html__( 'Parallax', 'dynamix' )
				),
				array(
					'type' => 'textfield',
					'heading' => esc_html__( 'Factor', 'dynamix' ),
					'param_name' => 'paroller_factor',
					'description' => esc_html__( 'Enter a value between -0.3 & 0.3.', 'dynamix' ),
					'group' => esc_html__( 'Parallax', 'dynamix' ),
					'std' => '-0.1',
				),						
			);
	

			vc_add_params('vc_btn',
				$button_params
			);				
			
			$allowed_tags = wp_kses_allowed_html();
						
			$row_params = array_merge( 
				array(
					array(
						'type' => 'dropdown',
						'heading' => esc_html__( 'Row Stretch', 'dynamix' ),
						'param_name' => 'full_width',
						'value' => array(
							esc_html__('Default','dynamix') => '',
							esc_html__('Stretch row','dynamix') => 'stretch_row',
							esc_html__('Stretch row and content','dynamix') => 'stretch_row_content',
							esc_html__('Stretch row and content without spaces','dynamix') => 'stretch_row_content_no_spaces',
						),
						'description' => esc_html__( 'Select stretching options for row and content. Stretched row overlay sidebar and may not work if parent container has overflow: hidden css property.', 'dynamix' )
					),
					array(
						'type' => 'dropdown',
						'heading' => esc_html__( 'Row Height', 'dynamix' ),
						'param_name' => 'full_height',
						'value' => array(
							esc_html__('Default','dynamix') => '',
							esc_html__('25%','dynamix') => 'onequarter_row_height',
							esc_html__('50%','dynamix') => 'half_row_height',
							esc_html__('75%','dynamix') => 'threequarter_row_height',
							esc_html__('100%','dynamix') => 'full_row_height',					
						),
						'description' => esc_html__( 'Set the minimum height of the row. Size is based on Browser window size.', 'dynamix' )
					),		
					array(
						'type' => 'dropdown',
						'heading' => esc_html__( 'Content position', 'dynamix' ),
						'param_name' => 'content_placement',
						'value' => array(
							esc_html__( 'Middle', 'dynamix' ) => 'middle',
							esc_html__( 'Top', 'dynamix' ) => 'top',
							esc_html__( 'Bottom', 'dynamix' ) => 'bottom',
						),
						'description' => wp_kses( __( 'Select content position within <strong>Full Height</strong> row.', 'dynamix' ), $allowed_tags ),
					),			
					array(
						"type" => "checkbox",
						"class" => "",
						"heading" => esc_html__("Equal Column Height", 'dynamix'),
						"param_name" => "equal_height",
						"description" => esc_html__( 'If checked columns will be set to equal height.', 'dynamix' ),
						"value" => array(
							esc_html__( 'Yes', 'dynamix' ) => 'yes',
						),
					),										
					array(
					  "type" => "textfield",
					  "heading" => esc_html__("Anchor Link Name", 'dynamix'),
					  "param_name" => "anchor_link",
					  "description" => esc_html__("Use this field to add an Anchor Name. You can then use links to scroll to this row, including from the menu.", 'dynamix')
					),					  
					array(
					  "type" => "colorpicker",
					  "heading" => esc_html__('Font Color', 'dynamix'),
					  "param_name" => "font_color",
					),	
					vc_map_add_css_animation(),
					array(
					  "type" => "textfield",
					  "heading" => esc_html__("Extra class name", 'dynamix'),
					  "param_name" => "el_class",
					  "description" => wp_kses( __("<p>Use this field to add a class name and then refer to it in the Theme Options > Custom CSS field.", 'dynamix'), $allowed_tags )
					),	
					array(
					  "type" => "css_editor",
					  "heading" => esc_html__('Css', 'dynamix'),
					  "param_name" => "css",
					  // "description" => esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'dynamix'),
					  "group" => esc_html__('Design options', 'dynamix')
					),			
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Background Horizontal Position", 'dynamix'),
						"param_name" => "h_position",
						"value" => array(
							'Center' => 'center',
							'Left' => 'left',
							'Right' => 'right',
						),
						"group" => esc_html__('Design options', 'dynamix')
					),	
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Background Vertical Position", 'dynamix'),
						"param_name" => "v_position",
						"value" => array(
							'Center' => 'center',
							'Top' => 'top',
							'Bottom' => 'bottom',
						),
						"group" => esc_html__('Design options', 'dynamix')
					),	
					array(
						"type" => "colorpicker",
						"heading" => esc_html__("Overlay Color", 'dynamix'),
						"param_name" => "overlay_color",
						"value" => "",
						"description" => esc_html__( 'Set an overlay color for Image or Video background.', 'dynamix' ),
						"group" => esc_html__('Background Extras', 'dynamix')
					),				
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Parallax", 'dynamix'),
						"param_name" => "parallax",
						"description" => wp_kses( __( 'Add Parallax effect to <strong>Background Image</strong>.', 'dynamix' ), $allowed_tags ),
						"value" => array(
							'Disabled' => '',
							'Normal' => 'yes',
							'With Fade' => 'content-moving-fade',
						),
						"group" => esc_html__('Background Extras', 'dynamix')
					),						
					array(
						"type" => "attach_images",
						"heading" => esc_html__("Slider Images", 'dynamix'),
						"param_name" => "slider_images",
						"value" => "",
						"description" => esc_html__("Add a Slider to the row background.", 'dynamix'),
						"group" => esc_html__('Background Extras', 'dynamix')
					),
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__( 'Slider Effect', 'dynamix'),
						"param_name" => "slider_animation",
						"value" => acoda_options_array( 'animation' ),
						"group" => esc_html__('Background Extras', 'dynamix')
					),		
					array(
						"type" => "checkbox",
						"class" => "",
						"heading" => esc_html__("Slider Black & White Images", 'dynamix'),
						"param_name" => "slider_imgeffect",
						"description" => "Apply black & white effect to images.",
						"value" => array(
							'Enable' => 'enable',
						),
						"group" => esc_html__('Background Extras', 'dynamix')
					),							
					array(
						"type" => "textfield",
						"heading" => esc_html__("Slider Timeout", 'dynamix'),
						"param_name" => "slider_timeout",
						"value" => "",
						"description" => esc_html__("Add timeout in seconds.", 'dynamix'),
						"group" => esc_html__('Background Extras', 'dynamix')
					),						
					array(
						"type" => "textfield",
						"heading" => esc_html__("Video URL", 'dynamix'),
						"param_name" => "bg_video",
						"value" => "",
						"description" => "Add a video to the row background.",
						"group" => esc_html__('Background Extras', 'dynamix')
					),									 	
					array(
						"type" => "checkbox",
						"class" => "",
						"heading" => esc_html__("Inherit Skin Shaded Background Color", 'dynamix'),
						"param_name" => "inherit_shaded_color",
						"description" => esc_html__( 'Inherit the Shaded background color set in the skin options.', 'dynamix' ),
						"value" => array(
							'Enable' => 'enable',
						),
						"group" => esc_html__('Background Extras', 'dynamix')
					),
				)
			);		
		
			// VC Row
			vc_map( array(
			  "name" => esc_html__("Row", 'dynamix'),
			  "base" => "vc_row",
			  "is_container" => true,
			  "icon" => "icon-wpb-row",
			  "show_settings_on_create" => false,
			  "category" => esc_html__('Content', 'dynamix'),
			  "params" => $row_params,										 													  	
			  "js_view" => 'VcRowView'
			) );				
			
		}
		
		function acoda_vc_maps_before() 
		{
			vc_map( array(
				'name' => __( 'Icon', 'dynamix' ),
				'base' => 'vc_icon',
				'icon' => 'icon-wpb-vc_icon',
				'category' => __( 'Content', 'dynamix' ),
				'description' => __( 'Eye catching icons from libraries', 'dynamix' ),
				'params' => array(
					array(
						'type' => 'dropdown',
						'heading' => __( 'Icon library', 'dynamix' ),
						'value' => array(
							__( 'Font Awesome', 'dynamix' ) => 'fontawesome',
							__( 'Open Iconic', 'dynamix' ) => 'openiconic',
							__( 'Typicons', 'dynamix' ) => 'typicons',
							__( 'Entypo', 'dynamix' ) => 'entypo',
							__( 'Linecons', 'dynamix' ) => 'linecons',
							__( 'Mono Social', 'dynamix' ) => 'monosocial',
							__( 'Nucleo Glyph', 'dynamix' ) => 'nucleo_glyph',
							__( 'Nucleo Outline', 'dynamix' ) => 'nucleo_outline',
						),
						'admin_label' => true,
						'param_name' => 'type',
						'description' => __( 'Select icon library.', 'dynamix' ),
					),
					array(
						'type' => 'iconpicker',
						'heading' => __( 'Icon', 'dynamix' ),
						'param_name' => 'icon_fontawesome',
						'value' => 'fa fa-adjust', // default value to backend editor admin_label
						'settings' => array(
							'emptyIcon' => false,
							// default true, display an "EMPTY" icon?
							'iconsPerPage' => 4000,
							// default 100, how many icons per/page to display, we use (big number) to display all icons in single page
						),
						'dependency' => array(
							'element' => 'type',
							'value' => 'fontawesome',
						),
						'description' => __( 'Select icon from library.', 'dynamix' ),
					),
					array(
						'type' => 'iconpicker',
						'heading' => __( 'Icon', 'dynamix' ),
						'param_name' => 'icon_openiconic',
						'value' => 'vc-oi vc-oi-dial', // default value to backend editor admin_label
						'settings' => array(
							'emptyIcon' => false, // default true, display an "EMPTY" icon?
							'type' => 'openiconic',
							'iconsPerPage' => 4000, // default 100, how many icons per/page to display
						),
						'dependency' => array(
							'element' => 'type',
							'value' => 'openiconic',
						),
						'description' => __( 'Select icon from library.', 'dynamix' ),
					),
					array(
						'type' => 'iconpicker',
						'heading' => __( 'Icon', 'dynamix' ),
						'param_name' => 'icon_typicons',
						'value' => 'typcn typcn-adjust-brightness', // default value to backend editor admin_label
						'settings' => array(
							'emptyIcon' => false, // default true, display an "EMPTY" icon?
							'type' => 'typicons',
							'iconsPerPage' => 4000, // default 100, how many icons per/page to display
						),
						'dependency' => array(
							'element' => 'type',
							'value' => 'typicons',
						),
						'description' => __( 'Select icon from library.', 'dynamix' ),
					),
					array(
						'type' => 'iconpicker',
						'heading' => __( 'Icon', 'dynamix' ),
						'param_name' => 'icon_entypo',
						'value' => 'entypo-icon entypo-icon-note', // default value to backend editor admin_label
						'settings' => array(
							'emptyIcon' => false, // default true, display an "EMPTY" icon?
							'type' => 'entypo',
							'iconsPerPage' => 4000, // default 100, how many icons per/page to display
						),
						'dependency' => array(
							'element' => 'type',
							'value' => 'entypo',
						),
					),
					array(
						'type' => 'iconpicker',
						'heading' => __( 'Icon', 'dynamix' ),
						'param_name' => 'icon_linecons',
						'value' => 'vc_li vc_li-heart', // default value to backend editor admin_label
						'settings' => array(
							'emptyIcon' => false, // default true, display an "EMPTY" icon?
							'type' => 'linecons',
							'iconsPerPage' => 4000, // default 100, how many icons per/page to display
						),
						'dependency' => array(
							'element' => 'type',
							'value' => 'linecons',
						),
						'description' => __( 'Select icon from library.', 'dynamix' ),
					),
					array(
						'type' => 'iconpicker',
						'heading' => __( 'Icon', 'dynamix' ),
						'param_name' => 'icon_monosocial',
						'value' => 'vc-mono vc-mono-fivehundredpx', // default value to backend editor admin_label
						'settings' => array(
							'emptyIcon' => false, // default true, display an "EMPTY" icon?
							'type' => 'monosocial',
							'iconsPerPage' => 4000, // default 100, how many icons per/page to display
						),
						'dependency' => array(
							'element' => 'type',
							'value' => 'monosocial',
						),
						'description' => __( 'Select icon from library.', 'dynamix' ),
					),
					array(
						'type' => 'iconpicker',
						'heading' => __( 'Icon', 'dynamix' ),
						'param_name' => 'icon_nucleo_outline',
						'value' => 'nc-icon-outline nature_bear', // default value to backend editor admin_label
						'settings' => array(
							'emptyIcon' => false, // default true, display an "EMPTY" icon?
							'type' => 'nucleo_outline',
							'iconsPerPage' => 200, // default 100, how many icons per/page to display
						),
						'dependency' => array(
							'element' => 'type',
							'value' => 'nucleo_outline',
						),
						'description' => __( 'Select icon from library.', 'dynamix' ),
					),	
					array(
						'type' => 'iconpicker',
						'heading' => __( 'Icon', 'dynamix' ),
						'param_name' => 'icon_nucleo_glyph',
						'value' => 'nc-icon-glyph nature_bear', // default value to backend editor admin_label
						'settings' => array(
							'emptyIcon' => false, // default true, display an "EMPTY" icon?
							'type' => 'nucleo_glyph',
							'iconsPerPage' => 200, // default 100, how many icons per/page to display
						),
						'dependency' => array(
							'element' => 'type',
							'value' => 'nucleo_glyph',
						),
						'description' => __( 'Select icon from library.', 'dynamix' ),
					),										
					array(
						'type' => 'dropdown',
						'heading' => __( 'Icon color', 'dynamix' ),
						'param_name' => 'color',
						'value' => array_merge( getVcShared( 'colors' ), array( __( 'Custom color', 'dynamix' ) => 'custom' ) ),
						'description' => __( 'Select icon color.', 'dynamix' ),
						'param_holder_class' => 'vc_colored-dropdown',
					),
					array(
						'type' => 'colorpicker',
						'heading' => __( 'Custom color', 'dynamix' ),
						'param_name' => 'custom_color',
						'description' => __( 'Select custom icon color.', 'dynamix' ),
						'dependency' => array(
							'element' => 'color',
							'value' => 'custom',
						),
					),
					array(
						'type' => 'dropdown',
						'heading' => __( 'Background shape', 'dynamix' ),
						'param_name' => 'background_style',
						'value' => array(
							__( 'None', 'dynamix' ) => '',
							__( 'Circle', 'dynamix' ) => 'rounded',
							__( 'Square', 'dynamix' ) => 'boxed',
							__( 'Rounded', 'dynamix' ) => 'rounded-less',
							__( 'Outline Circle', 'dynamix' ) => 'rounded-outline',
							__( 'Outline Square', 'dynamix' ) => 'boxed-outline',
							__( 'Outline Rounded', 'dynamix' ) => 'rounded-less-outline',
						),
						'description' => __( 'Select background shape and style for icon.', 'dynamix' ),
					),
					array(
						'type' => 'dropdown',
						'heading' => __( 'Background color', 'dynamix' ),
						'param_name' => 'background_color',
						'value' => array_merge( getVcShared( 'colors' ), array( __( 'Custom color', 'dynamix' ) => 'custom' ) ),
						'std' => 'grey',
						'description' => __( 'Select background color for icon.', 'dynamix' ),
						'param_holder_class' => 'vc_colored-dropdown',
						'dependency' => array(
							'element' => 'background_style',
							'not_empty' => true,
						),
					),
					array(
						'type' => 'colorpicker',
						'heading' => __( 'Custom background color', 'dynamix' ),
						'param_name' => 'custom_background_color',
						'description' => __( 'Select custom icon background color.', 'dynamix' ),
						'dependency' => array(
							'element' => 'background_color',
							'value' => 'custom',
						),
					),
					array(
						'type' => 'dropdown',
						'heading' => __( 'Size', 'dynamix' ),
						'param_name' => 'size',
						'value' => array_merge( getVcShared( 'sizes' ), array( 'Extra Large' => 'xl', 'XXLarge' => 'xxl' ) ),
						'std' => 'md',
						'description' => __( 'Icon size.', 'dynamix' ),
					),
					array(
						'type' => 'dropdown',
						'heading' => __( 'Icon alignment', 'dynamix' ),
						'param_name' => 'align',
						'value' => array(
							__( 'Left', 'dynamix' ) => 'left',
							__( 'Right', 'dynamix' ) => 'right',
							__( 'Center', 'dynamix' ) => 'center',
						),
						'description' => __( 'Select icon alignment.', 'dynamix' ),
					),
					array(
						'type' => 'vc_link',
						'heading' => __( 'URL (Link)', 'dynamix' ),
						'param_name' => 'link',
						'description' => __( 'Add link to icon.', 'dynamix' ),
					),
					vc_map_add_css_animation(),
					array(
						'type' => 'textfield',
						'heading' => __( 'Extra class name', 'dynamix' ),
						'param_name' => 'el_class',
						'description' => __( 'Style particular content element differently - add a class name and refer to it in custom CSS.', 'dynamix' ),
					),
					array(
						'type' => 'css_editor',
						'heading' => __( 'CSS box', 'dynamix' ),
						'param_name' => 'css',
						'group' => __( 'Design Options', 'dynamix' ),
					),
				),
				'js_view' => 'VcIconElementView_Backend',
			) );
						
		}		
	
		/* ------------------------------------
		:: SHORTCODE OPTIONS FUNCTION
		------------------------------------*/
	
		function acoda_options_array( $type )
		{
			if( $type == 'animation' )
			{
				return $animation_types = array("fade","fadeZoom","cover","scrollHorz","scrollVert","shuffle","toss");	
			}
	
			if( $type == 'datasource' )
			{
				$datasource = array(
					esc_html__( 'Select Source', 'dynamix' ) => "", 
					esc_html__( 'Image Selector', 'dynamix' ) => "data-9", 
					//esc_html__( 'Slide Sets', 'dynamix' ) => "data-4",
					esc_html__( 'Build Query', 'dynamix' ) => "data-10", 
				);						
						
				return $datasource;
			}
			
			if( $type == 'imageeffect' )
			{
				return $image_effect = array(
					esc_html__( 'None', 'dynamix' ) => "",
					esc_html__( 'Shadow', 'dynamix' ) => "shadow",						
					esc_html__( 'Black / White', 'dynamix' ) => 'blackwhite',					
					esc_html__( 'Rounded', 'dynamix' ) => "rounded",
					esc_html__( 'Rounded + Shadow', 'dynamix' ) => "rounded shadow",		
					esc_html__( 'Rounded + Black / White', 'dynamix' ) => "rounded blackwhite",															
				);	
			}
		}
		
	
		/* ------------------------------------
		:: SHORTCODE GALLERY OPTIONS FUNCTION
		------------------------------------*/	
		
		function acoda_common_options( $type, $object ='', $option = null )
		{	
			$extras = '';
			
			if( $type == 'datasource' )
			{
				$option = array(
					"type" => "dropdown",
					"class" => "",
					"heading" => esc_html__("Select Image / Media Source", 'dynamix'),
					"param_name" => "data_source",
					"value" => acoda_options_array( 'datasource' )
				);
			}
			elseif( $type == 'data-9' )
			{
				$option = array(
					"type" => "attach_images",
					"heading" => esc_html__("Images", 'dynamix'),
					"param_name" => "images_attach",
					"value" => "",
					"description" => esc_html__("Select images from media library.", 'dynamix'),
					"dependency" => Array('element' => 'data_source' /*, 'not_empty' => true*/, 'value' => array('data-9'))
      			);
			}	
			elseif( $type == 'data-10' )
			{			
				$option = array(
					"type" => "loop",
					"heading" => esc_html__("Grids content", 'dynamix'),
					"param_name" => "loop",
					'settings' => array(
						'size' => array('hidden' => false, 'value' => 10),
						'order_by' => array('value' => 'date'),
					),
					"description" => esc_html__("Create WordPress loop, to populate content from your site.", 'dynamix'),
					"dependency" => Array('element' => 'data_source' /*, 'not_empty' => true*/, 'value' => array('data-10'))
				);
			}
			elseif( $type == 'orderby' )
			{
				if( $object == 'recentposts' )
				{
					$option = array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__( 'Order Post By', 'dynamix'),
						"param_name" => "orderby",
						"value" => array(
							esc_html__( 'Ascending', 'dynamix') => 'ASC',
							esc_html__( 'Descending', 'dynamix') => 'DESC'
						)
					);				
				}
				else
				{
					$option = array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__( 'Order Post By', 'dynamix'),
						"param_name" => "orderby",
						"dependency" => Array('element' => 'data_source' /*, 'not_empty' => true*/, 'value' => array('data-2','data-1','data-8','data-6','data-5')),
						"value" => array(
							esc_html__( 'Ascending', 'dynamix') => 'ASC',
							esc_html__( 'Descending', 'dynamix') => 'DESC'
						)
					);				
				}
	
			}
			elseif( $type == 'sortby' || $type == 'order' )
			{
				if( $object == 'recentposts' )
				{
					$option = array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__( 'Sort Post By', 'dynamix'),
						"param_name" => $type,
						"value" => array(
							esc_html__( 'Post Order', 'dynamix') => '',
							esc_html__( 'Date', 'dynamix') => 'date',
							esc_html__( 'Random', 'dynamix') => 'rand',
							esc_html__( 'Title', 'dynamix') => 'title',
						)
					);				
				}
				else
				{
					$option = array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Sort Post By", 'dynamix'),
						"param_name" => $type,
						"dependency" => Array('element' => 'data_source' /*, 'not_empty' => true*/, 'value' => array('data-2','data-1','data-8','data-6','data-5')),
						"value" => array(
							esc_html__( 'Post Order', 'dynamix') => '',
							esc_html__( 'Date', 'dynamix') => 'date',
							esc_html__( 'Random', 'dynamix') => 'rand',
							esc_html__( 'Title', 'dynamix') => 'title',
						)
					);
				}
			}				
			elseif( $type == 'data-4' )
			{
				$option = array(
					"type" => "checkbox",
					"class" => "",
					"heading" => esc_html__("Slide Sets", 'dynamix'),
					"param_name" => "slidesetid",
					"dependency" => Array('element' => 'data_source' /*, 'not_empty' => true*/, 'value' => array('data-4')),
					"value" => acoda_data_source( 'data-4', 'shortcode' )
				);
			}	
			elseif( $type == 'width' )
			{
				$option = array(
					"type" => "textfield",
					"class" => "",
					"heading" => esc_html__("Gallery Width", 'dynamix'),
					"param_name" => "width",
				);
			}
			elseif( $type == 'height' )
			{
				if( $object == 'grid' )
				{
					$text = esc_html__( 'Row Height', 'dynamix');	
				}
				else
				{
					$text = esc_html__( 'Gallery Height', 'dynamix');	
				}
				
				$option = array(
					"type" => "textfield",
					"class" => "",
					"heading" => $text,
					"param_name" => "height",
				);
			}
			elseif( $type == 'columns' )
			{
				$option = array(
					"type" => "dropdown",
					"class" => "",
					"heading" => esc_html__("Columns", 'dynamix'),
					"param_name" => "columns",
					"value" => array(
						esc_html__( '3 Columns', 'dynamix') => '',
						esc_html__( '1 Columns', 'dynamix') => '1',
						esc_html__( '2 Columns', 'dynamix') => '2',
						esc_html__( '4 Columns', 'dynamix') => '4',
						esc_html__( '5 Columns', 'dynamix') => '5',
						esc_html__( '6 Columns', 'dynamix') => '6',
					)
				);
			}
			elseif( $type == 'columnpadding' )
			{
				$option = array(
					"type" => "checkbox",
					"class" => "",
					"heading" => esc_html__( 'Column Padding', 'dynamix' ),
					"param_name" => "columnpadding",
					"value" => array(
						esc_html__( 'Enable', 'dynamix') => 'column_padding'
					)
				);
			}		
			elseif( $type == 'content' )
			{	
				$option = array(
					"type" => "dropdown",
					"class" => "",
					"heading" => esc_html__( 'Content', 'dynamix'),
					"param_name" => "content_type",
					"value" => array(
						esc_html__( 'Text on Hover + Image', 'dynamix') => 'titletextoverlay',
						esc_html__( 'Title on Hover + Image', 'dynamix') => 'titleoverlay',	
						esc_html__( 'Text Overlay + Image', 'dynamix') => 'textoverlay_static',	
						esc_html__( 'Title Overlay + Image', 'dynamix') => 'titleoverlay_static',					
						esc_html__( 'Text + Image', 'dynamix') => 'textimage',
						esc_html__( 'Title + Image', 'dynamix') => 'titleimage',
						esc_html__( 'Image Only', 'dynamix') => 'image',
						esc_html__( 'Text Only', 'dynamix') => 'text',
					)
				);
	
				if( $object == 'recent_posts' )
				{
					$option['value']['Title'] = 'title';
				}
				
			}		
			elseif( $type == 'align' || $type == 'position' )
			{
	
				if( $object !='' )
				{
					$text = $object;	
				}
				
				
				$option = array(
					"type" => "dropdown",
					"class" => "",
					"heading" => sprintf( esc_html__('%s Align', 'dynamix' ), $text ),
					"param_name" => $type,
					"value" => array(
						esc_html__('Normal', 'dynamix' ) => '',
						esc_html__('Left', 'dynamix' ) => 'alignleft',
						esc_html__('Center', 'dynamix' ) => 'aligncenter',
						esc_html__('Right', 'dynamix' ) => 'alignright'
					)
				);
			}			
			elseif( $type == 'imgwidth' )
			{
				$option = array(
					"type" => "textfield",
					"class" => "",
					"heading" => esc_html__("Image Width", 'dynamix'),
					"param_name" => "imgwidth",
				);
			}	
			elseif( $type == 'imgheight' )
			{
				$option = array(
					"type" => "textfield",
					"class" => "",
					"heading" => esc_html__("Image Height", 'dynamix'),
					"param_name" => "imgheight",
				);
			}
			elseif( $type == 'imageeffect' )
			{
				$option = array(
					"type" => "dropdown",
					"class" => "",
					'group' => esc_html__('Images', 'dynamix'),
					"heading" => esc_html__("Image Effect", 'dynamix'),
					"param_name" => "imageeffect",
					"dependency" => Array('element' => "content_type", 'value' => array('titleimage','textimage','titleoverlay','titletextoverlay','textoverlay_static','titleoverlay_static','image') ),
					"value" => acoda_options_array( 'imageeffect' )
				);
			}
			elseif( $type == 'timeout' )
			{
				$option = array(
					"type" => "textfield",
					"class" => "",
					"heading" => esc_html__("Timeout", 'dynamix'),
					"param_name" => "timeout",
					"description" => esc_html__("Time between animating slides, in seconds.", 'dynamix')
				);
			}												
			
			if( empty( $option ) )
			{
				$option = array(
					"type" => NULL,
					"param_name" => NULL,
					"value" => NULL
				);
			}
			
			return $option;
		}


		$box_styles = array(
			esc_html__( 'Default', 'dynamix' ) => '',
			esc_html__( 'Border', 'dynamix' ) => 'vc_box_border',
			esc_html__( 'Outline', 'dynamix' ) => 'vc_box_outline',
			esc_html__( 'Shadow', 'dynamix' ) => 'vc_box_shadow',
			esc_html__( 'Bordered shadow', 'dynamix' ) => 'vc_box_shadow_border',
			esc_html__( '3D Shadow', 'dynamix' ) => 'vc_box_shadow_3d'
		);


		$round_box_styles = array(
			esc_html__( 'Rounded', 'dynamix' ) => 'vc_box_circle',
			esc_html__( 'Rounded Border', 'dynamix' ) => 'vc_box_border_circle',
			esc_html__( 'Rounded Outline', 'dynamix' ) => 'vc_box_outline_circle',
			esc_html__( 'Rounded Shadow', 'dynamix' ) => 'vc_box_shadow_circle',
			esc_html__( 'Rounded Border Shadow', 'dynamix' ) => 'vc_box_shadow_border_circle'
		);


		$circle_box_styles = array(
			esc_html__( 'Circle', 'dynamix' ) => 'vc_box_circle_2',
			esc_html__( 'Circle Border', 'dynamix' ) => 'vc_box_border_circle_2',
			esc_html__( 'Circle Outline', 'dynamix' ) => 'vc_box_outline_circle_2',
			esc_html__( 'Circle Shadow', 'dynamix' ) => 'vc_box_shadow_circle_2',
			esc_html__( 'Circle Border Shadow', 'dynamix' ) => 'vc_box_shadow_border_circle_2'
		);	
		
		$all_box_styles = array_merge( $box_styles, $round_box_styles, $circle_box_styles );			

		$size_arr = array(
			esc_html__( 'Regular size', 'dynamix' ) => 'wpb_regularsize',
			esc_html__( 'Large', 'dynamix' ) => 'btn-large',
			esc_html__( 'Small', 'dynamix' ) => 'btn-small',
			esc_html__( 'Mini', 'dynamix' ) => "btn-mini"
		);	

		$el_widths = array(
			'100%' => '',
			'90%' => '90',
			'80%' => '80',
			'70%' => '70',
			'60%' => '60',
			'50%' => '50',
			'40%' => '40',
			'30%' => '30',
			'20%' => '20',
			'10%' => '10',
			'5%' => '5'
		);	

		$border_widths = array(
			'1px' => '1px',
			'2px' => '2px',
			'3px' => '3px',
			'4px' => '4px',
			'5px' => '5px',
			'6px' => '6px',
			'7px' => '7px',
			'8px' => '8px',
			'9px' => '9px',
			'10px' => '10px'
		);				

		$target_arr = array(
			esc_html__( 'Same window', 'dynamix' ) => '_self',
			esc_html__( 'New window', 'dynamix' ) => "_blank"
		);		

	
		/* ------------------------------------
		:: SHORTCODES + MAPS
		------------------------------------*/
	
		require_once( get_template_directory() . '/lib/inc/shortcodes/grid-gallery.php' );
		require_once( get_template_directory() . '/lib/inc/shortcodes/group-slider.php' );
		require_once( get_template_directory() . '/lib/inc/shortcodes/stage-slider.php' );
		//require_once( get_template_directory() . '/lib/inc/shortcodes/carousel-slider.php' );
		require_once( get_template_directory() . '/lib/inc/shortcodes/lists.php' );
		require_once( get_template_directory() . '/lib/inc/shortcodes/social-icons.php' );
		//require_once( get_template_directory() . '/lib/inc/shortcodes/text-slider.php' );
		require_once( get_template_directory() . '/lib/inc/shortcodes/row-shapes.php' );
		require_once( get_template_directory() . '/lib/inc/shortcodes/block-quote.php' );
	
		add_filter('widget_text', 'do_shortcode');
		
	
		/* ------------------------------------
		:: EXTRA PARAMS
		------------------------------------*/	
			
		// Progress Bar
		vc_add_param('vc_progress_bar',
			array(
				"type" => "colorpicker",
				"heading" => esc_html__( 'Text Color', 'dynamix' ),
				"param_name" => "textcolor",
				"value" => "",
				"dependency" => Array('element' => 'bgcolor' /*, 'not_empty' => true*/, 'value' => array('custom')),
			)
		);	

		// Video
		vc_add_param('vc_video',
			array(
				"type" => "dropdown",
				"heading" => esc_html__("Embed Type", 'dynamix'),
				"param_name" => "type",
				"value" => array(
					'oEmbed ' => "oembed", 
					'YouTube' => "youtube", 
					'Vimeo' => "vimeo", 																																											
					'JW Player' => "jwp", 
					'Wistia' => "wistia", 
				),
			)	
		);

		vc_add_param('vc_video',
			array(
				"type" => "dropdown",
				"heading" => esc_html__("Ratio", 'dynamix'),
				"param_name" => "ratio",
				"value" => array(
					'16:9' => "", 
					'4:3' => "four_by_three", 
					esc_html__( 'Normal', 'dynamix' ) => "normal", 																																											
				),
			)	
		);

		vc_add_param('vc_video',
			array(
				"type" => "dropdown",
				"heading" => esc_html__("Style", 'dynamix'),
				"param_name" => "style",
				"value" => array(
					esc_html__( 'Normal', 'dynamix' ) => "", 
					esc_html__( 'Frame', 'dynamix' ) => "frame", 																																											
				),
			)	
		);		

		vc_add_param('vc_video',
			array(
				"type" => "checkbox",
				"class" => "",
				"heading" => esc_html__("Autoplay", 'dynamix'),
				"param_name" => "autoplay",
				"dependency" => Array('element' => 'type' /*, 'not_empty' => true*/, 'value' => array( 'youtube','vimeo','jwp','wistia') ),
				"value" => array(
					'Enable' => '1',
				),
			)	
		);					
		
	


		function acoda_animation_styles() 
		{

			$styles = array(
				array(
					'values' => array(
						__( 'None', 'dynamix' ) => 'none',
					),
				),
				array(
					'label' => __( 'Attention Seekers', 'dynamix' ),
					'values' => array(
						// text to display => value
						__( 'bounce', 'dynamix' ) => array(
							'value' => 'bounce',
							'type' => 'other',
						),
						__( 'flash', 'dynamix' ) => array(
							'value' => 'flash',
							'type' => 'other',
						),
						__( 'pulse', 'dynamix' ) => array(
							'value' => 'pulse',
							'type' => 'other',
						),
						__( 'rubberBand', 'dynamix' ) => array(
							'value' => 'rubberBand',
							'type' => 'other',
						),
						__( 'shake', 'dynamix' ) => array(
							'value' => 'shake',
							'type' => 'other',
						),
						__( 'swing', 'dynamix' ) => array(
							'value' => 'swing',
							'type' => 'other',
						),
						__( 'tada', 'dynamix' ) => array(
							'value' => 'tada',
							'type' => 'other',
						),
						__( 'wobble', 'dynamix' ) => array(
							'value' => 'wobble',
							'type' => 'other',
						),
					),
				),
				array(
					'label' => __( 'Bouncing Entrances', 'dynamix' ),
					'values' => array(
						// text to display => value
						__( 'bounceIn', 'dynamix' ) => array(
							'value' => 'bounceIn',
							'type' => 'in',
						),
						__( 'bounceInDown', 'dynamix' ) => array(
							'value' => 'bounceInDown',
							'type' => 'in',
						),
						__( 'bounceInLeft', 'dynamix' ) => array(
							'value' => 'bounceInLeft',
							'type' => 'in',
						),
						__( 'bounceInRight', 'dynamix' ) => array(
							'value' => 'bounceInRight',
							'type' => 'in',
						),
						__( 'bounceInUp', 'dynamix' ) => array(
							'value' => 'bounceInUp',
							'type' => 'in',
						),
					),
				),
				array(
					'label' => __( 'Bouncing Exits', 'dynamix' ),
					'values' => array(
						// text to display => value
						__( 'bounceOut', 'dynamix' ) => array(
							'value' => 'bounceOut',
							'type' => 'out',
						),
						__( 'bounceOutDown', 'dynamix' ) => array(
							'value' => 'bounceOutDown',
							'type' => 'out',
						),
						__( 'bounceOutLeft', 'dynamix' ) => array(
							'value' => 'bounceOutLeft',
							'type' => 'out',
						),
						__( 'bounceOutRight', 'dynamix' ) => array(
							'value' => 'bounceOutRight',
							'type' => 'out',
						),
						__( 'bounceOutUp', 'dynamix' ) => array(
							'value' => 'bounceOutUp',
							'type' => 'out',
						),
					),
				),
				array(
					'label' => __( 'Fading Entrances', 'dynamix' ),
					'values' => array(
						// text to display => value
						__( 'fadeIn', 'dynamix' ) => array(
							'value' => 'fadeIn',
							'type' => 'in',
						),
						__( 'fadeInDown', 'dynamix' ) => array(
							'value' => 'fadeInDown',
							'type' => 'in',
						),
						__( 'fadeInDownBig', 'dynamix' ) => array(
							'value' => 'fadeInDownBig',
							'type' => 'in',
						),
						__( 'fadeInLeft', 'dynamix' ) => array(
							'value' => 'fadeInLeft',
							'type' => 'in',
						),
						__( 'fadeInLeftBig', 'dynamix' ) => array(
							'value' => 'fadeInLeftBig',
							'type' => 'in',
						),
						__( 'fadeInRight', 'dynamix' ) => array(
							'value' => 'fadeInRight',
							'type' => 'in',
						),
						__( 'fadeInRightBig', 'dynamix' ) => array(
							'value' => 'fadeInRightBig',
							'type' => 'in',
						),
						__( 'fadeInUp', 'dynamix' ) => array(
							'value' => 'fadeInUp',
							'type' => 'in',
						),
						__( 'fadeInUpBig', 'dynamix' ) => array(
							'value' => 'fadeInUpBig',
							'type' => 'in',
						),
					),
				),
				array(
					'label' => __( 'Fading Exits', 'dynamix' ),
					'values' => array(
						__( 'fadeOut', 'dynamix' ) => array(
							'value' => 'fadeOut',
							'type' => 'out',
						),
						__( 'fadeOutDown', 'dynamix' ) => array(
							'value' => 'fadeOutDown',
							'type' => 'out',
						),
						__( 'fadeOutDownBig', 'dynamix' ) => array(
							'value' => 'fadeOutDownBig',
							'type' => 'out',
						),
						__( 'fadeOutLeft', 'dynamix' ) => array(
							'value' => 'fadeOutLeft',
							'type' => 'out',
						),
						__( 'fadeOutLeftBig', 'dynamix' ) => array(
							'value' => 'fadeOutLeftBig',
							'type' => 'out',
						),
						__( 'fadeOutRight', 'dynamix' ) => array(
							'value' => 'fadeOutRight',
							'type' => 'out',
						),
						__( 'fadeOutRightBig', 'dynamix' ) => array(
							'value' => 'fadeOutRightBig',
							'type' => 'out',
						),
						__( 'fadeOutUp', 'dynamix' ) => array(
							'value' => 'fadeOutUp',
							'type' => 'out',
						),
						__( 'fadeOutUpBig', 'dynamix' ) => array(
							'value' => 'fadeOutUpBig',
							'type' => 'out',
						),
					),
				),
				array(
					'label' => __( 'Flippers', 'dynamix' ),
					'values' => array(
						__( 'flip', 'dynamix' ) => array(
							'value' => 'flip',
							'type' => 'other',
						),
						__( 'flipInX', 'dynamix' ) => array(
							'value' => 'flipInX',
							'type' => 'in',
						),
						__( 'flipInY', 'dynamix' ) => array(
							'value' => 'flipInY',
							'type' => 'in',
						),
						__( 'flipOutX', 'dynamix' ) => array(
							'value' => 'flipOutX',
							'type' => 'out',
						),
						__( 'flipOutY', 'dynamix' ) => array(
							'value' => 'flipOutY',
							'type' => 'out',
						),
					),
				),
				array(
					'label' => __( 'Lightspeed', 'dynamix' ),
					'values' => array(
						__( 'lightSpeedIn', 'dynamix' ) => array(
							'value' => 'lightSpeedIn',
							'type' => 'in',
						),
						__( 'lightSpeedOut', 'dynamix' ) => array(
							'value' => 'lightSpeedOut',
							'type' => 'out',
						),
					),
				),
				array(
					'label' => __( 'Rotating Entrances', 'dynamix' ),
					'values' => array(
						__( 'rotateIn', 'dynamix' ) => array(
							'value' => 'rotateIn',
							'type' => 'in',
						),
						__( 'rotateInDownLeft', 'dynamix' ) => array(
							'value' => 'rotateInDownLeft',
							'type' => 'in',
						),
						__( 'rotateInDownRight', 'dynamix' ) => array(
							'value' => 'rotateInDownRight',
							'type' => 'in',
						),
						__( 'rotateInUpLeft', 'dynamix' ) => array(
							'value' => 'rotateInUpLeft',
							'type' => 'in',
						),
						__( 'rotateInUpRight', 'dynamix' ) => array(
							'value' => 'rotateInUpRight',
							'type' => 'in',
						),
						__( 'rotateInTopBottom', 'dynamix' ) => array(
							'value' => 'rotate-top-to-bottom',
							'type' => 'in',
						),
						__( 'rotateInBottomTop', 'dynamix' ) => array(
							'value' => 'rotate-bottom-to-top',
							'type' => 'in',
						),					
						__( 'rotateInLeftRight', 'dynamix' ) => array(
							'value' => 'rotate-top-to-bottom',
							'type' => 'in',
						),
						__( 'rotateInRightLeft', 'dynamix' ) => array(
							'value' => 'rotate-right-to-left',
							'type' => 'in',
						),																			
					),
				),
				array(
					'label' => __( 'Rotating Exits', 'dynamix' ),
					'values' => array(
						__( 'rotateOut', 'dynamix' ) => array(
							'value' => 'rotateOut',
							'type' => 'out',
						),
						__( 'rotateOutDownLeft', 'dynamix' ) => array(
							'value' => 'rotateOutDownLeft',
							'type' => 'out',
						),
						__( 'rotateOutDownRight', 'dynamix' ) => array(
							'value' => 'rotateOutDownRight',
							'type' => 'out',
						),
						__( 'rotateOutUpLeft', 'dynamix' ) => array(
							'value' => 'rotateOutUpLeft',
							'type' => 'out',
						),
						__( 'rotateOutUpRight', 'dynamix' ) => array(
							'value' => 'rotateOutUpRight',
							'type' => 'out',
						),
					),
				),
				array(
					'label' => __( 'Specials', 'dynamix' ),
					'values' => array(
						__( 'hinge', 'dynamix' ) => array(
							'value' => 'hinge',
							'type' => 'out',
						),
						__( 'rollIn', 'dynamix' ) => array(
							'value' => 'rollIn',
							'type' => 'in',
						),
						__( 'rollOut', 'dynamix' ) => array(
							'value' => 'rollOut',
							'type' => 'out',
						),
					),
				),
				array(
					'label' => __( 'Zoom Entrances', 'dynamix' ),
					'values' => array(
						__( 'zoomIn', 'dynamix' ) => array(
							'value' => 'zoomIn',
							'type' => 'in',
						),
						__( 'zoomInDown', 'dynamix' ) => array(
							'value' => 'zoomInDown',
							'type' => 'in',
						),
						__( 'zoomInLeft', 'dynamix' ) => array(
							'value' => 'zoomInLeft',
							'type' => 'in',
						),
						__( 'zoomInRight', 'dynamix' ) => array(
							'value' => 'zoomInRight',
							'type' => 'in',
						),
						__( 'zoomInUp', 'dynamix' ) => array(
							'value' => 'zoomInUp',
							'type' => 'in',
						),
					),
				),
				array(
					'label' => __( 'Zoom Exits', 'dynamix' ),
					'values' => array(
						__( 'zoomOut', 'dynamix' ) => array(
							'value' => 'zoomOut',
							'type' => 'out',
						),
						__( 'zoomOutDown', 'dynamix' ) => array(
							'value' => 'zoomOutDown',
							'type' => 'out',
						),
						__( 'zoomOutLeft', 'dynamix' ) => array(
							'value' => 'zoomOutLeft',
							'type' => 'out',
						),
						__( 'zoomOutRight', 'dynamix' ) => array(
							'value' => 'zoomOutRight',
							'type' => 'out',
						),
						__( 'zoomOutUp', 'dynamix' ) => array(
							'value' => 'zoomOutUp',
							'type' => 'out',
						),
					),
				),
				array(
					'label' => __( 'Slide Entrances', 'dynamix' ),
					'values' => array(
						__( 'slideInDown', 'dynamix' ) => array(
							'value' => 'slideInDown',
							'type' => 'in',
						),
						__( 'slideInLeft', 'dynamix' ) => array(
							'value' => 'slideInLeft',
							'type' => 'in',
						),
						__( 'slideInRight', 'dynamix' ) => array(
							'value' => 'slideInRight',
							'type' => 'in',
						),
						__( 'slideInUp', 'dynamix' ) => array(
							'value' => 'slideInUp',
							'type' => 'in',
						),
					),
				),
				array(
					'label' => __( 'Slide Exits', 'dynamix' ),
					'values' => array(
						__( 'slideOutDown', 'dynamix' ) => array(
							'value' => 'slideOutDown',
							'type' => 'out',
						),
						__( 'slideOutLeft', 'dynamix' ) => array(
							'value' => 'slideOutLeft',
							'type' => 'out',
						),
						__( 'slideOutRight', 'dynamix' ) => array(
							'value' => 'slideOutRight',
							'type' => 'out',
						),
						__( 'slideOutUp', 'dynamix' ) => array(
							'value' => 'slideOutUp',
							'type' => 'out',
						),
					),
				),
				array(
					'label' => __( 'Looping', 'dynamix' ),
					'values' => array(
						__( 'Pulse', 'dynamix' ) => array(
							'value' => 'pulse',
							'type' => 'in',
						),
						__( 'Swing', 'dynamix' ) => array(
							'value' => 'swing',
							'type' => 'in',
						),
						__( 'SlideHorizontally', 'dynamix' ) => array(
							'value' => 'slide-left-to-right',
							'type' => 'in',
						),
						__( 'SlideVertically', 'dynamix' ) => array(
							'value' => 'slide-top-to-bottom',
							'type' => 'in',
						),
					),
				),			
			
			);
		
			return $styles;
		
		}

		/**
		 * Used to override animation style list
		 * @since 4.4
		 */


		
		add_filter( 'vc_param_animation_style_list', 'acoda_animation_styles' ); // Where $priority is default 10, $accepted_args is default 1.	

		add_action( 'vc_after_init', 'acoda_add_options' ); /* Note: here we are using vc_after_init because WPBMap::GetParam and mutateParame are available only when default content elements are "mapped" into the system */
		
		function acoda_add_options()
		{
			$param = WPBMap::getParam( 'vc_btn', 'color' );
			if( isset( $param['value'] ) || isset( $param['std'] ) )
			{
				$param['value'][esc_html__( 'Skin Default', 'dynamix' )] = 'link_color';
				$param['std'] = 'link_color';
			}

			vc_update_shortcode_param( 'vc_btn', $param );
	
			$param = WPBMap::getParam( 'vc_icon', 'color' );

			if( isset( $param['value'] ) || isset( $param['std'] ) )
			{
				$param['value'][esc_html__( 'Skin Default', 'dynamix' )] = 'skin_element';
				$param['value'][esc_html__( 'Skin Link Color', 'dynamix' )] = 'acoda_link_color';
				$param['value'][esc_html__( 'Skin Link Hover Color', 'dynamix' )] = 'acoda_link_hover_color';
				$param['std'] = 'skin_element';
			}
			  
			vc_update_shortcode_param( 'vc_icon', $param );
	
			$param = WPBMap::getParam( 'vc_icon', 'background_color' );

			if( isset( $param['value'] ) || isset( $param['std'] ) )
			{
				$param['value'][esc_html__( 'Skin Default', 'dynamix' )] = 'skin_element';
				$param['std'] = 'skin_element';
			}
			  
			vc_update_shortcode_param( 'vc_icon', $param );	

			$param = WPBMap::getParam( 'vc_icon', 'align' );

			if( isset( $param['value'] ) || isset( $param['std'] ) )
			{
				$param['value'][esc_html__( 'Inline', 'dynamix' )] = 'inline';
				$param['std'] = 'inline';
			}
			  
			vc_update_shortcode_param( 'vc_icon', $param );			

			$param = WPBMap::getParam( 'vc_cta', 'color' );

			if( isset( $param['value'] ) || isset( $param['std'] ) )
			{
				$param['value'][esc_html__( 'Skin Default', 'dynamix' )] = 'skin_element';
				$param['std'] = 'skin_element';
			}
			  
			vc_update_shortcode_param( 'vc_cta', $param );		
			

			$param = WPBMap::getParam( 'vc_separator', 'color' );

			if( isset( $param['value'] ) || isset( $param['std'] ) )
			{
				$param['value'][esc_html__( 'Skin Default', 'dynamix' )] = 'skin_element';
				$param['value'][esc_html__( 'Skin Link Color', 'dynamix' )] = 'acoda_link_color-border';
				$param['value'][esc_html__( 'Skin Link Hover Color', 'dynamix' )] = 'acoda_link_hover_color-border';
				$param['std'] = 'skin_element';
			}
			  
			vc_update_shortcode_param( 'vc_separator', $param );	

			$param = WPBMap::getParam( 'vc_tta_tabs', 'color' );

			if( isset( $param['value'] ) || isset( $param['std'] ) )
			{
				$param['value'][esc_html__( 'Skin Button Color', 'dynamix' )] = 'button_color';
				$param['value'][esc_html__( 'Skin Shaded Color', 'dynamix' )] = 'shaded_color';
				$param['std'] = 'button_color';
			}
			  
			vc_update_shortcode_param( 'vc_tta_tabs', $param );	

			$param = WPBMap::getParam( 'vc_tta_accordion', 'color' );

			if( isset( $param['value'] ) || isset( $param['std'] ) )
			{
				$param['value'][esc_html__( 'Skin Button Color', 'dynamix' )] = 'button_color';
				$param['value'][esc_html__( 'Skin Shaded Color', 'dynamix' )] = 'shaded_color';
				$param['std'] = 'shaded_color';
			}
			  
			vc_update_shortcode_param( 'vc_tta_accordion', $param );	
			
			$param = WPBMap::getParam( 'vc_message', 'message_box_color' );

			if( isset( $param['value'] ) || isset( $param['std'] ) )
			{
				$param['value'][esc_html__( 'Skin Button Color', 'dynamix' )] = 'button_color';
				$param['value'][esc_html__( 'Skin Shaded Color', 'dynamix' )] = 'shaded_color';
				$param['std'] = 'shaded_color';
			}
			  
			vc_update_shortcode_param( 'vc_message', $param );						

			$param = WPBMap::getParam( 'vc_toggle', 'color' );

			if( isset( $param['value'] ) || isset( $param['std'] ) )
			{
				$param['value'][esc_html__( 'Skin Button Color', 'dynamix' )] = 'button_color';
				$param['value'][esc_html__( 'Skin Button Hover Color', 'dynamix' )] = 'button_hover_color';
				$param['std'] = 'button_color';
			}
			  
			vc_update_shortcode_param( 'vc_toggle', $param );					

			$param = WPBMap::getParam( 'vc_tta_tour', 'color' );

			if( isset( $param['value'] ) || isset( $param['std'] ) )
			{
				$param['value'][esc_html__( 'Skin Button Color', 'dynamix' )] = 'button_color';
				$param['value'][esc_html__( 'Skin Shaded Color', 'dynamix' )] = 'shaded_color';
				$param['std'] = 'button_color';
			}
			  
			vc_update_shortcode_param( 'vc_tta_tour', $param );					
	

			$param = WPBMap::getParam( 'vc_btn', 'style' );

			if( isset( $param['value'] ) )
			{
				$param['value'][esc_html__( 'Text Only', 'dynamix' )] = 'outline text_only';
			}
			  
			vc_update_shortcode_param( 'vc_btn', $param );	

			$param = WPBMap::getParam( 'vc_btn', 'size' );

			if( isset( $param['value'] ) )
			{
				$param['value'][esc_html__( 'Extra Large', 'dynamix' )] = 'xlg';
				$param['value'][esc_html__( 'Super Size', 'dynamix' )] = 'sup';
			}
			  
			vc_update_shortcode_param( 'vc_btn', $param );	

			$param = WPBMap::getParam( 'vc_btn', 'shape' );

			if( isset( $param['value'] ) )
			{
				$param['value'][esc_html__( 'Default', 'dynamix' )] = 'default';
				$param['std'] = 'default';
			}
			  
			vc_update_shortcode_param( 'vc_btn', $param );																
		}			
		
		$allowed_tags = wp_kses_allowed_html();
	
				
	
		/* Single image */
		vc_map( array(
			'name' => esc_html__( 'Single Image', 'dynamix' ),
			'base' => 'vc_single_image',
			'icon' => 'icon-wpb-single-image',
			'category' => esc_html__( 'Content', 'dynamix' ),
			'description' => esc_html__( 'Simple image with CSS animation', 'dynamix' ),
			'params' => array(
				array(
					'type' => 'dropdown',
					'heading' => esc_html__( 'Image source', 'dynamix' ),
					'param_name' => 'source',
					'value' => array(
						esc_html__( 'Media library', 'dynamix' ) => 'media_library',
						esc_html__( 'External link', 'dynamix' ) => 'external_link',
						esc_html__( 'Featured Image', 'dynamix' ) => 'featured_image'
					),
					'std' => 'media_library',
					'description' => esc_html__( 'Select image source.', 'dynamix' )
				),
				array(
					'type' => 'attach_image',
					'heading' => esc_html__( 'Image', 'dynamix' ),
					'param_name' => 'image',
					'value' => '',
					'description' => esc_html__( 'Select image from media library.', 'dynamix' ),
					'dependency' => array(
						'element' => 'source',
						'value' => 'media_library'
					),
				),
				array(
					'type' => 'textfield',
					'heading' => esc_html__( 'External link', 'dynamix' ),
					'param_name' => 'custom_src',
					'description' => esc_html__( 'Select external link.', 'dynamix' ),
					'dependency' => array(
						'element' => 'source',
						'value' => 'external_link'
					),
				),
				array(
					'type' => 'textfield',
					'heading' => esc_html__( 'Image size', 'dynamix' ),
					'param_name' => 'img_size',
					'value' => 'thumbnail',
					'description' => esc_html__( 'Enter image size (Example: "thumbnail", "medium", "large", "full" or other sizes defined by theme). Alternatively enter size in pixels (Example: 200x100 (Width x Height)).', 'dynamix' ),
					'dependency' => array(
						'element' => 'source',
						'value' => array( 'media_library', 'featured_image' )
					),
				),
				array(
					'type' => 'textfield',
					'heading' => esc_html__( 'Image size', 'dynamix' ),
					'param_name' => 'external_img_size',
					'value' => '',
					'description' => esc_html__( 'Enter image size in pixels. Example: 200x100 (Width x Height).', 'dynamix' ),
					'dependency' => array(
						'element' => 'source',
						'value' => 'external_link'
					),
				),			
				array(
					"type" => "dropdown",
					"heading" => esc_html__("Caption", 'dynamix'),
					"param_name" => "add_caption",
					"value" => array( 
						esc_html__("None", 'dynamix') => '',
						esc_html__("Media Library Description", 'dynamix') => 'yes',
						esc_html__("Custom", 'dynamix') => 'custom',
					),					
					"description" => esc_html__("Set a Caption using the Media Library Description field or a Custom one.", 'dynamix')
				),
				array(
					'type' => 'textfield',
					'heading' => esc_html__( 'Title', 'dynamix' ),
					'param_name' => 'title',
					'description' => esc_html__( 'Enter text for image title.', 'dynamix' ),
					'dependency' => array(
						'element' => 'add_caption',
						'value' => 'custom'
					),
				),					
				array(
					'type' => 'textfield',
					'heading' => esc_html__( 'Caption', 'dynamix' ),
					'param_name' => 'caption',
					'description' => esc_html__( 'Enter text for image caption.', 'dynamix' ),
					'dependency' => array(
						'element' => 'add_caption',
						'value' => 'custom'
					),
				),				
				array(
					'type' => 'dropdown',
					'heading' => esc_html__( 'Title Size', 'dynamix' ),
					'param_name' => 'title_size',
					"value" => array( 
						esc_html__("Normal", 'dynamix') => '',
						esc_html__("Small", 'dynamix') => 'small',
						esc_html__("Medium", 'dynamix') => 'medium',
						esc_html__("Large", 'dynamix') => 'large',
					),					
					"dependency" => Array('element' => "add_caption", 'not_empty' => true),
					"description" => esc_html__("Set the Caption Title size.", 'dynamix')
				),					
				array(
					'type' => 'dropdown',
					'heading' => esc_html__( 'Image alignment', 'dynamix' ),
					'param_name' => 'alignment',
					'value' => array(
						esc_html__( 'Left', 'dynamix' ) => 'left',
						esc_html__( 'Right', 'dynamix' ) => 'right',
						esc_html__( 'Center', 'dynamix' ) => 'center'
					),
					'description' => esc_html__( 'Select image alignment.', 'dynamix' )
				),
				array(
					'type' => 'dropdown',
					'heading' => esc_html__( 'Image style', 'dynamix' ),
					'param_name' => 'style',
					'value' => $all_box_styles,
					'description' => esc_html__( 'Select image display style.', 'dynamix' ),
					'dependency' => array(
						'element' => 'source',
						'value' => array( 'media_library', 'featured_image' )
					),
				),
				array(
					'type' => 'dropdown',
					'heading' => esc_html__( 'Image style', 'dynamix' ),
					'param_name' => 'external_style',
					'value' => $box_styles,
					'description' => esc_html__( 'Select image display style.', 'dynamix' ),
					'dependency' => array(
						'element' => 'source',
						'value' => 'external_link'
					),
				),
				array(
					"type" => "dropdown",
					"heading" => esc_html__("On hover Effect", 'dynamix'),
					"param_name" => "hover_effect_circle",
					"value" => array( 
						esc_html__("Select Effect", 'dynamix') => '',
						esc_html__("Fade + Slide Text ( From Bottom ) + Animate Text", 'dynamix') => 'effect13 bottom_to_top'	,
						esc_html__("Fade + Slide Text ( From Left ) + Animate Text", 'dynamix') => 'effect13 from_left_and_right'	,
						esc_html__("Spin + Slide", 'dynamix') => 'effect2 left_to_right',
						esc_html__("Slide + Shrink", 'dynamix') => 'effect3 left_to_right',
						esc_html__("Slide + Fade", 'dynamix') => 'circle effect4 top_to_bottom',
						esc_html__("Roll Right + Fade", 'dynamix') => 'effect9 left_to_right',
						esc_html__("Spin + Fade", 'dynamix') => 'effect11 bottom_to_top',
						esc_html__("Fade + Fold Down", 'dynamix') => 'effect14 top_to_bottom'	,
						esc_html__("Flip Image Top", 'dynamix') => 'effect18 bottom_to_top',
						esc_html__("Flip Image Down", 'dynamix') => 'effect18 top_to_bottom',
						esc_html__("Flip Image Left", 'dynamix') => 'effect18 right_to_left',
						esc_html__("Flip Image Right", 'dynamix') => 'effect18 left_to_right',
	
					),
					"description" => esc_html__("Select hover effect - requires a title or caption.", 'dynamix'),
					'dependency' => array(
						'element' => 'style',
						'value' => array( 'vc_box_circle_2', 'vc_box_border_circle_2', 'vc_box_outline_circle_2', 'vc_box_shadow_circle_2', 'vc_box_shadow_border_circle_2' )
					),					
				),				
				array(
					"type" => "dropdown",
					"heading" => esc_html__("On hover Effect", 'dynamix'),
					"param_name" => "hover_effect_square",
					"value" => array( 
						esc_html__("Select Effect", 'dynamix') => '',
						esc_html__("Zoom Image + Slide Text ( From Top )", 'dynamix') => 'effect6 from_top_and_bottom',
						esc_html__("Zoom Image + Slide Text ( From Left )", 'dynamix') => 'effect6 from_left_and_right',
						esc_html__("Zoom Image + Text", 'dynamix') => 'effect7'	,					
						esc_html__("Flip Image Top", 'dynamix') => 'effect9 bottom_to_top',
						esc_html__("Flip Image Bottom", 'dynamix') => 'effect9 top_to_bottom',
						esc_html__("Flip Image Left", 'dynamix') => 'effect9 right_to_left',
						esc_html__("Flip Image Right", 'dynamix') => 'effect9 left_to_right',
						esc_html__("Slide Image + Text", 'dynamix') => 'effect10 right_to_left',
						esc_html__("3d Rotate Vertical", 'dynamix') => 'effect15 bottom_to_top'	,
						esc_html__("3d Rotate Horizontal", 'dynamix') => 'effect15 right_to_left',
					),
					"description" => esc_html__("Select hover effect - requires a title or caption.", 'dynamix'),
					'dependency' => array(
						'element' => 'style',
						'value' => array( '', 'vc_box_rounded', 'vc_box_rounded', 'vc_box_border', 'vc_box_outline', 'vc_box_shadow', 'vc_box_shadow_border', 'vc_box_shadow_3d', 'vc_box_circle', 'vc_box_border_circle', 'vc_box_outline_circle', 'vc_box_shadow_circle', 'vc_box_shadow_border_circle' )
					),		
				),				
				array(
					'type' => 'dropdown',
					'heading' => esc_html__( 'On click action', 'dynamix' ),
					'param_name' => 'onclick',
					'value' => array(
						esc_html__( 'None', 'dynamix' ) => '',
						esc_html__( 'Link to Large Image', 'dynamix' ) => 'img_link_large',
						esc_html__( 'Custom Link', 'dynamix' ) => 'custom_link',
					),
					'description' => esc_html__( 'Select action for click action.', 'dynamix' ),
					'std' => ''
				),			
				array(
					'type' => 'dropdown',
					'heading' => esc_html__( 'Link Icon', 'dynamix' ),
					'param_name' => 'link_icon',
					'value' => array(
						esc_html__( 'Enable', 'dynamix' ) => 'enable',
						esc_html__( 'Disable', 'dynamix' ) => 'disable',
					),
					'std' => 'enable',
					'dependency' => array(
						'element' => 'onclick',
						'not_empty' => true
					)					
				),
				array(
					'type' => 'textfield',
					'heading' => esc_html__( 'Custom URL', 'dynamix' ),
					'param_name' => 'link',
					'description' => esc_html__( 'Enter URL if you want this image to have a link (Note: parameters like "mailto:" are also accepted).', 'dynamix' ),
					'dependency' => array(
						'element' => 'onclick',
						'value' => 'custom_link',
					)
				),
				array(
					"type" => "checkbox",
					"class" => "",
					"heading" => esc_html__("Enable Lightbox", 'dynamix'),
					"param_name" => "lightbox",
					'description' => esc_html__( 'Open Large Image in Lightbox or use Lightbox Media URL to open alternative Media.', 'dynamix' ),
					"value" =>  array(
						esc_html__('Enable', 'dynamix') => "enable", 
					)
				),					
				array(
					'type' => 'textfield',
					'heading' => esc_html__( 'Lightbox Media URL', 'dynamix' ),
					'param_name' => 'media_url',
					'description' => esc_html__( 'Enter Media URL e.g. YouTube URL.', 'dynamix' ),
					'dependency' => array(
						'element' => 'lightbox',
						'value' => 'enable',
					)
				),				
				array(
					'type' => 'dropdown',
					'heading' => esc_html__( 'Link Target', 'dynamix' ),
					'param_name' => 'img_link_target',
					'value' => $target_arr,
					'dependency' => array(
						'element' => 'onclick',
						'value' => array( 'custom_link', 'img_link_large' ),
					),
				),
				vc_map_add_css_animation(),
				array(
					'type' => 'textfield',
					'heading' => esc_html__( 'Extra class name', 'dynamix' ),
					'param_name' => 'el_class',
					'description' => esc_html__( 'Style particular content element differently - add a class name and refer to it in custom CSS.', 'dynamix' )
				),
				array(
					'type' => 'css_editor',
					'heading' => esc_html__( 'CSS box', 'dynamix' ),
					'param_name' => 'css',
					'group' => esc_html__( 'Design Options', 'dynamix' )
				),
				array(
					'type' => 'dropdown',
					'heading' => esc_html__( 'Parallax', 'dynamix' ),
					'param_name' => 'paroller',
					'value' => array(
						esc_html__( 'Disable', 'dynamix' ) => 'disable',
						esc_html__( 'Vertical', 'dynamix' ) => 'vertical',
						esc_html__( 'Horizontal', 'dynamix' ) => 'horizontal',
					),
					'group' => esc_html__( 'Parallax', 'dynamix' )
				),
				array(
					'type' => 'textfield',
					'heading' => esc_html__( 'Factor', 'dynamix' ),
					'param_name' => 'paroller_factor',
					'description' => esc_html__( 'Enter a value between -0.3 & 0.3.', 'dynamix' ),
					'group' => esc_html__( 'Parallax', 'dynamix' ),
					'std' => '-0.1',
				),			
			
				// backward compatibility. since 4.6
				array(
					'type' => 'hidden',
					'param_name' => 'img_link_large'
				)
			)
		) );
		

		add_filter( 'vc_iconpicker-type-nucleo_glyph', 'vc_iconpicker_type_nucleo_glyph' );
		add_filter( 'vc_iconpicker-type-nucleo_outline', 'vc_iconpicker_type_nucleo_outline' );
		
		function vc_iconpicker_type_nucleo_outline( $icons ) 
		{
			$nucleo_icons = array(				
				'Animals & Nature' => array( 
					 array( 'nc-icon-outline nature_bear' => 'nature_bear' ),
					 array( 'nc-icon-outline nature_bee' => 'nature_bee' ),
					 array( 'nc-icon-outline nature_butterfly' => 'nature_butterfly' ),
					 array( 'nc-icon-outline nature_chicken' => 'nature_chicken' ),
					 array( 'nc-icon-outline nature_clover' => 'nature_clover' ),
					 array( 'nc-icon-outline nature_collar' => 'nature_collar' ),
					 array( 'nc-icon-outline nature_cow' => 'nature_cow' ),
					 array( 'nc-icon-outline nature_dog-house' => 'nature_dog-house' ),
					 array( 'nc-icon-outline nature_dog' => 'nature_dog' ),
					 array( 'nc-icon-outline nature_flower-05' => 'nature_flower-05' ),
					 array( 'nc-icon-outline nature_flower-06' => 'nature_flower-06' ),
					 array( 'nc-icon-outline nature_flower-07' => 'nature_flower-07' ),
					 array( 'nc-icon-outline nature_food-dog' => 'nature_food-dog' ),
					 array( 'nc-icon-outline nature_food' => 'nature_food' ),
					 array( 'nc-icon-outline nature_forest' => 'nature_forest' ),
					 array( 'nc-icon-outline nature_mountain' => 'nature_mountain' ),
					 array( 'nc-icon-outline nature_mushroom' => 'nature_mushroom' ),
					 array( 'nc-icon-outline nature_panda' => 'nature_panda' ),
					 array( 'nc-icon-outline nature_paw' => 'nature_paw' ),
					 array( 'nc-icon-outline nature_pig' => 'nature_pig' ),
					 array( 'nc-icon-outline nature_plant-ground' => 'nature_plant-ground' ),
					 array( 'nc-icon-outline nature_plant-vase' => 'nature_plant-vase' ),
					 array( 'nc-icon-outline nature_rat' => 'nature_rat' ),
					 array( 'nc-icon-outline nature_sheep' => 'nature_sheep' ),
					 array( 'nc-icon-outline nature_snake' => 'nature_snake' ),
					 array( 'nc-icon-outline nature_tree-01' => 'nature_tree-01' ),
					 array( 'nc-icon-outline nature_tree-02' => 'nature_tree-02' ),
					 array( 'nc-icon-outline nature_tree-03' => 'nature_tree-03' ),
					 array( 'nc-icon-outline nature_turtle' => 'nature_turtle' ),
					 array( 'nc-icon-outline nature_wood' => 'nature_wood' ),
				),
				'Arrows' => array( 
					 array( 'nc-icon-outline arrows-1_back-78' => 'arrows-1_back-78' ),
					 array( 'nc-icon-outline arrows-1_back-80' => 'arrows-1_back-80' ),
					 array( 'nc-icon-outline arrows-1_bold-direction' => 'arrows-1_bold-direction' ),
					 array( 'nc-icon-outline arrows-1_bold-down' => 'arrows-1_bold-down' ),
					 array( 'nc-icon-outline arrows-1_bold-left' => 'arrows-1_bold-left' ),
					 array( 'nc-icon-outline arrows-1_bold-right' => 'arrows-1_bold-right' ),
					 array( 'nc-icon-outline arrows-1_bold-up' => 'arrows-1_bold-up' ),
					 array( 'nc-icon-outline arrows-1_circle-down-12' => 'arrows-1_circle-down-12' ),
					 array( 'nc-icon-outline arrows-1_circle-down-40' => 'arrows-1_circle-down-40' ),
					 array( 'nc-icon-outline arrows-1_circle-left-10' => 'arrows-1_circle-left-10' ),
					 array( 'nc-icon-outline arrows-1_circle-left-38' => 'arrows-1_circle-left-38' ),
					 array( 'nc-icon-outline arrows-1_circle-right-09' => 'arrows-1_circle-right-09' ),
					 array( 'nc-icon-outline arrows-1_circle-right-37' => 'arrows-1_circle-right-37' ),
					 array( 'nc-icon-outline arrows-1_circle-up-11' => 'arrows-1_circle-up-11' ),
					 array( 'nc-icon-outline arrows-1_circle-up-39' => 'arrows-1_circle-up-39' ),
					 array( 'nc-icon-outline arrows-1_cloud-download-93' => 'arrows-1_cloud-download-93' ),
					 array( 'nc-icon-outline arrows-1_cloud-download-95' => 'arrows-1_cloud-download-95' ),
					 array( 'nc-icon-outline arrows-1_cloud-upload-94' => 'arrows-1_cloud-upload-94' ),
					 array( 'nc-icon-outline arrows-1_cloud-upload-96' => 'arrows-1_cloud-upload-96' ),
					 array( 'nc-icon-outline arrows-1_curved-next' => 'arrows-1_curved-next' ),
					 array( 'nc-icon-outline arrows-1_curved-previous' => 'arrows-1_curved-previous' ),
					 array( 'nc-icon-outline arrows-1_direction-53' => 'arrows-1_direction-53' ),
					 array( 'nc-icon-outline arrows-1_direction-56' => 'arrows-1_direction-56' ),
					 array( 'nc-icon-outline arrows-1_double-left' => 'arrows-1_double-left' ),
					 array( 'nc-icon-outline arrows-1_double-right' => 'arrows-1_double-right' ),
					 array( 'nc-icon-outline arrows-1_download' => 'arrows-1_download' ),
					 array( 'nc-icon-outline arrows-1_enlarge-diagonal-43' => 'arrows-1_enlarge-diagonal-43' ),
					 array( 'nc-icon-outline arrows-1_enlarge-diagonal-44' => 'arrows-1_enlarge-diagonal-44' ),
					 array( 'nc-icon-outline arrows-1_enlarge-horizontal' => 'arrows-1_enlarge-horizontal' ),
					 array( 'nc-icon-outline arrows-1_enlarge-vertical' => 'arrows-1_enlarge-vertical' ),
					 array( 'nc-icon-outline arrows-1_fit-horizontal' => 'arrows-1_fit-horizontal' ),
					 array( 'nc-icon-outline arrows-1_fit-vertical' => 'arrows-1_fit-vertical' ),
					 array( 'nc-icon-outline arrows-1_fullscreen-70' => 'arrows-1_fullscreen-70' ),
					 array( 'nc-icon-outline arrows-1_fullscreen-71' => 'arrows-1_fullscreen-71' ),
					 array( 'nc-icon-outline arrows-1_fullscreen-76' => 'arrows-1_fullscreen-76' ),
					 array( 'nc-icon-outline arrows-1_fullscreen-77' => 'arrows-1_fullscreen-77' ),
					 array( 'nc-icon-outline arrows-1_fullscreen-double-74' => 'arrows-1_fullscreen-double-74' ),
					 array( 'nc-icon-outline arrows-1_fullscreen-double-75' => 'arrows-1_fullscreen-double-75' ),
					 array( 'nc-icon-outline arrows-1_fullscreen-split-72' => 'arrows-1_fullscreen-split-72' ),
					 array( 'nc-icon-outline arrows-1_fullscreen-split-73' => 'arrows-1_fullscreen-split-73' ),
					 array( 'nc-icon-outline arrows-1_log-in' => 'arrows-1_log-in' ),
					 array( 'nc-icon-outline arrows-1_log-out' => 'arrows-1_log-out' ),
					 array( 'nc-icon-outline arrows-1_loop-82' => 'arrows-1_loop-82' ),
					 array( 'nc-icon-outline arrows-1_loop-83' => 'arrows-1_loop-83' ),
					 array( 'nc-icon-outline arrows-1_minimal-down' => 'arrows-1_minimal-down' ),
					 array( 'nc-icon-outline arrows-1_minimal-left' => 'arrows-1_minimal-left' ),
					 array( 'nc-icon-outline arrows-1_minimal-right' => 'arrows-1_minimal-right' ),
					 array( 'nc-icon-outline arrows-1_minimal-up' => 'arrows-1_minimal-up' ),
					 array( 'nc-icon-outline arrows-1_redo-79' => 'arrows-1_redo-79' ),
					 array( 'nc-icon-outline arrows-1_redo-81' => 'arrows-1_redo-81' ),
					 array( 'nc-icon-outline arrows-1_refresh-68' => 'arrows-1_refresh-68' ),
					 array( 'nc-icon-outline arrows-1_refresh-69' => 'arrows-1_refresh-69' ),
					 array( 'nc-icon-outline arrows-1_round-down' => 'arrows-1_round-down' ),
					 array( 'nc-icon-outline arrows-1_round-left' => 'arrows-1_round-left' ),
					 array( 'nc-icon-outline arrows-1_round-right' => 'arrows-1_round-right' ),
					 array( 'nc-icon-outline arrows-1_round-up' => 'arrows-1_round-up' ),
					 array( 'nc-icon-outline arrows-1_share-66' => 'arrows-1_share-66' ),
					 array( 'nc-icon-outline arrows-1_share-91' => 'arrows-1_share-91' ),
					 array( 'nc-icon-outline arrows-1_share-92' => 'arrows-1_share-92' ),
					 array( 'nc-icon-outline arrows-1_shuffle-97' => 'arrows-1_shuffle-97' ),
					 array( 'nc-icon-outline arrows-1_shuffle-98' => 'arrows-1_shuffle-98' ),
					 array( 'nc-icon-outline arrows-1_simple-down' => 'arrows-1_simple-down' ),
					 array( 'nc-icon-outline arrows-1_simple-left' => 'arrows-1_simple-left' ),
					 array( 'nc-icon-outline arrows-1_simple-right' => 'arrows-1_simple-right' ),
					 array( 'nc-icon-outline arrows-1_simple-up' => 'arrows-1_simple-up' ),
					 array( 'nc-icon-outline arrows-1_small-triangle-down' => 'arrows-1_small-triangle-down' ),
					 array( 'nc-icon-outline arrows-1_small-triangle-left' => 'arrows-1_small-triangle-left' ),
					 array( 'nc-icon-outline arrows-1_small-triangle-right' => 'arrows-1_small-triangle-right' ),
					 array( 'nc-icon-outline arrows-1_small-triangle-up' => 'arrows-1_small-triangle-up' ),
					 array( 'nc-icon-outline arrows-1_square-down' => 'arrows-1_square-down' ),
					 array( 'nc-icon-outline arrows-1_square-left' => 'arrows-1_square-left' ),
					 array( 'nc-icon-outline arrows-1_square-right' => 'arrows-1_square-right' ),
					 array( 'nc-icon-outline arrows-1_square-up' => 'arrows-1_square-up' ),
					 array( 'nc-icon-outline arrows-1_strong-down' => 'arrows-1_strong-down' ),
					 array( 'nc-icon-outline arrows-1_strong-left' => 'arrows-1_strong-left' ),
					 array( 'nc-icon-outline arrows-1_strong-right' => 'arrows-1_strong-right' ),
					 array( 'nc-icon-outline arrows-1_strong-up' => 'arrows-1_strong-up' ),
					 array( 'nc-icon-outline arrows-1_tail-down' => 'arrows-1_tail-down' ),
					 array( 'nc-icon-outline arrows-1_tail-left' => 'arrows-1_tail-left' ),
					 array( 'nc-icon-outline arrows-1_tail-right' => 'arrows-1_tail-right' ),
					 array( 'nc-icon-outline arrows-1_tail-triangle-down' => 'arrows-1_tail-triangle-down' ),
					 array( 'nc-icon-outline arrows-1_tail-triangle-left' => 'arrows-1_tail-triangle-left' ),
					 array( 'nc-icon-outline arrows-1_tail-triangle-right' => 'arrows-1_tail-triangle-right' ),
					 array( 'nc-icon-outline arrows-1_tail-triangle-up' => 'arrows-1_tail-triangle-up' ),
					 array( 'nc-icon-outline arrows-1_tail-up' => 'arrows-1_tail-up' ),
					 array( 'nc-icon-outline arrows-1_trend-down' => 'arrows-1_trend-down' ),
					 array( 'nc-icon-outline arrows-1_trend-up' => 'arrows-1_trend-up' ),
					 array( 'nc-icon-outline arrows-1_triangle-down-20' => 'arrows-1_triangle-down-20' ),
					 array( 'nc-icon-outline arrows-1_triangle-down-65' => 'arrows-1_triangle-down-65' ),
					 array( 'nc-icon-outline arrows-1_triangle-left-18' => 'arrows-1_triangle-left-18' ),
					 array( 'nc-icon-outline arrows-1_triangle-left-63' => 'arrows-1_triangle-left-63' ),
					 array( 'nc-icon-outline arrows-1_triangle-right-17' => 'arrows-1_triangle-right-17' ),
					 array( 'nc-icon-outline arrows-1_triangle-right-62' => 'arrows-1_triangle-right-62' ),
					 array( 'nc-icon-outline arrows-1_triangle-up-19' => 'arrows-1_triangle-up-19' ),
					 array( 'nc-icon-outline arrows-1_triangle-up-64' => 'arrows-1_triangle-up-64' ),
					 array( 'nc-icon-outline arrows-1_window-zoom-in' => 'arrows-1_window-zoom-in' ),
					 array( 'nc-icon-outline arrows-1_window-zoom-out' => 'arrows-1_window-zoom-out' ),
					 array( 'nc-icon-outline arrows-1_zoom-88' => 'arrows-1_zoom-88' ),
					 array( 'nc-icon-outline arrows-1_zoom-99' => 'arrows-1_zoom-99' ),
					 array( 'nc-icon-outline arrows-1_zoom-100' => 'arrows-1_zoom-100' ),
					 array( 'nc-icon-outline arrows-2_block-down' => 'arrows-2_block-down' ),
					 array( 'nc-icon-outline arrows-2_block-left' => 'arrows-2_block-left' ),
					 array( 'nc-icon-outline arrows-2_block-right' => 'arrows-2_block-right' ),
					 array( 'nc-icon-outline arrows-2_block-up' => 'arrows-2_block-up' ),
					 array( 'nc-icon-outline arrows-2_circle-in' => 'arrows-2_circle-in' ),
					 array( 'nc-icon-outline arrows-2_circle-out' => 'arrows-2_circle-out' ),
					 array( 'nc-icon-outline arrows-2_circuit-round' => 'arrows-2_circuit-round' ),
					 array( 'nc-icon-outline arrows-2_circuit' => 'arrows-2_circuit' ),
					 array( 'nc-icon-outline arrows-2_computer-upload' => 'arrows-2_computer-upload' ),
					 array( 'nc-icon-outline arrows-2_conversion' => 'arrows-2_conversion' ),
					 array( 'nc-icon-outline arrows-2_corner-down-round' => 'arrows-2_corner-down-round' ),
					 array( 'nc-icon-outline arrows-2_corner-down' => 'arrows-2_corner-down' ),
					 array( 'nc-icon-outline arrows-2_corner-left-down' => 'arrows-2_corner-left-down' ),
					 array( 'nc-icon-outline arrows-2_corner-left-round' => 'arrows-2_corner-left-round' ),
					 array( 'nc-icon-outline arrows-2_corner-left' => 'arrows-2_corner-left' ),
					 array( 'nc-icon-outline arrows-2_corner-right-down' => 'arrows-2_corner-right-down' ),
					 array( 'nc-icon-outline arrows-2_corner-right-round' => 'arrows-2_corner-right-round' ),
					 array( 'nc-icon-outline arrows-2_corner-right' => 'arrows-2_corner-right' ),
					 array( 'nc-icon-outline arrows-2_corner-up-left' => 'arrows-2_corner-up-left' ),
					 array( 'nc-icon-outline arrows-2_corner-up-right' => 'arrows-2_corner-up-right' ),
					 array( 'nc-icon-outline arrows-2_corner-up-round' => 'arrows-2_corner-up-round' ),
					 array( 'nc-icon-outline arrows-2_corner-up' => 'arrows-2_corner-up' ),
					 array( 'nc-icon-outline arrows-2_cross-down' => 'arrows-2_cross-down' ),
					 array( 'nc-icon-outline arrows-2_cross-horizontal' => 'arrows-2_cross-horizontal' ),
					 array( 'nc-icon-outline arrows-2_cross-left' => 'arrows-2_cross-left' ),
					 array( 'nc-icon-outline arrows-2_cross-right' => 'arrows-2_cross-right' ),
					 array( 'nc-icon-outline arrows-2_cross-up' => 'arrows-2_cross-up' ),
					 array( 'nc-icon-outline arrows-2_cross-vertical' => 'arrows-2_cross-vertical' ),
					 array( 'nc-icon-outline arrows-2_curve-circuit' => 'arrows-2_curve-circuit' ),
					 array( 'nc-icon-outline arrows-2_curve-directions' => 'arrows-2_curve-directions' ),
					 array( 'nc-icon-outline arrows-2_curve-split' => 'arrows-2_curve-split' ),
					 array( 'nc-icon-outline arrows-2_delete-49' => 'arrows-2_delete-49' ),
					 array( 'nc-icon-outline arrows-2_delete-50' => 'arrows-2_delete-50' ),
					 array( 'nc-icon-outline arrows-2_direction' => 'arrows-2_direction' ),
					 array( 'nc-icon-outline arrows-2_dots-download' => 'arrows-2_dots-download' ),
					 array( 'nc-icon-outline arrows-2_dots-upload' => 'arrows-2_dots-upload' ),
					 array( 'nc-icon-outline arrows-2_eject' => 'arrows-2_eject' ),
					 array( 'nc-icon-outline arrows-2_enlarge-circle' => 'arrows-2_enlarge-circle' ),
					 array( 'nc-icon-outline arrows-2_file-download-87' => 'arrows-2_file-download-87' ),
					 array( 'nc-icon-outline arrows-2_file-download-89' => 'arrows-2_file-download-89' ),
					 array( 'nc-icon-outline arrows-2_file-download-94' => 'arrows-2_file-download-94' ),
					 array( 'nc-icon-outline arrows-2_file-upload-86' => 'arrows-2_file-upload-86' ),
					 array( 'nc-icon-outline arrows-2_file-upload-88' => 'arrows-2_file-upload-88' ),
					 array( 'nc-icon-outline arrows-2_file-upload-93' => 'arrows-2_file-upload-93' ),
					 array( 'nc-icon-outline arrows-2_fork-round' => 'arrows-2_fork-round' ),
					 array( 'nc-icon-outline arrows-2_fork' => 'arrows-2_fork' ),
					 array( 'nc-icon-outline arrows-2_hit-down' => 'arrows-2_hit-down' ),
					 array( 'nc-icon-outline arrows-2_hit-left' => 'arrows-2_hit-left' ),
					 array( 'nc-icon-outline arrows-2_hit-right' => 'arrows-2_hit-right' ),
					 array( 'nc-icon-outline arrows-2_hit-up' => 'arrows-2_hit-up' ),
					 array( 'nc-icon-outline arrows-2_lines' => 'arrows-2_lines' ),
					 array( 'nc-icon-outline arrows-2_log-out' => 'arrows-2_log-out' ),
					 array( 'nc-icon-outline arrows-2_loop' => 'arrows-2_loop' ),
					 array( 'nc-icon-outline arrows-2_merge-round' => 'arrows-2_merge-round' ),
					 array( 'nc-icon-outline arrows-2_merge' => 'arrows-2_merge' ),
					 array( 'nc-icon-outline arrows-2_move-05' => 'arrows-2_move-05' ),
					 array( 'nc-icon-outline arrows-2_move-06' => 'arrows-2_move-06' ),
					 array( 'nc-icon-outline arrows-2_move-92' => 'arrows-2_move-92' ),
					 array( 'nc-icon-outline arrows-2_move-down-right' => 'arrows-2_move-down-right' ),
					 array( 'nc-icon-outline arrows-2_move-down' => 'arrows-2_move-down' ),
					 array( 'nc-icon-outline arrows-2_move-left' => 'arrows-2_move-left' ),
					 array( 'nc-icon-outline arrows-2_move-right' => 'arrows-2_move-right' ),
					 array( 'nc-icon-outline arrows-2_move-up-left' => 'arrows-2_move-up-left' ),
					 array( 'nc-icon-outline arrows-2_move-up' => 'arrows-2_move-up' ),
					 array( 'nc-icon-outline arrows-2_push-next' => 'arrows-2_push-next' ),
					 array( 'nc-icon-outline arrows-2_push-previous' => 'arrows-2_push-previous' ),
					 array( 'nc-icon-outline arrows-2_reload' => 'arrows-2_reload' ),
					 array( 'nc-icon-outline arrows-2_replay' => 'arrows-2_replay' ),
					 array( 'nc-icon-outline arrows-2_rotate-left' => 'arrows-2_rotate-left' ),
					 array( 'nc-icon-outline arrows-2_rotate-right' => 'arrows-2_rotate-right' ),
					 array( 'nc-icon-outline arrows-2_round-left-down' => 'arrows-2_round-left-down' ),
					 array( 'nc-icon-outline arrows-2_round-right-down' => 'arrows-2_round-right-down' ),
					 array( 'nc-icon-outline arrows-2_round-up-left' => 'arrows-2_round-up-left' ),
					 array( 'nc-icon-outline arrows-2_round-up-right' => 'arrows-2_round-up-right' ),
					 array( 'nc-icon-outline arrows-2_select-83' => 'arrows-2_select-83' ),
					 array( 'nc-icon-outline arrows-2_select-84' => 'arrows-2_select-84' ),
					 array( 'nc-icon-outline arrows-2_separate-round' => 'arrows-2_separate-round' ),
					 array( 'nc-icon-outline arrows-2_separate' => 'arrows-2_separate' ),
					 array( 'nc-icon-outline arrows-2_share-left' => 'arrows-2_share-left' ),
					 array( 'nc-icon-outline arrows-2_share-right' => 'arrows-2_share-right' ),
					 array( 'nc-icon-outline arrows-2_skew-down' => 'arrows-2_skew-down' ),
					 array( 'nc-icon-outline arrows-2_skew-left' => 'arrows-2_skew-left' ),
					 array( 'nc-icon-outline arrows-2_skew-right' => 'arrows-2_skew-right' ),
					 array( 'nc-icon-outline arrows-2_skew-up' => 'arrows-2_skew-up' ),
					 array( 'nc-icon-outline arrows-2_small-left' => 'arrows-2_small-left' ),
					 array( 'nc-icon-outline arrows-2_small-right' => 'arrows-2_small-right' ),
					 array( 'nc-icon-outline arrows-2_split-horizontal' => 'arrows-2_split-horizontal' ),
					 array( 'nc-icon-outline arrows-2_split-round' => 'arrows-2_split-round' ),
					 array( 'nc-icon-outline arrows-2_split-vertical' => 'arrows-2_split-vertical' ),
					 array( 'nc-icon-outline arrows-2_split' => 'arrows-2_split' ),
					 array( 'nc-icon-outline arrows-2_square-download' => 'arrows-2_square-download' ),
					 array( 'nc-icon-outline arrows-2_square-upload' => 'arrows-2_square-upload' ),
					 array( 'nc-icon-outline arrows-2_time' => 'arrows-2_time' ),
					 array( 'nc-icon-outline arrows-2_triangle-down' => 'arrows-2_triangle-down' ),
					 array( 'nc-icon-outline arrows-2_triangle-left' => 'arrows-2_triangle-left' ),
					 array( 'nc-icon-outline arrows-2_triangle-right' => 'arrows-2_triangle-right' ),
					 array( 'nc-icon-outline arrows-2_triangle-up' => 'arrows-2_triangle-up' ),
					 array( 'nc-icon-outline arrows-2_unite-round' => 'arrows-2_unite-round' ),
					 array( 'nc-icon-outline arrows-2_unite' => 'arrows-2_unite' ),
					 array( 'nc-icon-outline arrows-2_zoom' => 'arrows-2_zoom' ),
					 array( 'nc-icon-outline arrows-3_circle-down' => 'arrows-3_circle-down' ),
					 array( 'nc-icon-outline arrows-3_circle-left' => 'arrows-3_circle-left' ),
					 array( 'nc-icon-outline arrows-3_circle-right' => 'arrows-3_circle-right' ),
					 array( 'nc-icon-outline arrows-3_circle-simple-down' => 'arrows-3_circle-simple-down' ),
					 array( 'nc-icon-outline arrows-3_circle-simple-left' => 'arrows-3_circle-simple-left' ),
					 array( 'nc-icon-outline arrows-3_circle-simple-right' => 'arrows-3_circle-simple-right' ),
					 array( 'nc-icon-outline arrows-3_circle-simple-up' => 'arrows-3_circle-simple-up' ),
					 array( 'nc-icon-outline arrows-3_circle-up' => 'arrows-3_circle-up' ),
					 array( 'nc-icon-outline arrows-3_cloud-refresh' => 'arrows-3_cloud-refresh' ),
					 array( 'nc-icon-outline arrows-3_separate' => 'arrows-3_separate' ),
					 array( 'nc-icon-outline arrows-3_small-down' => 'arrows-3_small-down' ),
					 array( 'nc-icon-outline arrows-3_small-up' => 'arrows-3_small-up' ),
					 array( 'nc-icon-outline arrows-3_square-corner-down-left-17' => 'arrows-3_square-corner-down-left-17' ),
					 array( 'nc-icon-outline arrows-3_square-corner-down-left-18' => 'arrows-3_square-corner-down-left-18' ),
					 array( 'nc-icon-outline arrows-3_square-corner-up-left' => 'arrows-3_square-corner-up-left' ),
					 array( 'nc-icon-outline arrows-3_square-corner-up-right' => 'arrows-3_square-corner-up-right' ),
					 array( 'nc-icon-outline arrows-3_square-down-06' => 'arrows-3_square-down-06' ),
					 array( 'nc-icon-outline arrows-3_square-down-22' => 'arrows-3_square-down-22' ),
					 array( 'nc-icon-outline arrows-3_square-enlarge' => 'arrows-3_square-enlarge' ),
					 array( 'nc-icon-outline arrows-3_square-left-04' => 'arrows-3_square-left-04' ),
					 array( 'nc-icon-outline arrows-3_square-left-20' => 'arrows-3_square-left-20' ),
					 array( 'nc-icon-outline arrows-3_square-right-03' => 'arrows-3_square-right-03' ),
					 array( 'nc-icon-outline arrows-3_square-right-19' => 'arrows-3_square-right-19' ),
					 array( 'nc-icon-outline arrows-3_square-simple-down' => 'arrows-3_square-simple-down' ),
					 array( 'nc-icon-outline arrows-3_square-simple-left' => 'arrows-3_square-simple-left' ),
					 array( 'nc-icon-outline arrows-3_square-simple-right' => 'arrows-3_square-simple-right' ),
					 array( 'nc-icon-outline arrows-3_square-simple-up' => 'arrows-3_square-simple-up' ),
					 array( 'nc-icon-outline arrows-3_square-up-05' => 'arrows-3_square-up-05' ),
					 array( 'nc-icon-outline arrows-3_square-up-21' => 'arrows-3_square-up-21' ),
					 array( 'nc-icon-outline arrows-3_square-zoom' => 'arrows-3_square-zoom' ),
					 array( 'nc-icon-outline arrows-3_super-bold-down' => 'arrows-3_super-bold-down' ),
					 array( 'nc-icon-outline arrows-3_super-bold-left' => 'arrows-3_super-bold-left' ),
					 array( 'nc-icon-outline arrows-3_super-bold-right' => 'arrows-3_super-bold-right' ),
					 array( 'nc-icon-outline arrows-3_super-bold-up' => 'arrows-3_super-bold-up' ),
				),
				'Business & Finance' => array( 
					 array( 'nc-icon-outline business_agenda' => 'business_agenda' ),
					 array( 'nc-icon-outline business_atm' => 'business_atm' ),
					 array( 'nc-icon-outline business_award-48' => 'business_award-48' ),
					 array( 'nc-icon-outline business_award-49' => 'business_award-49' ),
					 array( 'nc-icon-outline business_award-74' => 'business_award-74' ),
					 array( 'nc-icon-outline business_badge' => 'business_badge' ),
					 array( 'nc-icon-outline business_bank' => 'business_bank' ),
					 array( 'nc-icon-outline business_board-27' => 'business_board-27' ),
					 array( 'nc-icon-outline business_board-28' => 'business_board-28' ),
					 array( 'nc-icon-outline business_board-29' => 'business_board-29' ),
					 array( 'nc-icon-outline business_board-30' => 'business_board-30' ),
					 array( 'nc-icon-outline business_books' => 'business_books' ),
					 array( 'nc-icon-outline business_briefcase-24' => 'business_briefcase-24' ),
					 array( 'nc-icon-outline business_briefcase-25' => 'business_briefcase-25' ),
					 array( 'nc-icon-outline business_briefcase-26' => 'business_briefcase-26' ),
					 array( 'nc-icon-outline business_building' => 'business_building' ),
					 array( 'nc-icon-outline business_bulb-61' => 'business_bulb-61' ),
					 array( 'nc-icon-outline business_bulb-62' => 'business_bulb-62' ),
					 array( 'nc-icon-outline business_bulb-63' => 'business_bulb-63' ),
					 array( 'nc-icon-outline business_business-contact-85' => 'business_business-contact-85' ),
					 array( 'nc-icon-outline business_business-contact-86' => 'business_business-contact-86' ),
					 array( 'nc-icon-outline business_business-contact-87' => 'business_business-contact-87' ),
					 array( 'nc-icon-outline business_business-contact-88' => 'business_business-contact-88' ),
					 array( 'nc-icon-outline business_business-contact-89' => 'business_business-contact-89' ),
					 array( 'nc-icon-outline business_businessman-03' => 'business_businessman-03' ),
					 array( 'nc-icon-outline business_businessman-04' => 'business_businessman-04' ),
					 array( 'nc-icon-outline business_calculator' => 'business_calculator' ),
					 array( 'nc-icon-outline business_chair' => 'business_chair' ),
					 array( 'nc-icon-outline business_chart-bar-32' => 'business_chart-bar-32' ),
					 array( 'nc-icon-outline business_chart-bar-33' => 'business_chart-bar-33' ),
					 array( 'nc-icon-outline business_chart-growth' => 'business_chart-growth' ),
					 array( 'nc-icon-outline business_chart-pie-35' => 'business_chart-pie-35' ),
					 array( 'nc-icon-outline business_chart-pie-36' => 'business_chart-pie-36' ),
					 array( 'nc-icon-outline business_chart' => 'business_chart' ),
					 array( 'nc-icon-outline business_cheque' => 'business_cheque' ),
					 array( 'nc-icon-outline business_coins' => 'business_coins' ),
					 array( 'nc-icon-outline business_connect' => 'business_connect' ),
					 array( 'nc-icon-outline business_contacts' => 'business_contacts' ),
					 array( 'nc-icon-outline business_currency-dollar' => 'business_currency-dollar' ),
					 array( 'nc-icon-outline business_currency-euro' => 'business_currency-euro' ),
					 array( 'nc-icon-outline business_currency-pound' => 'business_currency-pound' ),
					 array( 'nc-icon-outline business_currency-yen' => 'business_currency-yen' ),
					 array( 'nc-icon-outline business_factory' => 'business_factory' ),
					 array( 'nc-icon-outline business_globe' => 'business_globe' ),
					 array( 'nc-icon-outline business_goal-64' => 'business_goal-64' ),
					 array( 'nc-icon-outline business_goal-65' => 'business_goal-65' ),
					 array( 'nc-icon-outline business_gold' => 'business_gold' ),
					 array( 'nc-icon-outline business_hammer' => 'business_hammer' ),
					 array( 'nc-icon-outline business_handout' => 'business_handout' ),
					 array( 'nc-icon-outline business_handshake' => 'business_handshake' ),
					 array( 'nc-icon-outline business_hat' => 'business_hat' ),
					 array( 'nc-icon-outline business_hierarchy-53' => 'business_hierarchy-53' ),
					 array( 'nc-icon-outline business_hierarchy-54' => 'business_hierarchy-54' ),
					 array( 'nc-icon-outline business_hierarchy-55' => 'business_hierarchy-55' ),
					 array( 'nc-icon-outline business_hierarchy-56' => 'business_hierarchy-56' ),
					 array( 'nc-icon-outline business_laptop-71' => 'business_laptop-71' ),
					 array( 'nc-icon-outline business_laptop-72' => 'business_laptop-72' ),
					 array( 'nc-icon-outline business_laptop-91' => 'business_laptop-91' ),
					 array( 'nc-icon-outline business_law' => 'business_law' ),
					 array( 'nc-icon-outline business_math' => 'business_math' ),
					 array( 'nc-icon-outline business_money-11' => 'business_money-11' ),
					 array( 'nc-icon-outline business_money-12' => 'business_money-12' ),
					 array( 'nc-icon-outline business_money-13' => 'business_money-13' ),
					 array( 'nc-icon-outline business_money-bag' => 'business_money-bag' ),
					 array( 'nc-icon-outline business_money-coins' => 'business_money-coins' ),
					 array( 'nc-icon-outline business_money-growth' => 'business_money-growth' ),
					 array( 'nc-icon-outline business_money-time' => 'business_money-time' ),
					 array( 'nc-icon-outline business_net' => 'business_net' ),
					 array( 'nc-icon-outline business_notes' => 'business_notes' ),
					 array( 'nc-icon-outline business_payment' => 'business_payment' ),
					 array( 'nc-icon-outline business_percentage-38' => 'business_percentage-38' ),
					 array( 'nc-icon-outline business_percentage-39' => 'business_percentage-39' ),
					 array( 'nc-icon-outline business_pig' => 'business_pig' ),
					 array( 'nc-icon-outline business_pin' => 'business_pin' ),
					 array( 'nc-icon-outline business_plug' => 'business_plug' ),
					 array( 'nc-icon-outline business_progress' => 'business_progress' ),
					 array( 'nc-icon-outline business_round-dollar' => 'business_round-dollar' ),
					 array( 'nc-icon-outline business_round-euro' => 'business_round-euro' ),
					 array( 'nc-icon-outline business_round-pound' => 'business_round-pound' ),
					 array( 'nc-icon-outline business_round-yen' => 'business_round-yen' ),
					 array( 'nc-icon-outline business_safe' => 'business_safe' ),
					 array( 'nc-icon-outline business_scale' => 'business_scale' ),
					 array( 'nc-icon-outline business_sign' => 'business_sign' ),
					 array( 'nc-icon-outline business_signature' => 'business_signature' ),
					 array( 'nc-icon-outline business_stock' => 'business_stock' ),
					 array( 'nc-icon-outline business_strategy' => 'business_strategy' ),
					 array( 'nc-icon-outline business_tie-01' => 'business_tie-01' ),
					 array( 'nc-icon-outline business_tie-02' => 'business_tie-02' ),
					 array( 'nc-icon-outline business_wallet-43' => 'business_wallet-43' ),
					 array( 'nc-icon-outline business_wallet-44' => 'business_wallet-44' ),
					 array( 'nc-icon-outline business_wallet-90' => 'business_wallet-90' ),
				),
				'Clothes & Accessories' => array( 
					 array( 'nc-icon-outline clothes_baby' => 'clothes_baby' ),
					 array( 'nc-icon-outline clothes_backpack' => 'clothes_backpack' ),
					 array( 'nc-icon-outline clothes_bag-21' => 'clothes_bag-21' ),
					 array( 'nc-icon-outline clothes_bag-22' => 'clothes_bag-22' ),
					 array( 'nc-icon-outline clothes_belt' => 'clothes_belt' ),
					 array( 'nc-icon-outline clothes_boot-woman' => 'clothes_boot-woman' ),
					 array( 'nc-icon-outline clothes_boot' => 'clothes_boot' ),
					 array( 'nc-icon-outline clothes_bra' => 'clothes_bra' ),
					 array( 'nc-icon-outline clothes_button' => 'clothes_button' ),
					 array( 'nc-icon-outline clothes_cap' => 'clothes_cap' ),
					 array( 'nc-icon-outline clothes_coat' => 'clothes_coat' ),
					 array( 'nc-icon-outline clothes_corset' => 'clothes_corset' ),
					 array( 'nc-icon-outline clothes_dress-man' => 'clothes_dress-man' ),
					 array( 'nc-icon-outline clothes_dress-woman' => 'clothes_dress-woman' ),
					 array( 'nc-icon-outline clothes_flip' => 'clothes_flip' ),
					 array( 'nc-icon-outline clothes_glasses' => 'clothes_glasses' ),
					 array( 'nc-icon-outline clothes_gloves' => 'clothes_gloves' ),
					 array( 'nc-icon-outline clothes_hat-top' => 'clothes_hat-top' ),
					 array( 'nc-icon-outline clothes_hat' => 'clothes_hat' ),
					 array( 'nc-icon-outline clothes_hoodie' => 'clothes_hoodie' ),
					 array( 'nc-icon-outline clothes_iron-dont' => 'clothes_iron-dont' ),
					 array( 'nc-icon-outline clothes_iron' => 'clothes_iron' ),
					 array( 'nc-icon-outline clothes_jeans-41' => 'clothes_jeans-41' ),
					 array( 'nc-icon-outline clothes_jeans-43' => 'clothes_jeans-43' ),
					 array( 'nc-icon-outline clothes_jeans-pocket' => 'clothes_jeans-pocket' ),
					 array( 'nc-icon-outline clothes_kitchen' => 'clothes_kitchen' ),
					 array( 'nc-icon-outline clothes_long-sleeve' => 'clothes_long-sleeve' ),
					 array( 'nc-icon-outline clothes_makeup' => 'clothes_makeup' ),
					 array( 'nc-icon-outline clothes_needle' => 'clothes_needle' ),
					 array( 'nc-icon-outline clothes_pajamas' => 'clothes_pajamas' ),
					 array( 'nc-icon-outline clothes_ring' => 'clothes_ring' ),
					 array( 'nc-icon-outline clothes_scarf' => 'clothes_scarf' ),
					 array( 'nc-icon-outline clothes_shirt-business' => 'clothes_shirt-business' ),
					 array( 'nc-icon-outline clothes_shirt-buttons' => 'clothes_shirt-buttons' ),
					 array( 'nc-icon-outline clothes_shirt-neck' => 'clothes_shirt-neck' ),
					 array( 'nc-icon-outline clothes_shirt' => 'clothes_shirt' ),
					 array( 'nc-icon-outline clothes_shoe-man' => 'clothes_shoe-man' ),
					 array( 'nc-icon-outline clothes_shoe-sport' => 'clothes_shoe-sport' ),
					 array( 'nc-icon-outline clothes_shoe-woman' => 'clothes_shoe-woman' ),
					 array( 'nc-icon-outline clothes_skirt' => 'clothes_skirt' ),
					 array( 'nc-icon-outline clothes_slacks-12' => 'clothes_slacks-12' ),
					 array( 'nc-icon-outline clothes_slacks-13' => 'clothes_slacks-13' ),
					 array( 'nc-icon-outline clothes_sock' => 'clothes_sock' ),
					 array( 'nc-icon-outline clothes_tie-bow' => 'clothes_tie-bow' ),
					 array( 'nc-icon-outline clothes_tshirt-53' => 'clothes_tshirt-53' ),
					 array( 'nc-icon-outline clothes_tshirt-54' => 'clothes_tshirt-54' ),
					 array( 'nc-icon-outline clothes_tshirt-sport' => 'clothes_tshirt-sport' ),
					 array( 'nc-icon-outline clothes_underwear-man' => 'clothes_underwear-man' ),
					 array( 'nc-icon-outline clothes_underwear' => 'clothes_underwear' ),
					 array( 'nc-icon-outline clothes_vest-sport' => 'clothes_vest-sport' ),
					 array( 'nc-icon-outline clothes_vest' => 'clothes_vest' ),
					 array( 'nc-icon-outline clothes_wash-30' => 'clothes_wash-30' ),
					 array( 'nc-icon-outline clothes_wash-60' => 'clothes_wash-60' ),
					 array( 'nc-icon-outline clothes_wash-90' => 'clothes_wash-90' ),
					 array( 'nc-icon-outline clothes_wash-hand' => 'clothes_wash-hand' ),
					 array( 'nc-icon-outline clothes_wash' => 'clothes_wash' ),
				),
				'Design & Development' => array( 
					 array( 'nc-icon-outline design_album' => 'design_album' ),
					 array( 'nc-icon-outline design_align-bottom' => 'design_align-bottom' ),
					 array( 'nc-icon-outline design_align-center-horizontal' => 'design_align-center-horizontal' ),
					 array( 'nc-icon-outline design_align-center-vertical' => 'design_align-center-vertical' ),
					 array( 'nc-icon-outline design_align-left' => 'design_align-left' ),
					 array( 'nc-icon-outline design_align-right' => 'design_align-right' ),
					 array( 'nc-icon-outline design_align-top' => 'design_align-top' ),
					 array( 'nc-icon-outline design_app' => 'design_app' ),
					 array( 'nc-icon-outline design_artboard' => 'design_artboard' ),
					 array( 'nc-icon-outline design_blend' => 'design_blend' ),
					 array( 'nc-icon-outline design_book-bookmark' => 'design_book-bookmark' ),
					 array( 'nc-icon-outline design_book-open' => 'design_book-open' ),
					 array( 'nc-icon-outline design_brush' => 'design_brush' ),
					 array( 'nc-icon-outline design_bug' => 'design_bug' ),
					 array( 'nc-icon-outline design_bullet-list-67' => 'design_bullet-list-67' ),
					 array( 'nc-icon-outline design_bullet-list-68' => 'design_bullet-list-68' ),
					 array( 'nc-icon-outline design_bullet-list-69' => 'design_bullet-list-69' ),
					 array( 'nc-icon-outline design_bullet-list-70' => 'design_bullet-list-70' ),
					 array( 'nc-icon-outline design_clone' => 'design_clone' ),
					 array( 'nc-icon-outline design_code-editor' => 'design_code-editor' ),
					 array( 'nc-icon-outline design_code' => 'design_code' ),
					 array( 'nc-icon-outline design_collection' => 'design_collection' ),
					 array( 'nc-icon-outline design_command' => 'design_command' ),
					 array( 'nc-icon-outline design_compass' => 'design_compass' ),
					 array( 'nc-icon-outline design_contrast' => 'design_contrast' ),
					 array( 'nc-icon-outline design_copy' => 'design_copy' ),
					 array( 'nc-icon-outline design_crop' => 'design_crop' ),
					 array( 'nc-icon-outline design_cursor-48' => 'design_cursor-48' ),
					 array( 'nc-icon-outline design_cursor-49' => 'design_cursor-49' ),
					 array( 'nc-icon-outline design_design-dev' => 'design_design-dev' ),
					 array( 'nc-icon-outline design_design' => 'design_design' ),
					 array( 'nc-icon-outline design_distribute-horizontal' => 'design_distribute-horizontal' ),
					 array( 'nc-icon-outline design_distribute-vertical' => 'design_distribute-vertical' ),
					 array( 'nc-icon-outline design_drag' => 'design_drag' ),
					 array( 'nc-icon-outline design_eraser-32' => 'design_eraser-32' ),
					 array( 'nc-icon-outline design_eraser-33' => 'design_eraser-33' ),
					 array( 'nc-icon-outline design_eraser-46' => 'design_eraser-46' ),
					 array( 'nc-icon-outline design_flip-horizontal' => 'design_flip-horizontal' ),
					 array( 'nc-icon-outline design_flip-vertical' => 'design_flip-vertical' ),
					 array( 'nc-icon-outline design_image' => 'design_image' ),
					 array( 'nc-icon-outline design_magnet' => 'design_magnet' ),
					 array( 'nc-icon-outline design_marker' => 'design_marker' ),
					 array( 'nc-icon-outline design_measure-02' => 'design_measure-02' ),
					 array( 'nc-icon-outline design_measure-17' => 'design_measure-17' ),
					 array( 'nc-icon-outline design_measure-big' => 'design_measure-big' ),
					 array( 'nc-icon-outline design_mobile-design' => 'design_mobile-design' ),
					 array( 'nc-icon-outline design_mobile-dev' => 'design_mobile-dev' ),
					 array( 'nc-icon-outline design_mouse-08' => 'design_mouse-08' ),
					 array( 'nc-icon-outline design_mouse-09' => 'design_mouse-09' ),
					 array( 'nc-icon-outline design_mouse-10' => 'design_mouse-10' ),
					 array( 'nc-icon-outline design_newsletter-dev' => 'design_newsletter-dev' ),
					 array( 'nc-icon-outline design_note-code' => 'design_note-code' ),
					 array( 'nc-icon-outline design_paint-16' => 'design_paint-16' ),
					 array( 'nc-icon-outline design_paint-37' => 'design_paint-37' ),
					 array( 'nc-icon-outline design_paint-38' => 'design_paint-38' ),
					 array( 'nc-icon-outline design_paint-bucket-39' => 'design_paint-bucket-39' ),
					 array( 'nc-icon-outline design_paint-bucket-40' => 'design_paint-bucket-40' ),
					 array( 'nc-icon-outline design_palette' => 'design_palette' ),
					 array( 'nc-icon-outline design_pantone' => 'design_pantone' ),
					 array( 'nc-icon-outline design_paper-design' => 'design_paper-design' ),
					 array( 'nc-icon-outline design_paper-dev' => 'design_paper-dev' ),
					 array( 'nc-icon-outline design_patch-19' => 'design_patch-19' ),
					 array( 'nc-icon-outline design_patch-34' => 'design_patch-34' ),
					 array( 'nc-icon-outline design_path-exclude' => 'design_path-exclude' ),
					 array( 'nc-icon-outline design_path-intersect' => 'design_path-intersect' ),
					 array( 'nc-icon-outline design_path-minus' => 'design_path-minus' ),
					 array( 'nc-icon-outline design_path-unite' => 'design_path-unite' ),
					 array( 'nc-icon-outline design_pen-01' => 'design_pen-01' ),
					 array( 'nc-icon-outline design_pen-23' => 'design_pen-23' ),
					 array( 'nc-icon-outline design_pen-tool' => 'design_pen-tool' ),
					 array( 'nc-icon-outline design_phone' => 'design_phone' ),
					 array( 'nc-icon-outline design_photo-editor' => 'design_photo-editor' ),
					 array( 'nc-icon-outline design_responsive' => 'design_responsive' ),
					 array( 'nc-icon-outline design_scissors-dashed' => 'design_scissors-dashed' ),
					 array( 'nc-icon-outline design_scissors' => 'design_scissors' ),
					 array( 'nc-icon-outline design_shape-adjust' => 'design_shape-adjust' ),
					 array( 'nc-icon-outline design_shape-circle' => 'design_shape-circle' ),
					 array( 'nc-icon-outline design_shape-polygon' => 'design_shape-polygon' ),
					 array( 'nc-icon-outline design_shape-square' => 'design_shape-square' ),
					 array( 'nc-icon-outline design_shape-triangle' => 'design_shape-triangle' ),
					 array( 'nc-icon-outline design_shapes' => 'design_shapes' ),
					 array( 'nc-icon-outline design_sharpener' => 'design_sharpener' ),
					 array( 'nc-icon-outline design_slice' => 'design_slice' ),
					 array( 'nc-icon-outline design_spray' => 'design_spray' ),
					 array( 'nc-icon-outline design_stamp' => 'design_stamp' ),
					 array( 'nc-icon-outline design_tablet-mobile' => 'design_tablet-mobile' ),
					 array( 'nc-icon-outline design_tablet' => 'design_tablet' ),
					 array( 'nc-icon-outline design_text' => 'design_text' ),
					 array( 'nc-icon-outline design_todo' => 'design_todo' ),
					 array( 'nc-icon-outline design_usb' => 'design_usb' ),
					 array( 'nc-icon-outline design_vector' => 'design_vector' ),
					 array( 'nc-icon-outline design_wand-11' => 'design_wand-11' ),
					 array( 'nc-icon-outline design_wand-99' => 'design_wand-99' ),
					 array( 'nc-icon-outline design_watch-dev' => 'design_watch-dev' ),
					 array( 'nc-icon-outline design_web-design' => 'design_web-design' ),
					 array( 'nc-icon-outline design_webpage' => 'design_webpage' ),
					 array( 'nc-icon-outline design_window-code' => 'design_window-code' ),
					 array( 'nc-icon-outline design_window-dev' => 'design_window-dev' ),
					 array( 'nc-icon-outline design_window-paragraph' => 'design_window-paragraph' ),
					 array( 'nc-icon-outline design_window-responsive' => 'design_window-responsive' ),
					 array( 'nc-icon-outline design-2_3d-28' => 'design-2_3d-28' ),
					 array( 'nc-icon-outline design-2_3d-29' => 'design-2_3d-29' ),
					 array( 'nc-icon-outline design-2_android' => 'design-2_android' ),
					 array( 'nc-icon-outline design-2_angle' => 'design-2_angle' ),
					 array( 'nc-icon-outline design-2_animation-14' => 'design-2_animation-14' ),
					 array( 'nc-icon-outline design-2_animation-31' => 'design-2_animation-31' ),
					 array( 'nc-icon-outline design-2_animation-32' => 'design-2_animation-32' ),
					 array( 'nc-icon-outline design-2_apple' => 'design-2_apple' ),
					 array( 'nc-icon-outline design-2_browser-chrome' => 'design-2_browser-chrome' ),
					 array( 'nc-icon-outline design-2_browser-edge' => 'design-2_browser-edge' ),
					 array( 'nc-icon-outline design-2_browser-firefox' => 'design-2_browser-firefox' ),
					 array( 'nc-icon-outline design-2_browser-ie' => 'design-2_browser-ie' ),
					 array( 'nc-icon-outline design-2_browser-opera' => 'design-2_browser-opera' ),
					 array( 'nc-icon-outline design-2_browser-safari' => 'design-2_browser-safari' ),
					 array( 'nc-icon-outline design-2_bucket' => 'design-2_bucket' ),
					 array( 'nc-icon-outline design-2_button' => 'design-2_button' ),
					 array( 'nc-icon-outline design-2_canvas' => 'design-2_canvas' ),
					 array( 'nc-icon-outline design-2_css3' => 'design-2_css3' ),
					 array( 'nc-icon-outline design-2_cursor-add' => 'design-2_cursor-add' ),
					 array( 'nc-icon-outline design-2_cursor-grab' => 'design-2_cursor-grab' ),
					 array( 'nc-icon-outline design-2_cursor-load' => 'design-2_cursor-load' ),
					 array( 'nc-icon-outline design-2_cursor-menu' => 'design-2_cursor-menu' ),
					 array( 'nc-icon-outline design-2_cursor-not-allowed' => 'design-2_cursor-not-allowed' ),
					 array( 'nc-icon-outline design-2_cursor-pointer' => 'design-2_cursor-pointer' ),
					 array( 'nc-icon-outline design-2_cursor-text' => 'design-2_cursor-text' ),
					 array( 'nc-icon-outline design-2_divider' => 'design-2_divider' ),
					 array( 'nc-icon-outline design-2_filter-organization' => 'design-2_filter-organization' ),
					 array( 'nc-icon-outline design-2_form' => 'design-2_form' ),
					 array( 'nc-icon-outline design-2_frame' => 'design-2_frame' ),
					 array( 'nc-icon-outline design-2_group' => 'design-2_group' ),
					 array( 'nc-icon-outline design-2_html5' => 'design-2_html5' ),
					 array( 'nc-icon-outline design-2_image' => 'design-2_image' ),
					 array( 'nc-icon-outline design-2_layers' => 'design-2_layers' ),
					 array( 'nc-icon-outline design-2_layout-11' => 'design-2_layout-11' ),
					 array( 'nc-icon-outline design-2_layout-25' => 'design-2_layout-25' ),
					 array( 'nc-icon-outline design-2_microsoft' => 'design-2_microsoft' ),
					 array( 'nc-icon-outline design-2_mirror' => 'design-2_mirror' ),
					 array( 'nc-icon-outline design-2_move-down' => 'design-2_move-down' ),
					 array( 'nc-icon-outline design-2_move-up' => 'design-2_move-up' ),
					 array( 'nc-icon-outline design-2_paint-brush' => 'design-2_paint-brush' ),
					 array( 'nc-icon-outline design-2_ruler-pencil' => 'design-2_ruler-pencil' ),
					 array( 'nc-icon-outline design-2_scale-down' => 'design-2_scale-down' ),
					 array( 'nc-icon-outline design-2_scale-up' => 'design-2_scale-up' ),
					 array( 'nc-icon-outline design-2_scale' => 'design-2_scale' ),
					 array( 'nc-icon-outline design-2_selection' => 'design-2_selection' ),
					 array( 'nc-icon-outline design-2_slider' => 'design-2_slider' ),
					 array( 'nc-icon-outline design-2_text' => 'design-2_text' ),
					 array( 'nc-icon-outline design-2_transform-origin' => 'design-2_transform-origin' ),
					 array( 'nc-icon-outline design-2_transform' => 'design-2_transform' ),
					 array( 'nc-icon-outline design-2_ungroup' => 'design-2_ungroup' ),
				),
				'Emoticons' => array( 
					 array( 'nc-icon-outline emoticons_alien' => 'emoticons_alien' ),
					 array( 'nc-icon-outline emoticons_angry-10' => 'emoticons_angry-10' ),
					 array( 'nc-icon-outline emoticons_angry-44' => 'emoticons_angry-44' ),
					 array( 'nc-icon-outline emoticons_big-eyes' => 'emoticons_big-eyes' ),
					 array( 'nc-icon-outline emoticons_big-smile' => 'emoticons_big-smile' ),
					 array( 'nc-icon-outline emoticons_bigmouth' => 'emoticons_bigmouth' ),
					 array( 'nc-icon-outline emoticons_bleah' => 'emoticons_bleah' ),
					 array( 'nc-icon-outline emoticons_blind' => 'emoticons_blind' ),
					 array( 'nc-icon-outline emoticons_bomb' => 'emoticons_bomb' ),
					 array( 'nc-icon-outline emoticons_bored' => 'emoticons_bored' ),
					 array( 'nc-icon-outline emoticons_cake' => 'emoticons_cake' ),
					 array( 'nc-icon-outline emoticons_cry-15' => 'emoticons_cry-15' ),
					 array( 'nc-icon-outline emoticons_cry-57' => 'emoticons_cry-57' ),
					 array( 'nc-icon-outline emoticons_cute' => 'emoticons_cute' ),
					 array( 'nc-icon-outline emoticons_devil' => 'emoticons_devil' ),
					 array( 'nc-icon-outline emoticons_disgusted' => 'emoticons_disgusted' ),
					 array( 'nc-icon-outline emoticons_fist' => 'emoticons_fist' ),
					 array( 'nc-icon-outline emoticons_ghost' => 'emoticons_ghost' ),
					 array( 'nc-icon-outline emoticons_hannibal' => 'emoticons_hannibal' ),
					 array( 'nc-icon-outline emoticons_happy-sun' => 'emoticons_happy-sun' ),
					 array( 'nc-icon-outline emoticons_kid' => 'emoticons_kid' ),
					 array( 'nc-icon-outline emoticons_kiss' => 'emoticons_kiss' ),
					 array( 'nc-icon-outline emoticons_laugh-17' => 'emoticons_laugh-17' ),
					 array( 'nc-icon-outline emoticons_laugh-35' => 'emoticons_laugh-35' ),
					 array( 'nc-icon-outline emoticons_like-no' => 'emoticons_like-no' ),
					 array( 'nc-icon-outline emoticons_like' => 'emoticons_like' ),
					 array( 'nc-icon-outline emoticons_mad-12' => 'emoticons_mad-12' ),
					 array( 'nc-icon-outline emoticons_mad-58' => 'emoticons_mad-58' ),
					 array( 'nc-icon-outline emoticons_malicious' => 'emoticons_malicious' ),
					 array( 'nc-icon-outline emoticons_manga-62' => 'emoticons_manga-62' ),
					 array( 'nc-icon-outline emoticons_manga-63' => 'emoticons_manga-63' ),
					 array( 'nc-icon-outline emoticons_monster' => 'emoticons_monster' ),
					 array( 'nc-icon-outline emoticons_nerd-22' => 'emoticons_nerd-22' ),
					 array( 'nc-icon-outline emoticons_nerd-23' => 'emoticons_nerd-23' ),
					 array( 'nc-icon-outline emoticons_ninja' => 'emoticons_ninja' ),
					 array( 'nc-icon-outline emoticons_no-words' => 'emoticons_no-words' ),
					 array( 'nc-icon-outline emoticons_parrot' => 'emoticons_parrot' ),
					 array( 'nc-icon-outline emoticons_penguin' => 'emoticons_penguin' ),
					 array( 'nc-icon-outline emoticons_pirate' => 'emoticons_pirate' ),
					 array( 'nc-icon-outline emoticons_poop' => 'emoticons_poop' ),
					 array( 'nc-icon-outline emoticons_puzzled' => 'emoticons_puzzled' ),
					 array( 'nc-icon-outline emoticons_quite-happy' => 'emoticons_quite-happy' ),
					 array( 'nc-icon-outline emoticons_robot' => 'emoticons_robot' ),
					 array( 'nc-icon-outline emoticons_rock' => 'emoticons_rock' ),
					 array( 'nc-icon-outline emoticons_sad' => 'emoticons_sad' ),
					 array( 'nc-icon-outline emoticons_satisfied' => 'emoticons_satisfied' ),
					 array( 'nc-icon-outline emoticons_shark' => 'emoticons_shark' ),
					 array( 'nc-icon-outline emoticons_shy' => 'emoticons_shy' ),
					 array( 'nc-icon-outline emoticons_sick' => 'emoticons_sick' ),
					 array( 'nc-icon-outline emoticons_silly' => 'emoticons_silly' ),
					 array( 'nc-icon-outline emoticons_skull' => 'emoticons_skull' ),
					 array( 'nc-icon-outline emoticons_sleep' => 'emoticons_sleep' ),
					 array( 'nc-icon-outline emoticons_sloth' => 'emoticons_sloth' ),
					 array( 'nc-icon-outline emoticons_smart' => 'emoticons_smart' ),
					 array( 'nc-icon-outline emoticons_smile' => 'emoticons_smile' ),
					 array( 'nc-icon-outline emoticons_soldier' => 'emoticons_soldier' ),
					 array( 'nc-icon-outline emoticons_speechless' => 'emoticons_speechless' ),
					 array( 'nc-icon-outline emoticons_spiteful' => 'emoticons_spiteful' ),
					 array( 'nc-icon-outline emoticons_sunglasses-48' => 'emoticons_sunglasses-48' ),
					 array( 'nc-icon-outline emoticons_sunglasses-49' => 'emoticons_sunglasses-49' ),
					 array( 'nc-icon-outline emoticons_surprise' => 'emoticons_surprise' ),
					 array( 'nc-icon-outline emoticons_upset-13' => 'emoticons_upset-13' ),
					 array( 'nc-icon-outline emoticons_upset-14' => 'emoticons_upset-14' ),
					 array( 'nc-icon-outline emoticons_virus' => 'emoticons_virus' ),
					 array( 'nc-icon-outline emoticons_what' => 'emoticons_what' ),
					 array( 'nc-icon-outline emoticons_whiskers' => 'emoticons_whiskers' ),
					 array( 'nc-icon-outline emoticons_wink-06' => 'emoticons_wink-06' ),
					 array( 'nc-icon-outline emoticons_wink-11' => 'emoticons_wink-11' ),
					 array( 'nc-icon-outline emoticons_wink-69' => 'emoticons_wink-69' ),
				),
				'Energy & Environment' => array( 
					 array( 'nc-icon-outline envir_bulb-saver' => 'envir_bulb-saver' ),
					 array( 'nc-icon-outline envir_bulb' => 'envir_bulb' ),
					 array( 'nc-icon-outline envir_car' => 'envir_car' ),
					 array( 'nc-icon-outline envir_fuel-electric' => 'envir_fuel-electric' ),
					 array( 'nc-icon-outline envir_fuel' => 'envir_fuel' ),
					 array( 'nc-icon-outline envir_home' => 'envir_home' ),
					 array( 'nc-icon-outline envir_level' => 'envir_level' ),
					 array( 'nc-icon-outline envir_panel' => 'envir_panel' ),
					 array( 'nc-icon-outline envir_radiation' => 'envir_radiation' ),
					 array( 'nc-icon-outline envir_recycling' => 'envir_recycling' ),
					 array( 'nc-icon-outline envir_save-planet' => 'envir_save-planet' ),
					 array( 'nc-icon-outline envir_waste-danger' => 'envir_waste-danger' ),
					 array( 'nc-icon-outline envir_waste-recycling' => 'envir_waste-recycling' ),
					 array( 'nc-icon-outline envir_waste' => 'envir_waste' ),
					 array( 'nc-icon-outline envir_water-hand' => 'envir_water-hand' ),
					 array( 'nc-icon-outline envir_water-sink' => 'envir_water-sink' ),
					 array( 'nc-icon-outline envir_water' => 'envir_water' ),
					 array( 'nc-icon-outline envir_wind' => 'envir_wind' ),
				),
				'Files & Folders' => array( 
					 array( 'nc-icon-outline files_add' => 'files_add' ),
					 array( 'nc-icon-outline files_archive-3d-check' => 'files_archive-3d-check' ),
					 array( 'nc-icon-outline files_archive-3d-content' => 'files_archive-3d-content' ),
					 array( 'nc-icon-outline files_archive-check' => 'files_archive-check' ),
					 array( 'nc-icon-outline files_archive-content' => 'files_archive-content' ),
					 array( 'nc-icon-outline files_archive-paper-check' => 'files_archive-paper-check' ),
					 array( 'nc-icon-outline files_archive-paper' => 'files_archive-paper' ),
					 array( 'nc-icon-outline files_archive' => 'files_archive' ),
					 array( 'nc-icon-outline files_audio' => 'files_audio' ),
					 array( 'nc-icon-outline files_book-07' => 'files_book-07' ),
					 array( 'nc-icon-outline files_book-08' => 'files_book-08' ),
					 array( 'nc-icon-outline files_bookmark' => 'files_bookmark' ),
					 array( 'nc-icon-outline files_box' => 'files_box' ),
					 array( 'nc-icon-outline files_chart-bar' => 'files_chart-bar' ),
					 array( 'nc-icon-outline files_chart-pie' => 'files_chart-pie' ),
					 array( 'nc-icon-outline files_check' => 'files_check' ),
					 array( 'nc-icon-outline files_cloud' => 'files_cloud' ),
					 array( 'nc-icon-outline files_copy' => 'files_copy' ),
					 array( 'nc-icon-outline files_dev' => 'files_dev' ),
					 array( 'nc-icon-outline files_download' => 'files_download' ),
					 array( 'nc-icon-outline files_drawer' => 'files_drawer' ),
					 array( 'nc-icon-outline files_edit' => 'files_edit' ),
					 array( 'nc-icon-outline files_exclamation' => 'files_exclamation' ),
					 array( 'nc-icon-outline files_folder-13' => 'files_folder-13' ),
					 array( 'nc-icon-outline files_folder-14' => 'files_folder-14' ),
					 array( 'nc-icon-outline files_folder-15' => 'files_folder-15' ),
					 array( 'nc-icon-outline files_folder-16' => 'files_folder-16' ),
					 array( 'nc-icon-outline files_folder-17' => 'files_folder-17' ),
					 array( 'nc-icon-outline files_folder-18' => 'files_folder-18' ),
					 array( 'nc-icon-outline files_folder-19' => 'files_folder-19' ),
					 array( 'nc-icon-outline files_folder-add' => 'files_folder-add' ),
					 array( 'nc-icon-outline files_folder-audio' => 'files_folder-audio' ),
					 array( 'nc-icon-outline files_folder-bookmark' => 'files_folder-bookmark' ),
					 array( 'nc-icon-outline files_folder-chart-bar' => 'files_folder-chart-bar' ),
					 array( 'nc-icon-outline files_folder-chart-pie' => 'files_folder-chart-pie' ),
					 array( 'nc-icon-outline files_folder-check' => 'files_folder-check' ),
					 array( 'nc-icon-outline files_folder-cloud' => 'files_folder-cloud' ),
					 array( 'nc-icon-outline files_folder-dev' => 'files_folder-dev' ),
					 array( 'nc-icon-outline files_folder-download' => 'files_folder-download' ),
					 array( 'nc-icon-outline files_folder-edit' => 'files_folder-edit' ),
					 array( 'nc-icon-outline files_folder-exclamation' => 'files_folder-exclamation' ),
					 array( 'nc-icon-outline files_folder-gallery' => 'files_folder-gallery' ),
					 array( 'nc-icon-outline files_folder-heart' => 'files_folder-heart' ),
					 array( 'nc-icon-outline files_folder-image' => 'files_folder-image' ),
					 array( 'nc-icon-outline files_folder-info' => 'files_folder-info' ),
					 array( 'nc-icon-outline files_folder-link' => 'files_folder-link' ),
					 array( 'nc-icon-outline files_folder-locked' => 'files_folder-locked' ),
					 array( 'nc-icon-outline files_folder-money' => 'files_folder-money' ),
					 array( 'nc-icon-outline files_folder-music' => 'files_folder-music' ),
					 array( 'nc-icon-outline files_folder-no-access' => 'files_folder-no-access' ),
					 array( 'nc-icon-outline files_folder-play' => 'files_folder-play' ),
					 array( 'nc-icon-outline files_folder-question' => 'files_folder-question' ),
					 array( 'nc-icon-outline files_folder-refresh' => 'files_folder-refresh' ),
					 array( 'nc-icon-outline files_folder-remove' => 'files_folder-remove' ),
					 array( 'nc-icon-outline files_folder-search' => 'files_folder-search' ),
					 array( 'nc-icon-outline files_folder-settings-81' => 'files_folder-settings-81' ),
					 array( 'nc-icon-outline files_folder-settings-97' => 'files_folder-settings-97' ),
					 array( 'nc-icon-outline files_folder-shared' => 'files_folder-shared' ),
					 array( 'nc-icon-outline files_folder-star' => 'files_folder-star' ),
					 array( 'nc-icon-outline files_folder-time' => 'files_folder-time' ),
					 array( 'nc-icon-outline files_folder-upload' => 'files_folder-upload' ),
					 array( 'nc-icon-outline files_folder-user' => 'files_folder-user' ),
					 array( 'nc-icon-outline files_folder-vector' => 'files_folder-vector' ),
					 array( 'nc-icon-outline files_gallery' => 'files_gallery' ),
					 array( 'nc-icon-outline files_heart' => 'files_heart' ),
					 array( 'nc-icon-outline files_image' => 'files_image' ),
					 array( 'nc-icon-outline files_info' => 'files_info' ),
					 array( 'nc-icon-outline files_link' => 'files_link' ),
					 array( 'nc-icon-outline files_locked' => 'files_locked' ),
					 array( 'nc-icon-outline files_money' => 'files_money' ),
					 array( 'nc-icon-outline files_music' => 'files_music' ),
					 array( 'nc-icon-outline files_no-access' => 'files_no-access' ),
					 array( 'nc-icon-outline files_notebook' => 'files_notebook' ),
					 array( 'nc-icon-outline files_paper' => 'files_paper' ),
					 array( 'nc-icon-outline files_play' => 'files_play' ),
					 array( 'nc-icon-outline files_question' => 'files_question' ),
					 array( 'nc-icon-outline files_refresh' => 'files_refresh' ),
					 array( 'nc-icon-outline files_remove' => 'files_remove' ),
					 array( 'nc-icon-outline files_replace-folder' => 'files_replace-folder' ),
					 array( 'nc-icon-outline files_replace' => 'files_replace' ),
					 array( 'nc-icon-outline files_search' => 'files_search' ),
					 array( 'nc-icon-outline files_settings-46' => 'files_settings-46' ),
					 array( 'nc-icon-outline files_settings-99' => 'files_settings-99' ),
					 array( 'nc-icon-outline files_shared' => 'files_shared' ),
					 array( 'nc-icon-outline files_single-content-02' => 'files_single-content-02' ),
					 array( 'nc-icon-outline files_single-content-03' => 'files_single-content-03' ),
					 array( 'nc-icon-outline files_single-copies' => 'files_single-copies' ),
					 array( 'nc-icon-outline files_single-copy-04' => 'files_single-copy-04' ),
					 array( 'nc-icon-outline files_single-copy-06' => 'files_single-copy-06' ),
					 array( 'nc-icon-outline files_single-folded-content' => 'files_single-folded-content' ),
					 array( 'nc-icon-outline files_single-folded' => 'files_single-folded' ),
					 array( 'nc-icon-outline files_single-paragraph' => 'files_single-paragraph' ),
					 array( 'nc-icon-outline files_single' => 'files_single' ),
					 array( 'nc-icon-outline files_star' => 'files_star' ),
					 array( 'nc-icon-outline files_time' => 'files_time' ),
					 array( 'nc-icon-outline files_upload' => 'files_upload' ),
					 array( 'nc-icon-outline files_user' => 'files_user' ),
					 array( 'nc-icon-outline files_vector' => 'files_vector' ),
					 array( 'nc-icon-outline files_zip-54' => 'files_zip-54' ),
					 array( 'nc-icon-outline files_zip-55' => 'files_zip-55' ),
					 array( 'nc-icon-outline files-2_ai-illustrator' => 'files-2_ai-illustrator' ),
					 array( 'nc-icon-outline files-2_avi' => 'files-2_avi' ),
					 array( 'nc-icon-outline files-2_css' => 'files-2_css' ),
					 array( 'nc-icon-outline files-2_csv' => 'files-2_csv' ),
					 array( 'nc-icon-outline files-2_doc' => 'files-2_doc' ),
					 array( 'nc-icon-outline files-2_docx' => 'files-2_docx' ),
					 array( 'nc-icon-outline files-2_epub' => 'files-2_epub' ),
					 array( 'nc-icon-outline files-2_exe' => 'files-2_exe' ),
					 array( 'nc-icon-outline files-2_font' => 'files-2_font' ),
					 array( 'nc-icon-outline files-2_gif' => 'files-2_gif' ),
					 array( 'nc-icon-outline files-2_html' => 'files-2_html' ),
					 array( 'nc-icon-outline files-2_jpg-jpeg' => 'files-2_jpg-jpeg' ),
					 array( 'nc-icon-outline files-2_js-javascript-jquery' => 'files-2_js-javascript-jquery' ),
					 array( 'nc-icon-outline files-3_mov' => 'files-3_mov' ),
					 array( 'nc-icon-outline files-3_mp3' => 'files-3_mp3' ),
					 array( 'nc-icon-outline files-3_mp4' => 'files-3_mp4' ),
					 array( 'nc-icon-outline files-3_pdf' => 'files-3_pdf' ),
					 array( 'nc-icon-outline files-3_png' => 'files-3_png' ),
					 array( 'nc-icon-outline files-3_psd-photoshop' => 'files-3_psd-photoshop' ),
					 array( 'nc-icon-outline files-3_rar' => 'files-3_rar' ),
					 array( 'nc-icon-outline files-3_sketch' => 'files-3_sketch' ),
					 array( 'nc-icon-outline files-3_svg' => 'files-3_svg' ),
					 array( 'nc-icon-outline files-3_txt' => 'files-3_txt' ),
					 array( 'nc-icon-outline files-3_wav' => 'files-3_wav' ),
					 array( 'nc-icon-outline files-3_zip' => 'files-3_zip' ),
				),
				'Food' => array( 
					 array( 'nc-icon-outline food_alcohol' => 'food_alcohol' ),
					 array( 'nc-icon-outline food_apple' => 'food_apple' ),
					 array( 'nc-icon-outline food_baby' => 'food_baby' ),
					 array( 'nc-icon-outline food_bacon' => 'food_bacon' ),
					 array( 'nc-icon-outline food_baguette' => 'food_baguette' ),
					 array( 'nc-icon-outline food_banana' => 'food_banana' ),
					 array( 'nc-icon-outline food_barbecue-02' => 'food_barbecue-02' ),
					 array( 'nc-icon-outline food_barbecue-15' => 'food_barbecue-15' ),
					 array( 'nc-icon-outline food_barbecue-tools' => 'food_barbecue-tools' ),
					 array( 'nc-icon-outline food_beer-95' => 'food_beer-95' ),
					 array( 'nc-icon-outline food_beer-96' => 'food_beer-96' ),
					 array( 'nc-icon-outline food_beverage' => 'food_beverage' ),
					 array( 'nc-icon-outline food_bottle-wine' => 'food_bottle-wine' ),
					 array( 'nc-icon-outline food_bottle' => 'food_bottle' ),
					 array( 'nc-icon-outline food_bowl' => 'food_bowl' ),
					 array( 'nc-icon-outline food_bread' => 'food_bread' ),
					 array( 'nc-icon-outline food_broccoli' => 'food_broccoli' ),
					 array( 'nc-icon-outline food_cake-13' => 'food_cake-13' ),
					 array( 'nc-icon-outline food_cake-100' => 'food_cake-100' ),
					 array( 'nc-icon-outline food_cake-slice' => 'food_cake-slice' ),
					 array( 'nc-icon-outline food_candle' => 'food_candle' ),
					 array( 'nc-icon-outline food_candy' => 'food_candy' ),
					 array( 'nc-icon-outline food_carrot' => 'food_carrot' ),
					 array( 'nc-icon-outline food_champagne' => 'food_champagne' ),
					 array( 'nc-icon-outline food_cheese-24' => 'food_cheese-24' ),
					 array( 'nc-icon-outline food_cheese-87' => 'food_cheese-87' ),
					 array( 'nc-icon-outline food_cheeseburger' => 'food_cheeseburger' ),
					 array( 'nc-icon-outline food_chef-hat' => 'food_chef-hat' ),
					 array( 'nc-icon-outline food_cherry' => 'food_cherry' ),
					 array( 'nc-icon-outline food_chicken' => 'food_chicken' ),
					 array( 'nc-icon-outline food_chili' => 'food_chili' ),
					 array( 'nc-icon-outline food_chinese' => 'food_chinese' ),
					 array( 'nc-icon-outline food_chips' => 'food_chips' ),
					 array( 'nc-icon-outline food_chocolate' => 'food_chocolate' ),
					 array( 'nc-icon-outline food_cocktail' => 'food_cocktail' ),
					 array( 'nc-icon-outline food_coffe-long' => 'food_coffe-long' ),
					 array( 'nc-icon-outline food_coffee-long' => 'food_coffee-long' ),
					 array( 'nc-icon-outline food_coffee' => 'food_coffee' ),
					 array( 'nc-icon-outline food_cookies' => 'food_cookies' ),
					 array( 'nc-icon-outline food_course' => 'food_course' ),
					 array( 'nc-icon-outline food_crab' => 'food_crab' ),
					 array( 'nc-icon-outline food_croissant' => 'food_croissant' ),
					 array( 'nc-icon-outline food_cutlery-75' => 'food_cutlery-75' ),
					 array( 'nc-icon-outline food_cutlery-76' => 'food_cutlery-76' ),
					 array( 'nc-icon-outline food_cutlery-77' => 'food_cutlery-77' ),
					 array( 'nc-icon-outline food_dishwasher' => 'food_dishwasher' ),
					 array( 'nc-icon-outline food_donut' => 'food_donut' ),
					 array( 'nc-icon-outline food_drink' => 'food_drink' ),
					 array( 'nc-icon-outline food_egg' => 'food_egg' ),
					 array( 'nc-icon-outline food_energy-drink' => 'food_energy-drink' ),
					 array( 'nc-icon-outline food_fish' => 'food_fish' ),
					 array( 'nc-icon-outline food_fishbone' => 'food_fishbone' ),
					 array( 'nc-icon-outline food_fridge' => 'food_fridge' ),
					 array( 'nc-icon-outline food_glass' => 'food_glass' ),
					 array( 'nc-icon-outline food_grape' => 'food_grape' ),
					 array( 'nc-icon-outline food_hob' => 'food_hob' ),
					 array( 'nc-icon-outline food_hot-dog' => 'food_hot-dog' ),
					 array( 'nc-icon-outline food_ice-cream-22' => 'food_ice-cream-22' ),
					 array( 'nc-icon-outline food_ice-cream-72' => 'food_ice-cream-72' ),
					 array( 'nc-icon-outline food_jam' => 'food_jam' ),
					 array( 'nc-icon-outline food_kettle' => 'food_kettle' ),
					 array( 'nc-icon-outline food_kitchen-fan' => 'food_kitchen-fan' ),
					 array( 'nc-icon-outline food_knife' => 'food_knife' ),
					 array( 'nc-icon-outline food_lemon-slice' => 'food_lemon-slice' ),
					 array( 'nc-icon-outline food_lighter' => 'food_lighter' ),
					 array( 'nc-icon-outline food_lobster' => 'food_lobster' ),
					 array( 'nc-icon-outline food_matches' => 'food_matches' ),
					 array( 'nc-icon-outline food_measuring-cup' => 'food_measuring-cup' ),
					 array( 'nc-icon-outline food_meat-spit' => 'food_meat-spit' ),
					 array( 'nc-icon-outline food_microwave' => 'food_microwave' ),
					 array( 'nc-icon-outline food_milk' => 'food_milk' ),
					 array( 'nc-icon-outline food_moka' => 'food_moka' ),
					 array( 'nc-icon-outline food_muffin' => 'food_muffin' ),
					 array( 'nc-icon-outline food_mug' => 'food_mug' ),
					 array( 'nc-icon-outline food_oven' => 'food_oven' ),
					 array( 'nc-icon-outline food_pan' => 'food_pan' ),
					 array( 'nc-icon-outline food_pizza-slice' => 'food_pizza-slice' ),
					 array( 'nc-icon-outline food_pizza' => 'food_pizza' ),
					 array( 'nc-icon-outline food_plate' => 'food_plate' ),
					 array( 'nc-icon-outline food_pot' => 'food_pot' ),
					 array( 'nc-icon-outline food_prosciutto' => 'food_prosciutto' ),
					 array( 'nc-icon-outline food_recipe-book-46' => 'food_recipe-book-46' ),
					 array( 'nc-icon-outline food_recipe-book-47' => 'food_recipe-book-47' ),
					 array( 'nc-icon-outline food_rolling-pin' => 'food_rolling-pin' ),
					 array( 'nc-icon-outline food_salt' => 'food_salt' ),
					 array( 'nc-icon-outline food_sausage' => 'food_sausage' ),
					 array( 'nc-icon-outline food_scale' => 'food_scale' ),
					 array( 'nc-icon-outline food_scotch' => 'food_scotch' ),
					 array( 'nc-icon-outline food_shrimp' => 'food_shrimp' ),
					 array( 'nc-icon-outline food_steak' => 'food_steak' ),
					 array( 'nc-icon-outline food_store' => 'food_store' ),
					 array( 'nc-icon-outline food_strawberry' => 'food_strawberry' ),
					 array( 'nc-icon-outline food_sushi' => 'food_sushi' ),
					 array( 'nc-icon-outline food_tacos' => 'food_tacos' ),
					 array( 'nc-icon-outline food_tea' => 'food_tea' ),
					 array( 'nc-icon-outline food_temperature' => 'food_temperature' ),
					 array( 'nc-icon-outline food_vest-07' => 'food_vest-07' ),
					 array( 'nc-icon-outline food_vest-31' => 'food_vest-31' ),
					 array( 'nc-icon-outline food_watermelon' => 'food_watermelon' ),
					 array( 'nc-icon-outline food_whisk' => 'food_whisk' ),
				),
				'Healthcare & Medical' => array( 
					 array( 'nc-icon-outline health_ambulance' => 'health_ambulance' ),
					 array( 'nc-icon-outline health_apple' => 'health_apple' ),
					 array( 'nc-icon-outline health_bag-49' => 'health_bag-49' ),
					 array( 'nc-icon-outline health_bag-50' => 'health_bag-50' ),
					 array( 'nc-icon-outline health_brain' => 'health_brain' ),
					 array( 'nc-icon-outline health_dna-27' => 'health_dna-27' ),
					 array( 'nc-icon-outline health_dna-38' => 'health_dna-38' ),
					 array( 'nc-icon-outline health_doctor' => 'health_doctor' ),
					 array( 'nc-icon-outline health_flask' => 'health_flask' ),
					 array( 'nc-icon-outline health_heartbeat-16' => 'health_heartbeat-16' ),
					 array( 'nc-icon-outline health_height' => 'health_height' ),
					 array( 'nc-icon-outline health_hospital-32' => 'health_hospital-32' ),
					 array( 'nc-icon-outline health_hospital-33' => 'health_hospital-33' ),
					 array( 'nc-icon-outline health_hospital-34' => 'health_hospital-34' ),
					 array( 'nc-icon-outline health_humidity-26' => 'health_humidity-26' ),
					 array( 'nc-icon-outline health_humidity-52' => 'health_humidity-52' ),
					 array( 'nc-icon-outline health_intestine' => 'health_intestine' ),
					 array( 'nc-icon-outline health_lungs' => 'health_lungs' ),
					 array( 'nc-icon-outline health_molecule-39' => 'health_molecule-39' ),
					 array( 'nc-icon-outline health_molecule-40' => 'health_molecule-40' ),
					 array( 'nc-icon-outline health_notebook' => 'health_notebook' ),
					 array( 'nc-icon-outline health_nurse' => 'health_nurse' ),
					 array( 'nc-icon-outline health_patch-46' => 'health_patch-46' ),
					 array( 'nc-icon-outline health_pill-42' => 'health_pill-42' ),
					 array( 'nc-icon-outline health_pill-43' => 'health_pill-43' ),
					 array( 'nc-icon-outline health_pill-container-44' => 'health_pill-container-44' ),
					 array( 'nc-icon-outline health_pill-container-47' => 'health_pill-container-47' ),
					 array( 'nc-icon-outline health_pulse-chart' => 'health_pulse-chart' ),
					 array( 'nc-icon-outline health_pulse-phone' => 'health_pulse-phone' ),
					 array( 'nc-icon-outline health_pulse-sleep' => 'health_pulse-sleep' ),
					 array( 'nc-icon-outline health_pulse-watch' => 'health_pulse-watch' ),
					 array( 'nc-icon-outline health_pulse' => 'health_pulse' ),
					 array( 'nc-icon-outline health_sleep' => 'health_sleep' ),
					 array( 'nc-icon-outline health_steps' => 'health_steps' ),
					 array( 'nc-icon-outline health_syringe' => 'health_syringe' ),
					 array( 'nc-icon-outline health_temperature-23' => 'health_temperature-23' ),
					 array( 'nc-icon-outline health_temperature-24' => 'health_temperature-24' ),
					 array( 'nc-icon-outline health_tooth' => 'health_tooth' ),
					 array( 'nc-icon-outline health_weed' => 'health_weed' ),
					 array( 'nc-icon-outline health_weight' => 'health_weight' ),
					 array( 'nc-icon-outline health_wheelchair' => 'health_wheelchair' ),
					 array( 'nc-icon-outline health_woman' => 'health_woman' ),
				),
				'Holidays' => array( 
					 array( 'nc-icon-outline holidays_bat' => 'holidays_bat' ),
					 array( 'nc-icon-outline holidays_biscuit' => 'holidays_biscuit' ),
					 array( 'nc-icon-outline holidays_bones' => 'holidays_bones' ),
					 array( 'nc-icon-outline holidays_boot' => 'holidays_boot' ),
					 array( 'nc-icon-outline holidays_candy' => 'holidays_candy' ),
					 array( 'nc-icon-outline holidays_cat' => 'holidays_cat' ),
					 array( 'nc-icon-outline holidays_cauldron' => 'holidays_cauldron' ),
					 array( 'nc-icon-outline holidays_chimney' => 'holidays_chimney' ),
					 array( 'nc-icon-outline holidays_cockade' => 'holidays_cockade' ),
					 array( 'nc-icon-outline holidays_coffin' => 'holidays_coffin' ),
					 array( 'nc-icon-outline holidays_dead-hand' => 'holidays_dead-hand' ),
					 array( 'nc-icon-outline holidays_decoration' => 'holidays_decoration' ),
					 array( 'nc-icon-outline holidays_deer' => 'holidays_deer' ),
					 array( 'nc-icon-outline holidays_egg-38' => 'holidays_egg-38' ),
					 array( 'nc-icon-outline holidays_egg-39' => 'holidays_egg-39' ),
					 array( 'nc-icon-outline holidays_frankenstein' => 'holidays_frankenstein' ),
					 array( 'nc-icon-outline holidays_ghost' => 'holidays_ghost' ),
					 array( 'nc-icon-outline holidays_gift-exchange' => 'holidays_gift-exchange' ),
					 array( 'nc-icon-outline holidays_gift' => 'holidays_gift' ),
					 array( 'nc-icon-outline holidays_glove' => 'holidays_glove' ),
					 array( 'nc-icon-outline holidays_grave' => 'holidays_grave' ),
					 array( 'nc-icon-outline holidays_light' => 'holidays_light' ),
					 array( 'nc-icon-outline holidays_message' => 'holidays_message' ),
					 array( 'nc-icon-outline holidays_mistletoe' => 'holidays_mistletoe' ),
					 array( 'nc-icon-outline holidays_owl' => 'holidays_owl' ),
					 array( 'nc-icon-outline holidays_pumpkin' => 'holidays_pumpkin' ),
					 array( 'nc-icon-outline holidays_rabbit' => 'holidays_rabbit' ),
					 array( 'nc-icon-outline holidays_santa-hat' => 'holidays_santa-hat' ),
					 array( 'nc-icon-outline holidays_sickle' => 'holidays_sickle' ),
					 array( 'nc-icon-outline holidays_snow-ball' => 'holidays_snow-ball' ),
					 array( 'nc-icon-outline holidays_snowman-head' => 'holidays_snowman-head' ),
					 array( 'nc-icon-outline holidays_snowman' => 'holidays_snowman' ),
					 array( 'nc-icon-outline holidays_soak' => 'holidays_soak' ),
					 array( 'nc-icon-outline holidays_spider' => 'holidays_spider' ),
					 array( 'nc-icon-outline holidays_tree-ball' => 'holidays_tree-ball' ),
					 array( 'nc-icon-outline holidays_tree' => 'holidays_tree' ),
					 array( 'nc-icon-outline holidays_vampire' => 'holidays_vampire' ),
					 array( 'nc-icon-outline holidays_witch-hat' => 'holidays_witch-hat' ),
					 array( 'nc-icon-outline holidays_wolf' => 'holidays_wolf' ),
					 array( 'nc-icon-outline holidays_zombie' => 'holidays_zombie' ),
				),
				'Home furniture' => array( 
					 array( 'nc-icon-outline furniture_air-conditioner' => 'furniture_air-conditioner' ),
					 array( 'nc-icon-outline furniture_armchair' => 'furniture_armchair' ),
					 array( 'nc-icon-outline furniture_bath-tub' => 'furniture_bath-tub' ),
					 array( 'nc-icon-outline furniture_bed-09' => 'furniture_bed-09' ),
					 array( 'nc-icon-outline furniture_bed-23' => 'furniture_bed-23' ),
					 array( 'nc-icon-outline furniture_bed-side' => 'furniture_bed-side' ),
					 array( 'nc-icon-outline furniture_cabinet' => 'furniture_cabinet' ),
					 array( 'nc-icon-outline furniture_cactus' => 'furniture_cactus' ),
					 array( 'nc-icon-outline furniture_chair' => 'furniture_chair' ),
					 array( 'nc-icon-outline furniture_coat-hanger' => 'furniture_coat-hanger' ),
					 array( 'nc-icon-outline furniture_coffee' => 'furniture_coffee' ),
					 array( 'nc-icon-outline furniture_cradle' => 'furniture_cradle' ),
					 array( 'nc-icon-outline furniture_curtain' => 'furniture_curtain' ),
					 array( 'nc-icon-outline furniture_desk-drawer' => 'furniture_desk-drawer' ),
					 array( 'nc-icon-outline furniture_desk' => 'furniture_desk' ),
					 array( 'nc-icon-outline furniture_door' => 'furniture_door' ),
					 array( 'nc-icon-outline furniture_drawer' => 'furniture_drawer' ),
					 array( 'nc-icon-outline furniture_fridge' => 'furniture_fridge' ),
					 array( 'nc-icon-outline furniture_hanger-clothes' => 'furniture_hanger-clothes' ),
					 array( 'nc-icon-outline furniture_hanger' => 'furniture_hanger' ),
					 array( 'nc-icon-outline furniture_heater' => 'furniture_heater' ),
					 array( 'nc-icon-outline furniture_iron' => 'furniture_iron' ),
					 array( 'nc-icon-outline furniture_lamp-floor' => 'furniture_lamp-floor' ),
					 array( 'nc-icon-outline furniture_lamp' => 'furniture_lamp' ),
					 array( 'nc-icon-outline furniture_library' => 'furniture_library' ),
					 array( 'nc-icon-outline furniture_light' => 'furniture_light' ),
					 array( 'nc-icon-outline furniture_mixer' => 'furniture_mixer' ),
					 array( 'nc-icon-outline furniture_oven' => 'furniture_oven' ),
					 array( 'nc-icon-outline furniture_shower' => 'furniture_shower' ),
					 array( 'nc-icon-outline furniture_sink-wash' => 'furniture_sink-wash' ),
					 array( 'nc-icon-outline furniture_sink' => 'furniture_sink' ),
					 array( 'nc-icon-outline furniture_sofa' => 'furniture_sofa' ),
					 array( 'nc-icon-outline furniture_storage-hanger' => 'furniture_storage-hanger' ),
					 array( 'nc-icon-outline furniture_storage' => 'furniture_storage' ),
					 array( 'nc-icon-outline furniture_table' => 'furniture_table' ),
					 array( 'nc-icon-outline furniture_toilet-paper' => 'furniture_toilet-paper' ),
					 array( 'nc-icon-outline furniture_toilet' => 'furniture_toilet' ),
					 array( 'nc-icon-outline furniture_tv' => 'furniture_tv' ),
					 array( 'nc-icon-outline furniture_wardrobe' => 'furniture_wardrobe' ),
					 array( 'nc-icon-outline furniture_wash' => 'furniture_wash' ),
				),
				'Loaders' => array( 
					 array( 'nc-icon-outline loader_circle-04 spin' => 'loader_circle-04' ),
					 array( 'nc-icon-outline loader_dots-06 spin' => 'loader_dots-06' ),
					 array( 'nc-icon-outline loader_gear spin' => 'loader_gear' ),
					 array( 'nc-icon-outline loader_refresh spin' => 'loader_refresh' ),
				),
				'Maps & Location' => array( 
					 array( 'nc-icon-outline location_appointment' => 'location_appointment' ),
					 array( 'nc-icon-outline location_bookmark-add' => 'location_bookmark-add' ),
					 array( 'nc-icon-outline location_bookmark-remove' => 'location_bookmark-remove' ),
					 array( 'nc-icon-outline location_bookmark' => 'location_bookmark' ),
					 array( 'nc-icon-outline location_compass-04' => 'location_compass-04' ),
					 array( 'nc-icon-outline location_compass-05' => 'location_compass-05' ),
					 array( 'nc-icon-outline location_compass-06' => 'location_compass-06' ),
					 array( 'nc-icon-outline location_crosshair' => 'location_crosshair' ),
					 array( 'nc-icon-outline location_explore-user' => 'location_explore-user' ),
					 array( 'nc-icon-outline location_explore' => 'location_explore' ),
					 array( 'nc-icon-outline location_flag-complex' => 'location_flag-complex' ),
					 array( 'nc-icon-outline location_flag-diagonal-33' => 'location_flag-diagonal-33' ),
					 array( 'nc-icon-outline location_flag-diagonal-34' => 'location_flag-diagonal-34' ),
					 array( 'nc-icon-outline location_flag-points-31' => 'location_flag-points-31' ),
					 array( 'nc-icon-outline location_flag-points-32' => 'location_flag-points-32' ),
					 array( 'nc-icon-outline location_flag-simple' => 'location_flag-simple' ),
					 array( 'nc-icon-outline location_flag-triangle' => 'location_flag-triangle' ),
					 array( 'nc-icon-outline location_flag' => 'location_flag' ),
					 array( 'nc-icon-outline location_gps' => 'location_gps' ),
					 array( 'nc-icon-outline location_map-big' => 'location_map-big' ),
					 array( 'nc-icon-outline location_map-compass' => 'location_map-compass' ),
					 array( 'nc-icon-outline location_map-gps' => 'location_map-gps' ),
					 array( 'nc-icon-outline location_map-marker' => 'location_map-marker' ),
					 array( 'nc-icon-outline location_map-pin' => 'location_map-pin' ),
					 array( 'nc-icon-outline location_map' => 'location_map' ),
					 array( 'nc-icon-outline location_marker' => 'location_marker' ),
					 array( 'nc-icon-outline location_pin-add' => 'location_pin-add' ),
					 array( 'nc-icon-outline location_pin-copy' => 'location_pin-copy' ),
					 array( 'nc-icon-outline location_pin-remove' => 'location_pin-remove' ),
					 array( 'nc-icon-outline location_pin' => 'location_pin' ),
					 array( 'nc-icon-outline location_pins' => 'location_pins' ),
					 array( 'nc-icon-outline location_position-marker' => 'location_position-marker' ),
					 array( 'nc-icon-outline location_position-pin' => 'location_position-pin' ),
					 array( 'nc-icon-outline location_position-user' => 'location_position-user' ),
					 array( 'nc-icon-outline location_radar' => 'location_radar' ),
					 array( 'nc-icon-outline location_road' => 'location_road' ),
					 array( 'nc-icon-outline location_route-alert' => 'location_route-alert' ),
					 array( 'nc-icon-outline location_route-close' => 'location_route-close' ),
					 array( 'nc-icon-outline location_route-open' => 'location_route-open' ),
					 array( 'nc-icon-outline location_square-marker' => 'location_square-marker' ),
					 array( 'nc-icon-outline location_square-pin' => 'location_square-pin' ),
					 array( 'nc-icon-outline location_treasure-map-21' => 'location_treasure-map-21' ),
					 array( 'nc-icon-outline location_treasure-map-40' => 'location_treasure-map-40' ),
					 array( 'nc-icon-outline location_worl-marker' => 'location_worl-marker' ),
					 array( 'nc-icon-outline location_world-pin' => 'location_world-pin' ),
					 array( 'nc-icon-outline location_world' => 'location_world' ),
				),
				'Media' => array( 
					 array( 'nc-icon-outline media-1_3d' => 'media-1_3d' ),
					 array( 'nc-icon-outline media-1_action-73' => 'media-1_action-73' ),
					 array( 'nc-icon-outline media-1_action-74' => 'media-1_action-74' ),
					 array( 'nc-icon-outline media-1_album' => 'media-1_album' ),
					 array( 'nc-icon-outline media-1_audio-91' => 'media-1_audio-91' ),
					 array( 'nc-icon-outline media-1_audio-92' => 'media-1_audio-92' ),
					 array( 'nc-icon-outline media-1_balance' => 'media-1_balance' ),
					 array( 'nc-icon-outline media-1_brightness-46' => 'media-1_brightness-46' ),
					 array( 'nc-icon-outline media-1_brightness-47' => 'media-1_brightness-47' ),
					 array( 'nc-icon-outline media-1_button-circle-pause' => 'media-1_button-circle-pause' ),
					 array( 'nc-icon-outline media-1_button-circle-play' => 'media-1_button-circle-play' ),
					 array( 'nc-icon-outline media-1_button-circle-stop' => 'media-1_button-circle-stop' ),
					 array( 'nc-icon-outline media-1_button-eject' => 'media-1_button-eject' ),
					 array( 'nc-icon-outline media-1_button-next' => 'media-1_button-next' ),
					 array( 'nc-icon-outline media-1_button-pause' => 'media-1_button-pause' ),
					 array( 'nc-icon-outline media-1_button-play' => 'media-1_button-play' ),
					 array( 'nc-icon-outline media-1_button-power' => 'media-1_button-power' ),
					 array( 'nc-icon-outline media-1_button-previous' => 'media-1_button-previous' ),
					 array( 'nc-icon-outline media-1_button-record' => 'media-1_button-record' ),
					 array( 'nc-icon-outline media-1_button-rewind' => 'media-1_button-rewind' ),
					 array( 'nc-icon-outline media-1_button-skip' => 'media-1_button-skip' ),
					 array( 'nc-icon-outline media-1_button-stop' => 'media-1_button-stop' ),
					 array( 'nc-icon-outline media-1_camera-18' => 'media-1_camera-18' ),
					 array( 'nc-icon-outline media-1_camera-19' => 'media-1_camera-19' ),
					 array( 'nc-icon-outline media-1_camera-20' => 'media-1_camera-20' ),
					 array( 'nc-icon-outline media-1_camera-ban-36' => 'media-1_camera-ban-36' ),
					 array( 'nc-icon-outline media-1_camera-ban-37' => 'media-1_camera-ban-37' ),
					 array( 'nc-icon-outline media-1_camera-compact' => 'media-1_camera-compact' ),
					 array( 'nc-icon-outline media-1_camera-screen' => 'media-1_camera-screen' ),
					 array( 'nc-icon-outline media-1_camera-square-57' => 'media-1_camera-square-57' ),
					 array( 'nc-icon-outline media-1_camera-square-58' => 'media-1_camera-square-58' ),
					 array( 'nc-icon-outline media-1_camera-time' => 'media-1_camera-time' ),
					 array( 'nc-icon-outline media-1_countdown-34' => 'media-1_countdown-34' ),
					 array( 'nc-icon-outline media-1_countdown-35' => 'media-1_countdown-35' ),
					 array( 'nc-icon-outline media-1_edit-color' => 'media-1_edit-color' ),
					 array( 'nc-icon-outline media-1_edit-contrast-42' => 'media-1_edit-contrast-42' ),
					 array( 'nc-icon-outline media-1_edit-contrast-43' => 'media-1_edit-contrast-43' ),
					 array( 'nc-icon-outline media-1_edit-saturation' => 'media-1_edit-saturation' ),
					 array( 'nc-icon-outline media-1_flash-21' => 'media-1_flash-21' ),
					 array( 'nc-icon-outline media-1_flash-24' => 'media-1_flash-24' ),
					 array( 'nc-icon-outline media-1_flash-29' => 'media-1_flash-29' ),
					 array( 'nc-icon-outline media-1_flash-auto-22' => 'media-1_flash-auto-22' ),
					 array( 'nc-icon-outline media-1_flash-auto-25' => 'media-1_flash-auto-25' ),
					 array( 'nc-icon-outline media-1_flash-off-23' => 'media-1_flash-off-23' ),
					 array( 'nc-icon-outline media-1_flash-off-26' => 'media-1_flash-off-26' ),
					 array( 'nc-icon-outline media-1_focus-32' => 'media-1_focus-32' ),
					 array( 'nc-icon-outline media-1_focus-38' => 'media-1_focus-38' ),
					 array( 'nc-icon-outline media-1_focus-40' => 'media-1_focus-40' ),
					 array( 'nc-icon-outline media-1_focus-circle' => 'media-1_focus-circle' ),
					 array( 'nc-icon-outline media-1_frame-12' => 'media-1_frame-12' ),
					 array( 'nc-icon-outline media-1_frame-41' => 'media-1_frame-41' ),
					 array( 'nc-icon-outline media-1_grid' => 'media-1_grid' ),
					 array( 'nc-icon-outline media-1_image-01' => 'media-1_image-01' ),
					 array( 'nc-icon-outline media-1_image-02' => 'media-1_image-02' ),
					 array( 'nc-icon-outline media-1_image-05' => 'media-1_image-05' ),
					 array( 'nc-icon-outline media-1_image-add' => 'media-1_image-add' ),
					 array( 'nc-icon-outline media-1_image-delete' => 'media-1_image-delete' ),
					 array( 'nc-icon-outline media-1_image-location' => 'media-1_image-location' ),
					 array( 'nc-icon-outline media-1_kid' => 'media-1_kid' ),
					 array( 'nc-icon-outline media-1_layers' => 'media-1_layers' ),
					 array( 'nc-icon-outline media-1_lens-31' => 'media-1_lens-31' ),
					 array( 'nc-icon-outline media-1_lens-56' => 'media-1_lens-56' ),
					 array( 'nc-icon-outline media-1_macro' => 'media-1_macro' ),
					 array( 'nc-icon-outline media-1_movie-61' => 'media-1_movie-61' ),
					 array( 'nc-icon-outline media-1_movie-62' => 'media-1_movie-62' ),
					 array( 'nc-icon-outline media-1_night' => 'media-1_night' ),
					 array( 'nc-icon-outline media-1_picture' => 'media-1_picture' ),
					 array( 'nc-icon-outline media-1_play-68' => 'media-1_play-68' ),
					 array( 'nc-icon-outline media-1_play-69' => 'media-1_play-69' ),
					 array( 'nc-icon-outline media-1_player' => 'media-1_player' ),
					 array( 'nc-icon-outline media-1_polaroid-add' => 'media-1_polaroid-add' ),
					 array( 'nc-icon-outline media-1_polaroid-delete' => 'media-1_polaroid-delete' ),
					 array( 'nc-icon-outline media-1_polaroid-multiple' => 'media-1_polaroid-multiple' ),
					 array( 'nc-icon-outline media-1_polaroid-user' => 'media-1_polaroid-user' ),
					 array( 'nc-icon-outline media-1_polaroid' => 'media-1_polaroid' ),
					 array( 'nc-icon-outline media-1_roll' => 'media-1_roll' ),
					 array( 'nc-icon-outline media-1_rotate-left' => 'media-1_rotate-left' ),
					 array( 'nc-icon-outline media-1_rotate-right' => 'media-1_rotate-right' ),
					 array( 'nc-icon-outline media-1_sd' => 'media-1_sd' ),
					 array( 'nc-icon-outline media-1_selfie' => 'media-1_selfie' ),
					 array( 'nc-icon-outline media-1_shake' => 'media-1_shake' ),
					 array( 'nc-icon-outline media-1_speaker' => 'media-1_speaker' ),
					 array( 'nc-icon-outline media-1_sport' => 'media-1_sport' ),
					 array( 'nc-icon-outline media-1_ticket-75' => 'media-1_ticket-75' ),
					 array( 'nc-icon-outline media-1_ticket-76' => 'media-1_ticket-76' ),
					 array( 'nc-icon-outline media-1_touch' => 'media-1_touch' ),
					 array( 'nc-icon-outline media-1_tripod' => 'media-1_tripod' ),
					 array( 'nc-icon-outline media-1_video-64' => 'media-1_video-64' ),
					 array( 'nc-icon-outline media-1_video-65' => 'media-1_video-65' ),
					 array( 'nc-icon-outline media-1_video-66' => 'media-1_video-66' ),
					 array( 'nc-icon-outline media-1_video-67' => 'media-1_video-67' ),
					 array( 'nc-icon-outline media-1_videocamera-71' => 'media-1_videocamera-71' ),
					 array( 'nc-icon-outline media-1_videocamera-72' => 'media-1_videocamera-72' ),
					 array( 'nc-icon-outline media-1_volume-93' => 'media-1_volume-93' ),
					 array( 'nc-icon-outline media-1_volume-97' => 'media-1_volume-97' ),
					 array( 'nc-icon-outline media-1_volume-98' => 'media-1_volume-98' ),
					 array( 'nc-icon-outline media-1_volume-ban' => 'media-1_volume-ban' ),
					 array( 'nc-icon-outline media-1_volume-down' => 'media-1_volume-down' ),
					 array( 'nc-icon-outline media-1_volume-off' => 'media-1_volume-off' ),
					 array( 'nc-icon-outline media-1_volume-up' => 'media-1_volume-up' ),
					 array( 'nc-icon-outline media-2_guitar' => 'media-2_guitar' ),
					 array( 'nc-icon-outline media-2_headphones-mic' => 'media-2_headphones-mic' ),
					 array( 'nc-icon-outline media-2_headphones' => 'media-2_headphones' ),
					 array( 'nc-icon-outline media-2_knob' => 'media-2_knob' ),
					 array( 'nc-icon-outline media-2_mic' => 'media-2_mic' ),
					 array( 'nc-icon-outline media-2_music-album' => 'media-2_music-album' ),
					 array( 'nc-icon-outline media-2_music-cloud' => 'media-2_music-cloud' ),
					 array( 'nc-icon-outline media-2_note-03' => 'media-2_note-03' ),
					 array( 'nc-icon-outline media-2_note-04' => 'media-2_note-04' ),
					 array( 'nc-icon-outline media-2_piano' => 'media-2_piano' ),
					 array( 'nc-icon-outline media-2_radio' => 'media-2_radio' ),
					 array( 'nc-icon-outline media-2_remix' => 'media-2_remix' ),
					 array( 'nc-icon-outline media-2_sound-wave' => 'media-2_sound-wave' ),
					 array( 'nc-icon-outline media-2_speaker-01' => 'media-2_speaker-01' ),
					 array( 'nc-icon-outline media-2_speaker-05' => 'media-2_speaker-05' ),
					 array( 'nc-icon-outline media-2_tape' => 'media-2_tape' ),
				),
				'Objects' => array( 
					 array( 'nc-icon-outline objects_alien-29' => 'objects_alien-29' ),
					 array( 'nc-icon-outline objects_alien-33' => 'objects_alien-33' ),
					 array( 'nc-icon-outline objects_anchor' => 'objects_anchor' ),
					 array( 'nc-icon-outline objects_astronaut' => 'objects_astronaut' ),
					 array( 'nc-icon-outline objects_axe' => 'objects_axe' ),
					 array( 'nc-icon-outline objects_baby-bottle' => 'objects_baby-bottle' ),
					 array( 'nc-icon-outline objects_baby' => 'objects_baby' ),
					 array( 'nc-icon-outline objects_baloon' => 'objects_baloon' ),
					 array( 'nc-icon-outline objects_battery' => 'objects_battery' ),
					 array( 'nc-icon-outline objects_bear' => 'objects_bear' ),
					 array( 'nc-icon-outline objects_billiard' => 'objects_billiard' ),
					 array( 'nc-icon-outline objects_binocular' => 'objects_binocular' ),
					 array( 'nc-icon-outline objects_bow' => 'objects_bow' ),
					 array( 'nc-icon-outline objects_bowling' => 'objects_bowling' ),
					 array( 'nc-icon-outline objects_broom' => 'objects_broom' ),
					 array( 'nc-icon-outline objects_cone' => 'objects_cone' ),
					 array( 'nc-icon-outline objects_controller' => 'objects_controller' ),
					 array( 'nc-icon-outline objects_diamond' => 'objects_diamond' ),
					 array( 'nc-icon-outline objects_dice' => 'objects_dice' ),
					 array( 'nc-icon-outline objects_globe' => 'objects_globe' ),
					 array( 'nc-icon-outline objects_hut' => 'objects_hut' ),
					 array( 'nc-icon-outline objects_key-25' => 'objects_key-25' ),
					 array( 'nc-icon-outline objects_key-26' => 'objects_key-26' ),
					 array( 'nc-icon-outline objects_lamp' => 'objects_lamp' ),
					 array( 'nc-icon-outline objects_leaf-36' => 'objects_leaf-36' ),
					 array( 'nc-icon-outline objects_leaf-38' => 'objects_leaf-38' ),
					 array( 'nc-icon-outline objects_light' => 'objects_light' ),
					 array( 'nc-icon-outline objects_pipe' => 'objects_pipe' ),
					 array( 'nc-icon-outline objects_planet' => 'objects_planet' ),
					 array( 'nc-icon-outline objects_puzzle-09' => 'objects_puzzle-09' ),
					 array( 'nc-icon-outline objects_puzzle-10' => 'objects_puzzle-10' ),
					 array( 'nc-icon-outline objects_shovel' => 'objects_shovel' ),
					 array( 'nc-icon-outline objects_skull' => 'objects_skull' ),
					 array( 'nc-icon-outline objects_spaceship' => 'objects_spaceship' ),
					 array( 'nc-icon-outline objects_spray' => 'objects_spray' ),
					 array( 'nc-icon-outline objects_support-16' => 'objects_support-16' ),
					 array( 'nc-icon-outline objects_support-17' => 'objects_support-17' ),
					 array( 'nc-icon-outline objects_umbrella-13' => 'objects_umbrella-13' ),
					 array( 'nc-icon-outline objects_umbrella-14' => 'objects_umbrella-14' ),
					 array( 'nc-icon-outline objects_wool-ball' => 'objects_wool-ball' ),
				),
				'School & Education' => array( 
					 array( 'nc-icon-outline education_abc' => 'education_abc' ),
					 array( 'nc-icon-outline education_agenda-bookmark' => 'education_agenda-bookmark' ),
					 array( 'nc-icon-outline education_atom' => 'education_atom' ),
					 array( 'nc-icon-outline education_award-55' => 'education_award-55' ),
					 array( 'nc-icon-outline education_backpack-57' => 'education_backpack-57' ),
					 array( 'nc-icon-outline education_backpack-58' => 'education_backpack-58' ),
					 array( 'nc-icon-outline education_ball-basket' => 'education_ball-basket' ),
					 array( 'nc-icon-outline education_ball-soccer' => 'education_ball-soccer' ),
					 array( 'nc-icon-outline education_board-51' => 'education_board-51' ),
					 array( 'nc-icon-outline education_book-39' => 'education_book-39' ),
					 array( 'nc-icon-outline education_book-bookmark' => 'education_book-bookmark' ),
					 array( 'nc-icon-outline education_book-open' => 'education_book-open' ),
					 array( 'nc-icon-outline education_books-46' => 'education_books-46' ),
					 array( 'nc-icon-outline education_chalkboard' => 'education_chalkboard' ),
					 array( 'nc-icon-outline education_flask' => 'education_flask' ),
					 array( 'nc-icon-outline education_glasses' => 'education_glasses' ),
					 array( 'nc-icon-outline education_grammar-check' => 'education_grammar-check' ),
					 array( 'nc-icon-outline education_hat' => 'education_hat' ),
					 array( 'nc-icon-outline education_language' => 'education_language' ),
					 array( 'nc-icon-outline education_microscope' => 'education_microscope' ),
					 array( 'nc-icon-outline education_molecule' => 'education_molecule' ),
					 array( 'nc-icon-outline education_notepad' => 'education_notepad' ),
					 array( 'nc-icon-outline education_paper-diploma' => 'education_paper-diploma' ),
					 array( 'nc-icon-outline education_paper' => 'education_paper' ),
					 array( 'nc-icon-outline education_pencil-47' => 'education_pencil-47' ),
					 array( 'nc-icon-outline education_school' => 'education_school' ),
				),
				'Shopping' => array( 
					 array( 'nc-icon-outline shopping_award' => 'shopping_award' ),
					 array( 'nc-icon-outline shopping_bag-09' => 'shopping_bag-09' ),
					 array( 'nc-icon-outline shopping_bag-16' => 'shopping_bag-16' ),
					 array( 'nc-icon-outline shopping_bag-17' => 'shopping_bag-17' ),
					 array( 'nc-icon-outline shopping_bag-20' => 'shopping_bag-20' ),
					 array( 'nc-icon-outline shopping_bag-add-18' => 'shopping_bag-add-18' ),
					 array( 'nc-icon-outline shopping_bag-add-21' => 'shopping_bag-add-21' ),
					 array( 'nc-icon-outline shopping_bag-edit' => 'shopping_bag-edit' ),
					 array( 'nc-icon-outline shopping_bag-remove-19' => 'shopping_bag-remove-19' ),
					 array( 'nc-icon-outline shopping_bag-remove-22' => 'shopping_bag-remove-22' ),
					 array( 'nc-icon-outline shopping_barcode-scan' => 'shopping_barcode-scan' ),
					 array( 'nc-icon-outline shopping_barcode' => 'shopping_barcode' ),
					 array( 'nc-icon-outline shopping_bardcode-qr' => 'shopping_bardcode-qr' ),
					 array( 'nc-icon-outline shopping_basket-add' => 'shopping_basket-add' ),
					 array( 'nc-icon-outline shopping_basket-edit' => 'shopping_basket-edit' ),
					 array( 'nc-icon-outline shopping_basket-remove' => 'shopping_basket-remove' ),
					 array( 'nc-icon-outline shopping_basket-simple-add' => 'shopping_basket-simple-add' ),
					 array( 'nc-icon-outline shopping_basket-simple-remove' => 'shopping_basket-simple-remove' ),
					 array( 'nc-icon-outline shopping_basket-simple' => 'shopping_basket-simple' ),
					 array( 'nc-icon-outline shopping_basket' => 'shopping_basket' ),
					 array( 'nc-icon-outline shopping_bitcoin' => 'shopping_bitcoin' ),
					 array( 'nc-icon-outline shopping_board' => 'shopping_board' ),
					 array( 'nc-icon-outline shopping_box-3d-50' => 'shopping_box-3d-50' ),
					 array( 'nc-icon-outline shopping_box-3d-67' => 'shopping_box-3d-67' ),
					 array( 'nc-icon-outline shopping_box-ribbon' => 'shopping_box-ribbon' ),
					 array( 'nc-icon-outline shopping_box' => 'shopping_box' ),
					 array( 'nc-icon-outline shopping_cart-add' => 'shopping_cart-add' ),
					 array( 'nc-icon-outline shopping_cart-modern-add' => 'shopping_cart-modern-add' ),
					 array( 'nc-icon-outline shopping_cart-modern-in' => 'shopping_cart-modern-in' ),
					 array( 'nc-icon-outline shopping_cart-modern-remove' => 'shopping_cart-modern-remove' ),
					 array( 'nc-icon-outline shopping_cart-modern' => 'shopping_cart-modern' ),
					 array( 'nc-icon-outline shopping_cart-remove' => 'shopping_cart-remove' ),
					 array( 'nc-icon-outline shopping_cart-simple-add' => 'shopping_cart-simple-add' ),
					 array( 'nc-icon-outline shopping_cart-simple-in' => 'shopping_cart-simple-in' ),
					 array( 'nc-icon-outline shopping_cart-simple-remove' => 'shopping_cart-simple-remove' ),
					 array( 'nc-icon-outline shopping_cart-simple' => 'shopping_cart-simple' ),
					 array( 'nc-icon-outline shopping_cart' => 'shopping_cart' ),
					 array( 'nc-icon-outline shopping_cash-register' => 'shopping_cash-register' ),
					 array( 'nc-icon-outline shopping_chart' => 'shopping_chart' ),
					 array( 'nc-icon-outline shopping_credit-card-in' => 'shopping_credit-card-in' ),
					 array( 'nc-icon-outline shopping_credit-card' => 'shopping_credit-card' ),
					 array( 'nc-icon-outline shopping_credit-locked' => 'shopping_credit-locked' ),
					 array( 'nc-icon-outline shopping_delivery-fast' => 'shopping_delivery-fast' ),
					 array( 'nc-icon-outline shopping_delivery-time' => 'shopping_delivery-time' ),
					 array( 'nc-icon-outline shopping_delivery-track' => 'shopping_delivery-track' ),
					 array( 'nc-icon-outline shopping_delivery' => 'shopping_delivery' ),
					 array( 'nc-icon-outline shopping_discount' => 'shopping_discount' ),
					 array( 'nc-icon-outline shopping_gift' => 'shopping_gift' ),
					 array( 'nc-icon-outline shopping_hand-card' => 'shopping_hand-card' ),
					 array( 'nc-icon-outline shopping_list' => 'shopping_list' ),
					 array( 'nc-icon-outline shopping_mobile-card' => 'shopping_mobile-card' ),
					 array( 'nc-icon-outline shopping_mobile-cart' => 'shopping_mobile-cart' ),
					 array( 'nc-icon-outline shopping_mobile-touch' => 'shopping_mobile-touch' ),
					 array( 'nc-icon-outline shopping_newsletter' => 'shopping_newsletter' ),
					 array( 'nc-icon-outline shopping_pos' => 'shopping_pos' ),
					 array( 'nc-icon-outline shopping_receipt-list-42' => 'shopping_receipt-list-42' ),
					 array( 'nc-icon-outline shopping_receipt-list-43' => 'shopping_receipt-list-43' ),
					 array( 'nc-icon-outline shopping_receipt' => 'shopping_receipt' ),
					 array( 'nc-icon-outline shopping_shop-location' => 'shopping_shop-location' ),
					 array( 'nc-icon-outline shopping_shop' => 'shopping_shop' ),
					 array( 'nc-icon-outline shopping_stock' => 'shopping_stock' ),
					 array( 'nc-icon-outline shopping_tag-content' => 'shopping_tag-content' ),
					 array( 'nc-icon-outline shopping_tag-cut' => 'shopping_tag-cut' ),
					 array( 'nc-icon-outline shopping_tag-line' => 'shopping_tag-line' ),
					 array( 'nc-icon-outline shopping_tag-sale' => 'shopping_tag-sale' ),
					 array( 'nc-icon-outline shopping_tag' => 'shopping_tag' ),
					 array( 'nc-icon-outline shopping_wallet' => 'shopping_wallet' ),
				),
				'Socials' => array( 
					 array( 'nc-icon-outline socials-1_logo-500px' => 'socials-1_logo-500px' ),
					 array( 'nc-icon-outline socials-1_logo-angellist' => 'socials-1_logo-angellist' ),
					 array( 'nc-icon-outline socials-1_logo-behance' => 'socials-1_logo-behance' ),
					 array( 'nc-icon-outline socials-1_logo-blogger' => 'socials-1_logo-blogger' ),
					 array( 'nc-icon-outline socials-1_logo-buffer' => 'socials-1_logo-buffer' ),
					 array( 'nc-icon-outline socials-1_logo-buysellads' => 'socials-1_logo-buysellads' ),
					 array( 'nc-icon-outline socials-1_logo-codepen' => 'socials-1_logo-codepen' ),
					 array( 'nc-icon-outline socials-1_logo-creative-market' => 'socials-1_logo-creative-market' ),
					 array( 'nc-icon-outline socials-1_logo-crunchbase' => 'socials-1_logo-crunchbase' ),
					 array( 'nc-icon-outline socials-1_logo-deviantart' => 'socials-1_logo-deviantart' ),
					 array( 'nc-icon-outline socials-1_logo-dribbble' => 'socials-1_logo-dribbble' ),
					 array( 'nc-icon-outline socials-1_logo-dropbox' => 'socials-1_logo-dropbox' ),
					 array( 'nc-icon-outline socials-1_logo-envato' => 'socials-1_logo-envato' ),
					 array( 'nc-icon-outline socials-1_logo-evernote' => 'socials-1_logo-evernote' ),
					 array( 'nc-icon-outline socials-1_logo-facebook' => 'socials-1_logo-facebook' ),
					 array( 'nc-icon-outline socials-1_logo-fb-simple' => 'socials-1_logo-fb-simple' ),
					 array( 'nc-icon-outline socials-1_logo-feedly' => 'socials-1_logo-feedly' ),
					 array( 'nc-icon-outline socials-1_logo-flickr' => 'socials-1_logo-flickr' ),
					 array( 'nc-icon-outline socials-1_logo-github' => 'socials-1_logo-github' ),
					 array( 'nc-icon-outline socials-1_logo-google-plus' => 'socials-1_logo-google-plus' ),
					 array( 'nc-icon-outline socials-1_logo-instagram' => 'socials-1_logo-instagram' ),
					 array( 'nc-icon-outline socials-1_logo-lastfm' => 'socials-1_logo-lastfm' ),
					 array( 'nc-icon-outline socials-1_logo-linkedin' => 'socials-1_logo-linkedin' ),
					 array( 'nc-icon-outline socials-1_logo-meetup' => 'socials-1_logo-meetup' ),
					 array( 'nc-icon-outline socials-1_logo-myspace' => 'socials-1_logo-myspace' ),
					 array( 'nc-icon-outline socials-1_logo-paypal' => 'socials-1_logo-paypal' ),
					 array( 'nc-icon-outline socials-1_logo-pinterest' => 'socials-1_logo-pinterest' ),
					 array( 'nc-icon-outline socials-1_logo-product-hunt' => 'socials-1_logo-product-hunt' ),
					 array( 'nc-icon-outline socials-1_logo-reddit' => 'socials-1_logo-reddit' ),
					 array( 'nc-icon-outline socials-1_logo-rss' => 'socials-1_logo-rss' ),
					 array( 'nc-icon-outline socials-1_logo-shopify' => 'socials-1_logo-shopify' ),
					 array( 'nc-icon-outline socials-1_logo-skype' => 'socials-1_logo-skype' ),
					 array( 'nc-icon-outline socials-1_logo-slack' => 'socials-1_logo-slack' ),
					 array( 'nc-icon-outline socials-1_logo-soundcloud' => 'socials-1_logo-soundcloud' ),
					 array( 'nc-icon-outline socials-1_logo-spotify' => 'socials-1_logo-spotify' ),
					 array( 'nc-icon-outline socials-1_logo-trello' => 'socials-1_logo-trello' ),
					 array( 'nc-icon-outline socials-1_logo-tumblr' => 'socials-1_logo-tumblr' ),
					 array( 'nc-icon-outline socials-1_logo-twitter' => 'socials-1_logo-twitter' ),
					 array( 'nc-icon-outline socials-1_logo-vimeo' => 'socials-1_logo-vimeo' ),
					 array( 'nc-icon-outline socials-1_logo-vine' => 'socials-1_logo-vine' ),
					 array( 'nc-icon-outline socials-1_logo-whatsapp' => 'socials-1_logo-whatsapp' ),
					 array( 'nc-icon-outline socials-1_logo-wordpress' => 'socials-1_logo-wordpress' ),
					 array( 'nc-icon-outline socials-1_logo-yelp' => 'socials-1_logo-yelp' ),
					 array( 'nc-icon-outline socials-1_logo-youtube' => 'socials-1_logo-youtube' ),
				),
				'Sport' => array( 
					 array( 'nc-icon-outline sport_badminton' => 'sport_badminton' ),
					 array( 'nc-icon-outline sport_baseball-ball' => 'sport_baseball-ball' ),
					 array( 'nc-icon-outline sport_baseball-bat' => 'sport_baseball-bat' ),
					 array( 'nc-icon-outline sport_baseball' => 'sport_baseball' ),
					 array( 'nc-icon-outline sport_basketball-12' => 'sport_basketball-12' ),
					 array( 'nc-icon-outline sport_basketball-13' => 'sport_basketball-13' ),
					 array( 'nc-icon-outline sport_boxing' => 'sport_boxing' ),
					 array( 'nc-icon-outline sport_cardio' => 'sport_cardio' ),
					 array( 'nc-icon-outline sport_cricket' => 'sport_cricket' ),
					 array( 'nc-icon-outline sport_crown' => 'sport_crown' ),
					 array( 'nc-icon-outline sport_dart' => 'sport_dart' ),
					 array( 'nc-icon-outline sport_dumbbells' => 'sport_dumbbells' ),
					 array( 'nc-icon-outline sport_energy-drink' => 'sport_energy-drink' ),
					 array( 'nc-icon-outline sport_energy-supplement' => 'sport_energy-supplement' ),
					 array( 'nc-icon-outline sport_fencing' => 'sport_fencing' ),
					 array( 'nc-icon-outline sport_fishing' => 'sport_fishing' ),
					 array( 'nc-icon-outline sport_flag-finish' => 'sport_flag-finish' ),
					 array( 'nc-icon-outline sport_football-headguard' => 'sport_football-headguard' ),
					 array( 'nc-icon-outline sport_golf' => 'sport_golf' ),
					 array( 'nc-icon-outline sport_helmet' => 'sport_helmet' ),
					 array( 'nc-icon-outline sport_hockey' => 'sport_hockey' ),
					 array( 'nc-icon-outline sport_kettlebell' => 'sport_kettlebell' ),
					 array( 'nc-icon-outline sport_ping-pong' => 'sport_ping-pong' ),
					 array( 'nc-icon-outline sport_podium-trophy' => 'sport_podium-trophy' ),
					 array( 'nc-icon-outline sport_podium' => 'sport_podium' ),
					 array( 'nc-icon-outline sport_rope' => 'sport_rope' ),
					 array( 'nc-icon-outline sport_rugby' => 'sport_rugby' ),
					 array( 'nc-icon-outline sport_shaker' => 'sport_shaker' ),
					 array( 'nc-icon-outline sport_shoe-run' => 'sport_shoe-run' ),
					 array( 'nc-icon-outline sport_skateboard' => 'sport_skateboard' ),
					 array( 'nc-icon-outline sport_snowboard' => 'sport_snowboard' ),
					 array( 'nc-icon-outline sport_soccer-field' => 'sport_soccer-field' ),
					 array( 'nc-icon-outline sport_steering-wheel' => 'sport_steering-wheel' ),
					 array( 'nc-icon-outline sport_supplement' => 'sport_supplement' ),
					 array( 'nc-icon-outline sport_surf' => 'sport_surf' ),
					 array( 'nc-icon-outline sport_tactic' => 'sport_tactic' ),
					 array( 'nc-icon-outline sport_tennis-ball' => 'sport_tennis-ball' ),
					 array( 'nc-icon-outline sport_tennis' => 'sport_tennis' ),
					 array( 'nc-icon-outline sport_trophy' => 'sport_trophy' ),
					 array( 'nc-icon-outline sport_user-balance' => 'sport_user-balance' ),
					 array( 'nc-icon-outline sport_user-climb' => 'sport_user-climb' ),
					 array( 'nc-icon-outline sport_user-meditation' => 'sport_user-meditation' ),
					 array( 'nc-icon-outline sport_user-run' => 'sport_user-run' ),
					 array( 'nc-icon-outline sport_user-snowboard' => 'sport_user-snowboard' ),
					 array( 'nc-icon-outline sport_user-swim' => 'sport_user-swim' ),
					 array( 'nc-icon-outline sport_volleyball' => 'sport_volleyball' ),
					 array( 'nc-icon-outline sport_whistle' => 'sport_whistle' ),
				),
				'Technology' => array( 
					 array( 'nc-icon-outline tech_cable-49' => 'tech_cable-49' ),
					 array( 'nc-icon-outline tech_cable-50' => 'tech_cable-50' ),
					 array( 'nc-icon-outline tech_cd-reader' => 'tech_cd-reader' ),
					 array( 'nc-icon-outline tech_computer-monitor' => 'tech_computer-monitor' ),
					 array( 'nc-icon-outline tech_computer-old' => 'tech_computer-old' ),
					 array( 'nc-icon-outline tech_computer' => 'tech_computer' ),
					 array( 'nc-icon-outline tech_controller-modern' => 'tech_controller-modern' ),
					 array( 'nc-icon-outline tech_controller' => 'tech_controller' ),
					 array( 'nc-icon-outline tech_desktop-screen' => 'tech_desktop-screen' ),
					 array( 'nc-icon-outline tech_desktop' => 'tech_desktop' ),
					 array( 'nc-icon-outline tech_disk-reader' => 'tech_disk-reader' ),
					 array( 'nc-icon-outline tech_disk' => 'tech_disk' ),
					 array( 'nc-icon-outline tech_gopro' => 'tech_gopro' ),
					 array( 'nc-icon-outline tech_headphones' => 'tech_headphones' ),
					 array( 'nc-icon-outline tech_keyboard-mouse' => 'tech_keyboard-mouse' ),
					 array( 'nc-icon-outline tech_keyboard-wifi' => 'tech_keyboard-wifi' ),
					 array( 'nc-icon-outline tech_keyboard' => 'tech_keyboard' ),
					 array( 'nc-icon-outline tech_laptop-camera' => 'tech_laptop-camera' ),
					 array( 'nc-icon-outline tech_laptop-front' => 'tech_laptop-front' ),
					 array( 'nc-icon-outline tech_laptop' => 'tech_laptop' ),
					 array( 'nc-icon-outline tech_mobile-button' => 'tech_mobile-button' ),
					 array( 'nc-icon-outline tech_mobile-camera' => 'tech_mobile-camera' ),
					 array( 'nc-icon-outline tech_mobile-recharger-08' => 'tech_mobile-recharger-08' ),
					 array( 'nc-icon-outline tech_mobile-recharger-09' => 'tech_mobile-recharger-09' ),
					 array( 'nc-icon-outline tech_mobile-toolbar' => 'tech_mobile-toolbar' ),
					 array( 'nc-icon-outline tech_mobile' => 'tech_mobile' ),
					 array( 'nc-icon-outline tech_music' => 'tech_music' ),
					 array( 'nc-icon-outline tech_navigation' => 'tech_navigation' ),
					 array( 'nc-icon-outline tech_player-19' => 'tech_player-19' ),
					 array( 'nc-icon-outline tech_player-48' => 'tech_player-48' ),
					 array( 'nc-icon-outline tech_print-fold' => 'tech_print-fold' ),
					 array( 'nc-icon-outline tech_print-round-fold' => 'tech_print-round-fold' ),
					 array( 'nc-icon-outline tech_print-round' => 'tech_print-round' ),
					 array( 'nc-icon-outline tech_print' => 'tech_print' ),
					 array( 'nc-icon-outline tech_ram' => 'tech_ram' ),
					 array( 'nc-icon-outline tech_remote' => 'tech_remote' ),
					 array( 'nc-icon-outline tech_signal' => 'tech_signal' ),
					 array( 'nc-icon-outline tech_socket' => 'tech_socket' ),
					 array( 'nc-icon-outline tech_sync' => 'tech_sync' ),
					 array( 'nc-icon-outline tech_tablet-button' => 'tech_tablet-button' ),
					 array( 'nc-icon-outline tech_tablet-reader-31' => 'tech_tablet-reader-31' ),
					 array( 'nc-icon-outline tech_tablet-reader-42' => 'tech_tablet-reader-42' ),
					 array( 'nc-icon-outline tech_tablet-toolbar' => 'tech_tablet-toolbar' ),
					 array( 'nc-icon-outline tech_tablet' => 'tech_tablet' ),
					 array( 'nc-icon-outline tech_tv-old' => 'tech_tv-old' ),
					 array( 'nc-icon-outline tech_tv' => 'tech_tv' ),
					 array( 'nc-icon-outline tech_watch-circle' => 'tech_watch-circle' ),
					 array( 'nc-icon-outline tech_watch-time' => 'tech_watch-time' ),
					 array( 'nc-icon-outline tech_watch' => 'tech_watch' ),
					 array( 'nc-icon-outline tech_webcam-38' => 'tech_webcam-38' ),
					 array( 'nc-icon-outline tech_webcam-39' => 'tech_webcam-39' ),
					 array( 'nc-icon-outline tech_wifi-router' => 'tech_wifi-router' ),
					 array( 'nc-icon-outline tech_wifi' => 'tech_wifi' ),
				),
				'Text Editing' => array( 
					 array( 'nc-icon-outline text_align-center' => 'text_align-center' ),
					 array( 'nc-icon-outline text_align-justify' => 'text_align-justify' ),
					 array( 'nc-icon-outline text_align-left' => 'text_align-left' ),
					 array( 'nc-icon-outline text_align-right' => 'text_align-right' ),
					 array( 'nc-icon-outline text_background' => 'text_background' ),
					 array( 'nc-icon-outline text_bold' => 'text_bold' ),
					 array( 'nc-icon-outline text_capitalize' => 'text_capitalize' ),
					 array( 'nc-icon-outline text_caps-all' => 'text_caps-all' ),
					 array( 'nc-icon-outline text_caps-small' => 'text_caps-small' ),
					 array( 'nc-icon-outline text_color' => 'text_color' ),
					 array( 'nc-icon-outline text_edit' => 'text_edit' ),
					 array( 'nc-icon-outline text_italic' => 'text_italic' ),
					 array( 'nc-icon-outline text_line-height' => 'text_line-height' ),
					 array( 'nc-icon-outline text_list-bullet' => 'text_list-bullet' ),
					 array( 'nc-icon-outline text_list-numbers' => 'text_list-numbers' ),
					 array( 'nc-icon-outline text_margin-left' => 'text_margin-left' ),
					 array( 'nc-icon-outline text_margin-right' => 'text_margin-right' ),
					 array( 'nc-icon-outline text_quote' => 'text_quote' ),
					 array( 'nc-icon-outline text_scale-horizontal' => 'text_scale-horizontal' ),
					 array( 'nc-icon-outline text_scale-vertical' => 'text_scale-vertical' ),
					 array( 'nc-icon-outline text_size' => 'text_size' ),
					 array( 'nc-icon-outline text_strikethrough' => 'text_strikethrough' ),
					 array( 'nc-icon-outline text_subscript' => 'text_subscript' ),
					 array( 'nc-icon-outline text_superscript' => 'text_superscript' ),
					 array( 'nc-icon-outline text_tracking' => 'text_tracking' ),
					 array( 'nc-icon-outline text_underline' => 'text_underline' ),
				),
				'Touch Gestures' => array( 
					 array( 'nc-icon-outline gestures_2x-drag-down' => 'gestures_2x-drag-down' ),
					 array( 'nc-icon-outline gestures_2x-drag-up' => 'gestures_2x-drag-up' ),
					 array( 'nc-icon-outline gestures_2x-swipe-down' => 'gestures_2x-swipe-down' ),
					 array( 'nc-icon-outline gestures_2x-swipe-left' => 'gestures_2x-swipe-left' ),
					 array( 'nc-icon-outline gestures_2x-swipe-right' => 'gestures_2x-swipe-right' ),
					 array( 'nc-icon-outline gestures_2x-swipe-up' => 'gestures_2x-swipe-up' ),
					 array( 'nc-icon-outline gestures_2x-tap' => 'gestures_2x-tap' ),
					 array( 'nc-icon-outline gestures_3x-swipe-left' => 'gestures_3x-swipe-left' ),
					 array( 'nc-icon-outline gestures_3x-swipe-right' => 'gestures_3x-swipe-right' ),
					 array( 'nc-icon-outline gestures_3x-swipe-up' => 'gestures_3x-swipe-up' ),
					 array( 'nc-icon-outline gestures_3x-tap' => 'gestures_3x-tap' ),
					 array( 'nc-icon-outline gestures_4x-swipe-left' => 'gestures_4x-swipe-left' ),
					 array( 'nc-icon-outline gestures_4x-swipe-right' => 'gestures_4x-swipe-right' ),
					 array( 'nc-icon-outline gestures_4x-swipe-up' => 'gestures_4x-swipe-up' ),
					 array( 'nc-icon-outline gestures_active-38' => 'gestures_active-38' ),
					 array( 'nc-icon-outline gestures_active-40' => 'gestures_active-40' ),
					 array( 'nc-icon-outline gestures_camera' => 'gestures_camera' ),
					 array( 'nc-icon-outline gestures_double-tap' => 'gestures_double-tap' ),
					 array( 'nc-icon-outline gestures_drag-21' => 'gestures_drag-21' ),
					 array( 'nc-icon-outline gestures_drag-31' => 'gestures_drag-31' ),
					 array( 'nc-icon-outline gestures_drag-down' => 'gestures_drag-down' ),
					 array( 'nc-icon-outline gestures_drag-left' => 'gestures_drag-left' ),
					 array( 'nc-icon-outline gestures_drag-right' => 'gestures_drag-right' ),
					 array( 'nc-icon-outline gestures_drag-up' => 'gestures_drag-up' ),
					 array( 'nc-icon-outline gestures_flick-down' => 'gestures_flick-down' ),
					 array( 'nc-icon-outline gestures_flick-left' => 'gestures_flick-left' ),
					 array( 'nc-icon-outline gestures_flick-right' => 'gestures_flick-right' ),
					 array( 'nc-icon-outline gestures_flick-up' => 'gestures_flick-up' ),
					 array( 'nc-icon-outline gestures_grab' => 'gestures_grab' ),
					 array( 'nc-icon-outline gestures_hold' => 'gestures_hold' ),
					 array( 'nc-icon-outline gestures_pin' => 'gestures_pin' ),
					 array( 'nc-icon-outline gestures_pinch' => 'gestures_pinch' ),
					 array( 'nc-icon-outline gestures_rotate-22' => 'gestures_rotate-22' ),
					 array( 'nc-icon-outline gestures_rotate-23' => 'gestures_rotate-23' ),
					 array( 'nc-icon-outline gestures_scan' => 'gestures_scan' ),
					 array( 'nc-icon-outline gestures_scroll-horitontal' => 'gestures_scroll-horitontal' ),
					 array( 'nc-icon-outline gestures_scroll-vertical' => 'gestures_scroll-vertical' ),
					 array( 'nc-icon-outline gestures_stretch' => 'gestures_stretch' ),
					 array( 'nc-icon-outline gestures_swipe-bottom' => 'gestures_swipe-bottom' ),
					 array( 'nc-icon-outline gestures_swipe-left' => 'gestures_swipe-left' ),
					 array( 'nc-icon-outline gestures_swipe-right' => 'gestures_swipe-right' ),
					 array( 'nc-icon-outline gestures_swipe-up' => 'gestures_swipe-up' ),
					 array( 'nc-icon-outline gestures_tap-01' => 'gestures_tap-01' ),
					 array( 'nc-icon-outline gestures_tap-02' => 'gestures_tap-02' ),
				),
				'Transportation' => array( 
					 array( 'nc-icon-outline transportation_air-baloon' => 'transportation_air-baloon' ),
					 array( 'nc-icon-outline transportation_bike-sport' => 'transportation_bike-sport' ),
					 array( 'nc-icon-outline transportation_bike' => 'transportation_bike' ),
					 array( 'nc-icon-outline transportation_boat-front' => 'transportation_boat-front' ),
					 array( 'nc-icon-outline transportation_boat-small-02' => 'transportation_boat-small-02' ),
					 array( 'nc-icon-outline transportation_boat-small-03' => 'transportation_boat-small-03' ),
					 array( 'nc-icon-outline transportation_boat' => 'transportation_boat' ),
					 array( 'nc-icon-outline transportation_bus-front-10' => 'transportation_bus-front-10' ),
					 array( 'nc-icon-outline transportation_bus-front-12' => 'transportation_bus-front-12' ),
					 array( 'nc-icon-outline transportation_bus' => 'transportation_bus' ),
					 array( 'nc-icon-outline transportation_car-front' => 'transportation_car-front' ),
					 array( 'nc-icon-outline transportation_car-simple' => 'transportation_car-simple' ),
					 array( 'nc-icon-outline transportation_car-sport' => 'transportation_car-sport' ),
					 array( 'nc-icon-outline transportation_car-taxi' => 'transportation_car-taxi' ),
					 array( 'nc-icon-outline transportation_car' => 'transportation_car' ),
					 array( 'nc-icon-outline transportation_helicopter' => 'transportation_helicopter' ),
					 array( 'nc-icon-outline transportation_helmet' => 'transportation_helmet' ),
					 array( 'nc-icon-outline transportation_light-traffic' => 'transportation_light-traffic' ),
					 array( 'nc-icon-outline transportation_moto' => 'transportation_moto' ),
					 array( 'nc-icon-outline transportation_plane-17' => 'transportation_plane-17' ),
					 array( 'nc-icon-outline transportation_plane-18' => 'transportation_plane-18' ),
					 array( 'nc-icon-outline transportation_road' => 'transportation_road' ),
					 array( 'nc-icon-outline transportation_skateboard' => 'transportation_skateboard' ),
					 array( 'nc-icon-outline transportation_tractor' => 'transportation_tractor' ),
					 array( 'nc-icon-outline transportation_train-speed' => 'transportation_train-speed' ),
					 array( 'nc-icon-outline transportation_train' => 'transportation_train' ),
					 array( 'nc-icon-outline transportation_tram' => 'transportation_tram"' ),
					 array( 'nc-icon-outline transportation_truck-front' => 'transportation_truck-front' ),
					 array( 'nc-icon-outline transportation_vespa-front' => 'transportation_vespa-front' ),
					 array( 'nc-icon-outline transportation_vespa' => 'transportation_vespa' ),
				),
				'Travel' => array( 
					 array( 'nc-icon-outline travel_axe' => 'travel_axe' ),
					 array( 'nc-icon-outline travel_backpack' => 'travel_backpack' ),
					 array( 'nc-icon-outline travel_bag' => 'travel_bag' ),
					 array( 'nc-icon-outline travel_barbecue' => 'travel_barbecue' ),
					 array( 'nc-icon-outline travel_beach-umbrella' => 'travel_beach-umbrella' ),
					 array( 'nc-icon-outline travel_berlin' => 'travel_berlin' ),
					 array( 'nc-icon-outline travel_binocular' => 'travel_binocular' ),
					 array( 'nc-icon-outline travel_camper' => 'travel_camper' ),
					 array( 'nc-icon-outline travel_camping' => 'travel_camping' ),
					 array( 'nc-icon-outline travel_castle' => 'travel_castle' ),
					 array( 'nc-icon-outline travel_china' => 'travel_china' ),
					 array( 'nc-icon-outline travel_church' => 'travel_church' ),
					 array( 'nc-icon-outline travel_drink' => 'travel_drink' ),
					 array( 'nc-icon-outline travel_explore' => 'travel_explore' ),
					 array( 'nc-icon-outline travel_fire' => 'travel_fire' ),
					 array( 'nc-icon-outline travel_hotel-bell' => 'travel_hotel-bell' ),
					 array( 'nc-icon-outline travel_hotel-symbol' => 'travel_hotel-symbol' ),
					 array( 'nc-icon-outline travel_hotel' => 'travel_hotel' ),
					 array( 'nc-icon-outline travel_hut' => 'travel_hut' ),
					 array( 'nc-icon-outline travel_igloo' => 'travel_igloo' ),
					 array( 'nc-icon-outline travel_info' => 'travel_info' ),
					 array( 'nc-icon-outline travel_istanbul' => 'travel_istanbul' ),
					 array( 'nc-icon-outline travel_jellyfish' => 'travel_jellyfish' ),
					 array( 'nc-icon-outline travel_lamp' => 'travel_lamp' ),
					 array( 'nc-icon-outline travel_lighthouse' => 'travel_lighthouse' ),
					 array( 'nc-icon-outline travel_london' => 'travel_london' ),
					 array( 'nc-icon-outline travel_luggage' => 'travel_luggage' ),
					 array( 'nc-icon-outline travel_mosque' => 'travel_mosque' ),
					 array( 'nc-icon-outline travel_ny' => 'travel_ny' ),
					 array( 'nc-icon-outline travel_octopus' => 'travel_octopus' ),
					 array( 'nc-icon-outline travel_paris-tower' => 'travel_paris-tower' ),
					 array( 'nc-icon-outline travel_passport' => 'travel_passport' ),
					 array( 'nc-icon-outline travel_pickaxe' => 'travel_pickaxe' ),
					 array( 'nc-icon-outline travel_pool' => 'travel_pool' ),
					 array( 'nc-icon-outline travel_pyramid' => 'travel_pyramid' ),
					 array( 'nc-icon-outline travel_rackets' => 'travel_rackets' ),
					 array( 'nc-icon-outline travel_rio' => 'travel_rio' ),
					 array( 'nc-icon-outline travel_road-sign-left' => 'travel_road-sign-left' ),
					 array( 'nc-icon-outline travel_road-sign-right' => 'travel_road-sign-right' ),
					 array( 'nc-icon-outline travel_rome' => 'travel_rome' ),
					 array( 'nc-icon-outline travel_rowing' => 'travel_rowing' ),
					 array( 'nc-icon-outline travel_sea-mask' => 'travel_sea-mask' ),
					 array( 'nc-icon-outline travel_sf-bridge' => 'travel_sf-bridge' ),
					 array( 'nc-icon-outline travel_shark' => 'travel_shark' ),
					 array( 'nc-icon-outline travel_spa' => 'travel_spa' ),
					 array( 'nc-icon-outline travel_sunglasses' => 'travel_sunglasses' ),
					 array( 'nc-icon-outline travel_surf' => 'travel_surf' ),
					 array( 'nc-icon-outline travel_swimsuit' => 'travel_swimsuit' ),
					 array( 'nc-icon-outline travel_swimwear' => 'travel_swimwear' ),
					 array( 'nc-icon-outline travel_swiss-knife' => 'travel_swiss-knife' ),
					 array( 'nc-icon-outline travel_temple-02' => 'travel_temple-02' ),
					 array( 'nc-icon-outline travel_temple-25' => 'travel_temple-25' ),
					 array( 'nc-icon-outline travel_trolley' => 'travel_trolley' ),
					 array( 'nc-icon-outline travel_white-house' => 'travel_white-house' ),
					 array( 'nc-icon-outline travel_world' => 'travel_world' ),
					 array( 'nc-icon-outline travel_worldmap' => 'travel_worldmap' ),
				),
				'User Interface' => array( 
					 array( 'nc-icon-outline ui-1_analytics-88' => 'ui-1_analytics-88' ),
					 array( 'nc-icon-outline ui-1_analytics-89' => 'ui-1_analytics-89' ),
					 array( 'nc-icon-outline ui-1_attach-86' => 'ui-1_attach-86' ),
					 array( 'nc-icon-outline ui-1_attach-87' => 'ui-1_attach-87' ),
					 array( 'nc-icon-outline ui-1_bell-53' => 'ui-1_bell-53' ),
					 array( 'nc-icon-outline ui-1_bell-54' => 'ui-1_bell-54' ),
					 array( 'nc-icon-outline ui-1_bell-55' => 'ui-1_bell-55' ),
					 array( 'nc-icon-outline ui-1_bold-add' => 'ui-1_bold-add' ),
					 array( 'nc-icon-outline ui-1_bold-delete' => 'ui-1_bold-delete' ),
					 array( 'nc-icon-outline ui-1_bold-remove' => 'ui-1_bold-remove' ),
					 array( 'nc-icon-outline ui-1_bookmark-add' => 'ui-1_bookmark-add' ),
					 array( 'nc-icon-outline ui-1_bookmark-remove' => 'ui-1_bookmark-remove' ),
					 array( 'nc-icon-outline ui-1_calendar-57' => 'ui-1_calendar-57' ),
					 array( 'nc-icon-outline ui-1_calendar-60' => 'ui-1_calendar-60' ),
					 array( 'nc-icon-outline ui-1_calendar-check-59' => 'ui-1_calendar-check-59' ),
					 array( 'nc-icon-outline ui-1_calendar-check-62' => 'ui-1_calendar-check-62' ),
					 array( 'nc-icon-outline ui-1_calendar-grid-58' => 'ui-1_calendar-grid-58' ),
					 array( 'nc-icon-outline ui-1_calendar-grid-61' => 'ui-1_calendar-grid-61' ),
					 array( 'nc-icon-outline ui-1_check-bold' => 'ui-1_check-bold' ),
					 array( 'nc-icon-outline ui-1_check-circle-07' => 'ui-1_check-circle-07' ),
					 array( 'nc-icon-outline ui-1_check-circle-08' => 'ui-1_check-circle-08' ),
					 array( 'nc-icon-outline ui-1_check-curve' => 'ui-1_check-curve' ),
					 array( 'nc-icon-outline ui-1_check-simple' => 'ui-1_check-simple' ),
					 array( 'nc-icon-outline ui-1_check-small' => 'ui-1_check-small' ),
					 array( 'nc-icon-outline ui-1_check-square-09' => 'ui-1_check-square-09' ),
					 array( 'nc-icon-outline ui-1_check-square-11' => 'ui-1_check-square-11' ),
					 array( 'nc-icon-outline ui-1_check' => 'ui-1_check' ),
					 array( 'nc-icon-outline ui-1_circle-add' => 'ui-1_circle-add' ),
					 array( 'nc-icon-outline ui-1_circle-bold-add' => 'ui-1_circle-bold-add' ),
					 array( 'nc-icon-outline ui-1_circle-bold-remove' => 'ui-1_circle-bold-remove' ),
					 array( 'nc-icon-outline ui-1_circle-delete' => 'ui-1_circle-delete' ),
					 array( 'nc-icon-outline ui-1_circle-remove' => 'ui-1_circle-remove' ),
					 array( 'nc-icon-outline ui-1_dashboard-29' => 'ui-1_dashboard-29' ),
					 array( 'nc-icon-outline ui-1_dashboard-30' => 'ui-1_dashboard-30' ),
					 array( 'nc-icon-outline ui-1_dashboard-half' => 'ui-1_dashboard-half' ),
					 array( 'nc-icon-outline ui-1_dashboard-level' => 'ui-1_dashboard-level' ),
					 array( 'nc-icon-outline ui-1_database' => 'ui-1_database' ),
					 array( 'nc-icon-outline ui-1_drop' => 'ui-1_drop' ),
					 array( 'nc-icon-outline ui-1_edit-71' => 'ui-1_edit-71' ),
					 array( 'nc-icon-outline ui-1_edit-72' => 'ui-1_edit-72' ),
					 array( 'nc-icon-outline ui-1_edit-73' => 'ui-1_edit-73' ),
					 array( 'nc-icon-outline ui-1_edit-74' => 'ui-1_edit-74' ),
					 array( 'nc-icon-outline ui-1_edit-75' => 'ui-1_edit-75' ),
					 array( 'nc-icon-outline ui-1_edit-76' => 'ui-1_edit-76' ),
					 array( 'nc-icon-outline ui-1_edit-77' => 'ui-1_edit-77' ),
					 array( 'nc-icon-outline ui-1_edit-78' => 'ui-1_edit-78' ),
					 array( 'nc-icon-outline ui-1_email-83' => 'ui-1_email-83' ),
					 array( 'nc-icon-outline ui-1_email-84' => 'ui-1_email-84' ),
					 array( 'nc-icon-outline ui-1_email-85' => 'ui-1_email-85' ),
					 array( 'nc-icon-outline ui-1_eye-17' => 'ui-1_eye-17' ),
					 array( 'nc-icon-outline ui-1_eye-19' => 'ui-1_eye-19' ),
					 array( 'nc-icon-outline ui-1_eye-ban-18' => 'ui-1_eye-ban-18' ),
					 array( 'nc-icon-outline ui-1_eye-ban-20' => 'ui-1_eye-ban-20' ),
					 array( 'nc-icon-outline ui-1_flame' => 'ui-1_flame' ),
					 array( 'nc-icon-outline ui-1_home-51' => 'ui-1_home-51' ),
					 array( 'nc-icon-outline ui-1_home-52' => 'ui-1_home-52' ),
					 array( 'nc-icon-outline ui-1_home-minimal' => 'ui-1_home-minimal' ),
					 array( 'nc-icon-outline ui-1_home-simple' => 'ui-1_home-simple' ),
					 array( 'nc-icon-outline ui-1_leaf-80' => 'ui-1_leaf-80' ),
					 array( 'nc-icon-outline ui-1_leaf-81' => 'ui-1_leaf-81' ),
					 array( 'nc-icon-outline ui-1_leaf-edit' => 'ui-1_leaf-edit' ),
					 array( 'nc-icon-outline ui-1_lock-circle-open' => 'ui-1_lock-circle-open' ),
					 array( 'nc-icon-outline ui-1_lock-circle' => 'ui-1_lock-circle' ),
					 array( 'nc-icon-outline ui-1_lock-open' => 'ui-1_lock-open' ),
					 array( 'nc-icon-outline ui-1_lock' => 'ui-1_lock' ),
					 array( 'nc-icon-outline ui-1_notification-69' => 'ui-1_notification-69' ),
					 array( 'nc-icon-outline ui-1_notification-70' => 'ui-1_notification-70' ),
					 array( 'nc-icon-outline ui-1_pencil' => 'ui-1_pencil' ),
					 array( 'nc-icon-outline ui-1_preferences-circle-rotate' => 'ui-1_preferences-circle-rotate' ),
					 array( 'nc-icon-outline ui-1_preferences-circle' => 'ui-1_preferences-circle' ),
					 array( 'nc-icon-outline ui-1_preferences-container-circle-rotate' => 'ui-1_preferences-container-circle-rotate' ),
					 array( 'nc-icon-outline ui-1_preferences-container-circle' => 'ui-1_preferences-container-circle' ),
					 array( 'nc-icon-outline ui-1_preferences-container-rotate' => 'ui-1_preferences-container-rotate' ),
					 array( 'nc-icon-outline ui-1_preferences-container' => 'ui-1_preferences-container' ),
					 array( 'nc-icon-outline ui-1_preferences-rotate' => 'ui-1_preferences-rotate' ),
					 array( 'nc-icon-outline ui-1_preferences' => 'ui-1_preferences' ),
					 array( 'nc-icon-outline ui-1_send' => 'ui-1_send' ),
					 array( 'nc-icon-outline ui-1_settings-gear-63' => 'ui-1_settings-gear-63' ),
					 array( 'nc-icon-outline ui-1_settings-gear-64' => 'ui-1_settings-gear-64' ),
					 array( 'nc-icon-outline ui-1_settings-gear-65' => 'ui-1_settings-gear-65' ),
					 array( 'nc-icon-outline ui-1_settings-tool-66' => 'ui-1_settings-tool-66' ),
					 array( 'nc-icon-outline ui-1_settings-tool-67' => 'ui-1_settings-tool-67' ),
					 array( 'nc-icon-outline ui-1_settings' => 'ui-1_settings' ),
					 array( 'nc-icon-outline ui-1_simple-add' => 'ui-1_simple-add' ),
					 array( 'nc-icon-outline ui-1_simple-delete' => 'ui-1_simple-delete' ),
					 array( 'nc-icon-outline ui-1_simple-remove' => 'ui-1_simple-remove' ),
					 array( 'nc-icon-outline ui-1_trash-round' => 'ui-1_trash-round' ),
					 array( 'nc-icon-outline ui-1_trash-simple' => 'ui-1_trash-simple' ),
					 array( 'nc-icon-outline ui-1_trash' => 'ui-1_trash' ),
					 array( 'nc-icon-outline ui-1_ui-03' => 'ui-1_ui-03' ),
					 array( 'nc-icon-outline ui-1_ui-04' => 'ui-1_ui-04' ),
					 array( 'nc-icon-outline ui-1_zoom-bold-in' => 'ui-1_zoom-bold-in' ),
					 array( 'nc-icon-outline ui-1_zoom-bold-out' => 'ui-1_zoom-bold-out' ),
					 array( 'nc-icon-outline ui-1_zoom-bold' => 'ui-1_zoom-bold' ),
					 array( 'nc-icon-outline ui-1_zoom-in' => 'ui-1_zoom-in' ),
					 array( 'nc-icon-outline ui-1_zoom-out' => 'ui-1_zoom-out' ),
					 array( 'nc-icon-outline ui-1_zoom-split-in' => 'ui-1_zoom-split-in' ),
					 array( 'nc-icon-outline ui-1_zoom-split-out' => 'ui-1_zoom-split-out' ),
					 array( 'nc-icon-outline ui-1_zoom-split' => 'ui-1_zoom-split' ),
					 array( 'nc-icon-outline ui-1_zoom' => 'ui-1_zoom' ),
					 array( 'nc-icon-outline ui-2_alert' => 'ui-2_alert' ),
					 array( 'nc-icon-outline ui-2_alert-' => 'ui-2_alert-' ),
					 array( 'nc-icon-outline ui-2_alert-circle' => 'ui-2_alert-circle' ),
					 array( 'nc-icon-outline ui-2_alert-circle-' => 'ui-2_alert-circle-' ),
					 array( 'nc-icon-outline ui-2_alert-circle-i' => 'ui-2_alert-circle-i' ),
					 array( 'nc-icon-outline ui-2_alert-i' => 'ui-2_alert-i' ),
					 array( 'nc-icon-outline ui-2_alert-square' => 'ui-2_alert-square' ),
					 array( 'nc-icon-outline ui-2_alert-square-' => 'ui-2_alert-square-' ),
					 array( 'nc-icon-outline ui-2_alert-square-i' => 'ui-2_alert-square-i' ),
					 array( 'nc-icon-outline ui-2_archive' => 'ui-2_archive' ),
					 array( 'nc-icon-outline ui-2_ban-bold' => 'ui-2_ban-bold' ),
					 array( 'nc-icon-outline ui-2_ban' => 'ui-2_ban' ),
					 array( 'nc-icon-outline ui-2_battery-81' => 'ui-2_battery-81' ),
					 array( 'nc-icon-outline ui-2_battery-83' => 'ui-2_battery-83' ),
					 array( 'nc-icon-outline ui-2_battery-half' => 'ui-2_battery-half' ),
					 array( 'nc-icon-outline ui-2_battery-low' => 'ui-2_battery-low' ),
					 array( 'nc-icon-outline ui-2_bluetooth' => 'ui-2_bluetooth' ),
					 array( 'nc-icon-outline ui-2_book' => 'ui-2_book' ),
					 array( 'nc-icon-outline ui-2_chart-bar-52' => 'ui-2_chart-bar-52' ),
					 array( 'nc-icon-outline ui-2_chart-bar-53' => 'ui-2_chart-bar-53' ),
					 array( 'nc-icon-outline ui-2_chat-content' => 'ui-2_chat-content' ),
					 array( 'nc-icon-outline ui-2_chat-round-content' => 'ui-2_chat-round-content' ),
					 array( 'nc-icon-outline ui-2_chat-round' => 'ui-2_chat-round' ),
					 array( 'nc-icon-outline ui-2_chat' => 'ui-2_chat' ),
					 array( 'nc-icon-outline ui-2_circle-bold-delete' => 'ui-2_circle-bold-delete' ),
					 array( 'nc-icon-outline ui-2_cloud-25' => 'ui-2_cloud-25' ),
					 array( 'nc-icon-outline ui-2_cloud-26' => 'ui-2_cloud-26' ),
					 array( 'nc-icon-outline ui-2_disk' => 'ui-2_disk' ),
					 array( 'nc-icon-outline ui-2_enlarge-57' => 'ui-2_enlarge-57' ),
					 array( 'nc-icon-outline ui-2_enlarge-58' => 'ui-2_enlarge-58' ),
					 array( 'nc-icon-outline ui-2_enlarge-59' => 'ui-2_enlarge-59' ),
					 array( 'nc-icon-outline ui-2_fat-add' => 'ui-2_fat-add' ),
					 array( 'nc-icon-outline ui-2_fat-delete' => 'ui-2_fat-delete' ),
					 array( 'nc-icon-outline ui-2_fat-remove' => 'ui-2_fat-remove' ),
					 array( 'nc-icon-outline ui-2_favourite-28' => 'ui-2_favourite-28' ),
					 array( 'nc-icon-outline ui-2_favourite-31' => 'ui-2_favourite-31' ),
					 array( 'nc-icon-outline ui-2_favourite-add-29' => 'ui-2_favourite-add-29' ),
					 array( 'nc-icon-outline ui-2_favourite-add-32' => 'ui-2_favourite-add-32' ),
					 array( 'nc-icon-outline ui-2_favourite-remove-30' => 'ui-2_favourite-remove-30' ),
					 array( 'nc-icon-outline ui-2_favourite-remove-33' => 'ui-2_favourite-remove-33' ),
					 array( 'nc-icon-outline ui-2_filter' => 'ui-2_filter' ),
					 array( 'nc-icon-outline ui-2_fullsize' => 'ui-2_fullsize' ),
					 array( 'nc-icon-outline ui-2_grid-45' => 'ui-2_grid-45' ),
					 array( 'nc-icon-outline ui-2_grid-46' => 'ui-2_grid-46' ),
					 array( 'nc-icon-outline ui-2_grid-48' => 'ui-2_grid-48' ),
					 array( 'nc-icon-outline ui-2_grid-49' => 'ui-2_grid-49' ),
					 array( 'nc-icon-outline ui-2_grid-50' => 'ui-2_grid-50' ),
					 array( 'nc-icon-outline ui-2_grid-square' => 'ui-2_grid-square' ),
					 array( 'nc-icon-outline ui-2_hourglass' => 'ui-2_hourglass' ),
					 array( 'nc-icon-outline ui-2_lab' => 'ui-2_lab' ),
					 array( 'nc-icon-outline ui-2_layers' => 'ui-2_layers' ),
					 array( 'nc-icon-outline ui-2_like' => 'ui-2_like' ),
					 array( 'nc-icon-outline ui-2_link-66' => 'ui-2_link-66' ),
					 array( 'nc-icon-outline ui-2_link-67' => 'ui-2_link-67' ),
					 array( 'nc-icon-outline ui-2_link-68' => 'ui-2_link-68' ),
					 array( 'nc-icon-outline ui-2_link-69' => 'ui-2_link-69' ),
					 array( 'nc-icon-outline ui-2_link-71' => 'ui-2_link-71' ),
					 array( 'nc-icon-outline ui-2_link-72' => 'ui-2_link-72' ),
					 array( 'nc-icon-outline ui-2_link-broken-70' => 'ui-2_link-broken-70' ),
					 array( 'nc-icon-outline ui-2_link-broken-73' => 'ui-2_link-broken-73' ),
					 array( 'nc-icon-outline ui-2_menu-34' => 'ui-2_menu-34' ),
					 array( 'nc-icon-outline ui-2_menu-35' => 'ui-2_menu-35' ),
					 array( 'nc-icon-outline ui-2_menu-bold' => 'ui-2_menu-bold' ),
					 array( 'nc-icon-outline ui-2_menu-dots' => 'ui-2_menu-dots' ),
					 array( 'nc-icon-outline ui-2_menu-square' => 'ui-2_menu-square' ),
					 array( 'nc-icon-outline ui-2_node' => 'ui-2_node' ),
					 array( 'nc-icon-outline ui-2_paragraph' => 'ui-2_paragraph' ),
					 array( 'nc-icon-outline ui-2_phone' => 'ui-2_phone' ),
					 array( 'nc-icon-outline ui-2_settings-90' => 'ui-2_settings-90' ),
					 array( 'nc-icon-outline ui-2_settings-91' => 'ui-2_settings-91' ),
					 array( 'nc-icon-outline ui-2_share-bold' => 'ui-2_share-bold' ),
					 array( 'nc-icon-outline ui-2_share' => 'ui-2_share' ),
					 array( 'nc-icon-outline ui-2_small-add' => 'ui-2_small-add' ),
					 array( 'nc-icon-outline ui-2_small-delete' => 'ui-2_small-delete' ),
					 array( 'nc-icon-outline ui-2_small-remove' => 'ui-2_small-remove' ),
					 array( 'nc-icon-outline ui-2_square-add-08' => 'ui-2_square-add-08' ),
					 array( 'nc-icon-outline ui-2_square-add-11' => 'ui-2_square-add-11' ),
					 array( 'nc-icon-outline ui-2_square-delete-10' => 'ui-2_square-delete-10' ),
					 array( 'nc-icon-outline ui-2_square-delete-13' => 'ui-2_square-delete-13' ),
					 array( 'nc-icon-outline ui-2_square-remove-09' => 'ui-2_square-remove-09' ),
					 array( 'nc-icon-outline ui-2_square-remove-12' => 'ui-2_square-remove-12' ),
					 array( 'nc-icon-outline ui-2_target' => 'ui-2_target' ),
					 array( 'nc-icon-outline ui-2_tile-55' => 'ui-2_tile-55' ),
					 array( 'nc-icon-outline ui-2_tile-56' => 'ui-2_tile-56' ),
					 array( 'nc-icon-outline ui-2_time-alarm' => 'ui-2_time-alarm' ),
					 array( 'nc-icon-outline ui-2_time-clock' => 'ui-2_time-clock' ),
					 array( 'nc-icon-outline ui-2_time-countdown' => 'ui-2_time-countdown' ),
					 array( 'nc-icon-outline ui-2_time' => 'ui-2_time' ),
					 array( 'nc-icon-outline ui-2_webpage' => 'ui-2_webpage' ),
					 array( 'nc-icon-outline ui-2_window-add' => 'ui-2_window-add' ),
					 array( 'nc-icon-outline ui-2_window-delete' => 'ui-2_window-delete' ),
					 array( 'nc-icon-outline ui-3_alert' => 'ui-3_alert' ),
					 array( 'nc-icon-outline ui-3_backward' => 'ui-3_backward' ),
					 array( 'nc-icon-outline ui-3_bolt' => 'ui-3_bolt' ),
					 array( 'nc-icon-outline ui-3_bullet-list' => 'ui-3_bullet-list' ),
					 array( 'nc-icon-outline ui-3_calendar-add' => 'ui-3_calendar-add' ),
					 array( 'nc-icon-outline ui-3_card-add' => 'ui-3_card-add' ),
					 array( 'nc-icon-outline ui-3_card-alert' => 'ui-3_card-alert' ),
					 array( 'nc-icon-outline ui-3_chart-bars' => 'ui-3_chart-bars' ),
					 array( 'nc-icon-outline ui-3_chart' => 'ui-3_chart' ),
					 array( 'nc-icon-outline ui-3_chat-33' => 'ui-3_chat-33' ),
					 array( 'nc-icon-outline ui-3_chat-45' => 'ui-3_chat-45' ),
					 array( 'nc-icon-outline ui-3_chat-46' => 'ui-3_chat-46' ),
					 array( 'nc-icon-outline ui-3_chat-reply' => 'ui-3_chat-reply' ),
					 array( 'nc-icon-outline ui-3_check-in' => 'ui-3_check-in' ),
					 array( 'nc-icon-outline ui-3_check-out' => 'ui-3_check-out' ),
					 array( 'nc-icon-outline ui-3_dock-bottom' => 'ui-3_dock-bottom' ),
					 array( 'nc-icon-outline ui-3_dock-left' => 'ui-3_dock-left' ),
					 array( 'nc-icon-outline ui-3_dock-right' => 'ui-3_dock-right' ),
					 array( 'nc-icon-outline ui-3_dock-top' => 'ui-3_dock-top' ),
					 array( 'nc-icon-outline ui-3_filter-check' => 'ui-3_filter-check' ),
					 array( 'nc-icon-outline ui-3_filter-remove' => 'ui-3_filter-remove' ),
					 array( 'nc-icon-outline ui-3_forward' => 'ui-3_forward' ),
					 array( 'nc-icon-outline ui-3_funnel-39' => 'ui-3_funnel-39' ),
					 array( 'nc-icon-outline ui-3_funnel-40' => 'ui-3_funnel-40' ),
					 array( 'nc-icon-outline ui-3_funnel-41' => 'ui-3_funnel-41' ),
					 array( 'nc-icon-outline ui-3_heart-add' => 'ui-3_heart-add' ),
					 array( 'nc-icon-outline ui-3_heart-remove' => 'ui-3_heart-remove' ),
					 array( 'nc-icon-outline ui-3_heart' => 'ui-3_heart' ),
					 array( 'nc-icon-outline ui-3_infinite' => 'ui-3_infinite' ),
					 array( 'nc-icon-outline ui-3_link' => 'ui-3_link' ),
					 array( 'nc-icon-outline ui-3_menu-left' => 'ui-3_menu-left' ),
					 array( 'nc-icon-outline ui-3_menu-right' => 'ui-3_menu-right' ),
					 array( 'nc-icon-outline ui-3_menu' => 'ui-3_menu' ),
					 array( 'nc-icon-outline ui-3_metrics' => 'ui-3_metrics' ),
					 array( 'nc-icon-outline ui-3_phone-call-end' => 'ui-3_phone-call-end' ),
					 array( 'nc-icon-outline ui-3_phone-call' => 'ui-3_phone-call' ),
					 array( 'nc-icon-outline ui-3_phone' => 'ui-3_phone' ),
					 array( 'nc-icon-outline ui-3_playlist' => 'ui-3_playlist' ),
					 array( 'nc-icon-outline ui-3_search' => 'ui-3_search' ),
					 array( 'nc-icon-outline ui-3_security' => 'ui-3_security' ),
					 array( 'nc-icon-outline ui-3_segmentation' => 'ui-3_segmentation' ),
					 array( 'nc-icon-outline ui-3_select' => 'ui-3_select' ),
					 array( 'nc-icon-outline ui-3_send' => 'ui-3_send' ),
					 array( 'nc-icon-outline ui-3_signal' => 'ui-3_signal' ),
					 array( 'nc-icon-outline ui-3_slide-left' => 'ui-3_slide-left' ),
					 array( 'nc-icon-outline ui-3_slide-right' => 'ui-3_slide-right' ),
					 array( 'nc-icon-outline ui-3_table-left' => 'ui-3_table-left' ),
					 array( 'nc-icon-outline ui-3_table-right' => 'ui-3_table-right' ),
					 array( 'nc-icon-outline ui-3_tag' => 'ui-3_tag' ),
					 array( 'nc-icon-outline ui-3_widget' => 'ui-3_widget' ),
				),
				'Users' => array( 
					 array( 'nc-icon-outline users_add-27' => 'users_add-27' ),
					 array( 'nc-icon-outline users_add-29' => 'users_add-29' ),
					 array( 'nc-icon-outline users_badge-13' => 'users_badge-13' ),
					 array( 'nc-icon-outline users_badge-14' => 'users_badge-14' ),
					 array( 'nc-icon-outline users_badge-15' => 'users_badge-15' ),
					 array( 'nc-icon-outline users_circle-08' => 'users_circle-08' ),
					 array( 'nc-icon-outline users_circle-09' => 'users_circle-09' ),
					 array( 'nc-icon-outline users_circle-10' => 'users_circle-10' ),
					 array( 'nc-icon-outline users_contacts' => 'users_contacts' ),
					 array( 'nc-icon-outline users_delete-28' => 'users_delete-28' ),
					 array( 'nc-icon-outline users_delete-30' => 'users_delete-30' ),
					 array( 'nc-icon-outline users_man-20' => 'users_man-20' ),
					 array( 'nc-icon-outline users_man-23' => 'users_man-23' ),
					 array( 'nc-icon-outline users_man-glasses' => 'users_man-glasses' ),
					 array( 'nc-icon-outline users_mobile-contact' => 'users_mobile-contact' ),
					 array( 'nc-icon-outline users_multiple-11' => 'users_multiple-11' ),
					 array( 'nc-icon-outline users_multiple-19' => 'users_multiple-19' ),
					 array( 'nc-icon-outline users_network' => 'users_network' ),
					 array( 'nc-icon-outline users_parent' => 'users_parent' ),
					 array( 'nc-icon-outline users_single-01' => 'users_single-01' ),
					 array( 'nc-icon-outline users_single-02' => 'users_single-02' ),
					 array( 'nc-icon-outline users_single-03' => 'users_single-03' ),
					 array( 'nc-icon-outline users_single-04' => 'users_single-04' ),
					 array( 'nc-icon-outline users_single-05' => 'users_single-05' ),
					 array( 'nc-icon-outline users_single-body' => 'users_single-body' ),
					 array( 'nc-icon-outline users_single-position' => 'users_single-position' ),
					 array( 'nc-icon-outline users_square-31' => 'users_square-31' ),
					 array( 'nc-icon-outline users_square-32' => 'users_square-32' ),
					 array( 'nc-icon-outline users_square-33' => 'users_square-33' ),
					 array( 'nc-icon-outline users_woman-21' => 'users_woman-21' ),
					 array( 'nc-icon-outline users_woman-24' => 'users_woman-24' ),
					 array( 'nc-icon-outline users_woman-25' => 'users_woman-25' ),
					 array( 'nc-icon-outline users_woman-34' => 'users_woman-34' ),
					 array( 'nc-icon-outline users_woman-35' => 'users_woman-35' ),
					 array( 'nc-icon-outline users_woman-man' => 'users_woman-man' ),
				),
				'Weather' => array( 
					 array( 'nc-icon-outline weather_celsius' => 'weather_celsius' ),
					 array( 'nc-icon-outline weather_cloud-13' => 'weather_cloud-13' ),
					 array( 'nc-icon-outline weather_cloud-14' => 'weather_cloud-14' ),
					 array( 'nc-icon-outline weather_cloud-drop' => 'weather_cloud-drop' ),
					 array( 'nc-icon-outline weather_cloud-fog-31' => 'weather_cloud-fog-31' ),
					 array( 'nc-icon-outline weather_cloud-fog-32' => 'weather_cloud-fog-32' ),
					 array( 'nc-icon-outline weather_cloud-hail' => 'weather_cloud-hail' ),
					 array( 'nc-icon-outline weather_cloud-light' => 'weather_cloud-light' ),
					 array( 'nc-icon-outline weather_cloud-moon' => 'weather_cloud-moon' ),
					 array( 'nc-icon-outline weather_cloud-rain' => 'weather_cloud-rain' ),
					 array( 'nc-icon-outline weather_cloud-rainbow' => 'weather_cloud-rainbow' ),
					 array( 'nc-icon-outline weather_cloud-snow-34' => 'weather_cloud-snow-34' ),
					 array( 'nc-icon-outline weather_cloud-snow-42' => 'weather_cloud-snow-42' ),
					 array( 'nc-icon-outline weather_cloud-sun-17' => 'weather_cloud-sun-17' ),
					 array( 'nc-icon-outline weather_cloud-sun-19' => 'weather_cloud-sun-19' ),
					 array( 'nc-icon-outline weather_compass' => 'weather_compass' ),
					 array( 'nc-icon-outline weather_drop-12' => 'weather_drop-12' ),
					 array( 'nc-icon-outline weather_drop-15' => 'weather_drop-15' ),
					 array( 'nc-icon-outline weather_drops' => 'weather_drops' ),
					 array( 'nc-icon-outline weather_eclipse' => 'weather_eclipse' ),
					 array( 'nc-icon-outline weather_fahrenheit' => 'weather_fahrenheit' ),
					 array( 'nc-icon-outline weather_fog' => 'weather_fog' ),
					 array( 'nc-icon-outline weather_forecast' => 'weather_forecast' ),
					 array( 'nc-icon-outline weather_hurricane-44' => 'weather_hurricane-44' ),
					 array( 'nc-icon-outline weather_hurricane-45' => 'weather_hurricane-45' ),
					 array( 'nc-icon-outline weather_moon-cloud-drop' => 'weather_moon-cloud-drop' ),
					 array( 'nc-icon-outline weather_moon-cloud-fog' => 'weather_moon-cloud-fog' ),
					 array( 'nc-icon-outline weather_moon-cloud-hail' => 'weather_moon-cloud-hail' ),
					 array( 'nc-icon-outline weather_moon-cloud-light' => 'weather_moon-cloud-light' ),
					 array( 'nc-icon-outline weather_moon-cloud-rain' => 'weather_moon-cloud-rain' ),
					 array( 'nc-icon-outline weather_moon-cloud-snow-61' => 'weather_moon-cloud-snow-61' ),
					 array( 'nc-icon-outline weather_moon-cloud-snow-62' => 'weather_moon-cloud-snow-62' ),
					 array( 'nc-icon-outline weather_moon-fog' => 'weather_moon-fog' ),
					 array( 'nc-icon-outline weather_moon-full' => 'weather_moon-full' ),
					 array( 'nc-icon-outline weather_moon-stars' => 'weather_moon-stars' ),
					 array( 'nc-icon-outline weather_moon' => 'weather_moon' ),
					 array( 'nc-icon-outline weather_rain-hail' => 'weather_rain-hail' ),
					 array( 'nc-icon-outline weather_rain' => 'weather_rain' ),
					 array( 'nc-icon-outline weather_rainbow' => 'weather_rainbow' ),
					 array( 'nc-icon-outline weather_snow' => 'weather_snow' ),
					 array( 'nc-icon-outline weather_sun-cloud-drop' => 'weather_sun-cloud-drop' ),
					 array( 'nc-icon-outline weather_sun-cloud-fog' => 'weather_sun-cloud-fog' ),
					 array( 'nc-icon-outline weather_sun-cloud-hail' => 'weather_sun-cloud-hail' ),
					 array( 'nc-icon-outline weather_sun-cloud-light' => 'weather_sun-cloud-light' ),
					 array( 'nc-icon-outline weather_sun-cloud-rain' => 'weather_sun-cloud-rain' ),
					 array( 'nc-icon-outline weather_sun-cloud-snow-54' => 'weather_sun-cloud-snow-54' ),
					 array( 'nc-icon-outline weather_sun-cloud-snow-55' => 'weather_sun-cloud-snow-55' ),
					 array( 'nc-icon-outline weather_sun-cloud' => 'weather_sun-cloud' ),
					 array( 'nc-icon-outline weather_sun-fog-29' => 'weather_sun-fog-29' ),
					 array( 'nc-icon-outline weather_sun-fog-30' => 'weather_sun-fog-30' ),
					 array( 'nc-icon-outline weather_sun-fog-43' => 'weather_sun-fog-43' ),
					 array( 'nc-icon-outline weather_sun' => 'weather_sun' ),
					 array( 'nc-icon-outline weather_wind' => 'weather_wind' ),
				),
			);
		
			return array_merge( $icons, $nucleo_icons );
		}		
	
		
		function vc_iconpicker_type_nucleo_glyph( $icons ) 
		{
			$nucleo_icons = array(				
				'Animals & Nature' => array( 
					 array( 'nc-icon-glyph nature_bear' => 'nature_bear' ),
					 array( 'nc-icon-glyph nature_bee' => 'nature_bee' ),
					 array( 'nc-icon-glyph nature_butterfly' => 'nature_butterfly' ),
					 array( 'nc-icon-glyph nature_chicken' => 'nature_chicken' ),
					 array( 'nc-icon-glyph nature_clover' => 'nature_clover' ),
					 array( 'nc-icon-glyph nature_collar' => 'nature_collar' ),
					 array( 'nc-icon-glyph nature_cow' => 'nature_cow' ),
					 array( 'nc-icon-glyph nature_dog-house' => 'nature_dog-house' ),
					 array( 'nc-icon-glyph nature_dog' => 'nature_dog' ),
					 array( 'nc-icon-glyph nature_flower-05' => 'nature_flower-05' ),
					 array( 'nc-icon-glyph nature_flower-06' => 'nature_flower-06' ),
					 array( 'nc-icon-glyph nature_flower-07' => 'nature_flower-07' ),
					 array( 'nc-icon-glyph nature_food-dog' => 'nature_food-dog' ),
					 array( 'nc-icon-glyph nature_food' => 'nature_food' ),
					 array( 'nc-icon-glyph nature_forest' => 'nature_forest' ),
					 array( 'nc-icon-glyph nature_mountain' => 'nature_mountain' ),
					 array( 'nc-icon-glyph nature_mushroom' => 'nature_mushroom' ),
					 array( 'nc-icon-glyph nature_panda' => 'nature_panda' ),
					 array( 'nc-icon-glyph nature_paw' => 'nature_paw' ),
					 array( 'nc-icon-glyph nature_pig' => 'nature_pig' ),
					 array( 'nc-icon-glyph nature_plant-ground' => 'nature_plant-ground' ),
					 array( 'nc-icon-glyph nature_plant-vase' => 'nature_plant-vase' ),
					 array( 'nc-icon-glyph nature_rat' => 'nature_rat' ),
					 array( 'nc-icon-glyph nature_sheep' => 'nature_sheep' ),
					 array( 'nc-icon-glyph nature_snake' => 'nature_snake' ),
					 array( 'nc-icon-glyph nature_tree-01' => 'nature_tree-01' ),
					 array( 'nc-icon-glyph nature_tree-02' => 'nature_tree-02' ),
					 array( 'nc-icon-glyph nature_tree-03' => 'nature_tree-03' ),
					 array( 'nc-icon-glyph nature_turtle' => 'nature_turtle' ),
					 array( 'nc-icon-glyph nature_wood' => 'nature_wood' ),
				),
				'Arrows' => array( 
					 array( 'nc-icon-glyph arrows-1_back-78' => 'arrows-1_back-78' ),
					 array( 'nc-icon-glyph arrows-1_back-80' => 'arrows-1_back-80' ),
					 array( 'nc-icon-glyph arrows-1_bold-direction' => 'arrows-1_bold-direction' ),
					 array( 'nc-icon-glyph arrows-1_bold-down' => 'arrows-1_bold-down' ),
					 array( 'nc-icon-glyph arrows-1_bold-left' => 'arrows-1_bold-left' ),
					 array( 'nc-icon-glyph arrows-1_bold-right' => 'arrows-1_bold-right' ),
					 array( 'nc-icon-glyph arrows-1_bold-up' => 'arrows-1_bold-up' ),
					 array( 'nc-icon-glyph arrows-1_circle-down-12' => 'arrows-1_circle-down-12' ),
					 array( 'nc-icon-glyph arrows-1_circle-down-40' => 'arrows-1_circle-down-40' ),
					 array( 'nc-icon-glyph arrows-1_circle-left-10' => 'arrows-1_circle-left-10' ),
					 array( 'nc-icon-glyph arrows-1_circle-left-38' => 'arrows-1_circle-left-38' ),
					 array( 'nc-icon-glyph arrows-1_circle-right-09' => 'arrows-1_circle-right-09' ),
					 array( 'nc-icon-glyph arrows-1_circle-right-37' => 'arrows-1_circle-right-37' ),
					 array( 'nc-icon-glyph arrows-1_circle-up-11' => 'arrows-1_circle-up-11' ),
					 array( 'nc-icon-glyph arrows-1_circle-up-39' => 'arrows-1_circle-up-39' ),
					 array( 'nc-icon-glyph arrows-1_cloud-download-93' => 'arrows-1_cloud-download-93' ),
					 array( 'nc-icon-glyph arrows-1_cloud-download-95' => 'arrows-1_cloud-download-95' ),
					 array( 'nc-icon-glyph arrows-1_cloud-upload-94' => 'arrows-1_cloud-upload-94' ),
					 array( 'nc-icon-glyph arrows-1_cloud-upload-96' => 'arrows-1_cloud-upload-96' ),
					 array( 'nc-icon-glyph arrows-1_curved-next' => 'arrows-1_curved-next' ),
					 array( 'nc-icon-glyph arrows-1_curved-previous' => 'arrows-1_curved-previous' ),
					 array( 'nc-icon-glyph arrows-1_direction-53' => 'arrows-1_direction-53' ),
					 array( 'nc-icon-glyph arrows-1_direction-56' => 'arrows-1_direction-56' ),
					 array( 'nc-icon-glyph arrows-1_double-left' => 'arrows-1_double-left' ),
					 array( 'nc-icon-glyph arrows-1_double-right' => 'arrows-1_double-right' ),
					 array( 'nc-icon-glyph arrows-1_download' => 'arrows-1_download' ),
					 array( 'nc-icon-glyph arrows-1_enlarge-diagonal-43' => 'arrows-1_enlarge-diagonal-43' ),
					 array( 'nc-icon-glyph arrows-1_enlarge-diagonal-44' => 'arrows-1_enlarge-diagonal-44' ),
					 array( 'nc-icon-glyph arrows-1_enlarge-horizontal' => 'arrows-1_enlarge-horizontal' ),
					 array( 'nc-icon-glyph arrows-1_enlarge-vertical' => 'arrows-1_enlarge-vertical' ),
					 array( 'nc-icon-glyph arrows-1_fit-horizontal' => 'arrows-1_fit-horizontal' ),
					 array( 'nc-icon-glyph arrows-1_fit-vertical' => 'arrows-1_fit-vertical' ),
					 array( 'nc-icon-glyph arrows-1_fullscreen-70' => 'arrows-1_fullscreen-70' ),
					 array( 'nc-icon-glyph arrows-1_fullscreen-71' => 'arrows-1_fullscreen-71' ),
					 array( 'nc-icon-glyph arrows-1_fullscreen-76' => 'arrows-1_fullscreen-76' ),
					 array( 'nc-icon-glyph arrows-1_fullscreen-77' => 'arrows-1_fullscreen-77' ),
					 array( 'nc-icon-glyph arrows-1_fullscreen-double-74' => 'arrows-1_fullscreen-double-74' ),
					 array( 'nc-icon-glyph arrows-1_fullscreen-double-75' => 'arrows-1_fullscreen-double-75' ),
					 array( 'nc-icon-glyph arrows-1_fullscreen-split-72' => 'arrows-1_fullscreen-split-72' ),
					 array( 'nc-icon-glyph arrows-1_fullscreen-split-73' => 'arrows-1_fullscreen-split-73' ),
					 array( 'nc-icon-glyph arrows-1_log-in' => 'arrows-1_log-in' ),
					 array( 'nc-icon-glyph arrows-1_log-out' => 'arrows-1_log-out' ),
					 array( 'nc-icon-glyph arrows-1_loop-82' => 'arrows-1_loop-82' ),
					 array( 'nc-icon-glyph arrows-1_loop-83' => 'arrows-1_loop-83' ),
					 array( 'nc-icon-glyph arrows-1_minimal-down' => 'arrows-1_minimal-down' ),
					 array( 'nc-icon-glyph arrows-1_minimal-left' => 'arrows-1_minimal-left' ),
					 array( 'nc-icon-glyph arrows-1_minimal-right' => 'arrows-1_minimal-right' ),
					 array( 'nc-icon-glyph arrows-1_minimal-up' => 'arrows-1_minimal-up' ),
					 array( 'nc-icon-glyph arrows-1_redo-79' => 'arrows-1_redo-79' ),
					 array( 'nc-icon-glyph arrows-1_redo-81' => 'arrows-1_redo-81' ),
					 array( 'nc-icon-glyph arrows-1_refresh-68' => 'arrows-1_refresh-68' ),
					 array( 'nc-icon-glyph arrows-1_refresh-69' => 'arrows-1_refresh-69' ),
					 array( 'nc-icon-glyph arrows-1_round-down' => 'arrows-1_round-down' ),
					 array( 'nc-icon-glyph arrows-1_round-left' => 'arrows-1_round-left' ),
					 array( 'nc-icon-glyph arrows-1_round-right' => 'arrows-1_round-right' ),
					 array( 'nc-icon-glyph arrows-1_round-up' => 'arrows-1_round-up' ),
					 array( 'nc-icon-glyph arrows-1_share-66' => 'arrows-1_share-66' ),
					 array( 'nc-icon-glyph arrows-1_share-91' => 'arrows-1_share-91' ),
					 array( 'nc-icon-glyph arrows-1_share-92' => 'arrows-1_share-92' ),
					 array( 'nc-icon-glyph arrows-1_shuffle-97' => 'arrows-1_shuffle-97' ),
					 array( 'nc-icon-glyph arrows-1_shuffle-98' => 'arrows-1_shuffle-98' ),
					 array( 'nc-icon-glyph arrows-1_simple-down' => 'arrows-1_simple-down' ),
					 array( 'nc-icon-glyph arrows-1_simple-left' => 'arrows-1_simple-left' ),
					 array( 'nc-icon-glyph arrows-1_simple-right' => 'arrows-1_simple-right' ),
					 array( 'nc-icon-glyph arrows-1_simple-up' => 'arrows-1_simple-up' ),
					 array( 'nc-icon-glyph arrows-1_small-triangle-down' => 'arrows-1_small-triangle-down' ),
					 array( 'nc-icon-glyph arrows-1_small-triangle-left' => 'arrows-1_small-triangle-left' ),
					 array( 'nc-icon-glyph arrows-1_small-triangle-right' => 'arrows-1_small-triangle-right' ),
					 array( 'nc-icon-glyph arrows-1_small-triangle-up' => 'arrows-1_small-triangle-up' ),
					 array( 'nc-icon-glyph arrows-1_square-down' => 'arrows-1_square-down' ),
					 array( 'nc-icon-glyph arrows-1_square-left' => 'arrows-1_square-left' ),
					 array( 'nc-icon-glyph arrows-1_square-right' => 'arrows-1_square-right' ),
					 array( 'nc-icon-glyph arrows-1_square-up' => 'arrows-1_square-up' ),
					 array( 'nc-icon-glyph arrows-1_strong-down' => 'arrows-1_strong-down' ),
					 array( 'nc-icon-glyph arrows-1_strong-left' => 'arrows-1_strong-left' ),
					 array( 'nc-icon-glyph arrows-1_strong-right' => 'arrows-1_strong-right' ),
					 array( 'nc-icon-glyph arrows-1_strong-up' => 'arrows-1_strong-up' ),
					 array( 'nc-icon-glyph arrows-1_tail-down' => 'arrows-1_tail-down' ),
					 array( 'nc-icon-glyph arrows-1_tail-left' => 'arrows-1_tail-left' ),
					 array( 'nc-icon-glyph arrows-1_tail-right' => 'arrows-1_tail-right' ),
					 array( 'nc-icon-glyph arrows-1_tail-triangle-down' => 'arrows-1_tail-triangle-down' ),
					 array( 'nc-icon-glyph arrows-1_tail-triangle-left' => 'arrows-1_tail-triangle-left' ),
					 array( 'nc-icon-glyph arrows-1_tail-triangle-right' => 'arrows-1_tail-triangle-right' ),
					 array( 'nc-icon-glyph arrows-1_tail-triangle-up' => 'arrows-1_tail-triangle-up' ),
					 array( 'nc-icon-glyph arrows-1_tail-up' => 'arrows-1_tail-up' ),
					 array( 'nc-icon-glyph arrows-1_trend-down' => 'arrows-1_trend-down' ),
					 array( 'nc-icon-glyph arrows-1_trend-up' => 'arrows-1_trend-up' ),
					 array( 'nc-icon-glyph arrows-1_triangle-down-20' => 'arrows-1_triangle-down-20' ),
					 array( 'nc-icon-glyph arrows-1_triangle-down-65' => 'arrows-1_triangle-down-65' ),
					 array( 'nc-icon-glyph arrows-1_triangle-left-18' => 'arrows-1_triangle-left-18' ),
					 array( 'nc-icon-glyph arrows-1_triangle-left-63' => 'arrows-1_triangle-left-63' ),
					 array( 'nc-icon-glyph arrows-1_triangle-right-17' => 'arrows-1_triangle-right-17' ),
					 array( 'nc-icon-glyph arrows-1_triangle-right-62' => 'arrows-1_triangle-right-62' ),
					 array( 'nc-icon-glyph arrows-1_triangle-up-19' => 'arrows-1_triangle-up-19' ),
					 array( 'nc-icon-glyph arrows-1_triangle-up-64' => 'arrows-1_triangle-up-64' ),
					 array( 'nc-icon-glyph arrows-1_window-zoom-in' => 'arrows-1_window-zoom-in' ),
					 array( 'nc-icon-glyph arrows-1_window-zoom-out' => 'arrows-1_window-zoom-out' ),
					 array( 'nc-icon-glyph arrows-1_zoom-88' => 'arrows-1_zoom-88' ),
					 array( 'nc-icon-glyph arrows-1_zoom-99' => 'arrows-1_zoom-99' ),
					 array( 'nc-icon-glyph arrows-1_zoom-100' => 'arrows-1_zoom-100' ),
					 array( 'nc-icon-glyph arrows-2_block-down' => 'arrows-2_block-down' ),
					 array( 'nc-icon-glyph arrows-2_block-left' => 'arrows-2_block-left' ),
					 array( 'nc-icon-glyph arrows-2_block-right' => 'arrows-2_block-right' ),
					 array( 'nc-icon-glyph arrows-2_block-up' => 'arrows-2_block-up' ),
					 array( 'nc-icon-glyph arrows-2_circle-in' => 'arrows-2_circle-in' ),
					 array( 'nc-icon-glyph arrows-2_circle-out' => 'arrows-2_circle-out' ),
					 array( 'nc-icon-glyph arrows-2_circuit-round' => 'arrows-2_circuit-round' ),
					 array( 'nc-icon-glyph arrows-2_circuit' => 'arrows-2_circuit' ),
					 array( 'nc-icon-glyph arrows-2_computer-upload' => 'arrows-2_computer-upload' ),
					 array( 'nc-icon-glyph arrows-2_conversion' => 'arrows-2_conversion' ),
					 array( 'nc-icon-glyph arrows-2_corner-down-round' => 'arrows-2_corner-down-round' ),
					 array( 'nc-icon-glyph arrows-2_corner-down' => 'arrows-2_corner-down' ),
					 array( 'nc-icon-glyph arrows-2_corner-left-down' => 'arrows-2_corner-left-down' ),
					 array( 'nc-icon-glyph arrows-2_corner-left-round' => 'arrows-2_corner-left-round' ),
					 array( 'nc-icon-glyph arrows-2_corner-left' => 'arrows-2_corner-left' ),
					 array( 'nc-icon-glyph arrows-2_corner-right-down' => 'arrows-2_corner-right-down' ),
					 array( 'nc-icon-glyph arrows-2_corner-right-round' => 'arrows-2_corner-right-round' ),
					 array( 'nc-icon-glyph arrows-2_corner-right' => 'arrows-2_corner-right' ),
					 array( 'nc-icon-glyph arrows-2_corner-up-left' => 'arrows-2_corner-up-left' ),
					 array( 'nc-icon-glyph arrows-2_corner-up-right' => 'arrows-2_corner-up-right' ),
					 array( 'nc-icon-glyph arrows-2_corner-up-round' => 'arrows-2_corner-up-round' ),
					 array( 'nc-icon-glyph arrows-2_corner-up' => 'arrows-2_corner-up' ),
					 array( 'nc-icon-glyph arrows-2_cross-down' => 'arrows-2_cross-down' ),
					 array( 'nc-icon-glyph arrows-2_cross-horizontal' => 'arrows-2_cross-horizontal' ),
					 array( 'nc-icon-glyph arrows-2_cross-left' => 'arrows-2_cross-left' ),
					 array( 'nc-icon-glyph arrows-2_cross-right' => 'arrows-2_cross-right' ),
					 array( 'nc-icon-glyph arrows-2_cross-up' => 'arrows-2_cross-up' ),
					 array( 'nc-icon-glyph arrows-2_cross-vertical' => 'arrows-2_cross-vertical' ),
					 array( 'nc-icon-glyph arrows-2_curve-circuit' => 'arrows-2_curve-circuit' ),
					 array( 'nc-icon-glyph arrows-2_curve-directions' => 'arrows-2_curve-directions' ),
					 array( 'nc-icon-glyph arrows-2_curve-split' => 'arrows-2_curve-split' ),
					 array( 'nc-icon-glyph arrows-2_delete-49' => 'arrows-2_delete-49' ),
					 array( 'nc-icon-glyph arrows-2_delete-50' => 'arrows-2_delete-50' ),
					 array( 'nc-icon-glyph arrows-2_direction' => 'arrows-2_direction' ),
					 array( 'nc-icon-glyph arrows-2_dots-download' => 'arrows-2_dots-download' ),
					 array( 'nc-icon-glyph arrows-2_dots-upload' => 'arrows-2_dots-upload' ),
					 array( 'nc-icon-glyph arrows-2_eject' => 'arrows-2_eject' ),
					 array( 'nc-icon-glyph arrows-2_enlarge-circle' => 'arrows-2_enlarge-circle' ),
					 array( 'nc-icon-glyph arrows-2_file-download-87' => 'arrows-2_file-download-87' ),
					 array( 'nc-icon-glyph arrows-2_file-download-89' => 'arrows-2_file-download-89' ),
					 array( 'nc-icon-glyph arrows-2_file-download-94' => 'arrows-2_file-download-94' ),
					 array( 'nc-icon-glyph arrows-2_file-upload-86' => 'arrows-2_file-upload-86' ),
					 array( 'nc-icon-glyph arrows-2_file-upload-88' => 'arrows-2_file-upload-88' ),
					 array( 'nc-icon-glyph arrows-2_file-upload-93' => 'arrows-2_file-upload-93' ),
					 array( 'nc-icon-glyph arrows-2_fork-round' => 'arrows-2_fork-round' ),
					 array( 'nc-icon-glyph arrows-2_fork' => 'arrows-2_fork' ),
					 array( 'nc-icon-glyph arrows-2_hit-down' => 'arrows-2_hit-down' ),
					 array( 'nc-icon-glyph arrows-2_hit-left' => 'arrows-2_hit-left' ),
					 array( 'nc-icon-glyph arrows-2_hit-right' => 'arrows-2_hit-right' ),
					 array( 'nc-icon-glyph arrows-2_hit-up' => 'arrows-2_hit-up' ),
					 array( 'nc-icon-glyph arrows-2_lines' => 'arrows-2_lines' ),
					 array( 'nc-icon-glyph arrows-2_log-out' => 'arrows-2_log-out' ),
					 array( 'nc-icon-glyph arrows-2_loop' => 'arrows-2_loop' ),
					 array( 'nc-icon-glyph arrows-2_merge-round' => 'arrows-2_merge-round' ),
					 array( 'nc-icon-glyph arrows-2_merge' => 'arrows-2_merge' ),
					 array( 'nc-icon-glyph arrows-2_move-05' => 'arrows-2_move-05' ),
					 array( 'nc-icon-glyph arrows-2_move-06' => 'arrows-2_move-06' ),
					 array( 'nc-icon-glyph arrows-2_move-92' => 'arrows-2_move-92' ),
					 array( 'nc-icon-glyph arrows-2_move-down-right' => 'arrows-2_move-down-right' ),
					 array( 'nc-icon-glyph arrows-2_move-down' => 'arrows-2_move-down' ),
					 array( 'nc-icon-glyph arrows-2_move-left' => 'arrows-2_move-left' ),
					 array( 'nc-icon-glyph arrows-2_move-right' => 'arrows-2_move-right' ),
					 array( 'nc-icon-glyph arrows-2_move-up-left' => 'arrows-2_move-up-left' ),
					 array( 'nc-icon-glyph arrows-2_move-up' => 'arrows-2_move-up' ),
					 array( 'nc-icon-glyph arrows-2_push-next' => 'arrows-2_push-next' ),
					 array( 'nc-icon-glyph arrows-2_push-previous' => 'arrows-2_push-previous' ),
					 array( 'nc-icon-glyph arrows-2_reload' => 'arrows-2_reload' ),
					 array( 'nc-icon-glyph arrows-2_replay' => 'arrows-2_replay' ),
					 array( 'nc-icon-glyph arrows-2_rotate-left' => 'arrows-2_rotate-left' ),
					 array( 'nc-icon-glyph arrows-2_rotate-right' => 'arrows-2_rotate-right' ),
					 array( 'nc-icon-glyph arrows-2_round-left-down' => 'arrows-2_round-left-down' ),
					 array( 'nc-icon-glyph arrows-2_round-right-down' => 'arrows-2_round-right-down' ),
					 array( 'nc-icon-glyph arrows-2_round-up-left' => 'arrows-2_round-up-left' ),
					 array( 'nc-icon-glyph arrows-2_round-up-right' => 'arrows-2_round-up-right' ),
					 array( 'nc-icon-glyph arrows-2_select-83' => 'arrows-2_select-83' ),
					 array( 'nc-icon-glyph arrows-2_select-84' => 'arrows-2_select-84' ),
					 array( 'nc-icon-glyph arrows-2_separate-round' => 'arrows-2_separate-round' ),
					 array( 'nc-icon-glyph arrows-2_separate' => 'arrows-2_separate' ),
					 array( 'nc-icon-glyph arrows-2_share-left' => 'arrows-2_share-left' ),
					 array( 'nc-icon-glyph arrows-2_share-right' => 'arrows-2_share-right' ),
					 array( 'nc-icon-glyph arrows-2_skew-down' => 'arrows-2_skew-down' ),
					 array( 'nc-icon-glyph arrows-2_skew-left' => 'arrows-2_skew-left' ),
					 array( 'nc-icon-glyph arrows-2_skew-right' => 'arrows-2_skew-right' ),
					 array( 'nc-icon-glyph arrows-2_skew-up' => 'arrows-2_skew-up' ),
					 array( 'nc-icon-glyph arrows-2_small-left' => 'arrows-2_small-left' ),
					 array( 'nc-icon-glyph arrows-2_small-right' => 'arrows-2_small-right' ),
					 array( 'nc-icon-glyph arrows-2_split-horizontal' => 'arrows-2_split-horizontal' ),
					 array( 'nc-icon-glyph arrows-2_split-round' => 'arrows-2_split-round' ),
					 array( 'nc-icon-glyph arrows-2_split-vertical' => 'arrows-2_split-vertical' ),
					 array( 'nc-icon-glyph arrows-2_split' => 'arrows-2_split' ),
					 array( 'nc-icon-glyph arrows-2_square-download' => 'arrows-2_square-download' ),
					 array( 'nc-icon-glyph arrows-2_square-upload' => 'arrows-2_square-upload' ),
					 array( 'nc-icon-glyph arrows-2_time' => 'arrows-2_time' ),
					 array( 'nc-icon-glyph arrows-2_triangle-down' => 'arrows-2_triangle-down' ),
					 array( 'nc-icon-glyph arrows-2_triangle-left' => 'arrows-2_triangle-left' ),
					 array( 'nc-icon-glyph arrows-2_triangle-right' => 'arrows-2_triangle-right' ),
					 array( 'nc-icon-glyph arrows-2_triangle-up' => 'arrows-2_triangle-up' ),
					 array( 'nc-icon-glyph arrows-2_unite-round' => 'arrows-2_unite-round' ),
					 array( 'nc-icon-glyph arrows-2_unite' => 'arrows-2_unite' ),
					 array( 'nc-icon-glyph arrows-2_zoom' => 'arrows-2_zoom' ),
					 array( 'nc-icon-glyph arrows-3_circle-down' => 'arrows-3_circle-down' ),
					 array( 'nc-icon-glyph arrows-3_circle-left' => 'arrows-3_circle-left' ),
					 array( 'nc-icon-glyph arrows-3_circle-right' => 'arrows-3_circle-right' ),
					 array( 'nc-icon-glyph arrows-3_circle-simple-down' => 'arrows-3_circle-simple-down' ),
					 array( 'nc-icon-glyph arrows-3_circle-simple-left' => 'arrows-3_circle-simple-left' ),
					 array( 'nc-icon-glyph arrows-3_circle-simple-right' => 'arrows-3_circle-simple-right' ),
					 array( 'nc-icon-glyph arrows-3_circle-simple-up' => 'arrows-3_circle-simple-up' ),
					 array( 'nc-icon-glyph arrows-3_circle-up' => 'arrows-3_circle-up' ),
					 array( 'nc-icon-glyph arrows-3_cloud-refresh' => 'arrows-3_cloud-refresh' ),
					 array( 'nc-icon-glyph arrows-3_separate' => 'arrows-3_separate' ),
					 array( 'nc-icon-glyph arrows-3_small-down' => 'arrows-3_small-down' ),
					 array( 'nc-icon-glyph arrows-3_small-up' => 'arrows-3_small-up' ),
					 array( 'nc-icon-glyph arrows-3_square-corner-down-left-17' => 'arrows-3_square-corner-down-left-17' ),
					 array( 'nc-icon-glyph arrows-3_square-corner-down-left-18' => 'arrows-3_square-corner-down-left-18' ),
					 array( 'nc-icon-glyph arrows-3_square-corner-up-left' => 'arrows-3_square-corner-up-left' ),
					 array( 'nc-icon-glyph arrows-3_square-corner-up-right' => 'arrows-3_square-corner-up-right' ),
					 array( 'nc-icon-glyph arrows-3_square-down-06' => 'arrows-3_square-down-06' ),
					 array( 'nc-icon-glyph arrows-3_square-down-22' => 'arrows-3_square-down-22' ),
					 array( 'nc-icon-glyph arrows-3_square-enlarge' => 'arrows-3_square-enlarge' ),
					 array( 'nc-icon-glyph arrows-3_square-left-04' => 'arrows-3_square-left-04' ),
					 array( 'nc-icon-glyph arrows-3_square-left-20' => 'arrows-3_square-left-20' ),
					 array( 'nc-icon-glyph arrows-3_square-right-03' => 'arrows-3_square-right-03' ),
					 array( 'nc-icon-glyph arrows-3_square-right-19' => 'arrows-3_square-right-19' ),
					 array( 'nc-icon-glyph arrows-3_square-simple-down' => 'arrows-3_square-simple-down' ),
					 array( 'nc-icon-glyph arrows-3_square-simple-left' => 'arrows-3_square-simple-left' ),
					 array( 'nc-icon-glyph arrows-3_square-simple-right' => 'arrows-3_square-simple-right' ),
					 array( 'nc-icon-glyph arrows-3_square-simple-up' => 'arrows-3_square-simple-up' ),
					 array( 'nc-icon-glyph arrows-3_square-up-05' => 'arrows-3_square-up-05' ),
					 array( 'nc-icon-glyph arrows-3_square-up-21' => 'arrows-3_square-up-21' ),
					 array( 'nc-icon-glyph arrows-3_square-zoom' => 'arrows-3_square-zoom' ),
					 array( 'nc-icon-glyph arrows-3_super-bold-down' => 'arrows-3_super-bold-down' ),
					 array( 'nc-icon-glyph arrows-3_super-bold-left' => 'arrows-3_super-bold-left' ),
					 array( 'nc-icon-glyph arrows-3_super-bold-right' => 'arrows-3_super-bold-right' ),
					 array( 'nc-icon-glyph arrows-3_super-bold-up' => 'arrows-3_super-bold-up' ),
				),
				'Business & Finance' => array( 
					 array( 'nc-icon-glyph business_agenda' => 'business_agenda' ),
					 array( 'nc-icon-glyph business_atm' => 'business_atm' ),
					 array( 'nc-icon-glyph business_award-48' => 'business_award-48' ),
					 array( 'nc-icon-glyph business_award-49' => 'business_award-49' ),
					 array( 'nc-icon-glyph business_award-74' => 'business_award-74' ),
					 array( 'nc-icon-glyph business_badge' => 'business_badge' ),
					 array( 'nc-icon-glyph business_bank' => 'business_bank' ),
					 array( 'nc-icon-glyph business_board-27' => 'business_board-27' ),
					 array( 'nc-icon-glyph business_board-28' => 'business_board-28' ),
					 array( 'nc-icon-glyph business_board-29' => 'business_board-29' ),
					 array( 'nc-icon-glyph business_board-30' => 'business_board-30' ),
					 array( 'nc-icon-glyph business_books' => 'business_books' ),
					 array( 'nc-icon-glyph business_briefcase-24' => 'business_briefcase-24' ),
					 array( 'nc-icon-glyph business_briefcase-25' => 'business_briefcase-25' ),
					 array( 'nc-icon-glyph business_briefcase-26' => 'business_briefcase-26' ),
					 array( 'nc-icon-glyph business_building' => 'business_building' ),
					 array( 'nc-icon-glyph business_bulb-61' => 'business_bulb-61' ),
					 array( 'nc-icon-glyph business_bulb-62' => 'business_bulb-62' ),
					 array( 'nc-icon-glyph business_bulb-63' => 'business_bulb-63' ),
					 array( 'nc-icon-glyph business_business-contact-85' => 'business_business-contact-85' ),
					 array( 'nc-icon-glyph business_business-contact-86' => 'business_business-contact-86' ),
					 array( 'nc-icon-glyph business_business-contact-87' => 'business_business-contact-87' ),
					 array( 'nc-icon-glyph business_business-contact-88' => 'business_business-contact-88' ),
					 array( 'nc-icon-glyph business_business-contact-89' => 'business_business-contact-89' ),
					 array( 'nc-icon-glyph business_businessman-03' => 'business_businessman-03' ),
					 array( 'nc-icon-glyph business_businessman-04' => 'business_businessman-04' ),
					 array( 'nc-icon-glyph business_calculator' => 'business_calculator' ),
					 array( 'nc-icon-glyph business_chair' => 'business_chair' ),
					 array( 'nc-icon-glyph business_chart-bar-32' => 'business_chart-bar-32' ),
					 array( 'nc-icon-glyph business_chart-bar-33' => 'business_chart-bar-33' ),
					 array( 'nc-icon-glyph business_chart-growth' => 'business_chart-growth' ),
					 array( 'nc-icon-glyph business_chart-pie-35' => 'business_chart-pie-35' ),
					 array( 'nc-icon-glyph business_chart-pie-36' => 'business_chart-pie-36' ),
					 array( 'nc-icon-glyph business_chart' => 'business_chart' ),
					 array( 'nc-icon-glyph business_cheque' => 'business_cheque' ),
					 array( 'nc-icon-glyph business_coins' => 'business_coins' ),
					 array( 'nc-icon-glyph business_connect' => 'business_connect' ),
					 array( 'nc-icon-glyph business_contacts' => 'business_contacts' ),
					 array( 'nc-icon-glyph business_currency-dollar' => 'business_currency-dollar' ),
					 array( 'nc-icon-glyph business_currency-euro' => 'business_currency-euro' ),
					 array( 'nc-icon-glyph business_currency-pound' => 'business_currency-pound' ),
					 array( 'nc-icon-glyph business_currency-yen' => 'business_currency-yen' ),
					 array( 'nc-icon-glyph business_factory' => 'business_factory' ),
					 array( 'nc-icon-glyph business_globe' => 'business_globe' ),
					 array( 'nc-icon-glyph business_goal-64' => 'business_goal-64' ),
					 array( 'nc-icon-glyph business_goal-65' => 'business_goal-65' ),
					 array( 'nc-icon-glyph business_gold' => 'business_gold' ),
					 array( 'nc-icon-glyph business_hammer' => 'business_hammer' ),
					 array( 'nc-icon-glyph business_handout' => 'business_handout' ),
					 array( 'nc-icon-glyph business_handshake' => 'business_handshake' ),
					 array( 'nc-icon-glyph business_hat' => 'business_hat' ),
					 array( 'nc-icon-glyph business_hierarchy-53' => 'business_hierarchy-53' ),
					 array( 'nc-icon-glyph business_hierarchy-54' => 'business_hierarchy-54' ),
					 array( 'nc-icon-glyph business_hierarchy-55' => 'business_hierarchy-55' ),
					 array( 'nc-icon-glyph business_hierarchy-56' => 'business_hierarchy-56' ),
					 array( 'nc-icon-glyph business_laptop-71' => 'business_laptop-71' ),
					 array( 'nc-icon-glyph business_laptop-72' => 'business_laptop-72' ),
					 array( 'nc-icon-glyph business_laptop-91' => 'business_laptop-91' ),
					 array( 'nc-icon-glyph business_law' => 'business_law' ),
					 array( 'nc-icon-glyph business_math' => 'business_math' ),
					 array( 'nc-icon-glyph business_money-11' => 'business_money-11' ),
					 array( 'nc-icon-glyph business_money-12' => 'business_money-12' ),
					 array( 'nc-icon-glyph business_money-13' => 'business_money-13' ),
					 array( 'nc-icon-glyph business_money-bag' => 'business_money-bag' ),
					 array( 'nc-icon-glyph business_money-coins' => 'business_money-coins' ),
					 array( 'nc-icon-glyph business_money-growth' => 'business_money-growth' ),
					 array( 'nc-icon-glyph business_money-time' => 'business_money-time' ),
					 array( 'nc-icon-glyph business_net' => 'business_net' ),
					 array( 'nc-icon-glyph business_notes' => 'business_notes' ),
					 array( 'nc-icon-glyph business_payment' => 'business_payment' ),
					 array( 'nc-icon-glyph business_percentage-38' => 'business_percentage-38' ),
					 array( 'nc-icon-glyph business_percentage-39' => 'business_percentage-39' ),
					 array( 'nc-icon-glyph business_pig' => 'business_pig' ),
					 array( 'nc-icon-glyph business_pin' => 'business_pin' ),
					 array( 'nc-icon-glyph business_plug' => 'business_plug' ),
					 array( 'nc-icon-glyph business_progress' => 'business_progress' ),
					 array( 'nc-icon-glyph business_round-dollar' => 'business_round-dollar' ),
					 array( 'nc-icon-glyph business_round-euro' => 'business_round-euro' ),
					 array( 'nc-icon-glyph business_round-pound' => 'business_round-pound' ),
					 array( 'nc-icon-glyph business_round-yen' => 'business_round-yen' ),
					 array( 'nc-icon-glyph business_safe' => 'business_safe' ),
					 array( 'nc-icon-glyph business_scale' => 'business_scale' ),
					 array( 'nc-icon-glyph business_sign' => 'business_sign' ),
					 array( 'nc-icon-glyph business_signature' => 'business_signature' ),
					 array( 'nc-icon-glyph business_stock' => 'business_stock' ),
					 array( 'nc-icon-glyph business_strategy' => 'business_strategy' ),
					 array( 'nc-icon-glyph business_tie-01' => 'business_tie-01' ),
					 array( 'nc-icon-glyph business_tie-02' => 'business_tie-02' ),
					 array( 'nc-icon-glyph business_wallet-43' => 'business_wallet-43' ),
					 array( 'nc-icon-glyph business_wallet-44' => 'business_wallet-44' ),
					 array( 'nc-icon-glyph business_wallet-90' => 'business_wallet-90' ),
				),
				'Clothes & Accessories' => array( 
					 array( 'nc-icon-glyph clothes_baby' => 'clothes_baby' ),
					 array( 'nc-icon-glyph clothes_backpack' => 'clothes_backpack' ),
					 array( 'nc-icon-glyph clothes_bag-21' => 'clothes_bag-21' ),
					 array( 'nc-icon-glyph clothes_bag-22' => 'clothes_bag-22' ),
					 array( 'nc-icon-glyph clothes_belt' => 'clothes_belt' ),
					 array( 'nc-icon-glyph clothes_boot-woman' => 'clothes_boot-woman' ),
					 array( 'nc-icon-glyph clothes_boot' => 'clothes_boot' ),
					 array( 'nc-icon-glyph clothes_bra' => 'clothes_bra' ),
					 array( 'nc-icon-glyph clothes_button' => 'clothes_button' ),
					 array( 'nc-icon-glyph clothes_cap' => 'clothes_cap' ),
					 array( 'nc-icon-glyph clothes_coat' => 'clothes_coat' ),
					 array( 'nc-icon-glyph clothes_corset' => 'clothes_corset' ),
					 array( 'nc-icon-glyph clothes_dress-man' => 'clothes_dress-man' ),
					 array( 'nc-icon-glyph clothes_dress-woman' => 'clothes_dress-woman' ),
					 array( 'nc-icon-glyph clothes_flip' => 'clothes_flip' ),
					 array( 'nc-icon-glyph clothes_glasses' => 'clothes_glasses' ),
					 array( 'nc-icon-glyph clothes_gloves' => 'clothes_gloves' ),
					 array( 'nc-icon-glyph clothes_hat-top' => 'clothes_hat-top' ),
					 array( 'nc-icon-glyph clothes_hat' => 'clothes_hat' ),
					 array( 'nc-icon-glyph clothes_hoodie' => 'clothes_hoodie' ),
					 array( 'nc-icon-glyph clothes_iron-dont' => 'clothes_iron-dont' ),
					 array( 'nc-icon-glyph clothes_iron' => 'clothes_iron' ),
					 array( 'nc-icon-glyph clothes_jeans-41' => 'clothes_jeans-41' ),
					 array( 'nc-icon-glyph clothes_jeans-43' => 'clothes_jeans-43' ),
					 array( 'nc-icon-glyph clothes_jeans-pocket' => 'clothes_jeans-pocket' ),
					 array( 'nc-icon-glyph clothes_kitchen' => 'clothes_kitchen' ),
					 array( 'nc-icon-glyph clothes_long-sleeve' => 'clothes_long-sleeve' ),
					 array( 'nc-icon-glyph clothes_makeup' => 'clothes_makeup' ),
					 array( 'nc-icon-glyph clothes_needle' => 'clothes_needle' ),
					 array( 'nc-icon-glyph clothes_pajamas' => 'clothes_pajamas' ),
					 array( 'nc-icon-glyph clothes_ring' => 'clothes_ring' ),
					 array( 'nc-icon-glyph clothes_scarf' => 'clothes_scarf' ),
					 array( 'nc-icon-glyph clothes_shirt-business' => 'clothes_shirt-business' ),
					 array( 'nc-icon-glyph clothes_shirt-buttons' => 'clothes_shirt-buttons' ),
					 array( 'nc-icon-glyph clothes_shirt-neck' => 'clothes_shirt-neck' ),
					 array( 'nc-icon-glyph clothes_shirt' => 'clothes_shirt' ),
					 array( 'nc-icon-glyph clothes_shoe-man' => 'clothes_shoe-man' ),
					 array( 'nc-icon-glyph clothes_shoe-sport' => 'clothes_shoe-sport' ),
					 array( 'nc-icon-glyph clothes_shoe-woman' => 'clothes_shoe-woman' ),
					 array( 'nc-icon-glyph clothes_skirt' => 'clothes_skirt' ),
					 array( 'nc-icon-glyph clothes_slacks-12' => 'clothes_slacks-12' ),
					 array( 'nc-icon-glyph clothes_slacks-13' => 'clothes_slacks-13' ),
					 array( 'nc-icon-glyph clothes_sock' => 'clothes_sock' ),
					 array( 'nc-icon-glyph clothes_tie-bow' => 'clothes_tie-bow' ),
					 array( 'nc-icon-glyph clothes_tshirt-53' => 'clothes_tshirt-53' ),
					 array( 'nc-icon-glyph clothes_tshirt-54' => 'clothes_tshirt-54' ),
					 array( 'nc-icon-glyph clothes_tshirt-sport' => 'clothes_tshirt-sport' ),
					 array( 'nc-icon-glyph clothes_underwear-man' => 'clothes_underwear-man' ),
					 array( 'nc-icon-glyph clothes_underwear' => 'clothes_underwear' ),
					 array( 'nc-icon-glyph clothes_vest-sport' => 'clothes_vest-sport' ),
					 array( 'nc-icon-glyph clothes_vest' => 'clothes_vest' ),
					 array( 'nc-icon-glyph clothes_wash-30' => 'clothes_wash-30' ),
					 array( 'nc-icon-glyph clothes_wash-60' => 'clothes_wash-60' ),
					 array( 'nc-icon-glyph clothes_wash-90' => 'clothes_wash-90' ),
					 array( 'nc-icon-glyph clothes_wash-hand' => 'clothes_wash-hand' ),
					 array( 'nc-icon-glyph clothes_wash' => 'clothes_wash' ),
				),
				'Design & Development' => array( 
					 array( 'nc-icon-glyph design_album' => 'design_album' ),
					 array( 'nc-icon-glyph design_align-bottom' => 'design_align-bottom' ),
					 array( 'nc-icon-glyph design_align-center-horizontal' => 'design_align-center-horizontal' ),
					 array( 'nc-icon-glyph design_align-center-vertical' => 'design_align-center-vertical' ),
					 array( 'nc-icon-glyph design_align-left' => 'design_align-left' ),
					 array( 'nc-icon-glyph design_align-right' => 'design_align-right' ),
					 array( 'nc-icon-glyph design_align-top' => 'design_align-top' ),
					 array( 'nc-icon-glyph design_app' => 'design_app' ),
					 array( 'nc-icon-glyph design_artboard' => 'design_artboard' ),
					 array( 'nc-icon-glyph design_blend' => 'design_blend' ),
					 array( 'nc-icon-glyph design_book-bookmark' => 'design_book-bookmark' ),
					 array( 'nc-icon-glyph design_book-open' => 'design_book-open' ),
					 array( 'nc-icon-glyph design_brush' => 'design_brush' ),
					 array( 'nc-icon-glyph design_bug' => 'design_bug' ),
					 array( 'nc-icon-glyph design_bullet-list-67' => 'design_bullet-list-67' ),
					 array( 'nc-icon-glyph design_bullet-list-68' => 'design_bullet-list-68' ),
					 array( 'nc-icon-glyph design_bullet-list-69' => 'design_bullet-list-69' ),
					 array( 'nc-icon-glyph design_bullet-list-70' => 'design_bullet-list-70' ),
					 array( 'nc-icon-glyph design_clone' => 'design_clone' ),
					 array( 'nc-icon-glyph design_code-editor' => 'design_code-editor' ),
					 array( 'nc-icon-glyph design_code' => 'design_code' ),
					 array( 'nc-icon-glyph design_collection' => 'design_collection' ),
					 array( 'nc-icon-glyph design_command' => 'design_command' ),
					 array( 'nc-icon-glyph design_compass' => 'design_compass' ),
					 array( 'nc-icon-glyph design_contrast' => 'design_contrast' ),
					 array( 'nc-icon-glyph design_copy' => 'design_copy' ),
					 array( 'nc-icon-glyph design_crop' => 'design_crop' ),
					 array( 'nc-icon-glyph design_cursor-48' => 'design_cursor-48' ),
					 array( 'nc-icon-glyph design_cursor-49' => 'design_cursor-49' ),
					 array( 'nc-icon-glyph design_design-dev' => 'design_design-dev' ),
					 array( 'nc-icon-glyph design_design' => 'design_design' ),
					 array( 'nc-icon-glyph design_distribute-horizontal' => 'design_distribute-horizontal' ),
					 array( 'nc-icon-glyph design_distribute-vertical' => 'design_distribute-vertical' ),
					 array( 'nc-icon-glyph design_drag' => 'design_drag' ),
					 array( 'nc-icon-glyph design_eraser-32' => 'design_eraser-32' ),
					 array( 'nc-icon-glyph design_eraser-33' => 'design_eraser-33' ),
					 array( 'nc-icon-glyph design_eraser-46' => 'design_eraser-46' ),
					 array( 'nc-icon-glyph design_flip-horizontal' => 'design_flip-horizontal' ),
					 array( 'nc-icon-glyph design_flip-vertical' => 'design_flip-vertical' ),
					 array( 'nc-icon-glyph design_image' => 'design_image' ),
					 array( 'nc-icon-glyph design_magnet' => 'design_magnet' ),
					 array( 'nc-icon-glyph design_marker' => 'design_marker' ),
					 array( 'nc-icon-glyph design_measure-02' => 'design_measure-02' ),
					 array( 'nc-icon-glyph design_measure-17' => 'design_measure-17' ),
					 array( 'nc-icon-glyph design_measure-big' => 'design_measure-big' ),
					 array( 'nc-icon-glyph design_mobile-design' => 'design_mobile-design' ),
					 array( 'nc-icon-glyph design_mobile-dev' => 'design_mobile-dev' ),
					 array( 'nc-icon-glyph design_mouse-08' => 'design_mouse-08' ),
					 array( 'nc-icon-glyph design_mouse-09' => 'design_mouse-09' ),
					 array( 'nc-icon-glyph design_mouse-10' => 'design_mouse-10' ),
					 array( 'nc-icon-glyph design_newsletter-dev' => 'design_newsletter-dev' ),
					 array( 'nc-icon-glyph design_note-code' => 'design_note-code' ),
					 array( 'nc-icon-glyph design_paint-16' => 'design_paint-16' ),
					 array( 'nc-icon-glyph design_paint-37' => 'design_paint-37' ),
					 array( 'nc-icon-glyph design_paint-38' => 'design_paint-38' ),
					 array( 'nc-icon-glyph design_paint-bucket-39' => 'design_paint-bucket-39' ),
					 array( 'nc-icon-glyph design_paint-bucket-40' => 'design_paint-bucket-40' ),
					 array( 'nc-icon-glyph design_palette' => 'design_palette' ),
					 array( 'nc-icon-glyph design_pantone' => 'design_pantone' ),
					 array( 'nc-icon-glyph design_paper-design' => 'design_paper-design' ),
					 array( 'nc-icon-glyph design_paper-dev' => 'design_paper-dev' ),
					 array( 'nc-icon-glyph design_patch-19' => 'design_patch-19' ),
					 array( 'nc-icon-glyph design_patch-34' => 'design_patch-34' ),
					 array( 'nc-icon-glyph design_path-exclude' => 'design_path-exclude' ),
					 array( 'nc-icon-glyph design_path-intersect' => 'design_path-intersect' ),
					 array( 'nc-icon-glyph design_path-minus' => 'design_path-minus' ),
					 array( 'nc-icon-glyph design_path-unite' => 'design_path-unite' ),
					 array( 'nc-icon-glyph design_pen-01' => 'design_pen-01' ),
					 array( 'nc-icon-glyph design_pen-23' => 'design_pen-23' ),
					 array( 'nc-icon-glyph design_pen-tool' => 'design_pen-tool' ),
					 array( 'nc-icon-glyph design_phone' => 'design_phone' ),
					 array( 'nc-icon-glyph design_photo-editor' => 'design_photo-editor' ),
					 array( 'nc-icon-glyph design_responsive' => 'design_responsive' ),
					 array( 'nc-icon-glyph design_scissors-dashed' => 'design_scissors-dashed' ),
					 array( 'nc-icon-glyph design_scissors' => 'design_scissors' ),
					 array( 'nc-icon-glyph design_shape-adjust' => 'design_shape-adjust' ),
					 array( 'nc-icon-glyph design_shape-circle' => 'design_shape-circle' ),
					 array( 'nc-icon-glyph design_shape-polygon' => 'design_shape-polygon' ),
					 array( 'nc-icon-glyph design_shape-square' => 'design_shape-square' ),
					 array( 'nc-icon-glyph design_shape-triangle' => 'design_shape-triangle' ),
					 array( 'nc-icon-glyph design_shapes' => 'design_shapes' ),
					 array( 'nc-icon-glyph design_sharpener' => 'design_sharpener' ),
					 array( 'nc-icon-glyph design_slice' => 'design_slice' ),
					 array( 'nc-icon-glyph design_spray' => 'design_spray' ),
					 array( 'nc-icon-glyph design_stamp' => 'design_stamp' ),
					 array( 'nc-icon-glyph design_tablet-mobile' => 'design_tablet-mobile' ),
					 array( 'nc-icon-glyph design_tablet' => 'design_tablet' ),
					 array( 'nc-icon-glyph design_text' => 'design_text' ),
					 array( 'nc-icon-glyph design_todo' => 'design_todo' ),
					 array( 'nc-icon-glyph design_usb' => 'design_usb' ),
					 array( 'nc-icon-glyph design_vector' => 'design_vector' ),
					 array( 'nc-icon-glyph design_wand-11' => 'design_wand-11' ),
					 array( 'nc-icon-glyph design_wand-99' => 'design_wand-99' ),
					 array( 'nc-icon-glyph design_watch-dev' => 'design_watch-dev' ),
					 array( 'nc-icon-glyph design_web-design' => 'design_web-design' ),
					 array( 'nc-icon-glyph design_webpage' => 'design_webpage' ),
					 array( 'nc-icon-glyph design_window-code' => 'design_window-code' ),
					 array( 'nc-icon-glyph design_window-dev' => 'design_window-dev' ),
					 array( 'nc-icon-glyph design_window-paragraph' => 'design_window-paragraph' ),
					 array( 'nc-icon-glyph design_window-responsive' => 'design_window-responsive' ),
					 array( 'nc-icon-glyph design-2_3d-28' => 'design-2_3d-28' ),
					 array( 'nc-icon-glyph design-2_3d-29' => 'design-2_3d-29' ),
					 array( 'nc-icon-glyph design-2_android' => 'design-2_android' ),
					 array( 'nc-icon-glyph design-2_angle' => 'design-2_angle' ),
					 array( 'nc-icon-glyph design-2_animation-14' => 'design-2_animation-14' ),
					 array( 'nc-icon-glyph design-2_animation-31' => 'design-2_animation-31' ),
					 array( 'nc-icon-glyph design-2_animation-32' => 'design-2_animation-32' ),
					 array( 'nc-icon-glyph design-2_apple' => 'design-2_apple' ),
					 array( 'nc-icon-glyph design-2_browser-chrome' => 'design-2_browser-chrome' ),
					 array( 'nc-icon-glyph design-2_browser-edge' => 'design-2_browser-edge' ),
					 array( 'nc-icon-glyph design-2_browser-firefox' => 'design-2_browser-firefox' ),
					 array( 'nc-icon-glyph design-2_browser-ie' => 'design-2_browser-ie' ),
					 array( 'nc-icon-glyph design-2_browser-opera' => 'design-2_browser-opera' ),
					 array( 'nc-icon-glyph design-2_browser-safari' => 'design-2_browser-safari' ),
					 array( 'nc-icon-glyph design-2_bucket' => 'design-2_bucket' ),
					 array( 'nc-icon-glyph design-2_button' => 'design-2_button' ),
					 array( 'nc-icon-glyph design-2_canvas' => 'design-2_canvas' ),
					 array( 'nc-icon-glyph design-2_css3' => 'design-2_css3' ),
					 array( 'nc-icon-glyph design-2_cursor-add' => 'design-2_cursor-add' ),
					 array( 'nc-icon-glyph design-2_cursor-grab' => 'design-2_cursor-grab' ),
					 array( 'nc-icon-glyph design-2_cursor-load' => 'design-2_cursor-load' ),
					 array( 'nc-icon-glyph design-2_cursor-menu' => 'design-2_cursor-menu' ),
					 array( 'nc-icon-glyph design-2_cursor-not-allowed' => 'design-2_cursor-not-allowed' ),
					 array( 'nc-icon-glyph design-2_cursor-pointer' => 'design-2_cursor-pointer' ),
					 array( 'nc-icon-glyph design-2_cursor-text' => 'design-2_cursor-text' ),
					 array( 'nc-icon-glyph design-2_divider' => 'design-2_divider' ),
					 array( 'nc-icon-glyph design-2_filter-organization' => 'design-2_filter-organization' ),
					 array( 'nc-icon-glyph design-2_form' => 'design-2_form' ),
					 array( 'nc-icon-glyph design-2_frame' => 'design-2_frame' ),
					 array( 'nc-icon-glyph design-2_group' => 'design-2_group' ),
					 array( 'nc-icon-glyph design-2_html5' => 'design-2_html5' ),
					 array( 'nc-icon-glyph design-2_image' => 'design-2_image' ),
					 array( 'nc-icon-glyph design-2_layers' => 'design-2_layers' ),
					 array( 'nc-icon-glyph design-2_layout-11' => 'design-2_layout-11' ),
					 array( 'nc-icon-glyph design-2_layout-25' => 'design-2_layout-25' ),
					 array( 'nc-icon-glyph design-2_microsoft' => 'design-2_microsoft' ),
					 array( 'nc-icon-glyph design-2_mirror' => 'design-2_mirror' ),
					 array( 'nc-icon-glyph design-2_move-down' => 'design-2_move-down' ),
					 array( 'nc-icon-glyph design-2_move-up' => 'design-2_move-up' ),
					 array( 'nc-icon-glyph design-2_paint-brush' => 'design-2_paint-brush' ),
					 array( 'nc-icon-glyph design-2_ruler-pencil' => 'design-2_ruler-pencil' ),
					 array( 'nc-icon-glyph design-2_scale-down' => 'design-2_scale-down' ),
					 array( 'nc-icon-glyph design-2_scale-up' => 'design-2_scale-up' ),
					 array( 'nc-icon-glyph design-2_scale' => 'design-2_scale' ),
					 array( 'nc-icon-glyph design-2_selection' => 'design-2_selection' ),
					 array( 'nc-icon-glyph design-2_slider' => 'design-2_slider' ),
					 array( 'nc-icon-glyph design-2_text' => 'design-2_text' ),
					 array( 'nc-icon-glyph design-2_transform-origin' => 'design-2_transform-origin' ),
					 array( 'nc-icon-glyph design-2_transform' => 'design-2_transform' ),
					 array( 'nc-icon-glyph design-2_ungroup' => 'design-2_ungroup' ),
				),
				'Emoticons' => array( 
					 array( 'nc-icon-glyph emoticons_alien' => 'emoticons_alien' ),
					 array( 'nc-icon-glyph emoticons_angry-10' => 'emoticons_angry-10' ),
					 array( 'nc-icon-glyph emoticons_angry-44' => 'emoticons_angry-44' ),
					 array( 'nc-icon-glyph emoticons_big-eyes' => 'emoticons_big-eyes' ),
					 array( 'nc-icon-glyph emoticons_big-smile' => 'emoticons_big-smile' ),
					 array( 'nc-icon-glyph emoticons_bigmouth' => 'emoticons_bigmouth' ),
					 array( 'nc-icon-glyph emoticons_bleah' => 'emoticons_bleah' ),
					 array( 'nc-icon-glyph emoticons_blind' => 'emoticons_blind' ),
					 array( 'nc-icon-glyph emoticons_bomb' => 'emoticons_bomb' ),
					 array( 'nc-icon-glyph emoticons_bored' => 'emoticons_bored' ),
					 array( 'nc-icon-glyph emoticons_cake' => 'emoticons_cake' ),
					 array( 'nc-icon-glyph emoticons_cry-15' => 'emoticons_cry-15' ),
					 array( 'nc-icon-glyph emoticons_cry-57' => 'emoticons_cry-57' ),
					 array( 'nc-icon-glyph emoticons_cute' => 'emoticons_cute' ),
					 array( 'nc-icon-glyph emoticons_devil' => 'emoticons_devil' ),
					 array( 'nc-icon-glyph emoticons_disgusted' => 'emoticons_disgusted' ),
					 array( 'nc-icon-glyph emoticons_fist' => 'emoticons_fist' ),
					 array( 'nc-icon-glyph emoticons_ghost' => 'emoticons_ghost' ),
					 array( 'nc-icon-glyph emoticons_hannibal' => 'emoticons_hannibal' ),
					 array( 'nc-icon-glyph emoticons_happy-sun' => 'emoticons_happy-sun' ),
					 array( 'nc-icon-glyph emoticons_kid' => 'emoticons_kid' ),
					 array( 'nc-icon-glyph emoticons_kiss' => 'emoticons_kiss' ),
					 array( 'nc-icon-glyph emoticons_laugh-17' => 'emoticons_laugh-17' ),
					 array( 'nc-icon-glyph emoticons_laugh-35' => 'emoticons_laugh-35' ),
					 array( 'nc-icon-glyph emoticons_like-no' => 'emoticons_like-no' ),
					 array( 'nc-icon-glyph emoticons_like' => 'emoticons_like' ),
					 array( 'nc-icon-glyph emoticons_mad-12' => 'emoticons_mad-12' ),
					 array( 'nc-icon-glyph emoticons_mad-58' => 'emoticons_mad-58' ),
					 array( 'nc-icon-glyph emoticons_malicious' => 'emoticons_malicious' ),
					 array( 'nc-icon-glyph emoticons_manga-62' => 'emoticons_manga-62' ),
					 array( 'nc-icon-glyph emoticons_manga-63' => 'emoticons_manga-63' ),
					 array( 'nc-icon-glyph emoticons_monster' => 'emoticons_monster' ),
					 array( 'nc-icon-glyph emoticons_nerd-22' => 'emoticons_nerd-22' ),
					 array( 'nc-icon-glyph emoticons_nerd-23' => 'emoticons_nerd-23' ),
					 array( 'nc-icon-glyph emoticons_ninja' => 'emoticons_ninja' ),
					 array( 'nc-icon-glyph emoticons_no-words' => 'emoticons_no-words' ),
					 array( 'nc-icon-glyph emoticons_parrot' => 'emoticons_parrot' ),
					 array( 'nc-icon-glyph emoticons_penguin' => 'emoticons_penguin' ),
					 array( 'nc-icon-glyph emoticons_pirate' => 'emoticons_pirate' ),
					 array( 'nc-icon-glyph emoticons_poop' => 'emoticons_poop' ),
					 array( 'nc-icon-glyph emoticons_puzzled' => 'emoticons_puzzled' ),
					 array( 'nc-icon-glyph emoticons_quite-happy' => 'emoticons_quite-happy' ),
					 array( 'nc-icon-glyph emoticons_robot' => 'emoticons_robot' ),
					 array( 'nc-icon-glyph emoticons_rock' => 'emoticons_rock' ),
					 array( 'nc-icon-glyph emoticons_sad' => 'emoticons_sad' ),
					 array( 'nc-icon-glyph emoticons_satisfied' => 'emoticons_satisfied' ),
					 array( 'nc-icon-glyph emoticons_shark' => 'emoticons_shark' ),
					 array( 'nc-icon-glyph emoticons_shy' => 'emoticons_shy' ),
					 array( 'nc-icon-glyph emoticons_sick' => 'emoticons_sick' ),
					 array( 'nc-icon-glyph emoticons_silly' => 'emoticons_silly' ),
					 array( 'nc-icon-glyph emoticons_skull' => 'emoticons_skull' ),
					 array( 'nc-icon-glyph emoticons_sleep' => 'emoticons_sleep' ),
					 array( 'nc-icon-glyph emoticons_sloth' => 'emoticons_sloth' ),
					 array( 'nc-icon-glyph emoticons_smart' => 'emoticons_smart' ),
					 array( 'nc-icon-glyph emoticons_smile' => 'emoticons_smile' ),
					 array( 'nc-icon-glyph emoticons_soldier' => 'emoticons_soldier' ),
					 array( 'nc-icon-glyph emoticons_speechless' => 'emoticons_speechless' ),
					 array( 'nc-icon-glyph emoticons_spiteful' => 'emoticons_spiteful' ),
					 array( 'nc-icon-glyph emoticons_sunglasses-48' => 'emoticons_sunglasses-48' ),
					 array( 'nc-icon-glyph emoticons_sunglasses-49' => 'emoticons_sunglasses-49' ),
					 array( 'nc-icon-glyph emoticons_surprise' => 'emoticons_surprise' ),
					 array( 'nc-icon-glyph emoticons_upset-13' => 'emoticons_upset-13' ),
					 array( 'nc-icon-glyph emoticons_upset-14' => 'emoticons_upset-14' ),
					 array( 'nc-icon-glyph emoticons_virus' => 'emoticons_virus' ),
					 array( 'nc-icon-glyph emoticons_what' => 'emoticons_what' ),
					 array( 'nc-icon-glyph emoticons_whiskers' => 'emoticons_whiskers' ),
					 array( 'nc-icon-glyph emoticons_wink-06' => 'emoticons_wink-06' ),
					 array( 'nc-icon-glyph emoticons_wink-11' => 'emoticons_wink-11' ),
					 array( 'nc-icon-glyph emoticons_wink-69' => 'emoticons_wink-69' ),
				),
				'Energy & Environment' => array( 
					 array( 'nc-icon-glyph envir_bulb-saver' => 'envir_bulb-saver' ),
					 array( 'nc-icon-glyph envir_bulb' => 'envir_bulb' ),
					 array( 'nc-icon-glyph envir_car' => 'envir_car' ),
					 array( 'nc-icon-glyph envir_fuel-electric' => 'envir_fuel-electric' ),
					 array( 'nc-icon-glyph envir_fuel' => 'envir_fuel' ),
					 array( 'nc-icon-glyph envir_home' => 'envir_home' ),
					 array( 'nc-icon-glyph envir_level' => 'envir_level' ),
					 array( 'nc-icon-glyph envir_panel' => 'envir_panel' ),
					 array( 'nc-icon-glyph envir_radiation' => 'envir_radiation' ),
					 array( 'nc-icon-glyph envir_recycling' => 'envir_recycling' ),
					 array( 'nc-icon-glyph envir_save-planet' => 'envir_save-planet' ),
					 array( 'nc-icon-glyph envir_waste-danger' => 'envir_waste-danger' ),
					 array( 'nc-icon-glyph envir_waste-recycling' => 'envir_waste-recycling' ),
					 array( 'nc-icon-glyph envir_waste' => 'envir_waste' ),
					 array( 'nc-icon-glyph envir_water-hand' => 'envir_water-hand' ),
					 array( 'nc-icon-glyph envir_water-sink' => 'envir_water-sink' ),
					 array( 'nc-icon-glyph envir_water' => 'envir_water' ),
					 array( 'nc-icon-glyph envir_wind' => 'envir_wind' ),
				),
				'Files & Folders' => array( 
					 array( 'nc-icon-glyph files_add' => 'files_add' ),
					 array( 'nc-icon-glyph files_archive-3d-check' => 'files_archive-3d-check' ),
					 array( 'nc-icon-glyph files_archive-3d-content' => 'files_archive-3d-content' ),
					 array( 'nc-icon-glyph files_archive-check' => 'files_archive-check' ),
					 array( 'nc-icon-glyph files_archive-content' => 'files_archive-content' ),
					 array( 'nc-icon-glyph files_archive-paper-check' => 'files_archive-paper-check' ),
					 array( 'nc-icon-glyph files_archive-paper' => 'files_archive-paper' ),
					 array( 'nc-icon-glyph files_archive' => 'files_archive' ),
					 array( 'nc-icon-glyph files_audio' => 'files_audio' ),
					 array( 'nc-icon-glyph files_book-07' => 'files_book-07' ),
					 array( 'nc-icon-glyph files_book-08' => 'files_book-08' ),
					 array( 'nc-icon-glyph files_bookmark' => 'files_bookmark' ),
					 array( 'nc-icon-glyph files_box' => 'files_box' ),
					 array( 'nc-icon-glyph files_chart-bar' => 'files_chart-bar' ),
					 array( 'nc-icon-glyph files_chart-pie' => 'files_chart-pie' ),
					 array( 'nc-icon-glyph files_check' => 'files_check' ),
					 array( 'nc-icon-glyph files_cloud' => 'files_cloud' ),
					 array( 'nc-icon-glyph files_copy' => 'files_copy' ),
					 array( 'nc-icon-glyph files_dev' => 'files_dev' ),
					 array( 'nc-icon-glyph files_download' => 'files_download' ),
					 array( 'nc-icon-glyph files_drawer' => 'files_drawer' ),
					 array( 'nc-icon-glyph files_edit' => 'files_edit' ),
					 array( 'nc-icon-glyph files_exclamation' => 'files_exclamation' ),
					 array( 'nc-icon-glyph files_folder-13' => 'files_folder-13' ),
					 array( 'nc-icon-glyph files_folder-14' => 'files_folder-14' ),
					 array( 'nc-icon-glyph files_folder-15' => 'files_folder-15' ),
					 array( 'nc-icon-glyph files_folder-16' => 'files_folder-16' ),
					 array( 'nc-icon-glyph files_folder-17' => 'files_folder-17' ),
					 array( 'nc-icon-glyph files_folder-18' => 'files_folder-18' ),
					 array( 'nc-icon-glyph files_folder-19' => 'files_folder-19' ),
					 array( 'nc-icon-glyph files_folder-add' => 'files_folder-add' ),
					 array( 'nc-icon-glyph files_folder-audio' => 'files_folder-audio' ),
					 array( 'nc-icon-glyph files_folder-bookmark' => 'files_folder-bookmark' ),
					 array( 'nc-icon-glyph files_folder-chart-bar' => 'files_folder-chart-bar' ),
					 array( 'nc-icon-glyph files_folder-chart-pie' => 'files_folder-chart-pie' ),
					 array( 'nc-icon-glyph files_folder-check' => 'files_folder-check' ),
					 array( 'nc-icon-glyph files_folder-cloud' => 'files_folder-cloud' ),
					 array( 'nc-icon-glyph files_folder-dev' => 'files_folder-dev' ),
					 array( 'nc-icon-glyph files_folder-download' => 'files_folder-download' ),
					 array( 'nc-icon-glyph files_folder-edit' => 'files_folder-edit' ),
					 array( 'nc-icon-glyph files_folder-exclamation' => 'files_folder-exclamation' ),
					 array( 'nc-icon-glyph files_folder-gallery' => 'files_folder-gallery' ),
					 array( 'nc-icon-glyph files_folder-heart' => 'files_folder-heart' ),
					 array( 'nc-icon-glyph files_folder-image' => 'files_folder-image' ),
					 array( 'nc-icon-glyph files_folder-info' => 'files_folder-info' ),
					 array( 'nc-icon-glyph files_folder-link' => 'files_folder-link' ),
					 array( 'nc-icon-glyph files_folder-locked' => 'files_folder-locked' ),
					 array( 'nc-icon-glyph files_folder-money' => 'files_folder-money' ),
					 array( 'nc-icon-glyph files_folder-music' => 'files_folder-music' ),
					 array( 'nc-icon-glyph files_folder-no-access' => 'files_folder-no-access' ),
					 array( 'nc-icon-glyph files_folder-play' => 'files_folder-play' ),
					 array( 'nc-icon-glyph files_folder-question' => 'files_folder-question' ),
					 array( 'nc-icon-glyph files_folder-refresh' => 'files_folder-refresh' ),
					 array( 'nc-icon-glyph files_folder-remove' => 'files_folder-remove' ),
					 array( 'nc-icon-glyph files_folder-search' => 'files_folder-search' ),
					 array( 'nc-icon-glyph files_folder-settings-81' => 'files_folder-settings-81' ),
					 array( 'nc-icon-glyph files_folder-settings-97' => 'files_folder-settings-97' ),
					 array( 'nc-icon-glyph files_folder-shared' => 'files_folder-shared' ),
					 array( 'nc-icon-glyph files_folder-star' => 'files_folder-star' ),
					 array( 'nc-icon-glyph files_folder-time' => 'files_folder-time' ),
					 array( 'nc-icon-glyph files_folder-upload' => 'files_folder-upload' ),
					 array( 'nc-icon-glyph files_folder-user' => 'files_folder-user' ),
					 array( 'nc-icon-glyph files_folder-vector' => 'files_folder-vector' ),
					 array( 'nc-icon-glyph files_gallery' => 'files_gallery' ),
					 array( 'nc-icon-glyph files_heart' => 'files_heart' ),
					 array( 'nc-icon-glyph files_image' => 'files_image' ),
					 array( 'nc-icon-glyph files_info' => 'files_info' ),
					 array( 'nc-icon-glyph files_link' => 'files_link' ),
					 array( 'nc-icon-glyph files_locked' => 'files_locked' ),
					 array( 'nc-icon-glyph files_money' => 'files_money' ),
					 array( 'nc-icon-glyph files_music' => 'files_music' ),
					 array( 'nc-icon-glyph files_no-access' => 'files_no-access' ),
					 array( 'nc-icon-glyph files_notebook' => 'files_notebook' ),
					 array( 'nc-icon-glyph files_paper' => 'files_paper' ),
					 array( 'nc-icon-glyph files_play' => 'files_play' ),
					 array( 'nc-icon-glyph files_question' => 'files_question' ),
					 array( 'nc-icon-glyph files_refresh' => 'files_refresh' ),
					 array( 'nc-icon-glyph files_remove' => 'files_remove' ),
					 array( 'nc-icon-glyph files_replace-folder' => 'files_replace-folder' ),
					 array( 'nc-icon-glyph files_replace' => 'files_replace' ),
					 array( 'nc-icon-glyph files_search' => 'files_search' ),
					 array( 'nc-icon-glyph files_settings-46' => 'files_settings-46' ),
					 array( 'nc-icon-glyph files_settings-99' => 'files_settings-99' ),
					 array( 'nc-icon-glyph files_shared' => 'files_shared' ),
					 array( 'nc-icon-glyph files_single-content-02' => 'files_single-content-02' ),
					 array( 'nc-icon-glyph files_single-content-03' => 'files_single-content-03' ),
					 array( 'nc-icon-glyph files_single-copies' => 'files_single-copies' ),
					 array( 'nc-icon-glyph files_single-copy-04' => 'files_single-copy-04' ),
					 array( 'nc-icon-glyph files_single-copy-06' => 'files_single-copy-06' ),
					 array( 'nc-icon-glyph files_single-folded-content' => 'files_single-folded-content' ),
					 array( 'nc-icon-glyph files_single-folded' => 'files_single-folded' ),
					 array( 'nc-icon-glyph files_single-paragraph' => 'files_single-paragraph' ),
					 array( 'nc-icon-glyph files_single' => 'files_single' ),
					 array( 'nc-icon-glyph files_star' => 'files_star' ),
					 array( 'nc-icon-glyph files_time' => 'files_time' ),
					 array( 'nc-icon-glyph files_upload' => 'files_upload' ),
					 array( 'nc-icon-glyph files_user' => 'files_user' ),
					 array( 'nc-icon-glyph files_vector' => 'files_vector' ),
					 array( 'nc-icon-glyph files_zip-54' => 'files_zip-54' ),
					 array( 'nc-icon-glyph files_zip-55' => 'files_zip-55' ),
					 array( 'nc-icon-glyph files-2_ai-illustrator' => 'files-2_ai-illustrator' ),
					 array( 'nc-icon-glyph files-2_avi' => 'files-2_avi' ),
					 array( 'nc-icon-glyph files-2_css' => 'files-2_css' ),
					 array( 'nc-icon-glyph files-2_csv' => 'files-2_csv' ),
					 array( 'nc-icon-glyph files-2_doc' => 'files-2_doc' ),
					 array( 'nc-icon-glyph files-2_docx' => 'files-2_docx' ),
					 array( 'nc-icon-glyph files-2_epub' => 'files-2_epub' ),
					 array( 'nc-icon-glyph files-2_exe' => 'files-2_exe' ),
					 array( 'nc-icon-glyph files-2_font' => 'files-2_font' ),
					 array( 'nc-icon-glyph files-2_gif' => 'files-2_gif' ),
					 array( 'nc-icon-glyph files-2_html' => 'files-2_html' ),
					 array( 'nc-icon-glyph files-2_jpg-jpeg' => 'files-2_jpg-jpeg' ),
					 array( 'nc-icon-glyph files-2_js-javascript-jquery' => 'files-2_js-javascript-jquery' ),
					 array( 'nc-icon-glyph files-3_mov' => 'files-3_mov' ),
					 array( 'nc-icon-glyph files-3_mp3' => 'files-3_mp3' ),
					 array( 'nc-icon-glyph files-3_mp4' => 'files-3_mp4' ),
					 array( 'nc-icon-glyph files-3_pdf' => 'files-3_pdf' ),
					 array( 'nc-icon-glyph files-3_png' => 'files-3_png' ),
					 array( 'nc-icon-glyph files-3_psd-photoshop' => 'files-3_psd-photoshop' ),
					 array( 'nc-icon-glyph files-3_rar' => 'files-3_rar' ),
					 array( 'nc-icon-glyph files-3_sketch' => 'files-3_sketch' ),
					 array( 'nc-icon-glyph files-3_svg' => 'files-3_svg' ),
					 array( 'nc-icon-glyph files-3_txt' => 'files-3_txt' ),
					 array( 'nc-icon-glyph files-3_wav' => 'files-3_wav' ),
					 array( 'nc-icon-glyph files-3_zip' => 'files-3_zip' ),
				),
				'Food' => array( 
					 array( 'nc-icon-glyph food_alcohol' => 'food_alcohol' ),
					 array( 'nc-icon-glyph food_apple' => 'food_apple' ),
					 array( 'nc-icon-glyph food_baby' => 'food_baby' ),
					 array( 'nc-icon-glyph food_bacon' => 'food_bacon' ),
					 array( 'nc-icon-glyph food_baguette' => 'food_baguette' ),
					 array( 'nc-icon-glyph food_banana' => 'food_banana' ),
					 array( 'nc-icon-glyph food_barbecue-02' => 'food_barbecue-02' ),
					 array( 'nc-icon-glyph food_barbecue-15' => 'food_barbecue-15' ),
					 array( 'nc-icon-glyph food_barbecue-tools' => 'food_barbecue-tools' ),
					 array( 'nc-icon-glyph food_beer-95' => 'food_beer-95' ),
					 array( 'nc-icon-glyph food_beer-96' => 'food_beer-96' ),
					 array( 'nc-icon-glyph food_beverage' => 'food_beverage' ),
					 array( 'nc-icon-glyph food_bottle-wine' => 'food_bottle-wine' ),
					 array( 'nc-icon-glyph food_bottle' => 'food_bottle' ),
					 array( 'nc-icon-glyph food_bowl' => 'food_bowl' ),
					 array( 'nc-icon-glyph food_bread' => 'food_bread' ),
					 array( 'nc-icon-glyph food_broccoli' => 'food_broccoli' ),
					 array( 'nc-icon-glyph food_cake-13' => 'food_cake-13' ),
					 array( 'nc-icon-glyph food_cake-100' => 'food_cake-100' ),
					 array( 'nc-icon-glyph food_cake-slice' => 'food_cake-slice' ),
					 array( 'nc-icon-glyph food_candle' => 'food_candle' ),
					 array( 'nc-icon-glyph food_candy' => 'food_candy' ),
					 array( 'nc-icon-glyph food_carrot' => 'food_carrot' ),
					 array( 'nc-icon-glyph food_champagne' => 'food_champagne' ),
					 array( 'nc-icon-glyph food_cheese-24' => 'food_cheese-24' ),
					 array( 'nc-icon-glyph food_cheese-87' => 'food_cheese-87' ),
					 array( 'nc-icon-glyph food_cheeseburger' => 'food_cheeseburger' ),
					 array( 'nc-icon-glyph food_chef-hat' => 'food_chef-hat' ),
					 array( 'nc-icon-glyph food_cherry' => 'food_cherry' ),
					 array( 'nc-icon-glyph food_chicken' => 'food_chicken' ),
					 array( 'nc-icon-glyph food_chili' => 'food_chili' ),
					 array( 'nc-icon-glyph food_chinese' => 'food_chinese' ),
					 array( 'nc-icon-glyph food_chips' => 'food_chips' ),
					 array( 'nc-icon-glyph food_chocolate' => 'food_chocolate' ),
					 array( 'nc-icon-glyph food_cocktail' => 'food_cocktail' ),
					 array( 'nc-icon-glyph food_coffe-long' => 'food_coffe-long' ),
					 array( 'nc-icon-glyph food_coffee-long' => 'food_coffee-long' ),
					 array( 'nc-icon-glyph food_coffee' => 'food_coffee' ),
					 array( 'nc-icon-glyph food_cookies' => 'food_cookies' ),
					 array( 'nc-icon-glyph food_course' => 'food_course' ),
					 array( 'nc-icon-glyph food_crab' => 'food_crab' ),
					 array( 'nc-icon-glyph food_croissant' => 'food_croissant' ),
					 array( 'nc-icon-glyph food_cutlery-75' => 'food_cutlery-75' ),
					 array( 'nc-icon-glyph food_cutlery-76' => 'food_cutlery-76' ),
					 array( 'nc-icon-glyph food_cutlery-77' => 'food_cutlery-77' ),
					 array( 'nc-icon-glyph food_dishwasher' => 'food_dishwasher' ),
					 array( 'nc-icon-glyph food_donut' => 'food_donut' ),
					 array( 'nc-icon-glyph food_drink' => 'food_drink' ),
					 array( 'nc-icon-glyph food_egg' => 'food_egg' ),
					 array( 'nc-icon-glyph food_energy-drink' => 'food_energy-drink' ),
					 array( 'nc-icon-glyph food_fish' => 'food_fish' ),
					 array( 'nc-icon-glyph food_fishbone' => 'food_fishbone' ),
					 array( 'nc-icon-glyph food_fridge' => 'food_fridge' ),
					 array( 'nc-icon-glyph food_glass' => 'food_glass' ),
					 array( 'nc-icon-glyph food_grape' => 'food_grape' ),
					 array( 'nc-icon-glyph food_hob' => 'food_hob' ),
					 array( 'nc-icon-glyph food_hot-dog' => 'food_hot-dog' ),
					 array( 'nc-icon-glyph food_ice-cream-22' => 'food_ice-cream-22' ),
					 array( 'nc-icon-glyph food_ice-cream-72' => 'food_ice-cream-72' ),
					 array( 'nc-icon-glyph food_jam' => 'food_jam' ),
					 array( 'nc-icon-glyph food_kettle' => 'food_kettle' ),
					 array( 'nc-icon-glyph food_kitchen-fan' => 'food_kitchen-fan' ),
					 array( 'nc-icon-glyph food_knife' => 'food_knife' ),
					 array( 'nc-icon-glyph food_lemon-slice' => 'food_lemon-slice' ),
					 array( 'nc-icon-glyph food_lighter' => 'food_lighter' ),
					 array( 'nc-icon-glyph food_lobster' => 'food_lobster' ),
					 array( 'nc-icon-glyph food_matches' => 'food_matches' ),
					 array( 'nc-icon-glyph food_measuring-cup' => 'food_measuring-cup' ),
					 array( 'nc-icon-glyph food_meat-spit' => 'food_meat-spit' ),
					 array( 'nc-icon-glyph food_microwave' => 'food_microwave' ),
					 array( 'nc-icon-glyph food_milk' => 'food_milk' ),
					 array( 'nc-icon-glyph food_moka' => 'food_moka' ),
					 array( 'nc-icon-glyph food_muffin' => 'food_muffin' ),
					 array( 'nc-icon-glyph food_mug' => 'food_mug' ),
					 array( 'nc-icon-glyph food_oven' => 'food_oven' ),
					 array( 'nc-icon-glyph food_pan' => 'food_pan' ),
					 array( 'nc-icon-glyph food_pizza-slice' => 'food_pizza-slice' ),
					 array( 'nc-icon-glyph food_pizza' => 'food_pizza' ),
					 array( 'nc-icon-glyph food_plate' => 'food_plate' ),
					 array( 'nc-icon-glyph food_pot' => 'food_pot' ),
					 array( 'nc-icon-glyph food_prosciutto' => 'food_prosciutto' ),
					 array( 'nc-icon-glyph food_recipe-book-46' => 'food_recipe-book-46' ),
					 array( 'nc-icon-glyph food_recipe-book-47' => 'food_recipe-book-47' ),
					 array( 'nc-icon-glyph food_rolling-pin' => 'food_rolling-pin' ),
					 array( 'nc-icon-glyph food_salt' => 'food_salt' ),
					 array( 'nc-icon-glyph food_sausage' => 'food_sausage' ),
					 array( 'nc-icon-glyph food_scale' => 'food_scale' ),
					 array( 'nc-icon-glyph food_scotch' => 'food_scotch' ),
					 array( 'nc-icon-glyph food_shrimp' => 'food_shrimp' ),
					 array( 'nc-icon-glyph food_steak' => 'food_steak' ),
					 array( 'nc-icon-glyph food_store' => 'food_store' ),
					 array( 'nc-icon-glyph food_strawberry' => 'food_strawberry' ),
					 array( 'nc-icon-glyph food_sushi' => 'food_sushi' ),
					 array( 'nc-icon-glyph food_tacos' => 'food_tacos' ),
					 array( 'nc-icon-glyph food_tea' => 'food_tea' ),
					 array( 'nc-icon-glyph food_temperature' => 'food_temperature' ),
					 array( 'nc-icon-glyph food_vest-07' => 'food_vest-07' ),
					 array( 'nc-icon-glyph food_vest-31' => 'food_vest-31' ),
					 array( 'nc-icon-glyph food_watermelon' => 'food_watermelon' ),
					 array( 'nc-icon-glyph food_whisk' => 'food_whisk' ),
				),
				'Healthcare & Medical' => array( 
					 array( 'nc-icon-glyph health_ambulance' => 'health_ambulance' ),
					 array( 'nc-icon-glyph health_apple' => 'health_apple' ),
					 array( 'nc-icon-glyph health_bag-49' => 'health_bag-49' ),
					 array( 'nc-icon-glyph health_bag-50' => 'health_bag-50' ),
					 array( 'nc-icon-glyph health_brain' => 'health_brain' ),
					 array( 'nc-icon-glyph health_dna-27' => 'health_dna-27' ),
					 array( 'nc-icon-glyph health_dna-38' => 'health_dna-38' ),
					 array( 'nc-icon-glyph health_doctor' => 'health_doctor' ),
					 array( 'nc-icon-glyph health_flask' => 'health_flask' ),
					 array( 'nc-icon-glyph health_heartbeat-16' => 'health_heartbeat-16' ),
					 array( 'nc-icon-glyph health_height' => 'health_height' ),
					 array( 'nc-icon-glyph health_hospital-32' => 'health_hospital-32' ),
					 array( 'nc-icon-glyph health_hospital-33' => 'health_hospital-33' ),
					 array( 'nc-icon-glyph health_hospital-34' => 'health_hospital-34' ),
					 array( 'nc-icon-glyph health_humidity-26' => 'health_humidity-26' ),
					 array( 'nc-icon-glyph health_humidity-52' => 'health_humidity-52' ),
					 array( 'nc-icon-glyph health_intestine' => 'health_intestine' ),
					 array( 'nc-icon-glyph health_lungs' => 'health_lungs' ),
					 array( 'nc-icon-glyph health_molecule-39' => 'health_molecule-39' ),
					 array( 'nc-icon-glyph health_molecule-40' => 'health_molecule-40' ),
					 array( 'nc-icon-glyph health_notebook' => 'health_notebook' ),
					 array( 'nc-icon-glyph health_nurse' => 'health_nurse' ),
					 array( 'nc-icon-glyph health_patch-46' => 'health_patch-46' ),
					 array( 'nc-icon-glyph health_pill-42' => 'health_pill-42' ),
					 array( 'nc-icon-glyph health_pill-43' => 'health_pill-43' ),
					 array( 'nc-icon-glyph health_pill-container-44' => 'health_pill-container-44' ),
					 array( 'nc-icon-glyph health_pill-container-47' => 'health_pill-container-47' ),
					 array( 'nc-icon-glyph health_pulse-chart' => 'health_pulse-chart' ),
					 array( 'nc-icon-glyph health_pulse-phone' => 'health_pulse-phone' ),
					 array( 'nc-icon-glyph health_pulse-sleep' => 'health_pulse-sleep' ),
					 array( 'nc-icon-glyph health_pulse-watch' => 'health_pulse-watch' ),
					 array( 'nc-icon-glyph health_pulse' => 'health_pulse' ),
					 array( 'nc-icon-glyph health_sleep' => 'health_sleep' ),
					 array( 'nc-icon-glyph health_steps' => 'health_steps' ),
					 array( 'nc-icon-glyph health_syringe' => 'health_syringe' ),
					 array( 'nc-icon-glyph health_temperature-23' => 'health_temperature-23' ),
					 array( 'nc-icon-glyph health_temperature-24' => 'health_temperature-24' ),
					 array( 'nc-icon-glyph health_tooth' => 'health_tooth' ),
					 array( 'nc-icon-glyph health_weed' => 'health_weed' ),
					 array( 'nc-icon-glyph health_weight' => 'health_weight' ),
					 array( 'nc-icon-glyph health_wheelchair' => 'health_wheelchair' ),
					 array( 'nc-icon-glyph health_woman' => 'health_woman' ),
				),
				'Holidays' => array( 
					 array( 'nc-icon-glyph holidays_bat' => 'holidays_bat' ),
					 array( 'nc-icon-glyph holidays_biscuit' => 'holidays_biscuit' ),
					 array( 'nc-icon-glyph holidays_bones' => 'holidays_bones' ),
					 array( 'nc-icon-glyph holidays_boot' => 'holidays_boot' ),
					 array( 'nc-icon-glyph holidays_candy' => 'holidays_candy' ),
					 array( 'nc-icon-glyph holidays_cat' => 'holidays_cat' ),
					 array( 'nc-icon-glyph holidays_cauldron' => 'holidays_cauldron' ),
					 array( 'nc-icon-glyph holidays_chimney' => 'holidays_chimney' ),
					 array( 'nc-icon-glyph holidays_cockade' => 'holidays_cockade' ),
					 array( 'nc-icon-glyph holidays_coffin' => 'holidays_coffin' ),
					 array( 'nc-icon-glyph holidays_dead-hand' => 'holidays_dead-hand' ),
					 array( 'nc-icon-glyph holidays_decoration' => 'holidays_decoration' ),
					 array( 'nc-icon-glyph holidays_deer' => 'holidays_deer' ),
					 array( 'nc-icon-glyph holidays_egg-38' => 'holidays_egg-38' ),
					 array( 'nc-icon-glyph holidays_egg-39' => 'holidays_egg-39' ),
					 array( 'nc-icon-glyph holidays_frankenstein' => 'holidays_frankenstein' ),
					 array( 'nc-icon-glyph holidays_ghost' => 'holidays_ghost' ),
					 array( 'nc-icon-glyph holidays_gift-exchange' => 'holidays_gift-exchange' ),
					 array( 'nc-icon-glyph holidays_gift' => 'holidays_gift' ),
					 array( 'nc-icon-glyph holidays_glove' => 'holidays_glove' ),
					 array( 'nc-icon-glyph holidays_grave' => 'holidays_grave' ),
					 array( 'nc-icon-glyph holidays_light' => 'holidays_light' ),
					 array( 'nc-icon-glyph holidays_message' => 'holidays_message' ),
					 array( 'nc-icon-glyph holidays_mistletoe' => 'holidays_mistletoe' ),
					 array( 'nc-icon-glyph holidays_owl' => 'holidays_owl' ),
					 array( 'nc-icon-glyph holidays_pumpkin' => 'holidays_pumpkin' ),
					 array( 'nc-icon-glyph holidays_rabbit' => 'holidays_rabbit' ),
					 array( 'nc-icon-glyph holidays_santa-hat' => 'holidays_santa-hat' ),
					 array( 'nc-icon-glyph holidays_sickle' => 'holidays_sickle' ),
					 array( 'nc-icon-glyph holidays_snow-ball' => 'holidays_snow-ball' ),
					 array( 'nc-icon-glyph holidays_snowman-head' => 'holidays_snowman-head' ),
					 array( 'nc-icon-glyph holidays_snowman' => 'holidays_snowman' ),
					 array( 'nc-icon-glyph holidays_soak' => 'holidays_soak' ),
					 array( 'nc-icon-glyph holidays_spider' => 'holidays_spider' ),
					 array( 'nc-icon-glyph holidays_tree-ball' => 'holidays_tree-ball' ),
					 array( 'nc-icon-glyph holidays_tree' => 'holidays_tree' ),
					 array( 'nc-icon-glyph holidays_vampire' => 'holidays_vampire' ),
					 array( 'nc-icon-glyph holidays_witch-hat' => 'holidays_witch-hat' ),
					 array( 'nc-icon-glyph holidays_wolf' => 'holidays_wolf' ),
					 array( 'nc-icon-glyph holidays_zombie' => 'holidays_zombie' ),
				),
				'Home furniture' => array( 
					 array( 'nc-icon-glyph furniture_air-conditioner' => 'furniture_air-conditioner' ),
					 array( 'nc-icon-glyph furniture_armchair' => 'furniture_armchair' ),
					 array( 'nc-icon-glyph furniture_bath-tub' => 'furniture_bath-tub' ),
					 array( 'nc-icon-glyph furniture_bed-09' => 'furniture_bed-09' ),
					 array( 'nc-icon-glyph furniture_bed-23' => 'furniture_bed-23' ),
					 array( 'nc-icon-glyph furniture_bed-side' => 'furniture_bed-side' ),
					 array( 'nc-icon-glyph furniture_cabinet' => 'furniture_cabinet' ),
					 array( 'nc-icon-glyph furniture_cactus' => 'furniture_cactus' ),
					 array( 'nc-icon-glyph furniture_chair' => 'furniture_chair' ),
					 array( 'nc-icon-glyph furniture_coat-hanger' => 'furniture_coat-hanger' ),
					 array( 'nc-icon-glyph furniture_coffee' => 'furniture_coffee' ),
					 array( 'nc-icon-glyph furniture_cradle' => 'furniture_cradle' ),
					 array( 'nc-icon-glyph furniture_curtain' => 'furniture_curtain' ),
					 array( 'nc-icon-glyph furniture_desk-drawer' => 'furniture_desk-drawer' ),
					 array( 'nc-icon-glyph furniture_desk' => 'furniture_desk' ),
					 array( 'nc-icon-glyph furniture_door' => 'furniture_door' ),
					 array( 'nc-icon-glyph furniture_drawer' => 'furniture_drawer' ),
					 array( 'nc-icon-glyph furniture_fridge' => 'furniture_fridge' ),
					 array( 'nc-icon-glyph furniture_hanger-clothes' => 'furniture_hanger-clothes' ),
					 array( 'nc-icon-glyph furniture_hanger' => 'furniture_hanger' ),
					 array( 'nc-icon-glyph furniture_heater' => 'furniture_heater' ),
					 array( 'nc-icon-glyph furniture_iron' => 'furniture_iron' ),
					 array( 'nc-icon-glyph furniture_lamp-floor' => 'furniture_lamp-floor' ),
					 array( 'nc-icon-glyph furniture_lamp' => 'furniture_lamp' ),
					 array( 'nc-icon-glyph furniture_library' => 'furniture_library' ),
					 array( 'nc-icon-glyph furniture_light' => 'furniture_light' ),
					 array( 'nc-icon-glyph furniture_mixer' => 'furniture_mixer' ),
					 array( 'nc-icon-glyph furniture_oven' => 'furniture_oven' ),
					 array( 'nc-icon-glyph furniture_shower' => 'furniture_shower' ),
					 array( 'nc-icon-glyph furniture_sink-wash' => 'furniture_sink-wash' ),
					 array( 'nc-icon-glyph furniture_sink' => 'furniture_sink' ),
					 array( 'nc-icon-glyph furniture_sofa' => 'furniture_sofa' ),
					 array( 'nc-icon-glyph furniture_storage-hanger' => 'furniture_storage-hanger' ),
					 array( 'nc-icon-glyph furniture_storage' => 'furniture_storage' ),
					 array( 'nc-icon-glyph furniture_table' => 'furniture_table' ),
					 array( 'nc-icon-glyph furniture_toilet-paper' => 'furniture_toilet-paper' ),
					 array( 'nc-icon-glyph furniture_toilet' => 'furniture_toilet' ),
					 array( 'nc-icon-glyph furniture_tv' => 'furniture_tv' ),
					 array( 'nc-icon-glyph furniture_wardrobe' => 'furniture_wardrobe' ),
					 array( 'nc-icon-glyph furniture_wash' => 'furniture_wash' ),
				),
				'Loaders' => array( 
					 array( 'nc-icon-glyph loader_circle-04 spin' => 'loader_circle-04' ),
					 array( 'nc-icon-glyph loader_dots-06 spin' => 'loader_dots-06' ),
					 array( 'nc-icon-glyph loader_gear spin' => 'loader_gear' ),
					 array( 'nc-icon-glyph loader_refresh spin' => 'loader_refresh' ),
				),
				'Maps & Location' => array( 
					 array( 'nc-icon-glyph location_appointment' => 'location_appointment' ),
					 array( 'nc-icon-glyph location_bookmark-add' => 'location_bookmark-add' ),
					 array( 'nc-icon-glyph location_bookmark-remove' => 'location_bookmark-remove' ),
					 array( 'nc-icon-glyph location_bookmark' => 'location_bookmark' ),
					 array( 'nc-icon-glyph location_compass-04' => 'location_compass-04' ),
					 array( 'nc-icon-glyph location_compass-05' => 'location_compass-05' ),
					 array( 'nc-icon-glyph location_compass-06' => 'location_compass-06' ),
					 array( 'nc-icon-glyph location_crosshair' => 'location_crosshair' ),
					 array( 'nc-icon-glyph location_explore-user' => 'location_explore-user' ),
					 array( 'nc-icon-glyph location_explore' => 'location_explore' ),
					 array( 'nc-icon-glyph location_flag-complex' => 'location_flag-complex' ),
					 array( 'nc-icon-glyph location_flag-diagonal-33' => 'location_flag-diagonal-33' ),
					 array( 'nc-icon-glyph location_flag-diagonal-34' => 'location_flag-diagonal-34' ),
					 array( 'nc-icon-glyph location_flag-points-31' => 'location_flag-points-31' ),
					 array( 'nc-icon-glyph location_flag-points-32' => 'location_flag-points-32' ),
					 array( 'nc-icon-glyph location_flag-simple' => 'location_flag-simple' ),
					 array( 'nc-icon-glyph location_flag-triangle' => 'location_flag-triangle' ),
					 array( 'nc-icon-glyph location_flag' => 'location_flag' ),
					 array( 'nc-icon-glyph location_gps' => 'location_gps' ),
					 array( 'nc-icon-glyph location_map-big' => 'location_map-big' ),
					 array( 'nc-icon-glyph location_map-compass' => 'location_map-compass' ),
					 array( 'nc-icon-glyph location_map-gps' => 'location_map-gps' ),
					 array( 'nc-icon-glyph location_map-marker' => 'location_map-marker' ),
					 array( 'nc-icon-glyph location_map-pin' => 'location_map-pin' ),
					 array( 'nc-icon-glyph location_map' => 'location_map' ),
					 array( 'nc-icon-glyph location_marker' => 'location_marker' ),
					 array( 'nc-icon-glyph location_pin-add' => 'location_pin-add' ),
					 array( 'nc-icon-glyph location_pin-copy' => 'location_pin-copy' ),
					 array( 'nc-icon-glyph location_pin-remove' => 'location_pin-remove' ),
					 array( 'nc-icon-glyph location_pin' => 'location_pin' ),
					 array( 'nc-icon-glyph location_pins' => 'location_pins' ),
					 array( 'nc-icon-glyph location_position-marker' => 'location_position-marker' ),
					 array( 'nc-icon-glyph location_position-pin' => 'location_position-pin' ),
					 array( 'nc-icon-glyph location_position-user' => 'location_position-user' ),
					 array( 'nc-icon-glyph location_radar' => 'location_radar' ),
					 array( 'nc-icon-glyph location_road' => 'location_road' ),
					 array( 'nc-icon-glyph location_route-alert' => 'location_route-alert' ),
					 array( 'nc-icon-glyph location_route-close' => 'location_route-close' ),
					 array( 'nc-icon-glyph location_route-open' => 'location_route-open' ),
					 array( 'nc-icon-glyph location_square-marker' => 'location_square-marker' ),
					 array( 'nc-icon-glyph location_square-pin' => 'location_square-pin' ),
					 array( 'nc-icon-glyph location_treasure-map-21' => 'location_treasure-map-21' ),
					 array( 'nc-icon-glyph location_treasure-map-40' => 'location_treasure-map-40' ),
					 array( 'nc-icon-glyph location_worl-marker' => 'location_worl-marker' ),
					 array( 'nc-icon-glyph location_world-pin' => 'location_world-pin' ),
					 array( 'nc-icon-glyph location_world' => 'location_world' ),
				),
				'Media' => array( 
					 array( 'nc-icon-glyph media-1_3d' => 'media-1_3d' ),
					 array( 'nc-icon-glyph media-1_action-73' => 'media-1_action-73' ),
					 array( 'nc-icon-glyph media-1_action-74' => 'media-1_action-74' ),
					 array( 'nc-icon-glyph media-1_album' => 'media-1_album' ),
					 array( 'nc-icon-glyph media-1_audio-91' => 'media-1_audio-91' ),
					 array( 'nc-icon-glyph media-1_audio-92' => 'media-1_audio-92' ),
					 array( 'nc-icon-glyph media-1_balance' => 'media-1_balance' ),
					 array( 'nc-icon-glyph media-1_brightness-46' => 'media-1_brightness-46' ),
					 array( 'nc-icon-glyph media-1_brightness-47' => 'media-1_brightness-47' ),
					 array( 'nc-icon-glyph media-1_button-circle-pause' => 'media-1_button-circle-pause' ),
					 array( 'nc-icon-glyph media-1_button-circle-play' => 'media-1_button-circle-play' ),
					 array( 'nc-icon-glyph media-1_button-circle-stop' => 'media-1_button-circle-stop' ),
					 array( 'nc-icon-glyph media-1_button-eject' => 'media-1_button-eject' ),
					 array( 'nc-icon-glyph media-1_button-next' => 'media-1_button-next' ),
					 array( 'nc-icon-glyph media-1_button-pause' => 'media-1_button-pause' ),
					 array( 'nc-icon-glyph media-1_button-play' => 'media-1_button-play' ),
					 array( 'nc-icon-glyph media-1_button-power' => 'media-1_button-power' ),
					 array( 'nc-icon-glyph media-1_button-previous' => 'media-1_button-previous' ),
					 array( 'nc-icon-glyph media-1_button-record' => 'media-1_button-record' ),
					 array( 'nc-icon-glyph media-1_button-rewind' => 'media-1_button-rewind' ),
					 array( 'nc-icon-glyph media-1_button-skip' => 'media-1_button-skip' ),
					 array( 'nc-icon-glyph media-1_button-stop' => 'media-1_button-stop' ),
					 array( 'nc-icon-glyph media-1_camera-18' => 'media-1_camera-18' ),
					 array( 'nc-icon-glyph media-1_camera-19' => 'media-1_camera-19' ),
					 array( 'nc-icon-glyph media-1_camera-20' => 'media-1_camera-20' ),
					 array( 'nc-icon-glyph media-1_camera-ban-36' => 'media-1_camera-ban-36' ),
					 array( 'nc-icon-glyph media-1_camera-ban-37' => 'media-1_camera-ban-37' ),
					 array( 'nc-icon-glyph media-1_camera-compact' => 'media-1_camera-compact' ),
					 array( 'nc-icon-glyph media-1_camera-screen' => 'media-1_camera-screen' ),
					 array( 'nc-icon-glyph media-1_camera-square-57' => 'media-1_camera-square-57' ),
					 array( 'nc-icon-glyph media-1_camera-square-58' => 'media-1_camera-square-58' ),
					 array( 'nc-icon-glyph media-1_camera-time' => 'media-1_camera-time' ),
					 array( 'nc-icon-glyph media-1_countdown-34' => 'media-1_countdown-34' ),
					 array( 'nc-icon-glyph media-1_countdown-35' => 'media-1_countdown-35' ),
					 array( 'nc-icon-glyph media-1_edit-color' => 'media-1_edit-color' ),
					 array( 'nc-icon-glyph media-1_edit-contrast-42' => 'media-1_edit-contrast-42' ),
					 array( 'nc-icon-glyph media-1_edit-contrast-43' => 'media-1_edit-contrast-43' ),
					 array( 'nc-icon-glyph media-1_edit-saturation' => 'media-1_edit-saturation' ),
					 array( 'nc-icon-glyph media-1_flash-21' => 'media-1_flash-21' ),
					 array( 'nc-icon-glyph media-1_flash-24' => 'media-1_flash-24' ),
					 array( 'nc-icon-glyph media-1_flash-29' => 'media-1_flash-29' ),
					 array( 'nc-icon-glyph media-1_flash-auto-22' => 'media-1_flash-auto-22' ),
					 array( 'nc-icon-glyph media-1_flash-auto-25' => 'media-1_flash-auto-25' ),
					 array( 'nc-icon-glyph media-1_flash-off-23' => 'media-1_flash-off-23' ),
					 array( 'nc-icon-glyph media-1_flash-off-26' => 'media-1_flash-off-26' ),
					 array( 'nc-icon-glyph media-1_focus-32' => 'media-1_focus-32' ),
					 array( 'nc-icon-glyph media-1_focus-38' => 'media-1_focus-38' ),
					 array( 'nc-icon-glyph media-1_focus-40' => 'media-1_focus-40' ),
					 array( 'nc-icon-glyph media-1_focus-circle' => 'media-1_focus-circle' ),
					 array( 'nc-icon-glyph media-1_frame-12' => 'media-1_frame-12' ),
					 array( 'nc-icon-glyph media-1_frame-41' => 'media-1_frame-41' ),
					 array( 'nc-icon-glyph media-1_grid' => 'media-1_grid' ),
					 array( 'nc-icon-glyph media-1_image-01' => 'media-1_image-01' ),
					 array( 'nc-icon-glyph media-1_image-02' => 'media-1_image-02' ),
					 array( 'nc-icon-glyph media-1_image-05' => 'media-1_image-05' ),
					 array( 'nc-icon-glyph media-1_image-add' => 'media-1_image-add' ),
					 array( 'nc-icon-glyph media-1_image-delete' => 'media-1_image-delete' ),
					 array( 'nc-icon-glyph media-1_image-location' => 'media-1_image-location' ),
					 array( 'nc-icon-glyph media-1_kid' => 'media-1_kid' ),
					 array( 'nc-icon-glyph media-1_layers' => 'media-1_layers' ),
					 array( 'nc-icon-glyph media-1_lens-31' => 'media-1_lens-31' ),
					 array( 'nc-icon-glyph media-1_lens-56' => 'media-1_lens-56' ),
					 array( 'nc-icon-glyph media-1_macro' => 'media-1_macro' ),
					 array( 'nc-icon-glyph media-1_movie-61' => 'media-1_movie-61' ),
					 array( 'nc-icon-glyph media-1_movie-62' => 'media-1_movie-62' ),
					 array( 'nc-icon-glyph media-1_night' => 'media-1_night' ),
					 array( 'nc-icon-glyph media-1_picture' => 'media-1_picture' ),
					 array( 'nc-icon-glyph media-1_play-68' => 'media-1_play-68' ),
					 array( 'nc-icon-glyph media-1_play-69' => 'media-1_play-69' ),
					 array( 'nc-icon-glyph media-1_player' => 'media-1_player' ),
					 array( 'nc-icon-glyph media-1_polaroid-add' => 'media-1_polaroid-add' ),
					 array( 'nc-icon-glyph media-1_polaroid-delete' => 'media-1_polaroid-delete' ),
					 array( 'nc-icon-glyph media-1_polaroid-multiple' => 'media-1_polaroid-multiple' ),
					 array( 'nc-icon-glyph media-1_polaroid-user' => 'media-1_polaroid-user' ),
					 array( 'nc-icon-glyph media-1_polaroid' => 'media-1_polaroid' ),
					 array( 'nc-icon-glyph media-1_roll' => 'media-1_roll' ),
					 array( 'nc-icon-glyph media-1_rotate-left' => 'media-1_rotate-left' ),
					 array( 'nc-icon-glyph media-1_rotate-right' => 'media-1_rotate-right' ),
					 array( 'nc-icon-glyph media-1_sd' => 'media-1_sd' ),
					 array( 'nc-icon-glyph media-1_selfie' => 'media-1_selfie' ),
					 array( 'nc-icon-glyph media-1_shake' => 'media-1_shake' ),
					 array( 'nc-icon-glyph media-1_speaker' => 'media-1_speaker' ),
					 array( 'nc-icon-glyph media-1_sport' => 'media-1_sport' ),
					 array( 'nc-icon-glyph media-1_ticket-75' => 'media-1_ticket-75' ),
					 array( 'nc-icon-glyph media-1_ticket-76' => 'media-1_ticket-76' ),
					 array( 'nc-icon-glyph media-1_touch' => 'media-1_touch' ),
					 array( 'nc-icon-glyph media-1_tripod' => 'media-1_tripod' ),
					 array( 'nc-icon-glyph media-1_video-64' => 'media-1_video-64' ),
					 array( 'nc-icon-glyph media-1_video-65' => 'media-1_video-65' ),
					 array( 'nc-icon-glyph media-1_video-66' => 'media-1_video-66' ),
					 array( 'nc-icon-glyph media-1_video-67' => 'media-1_video-67' ),
					 array( 'nc-icon-glyph media-1_videocamera-71' => 'media-1_videocamera-71' ),
					 array( 'nc-icon-glyph media-1_videocamera-72' => 'media-1_videocamera-72' ),
					 array( 'nc-icon-glyph media-1_volume-93' => 'media-1_volume-93' ),
					 array( 'nc-icon-glyph media-1_volume-97' => 'media-1_volume-97' ),
					 array( 'nc-icon-glyph media-1_volume-98' => 'media-1_volume-98' ),
					 array( 'nc-icon-glyph media-1_volume-ban' => 'media-1_volume-ban' ),
					 array( 'nc-icon-glyph media-1_volume-down' => 'media-1_volume-down' ),
					 array( 'nc-icon-glyph media-1_volume-off' => 'media-1_volume-off' ),
					 array( 'nc-icon-glyph media-1_volume-up' => 'media-1_volume-up' ),
					 array( 'nc-icon-glyph media-2_guitar' => 'media-2_guitar' ),
					 array( 'nc-icon-glyph media-2_headphones-mic' => 'media-2_headphones-mic' ),
					 array( 'nc-icon-glyph media-2_headphones' => 'media-2_headphones' ),
					 array( 'nc-icon-glyph media-2_knob' => 'media-2_knob' ),
					 array( 'nc-icon-glyph media-2_mic' => 'media-2_mic' ),
					 array( 'nc-icon-glyph media-2_music-album' => 'media-2_music-album' ),
					 array( 'nc-icon-glyph media-2_music-cloud' => 'media-2_music-cloud' ),
					 array( 'nc-icon-glyph media-2_note-03' => 'media-2_note-03' ),
					 array( 'nc-icon-glyph media-2_note-04' => 'media-2_note-04' ),
					 array( 'nc-icon-glyph media-2_piano' => 'media-2_piano' ),
					 array( 'nc-icon-glyph media-2_radio' => 'media-2_radio' ),
					 array( 'nc-icon-glyph media-2_remix' => 'media-2_remix' ),
					 array( 'nc-icon-glyph media-2_sound-wave' => 'media-2_sound-wave' ),
					 array( 'nc-icon-glyph media-2_speaker-01' => 'media-2_speaker-01' ),
					 array( 'nc-icon-glyph media-2_speaker-05' => 'media-2_speaker-05' ),
					 array( 'nc-icon-glyph media-2_tape' => 'media-2_tape' ),
				),
				'Objects' => array( 
					 array( 'nc-icon-glyph objects_alien-29' => 'objects_alien-29' ),
					 array( 'nc-icon-glyph objects_alien-33' => 'objects_alien-33' ),
					 array( 'nc-icon-glyph objects_anchor' => 'objects_anchor' ),
					 array( 'nc-icon-glyph objects_astronaut' => 'objects_astronaut' ),
					 array( 'nc-icon-glyph objects_axe' => 'objects_axe' ),
					 array( 'nc-icon-glyph objects_baby-bottle' => 'objects_baby-bottle' ),
					 array( 'nc-icon-glyph objects_baby' => 'objects_baby' ),
					 array( 'nc-icon-glyph objects_baloon' => 'objects_baloon' ),
					 array( 'nc-icon-glyph objects_battery' => 'objects_battery' ),
					 array( 'nc-icon-glyph objects_bear' => 'objects_bear' ),
					 array( 'nc-icon-glyph objects_billiard' => 'objects_billiard' ),
					 array( 'nc-icon-glyph objects_binocular' => 'objects_binocular' ),
					 array( 'nc-icon-glyph objects_bow' => 'objects_bow' ),
					 array( 'nc-icon-glyph objects_bowling' => 'objects_bowling' ),
					 array( 'nc-icon-glyph objects_broom' => 'objects_broom' ),
					 array( 'nc-icon-glyph objects_cone' => 'objects_cone' ),
					 array( 'nc-icon-glyph objects_controller' => 'objects_controller' ),
					 array( 'nc-icon-glyph objects_diamond' => 'objects_diamond' ),
					 array( 'nc-icon-glyph objects_dice' => 'objects_dice' ),
					 array( 'nc-icon-glyph objects_globe' => 'objects_globe' ),
					 array( 'nc-icon-glyph objects_hut' => 'objects_hut' ),
					 array( 'nc-icon-glyph objects_key-25' => 'objects_key-25' ),
					 array( 'nc-icon-glyph objects_key-26' => 'objects_key-26' ),
					 array( 'nc-icon-glyph objects_lamp' => 'objects_lamp' ),
					 array( 'nc-icon-glyph objects_leaf-36' => 'objects_leaf-36' ),
					 array( 'nc-icon-glyph objects_leaf-38' => 'objects_leaf-38' ),
					 array( 'nc-icon-glyph objects_light' => 'objects_light' ),
					 array( 'nc-icon-glyph objects_pipe' => 'objects_pipe' ),
					 array( 'nc-icon-glyph objects_planet' => 'objects_planet' ),
					 array( 'nc-icon-glyph objects_puzzle-09' => 'objects_puzzle-09' ),
					 array( 'nc-icon-glyph objects_puzzle-10' => 'objects_puzzle-10' ),
					 array( 'nc-icon-glyph objects_shovel' => 'objects_shovel' ),
					 array( 'nc-icon-glyph objects_skull' => 'objects_skull' ),
					 array( 'nc-icon-glyph objects_spaceship' => 'objects_spaceship' ),
					 array( 'nc-icon-glyph objects_spray' => 'objects_spray' ),
					 array( 'nc-icon-glyph objects_support-16' => 'objects_support-16' ),
					 array( 'nc-icon-glyph objects_support-17' => 'objects_support-17' ),
					 array( 'nc-icon-glyph objects_umbrella-13' => 'objects_umbrella-13' ),
					 array( 'nc-icon-glyph objects_umbrella-14' => 'objects_umbrella-14' ),
					 array( 'nc-icon-glyph objects_wool-ball' => 'objects_wool-ball' ),
				),
				'School & Education' => array( 
					 array( 'nc-icon-glyph education_abc' => 'education_abc' ),
					 array( 'nc-icon-glyph education_agenda-bookmark' => 'education_agenda-bookmark' ),
					 array( 'nc-icon-glyph education_atom' => 'education_atom' ),
					 array( 'nc-icon-glyph education_award-55' => 'education_award-55' ),
					 array( 'nc-icon-glyph education_backpack-57' => 'education_backpack-57' ),
					 array( 'nc-icon-glyph education_backpack-58' => 'education_backpack-58' ),
					 array( 'nc-icon-glyph education_ball-basket' => 'education_ball-basket' ),
					 array( 'nc-icon-glyph education_ball-soccer' => 'education_ball-soccer' ),
					 array( 'nc-icon-glyph education_board-51' => 'education_board-51' ),
					 array( 'nc-icon-glyph education_book-39' => 'education_book-39' ),
					 array( 'nc-icon-glyph education_book-bookmark' => 'education_book-bookmark' ),
					 array( 'nc-icon-glyph education_book-open' => 'education_book-open' ),
					 array( 'nc-icon-glyph education_books-46' => 'education_books-46' ),
					 array( 'nc-icon-glyph education_chalkboard' => 'education_chalkboard' ),
					 array( 'nc-icon-glyph education_flask' => 'education_flask' ),
					 array( 'nc-icon-glyph education_glasses' => 'education_glasses' ),
					 array( 'nc-icon-glyph education_grammar-check' => 'education_grammar-check' ),
					 array( 'nc-icon-glyph education_hat' => 'education_hat' ),
					 array( 'nc-icon-glyph education_language' => 'education_language' ),
					 array( 'nc-icon-glyph education_microscope' => 'education_microscope' ),
					 array( 'nc-icon-glyph education_molecule' => 'education_molecule' ),
					 array( 'nc-icon-glyph education_notepad' => 'education_notepad' ),
					 array( 'nc-icon-glyph education_paper-diploma' => 'education_paper-diploma' ),
					 array( 'nc-icon-glyph education_paper' => 'education_paper' ),
					 array( 'nc-icon-glyph education_pencil-47' => 'education_pencil-47' ),
					 array( 'nc-icon-glyph education_school' => 'education_school' ),
				),
				'Shopping' => array( 
					 array( 'nc-icon-glyph shopping_award' => 'shopping_award' ),
					 array( 'nc-icon-glyph shopping_bag-09' => 'shopping_bag-09' ),
					 array( 'nc-icon-glyph shopping_bag-16' => 'shopping_bag-16' ),
					 array( 'nc-icon-glyph shopping_bag-17' => 'shopping_bag-17' ),
					 array( 'nc-icon-glyph shopping_bag-20' => 'shopping_bag-20' ),
					 array( 'nc-icon-glyph shopping_bag-add-18' => 'shopping_bag-add-18' ),
					 array( 'nc-icon-glyph shopping_bag-add-21' => 'shopping_bag-add-21' ),
					 array( 'nc-icon-glyph shopping_bag-edit' => 'shopping_bag-edit' ),
					 array( 'nc-icon-glyph shopping_bag-remove-19' => 'shopping_bag-remove-19' ),
					 array( 'nc-icon-glyph shopping_bag-remove-22' => 'shopping_bag-remove-22' ),
					 array( 'nc-icon-glyph shopping_barcode-scan' => 'shopping_barcode-scan' ),
					 array( 'nc-icon-glyph shopping_barcode' => 'shopping_barcode' ),
					 array( 'nc-icon-glyph shopping_bardcode-qr' => 'shopping_bardcode-qr' ),
					 array( 'nc-icon-glyph shopping_basket-add' => 'shopping_basket-add' ),
					 array( 'nc-icon-glyph shopping_basket-edit' => 'shopping_basket-edit' ),
					 array( 'nc-icon-glyph shopping_basket-remove' => 'shopping_basket-remove' ),
					 array( 'nc-icon-glyph shopping_basket-simple-add' => 'shopping_basket-simple-add' ),
					 array( 'nc-icon-glyph shopping_basket-simple-remove' => 'shopping_basket-simple-remove' ),
					 array( 'nc-icon-glyph shopping_basket-simple' => 'shopping_basket-simple' ),
					 array( 'nc-icon-glyph shopping_basket' => 'shopping_basket' ),
					 array( 'nc-icon-glyph shopping_bitcoin' => 'shopping_bitcoin' ),
					 array( 'nc-icon-glyph shopping_board' => 'shopping_board' ),
					 array( 'nc-icon-glyph shopping_box-3d-50' => 'shopping_box-3d-50' ),
					 array( 'nc-icon-glyph shopping_box-3d-67' => 'shopping_box-3d-67' ),
					 array( 'nc-icon-glyph shopping_box-ribbon' => 'shopping_box-ribbon' ),
					 array( 'nc-icon-glyph shopping_box' => 'shopping_box' ),
					 array( 'nc-icon-glyph shopping_cart-add' => 'shopping_cart-add' ),
					 array( 'nc-icon-glyph shopping_cart-modern-add' => 'shopping_cart-modern-add' ),
					 array( 'nc-icon-glyph shopping_cart-modern-in' => 'shopping_cart-modern-in' ),
					 array( 'nc-icon-glyph shopping_cart-modern-remove' => 'shopping_cart-modern-remove' ),
					 array( 'nc-icon-glyph shopping_cart-modern' => 'shopping_cart-modern' ),
					 array( 'nc-icon-glyph shopping_cart-remove' => 'shopping_cart-remove' ),
					 array( 'nc-icon-glyph shopping_cart-simple-add' => 'shopping_cart-simple-add' ),
					 array( 'nc-icon-glyph shopping_cart-simple-in' => 'shopping_cart-simple-in' ),
					 array( 'nc-icon-glyph shopping_cart-simple-remove' => 'shopping_cart-simple-remove' ),
					 array( 'nc-icon-glyph shopping_cart-simple' => 'shopping_cart-simple' ),
					 array( 'nc-icon-glyph shopping_cart' => 'shopping_cart' ),
					 array( 'nc-icon-glyph shopping_cash-register' => 'shopping_cash-register' ),
					 array( 'nc-icon-glyph shopping_chart' => 'shopping_chart' ),
					 array( 'nc-icon-glyph shopping_credit-card-in' => 'shopping_credit-card-in' ),
					 array( 'nc-icon-glyph shopping_credit-card' => 'shopping_credit-card' ),
					 array( 'nc-icon-glyph shopping_credit-locked' => 'shopping_credit-locked' ),
					 array( 'nc-icon-glyph shopping_delivery-fast' => 'shopping_delivery-fast' ),
					 array( 'nc-icon-glyph shopping_delivery-time' => 'shopping_delivery-time' ),
					 array( 'nc-icon-glyph shopping_delivery-track' => 'shopping_delivery-track' ),
					 array( 'nc-icon-glyph shopping_delivery' => 'shopping_delivery' ),
					 array( 'nc-icon-glyph shopping_discount' => 'shopping_discount' ),
					 array( 'nc-icon-glyph shopping_gift' => 'shopping_gift' ),
					 array( 'nc-icon-glyph shopping_hand-card' => 'shopping_hand-card' ),
					 array( 'nc-icon-glyph shopping_list' => 'shopping_list' ),
					 array( 'nc-icon-glyph shopping_mobile-card' => 'shopping_mobile-card' ),
					 array( 'nc-icon-glyph shopping_mobile-cart' => 'shopping_mobile-cart' ),
					 array( 'nc-icon-glyph shopping_mobile-touch' => 'shopping_mobile-touch' ),
					 array( 'nc-icon-glyph shopping_newsletter' => 'shopping_newsletter' ),
					 array( 'nc-icon-glyph shopping_pos' => 'shopping_pos' ),
					 array( 'nc-icon-glyph shopping_receipt-list-42' => 'shopping_receipt-list-42' ),
					 array( 'nc-icon-glyph shopping_receipt-list-43' => 'shopping_receipt-list-43' ),
					 array( 'nc-icon-glyph shopping_receipt' => 'shopping_receipt' ),
					 array( 'nc-icon-glyph shopping_shop-location' => 'shopping_shop-location' ),
					 array( 'nc-icon-glyph shopping_shop' => 'shopping_shop' ),
					 array( 'nc-icon-glyph shopping_stock' => 'shopping_stock' ),
					 array( 'nc-icon-glyph shopping_tag-content' => 'shopping_tag-content' ),
					 array( 'nc-icon-glyph shopping_tag-cut' => 'shopping_tag-cut' ),
					 array( 'nc-icon-glyph shopping_tag-line' => 'shopping_tag-line' ),
					 array( 'nc-icon-glyph shopping_tag-sale' => 'shopping_tag-sale' ),
					 array( 'nc-icon-glyph shopping_tag' => 'shopping_tag' ),
					 array( 'nc-icon-glyph shopping_wallet' => 'shopping_wallet' ),
				),
				'Socials' => array( 
					 array( 'nc-icon-glyph socials-1_logo-500px' => 'socials-1_logo-500px' ),
					 array( 'nc-icon-glyph socials-1_logo-angellist' => 'socials-1_logo-angellist' ),
					 array( 'nc-icon-glyph socials-1_logo-behance' => 'socials-1_logo-behance' ),
					 array( 'nc-icon-glyph socials-1_logo-blogger' => 'socials-1_logo-blogger' ),
					 array( 'nc-icon-glyph socials-1_logo-buffer' => 'socials-1_logo-buffer' ),
					 array( 'nc-icon-glyph socials-1_logo-buysellads' => 'socials-1_logo-buysellads' ),
					 array( 'nc-icon-glyph socials-1_logo-codepen' => 'socials-1_logo-codepen' ),
					 array( 'nc-icon-glyph socials-1_logo-creative-market' => 'socials-1_logo-creative-market' ),
					 array( 'nc-icon-glyph socials-1_logo-crunchbase' => 'socials-1_logo-crunchbase' ),
					 array( 'nc-icon-glyph socials-1_logo-deviantart' => 'socials-1_logo-deviantart' ),
					 array( 'nc-icon-glyph socials-1_logo-dribbble' => 'socials-1_logo-dribbble' ),
					 array( 'nc-icon-glyph socials-1_logo-dropbox' => 'socials-1_logo-dropbox' ),
					 array( 'nc-icon-glyph socials-1_logo-envato' => 'socials-1_logo-envato' ),
					 array( 'nc-icon-glyph socials-1_logo-evernote' => 'socials-1_logo-evernote' ),
					 array( 'nc-icon-glyph socials-1_logo-facebook' => 'socials-1_logo-facebook' ),
					 array( 'nc-icon-glyph socials-1_logo-fb-simple' => 'socials-1_logo-fb-simple' ),
					 array( 'nc-icon-glyph socials-1_logo-feedly' => 'socials-1_logo-feedly' ),
					 array( 'nc-icon-glyph socials-1_logo-flickr' => 'socials-1_logo-flickr' ),
					 array( 'nc-icon-glyph socials-1_logo-github' => 'socials-1_logo-github' ),
					 array( 'nc-icon-glyph socials-1_logo-google-plus' => 'socials-1_logo-google-plus' ),
					 array( 'nc-icon-glyph socials-1_logo-instagram' => 'socials-1_logo-instagram' ),
					 array( 'nc-icon-glyph socials-1_logo-lastfm' => 'socials-1_logo-lastfm' ),
					 array( 'nc-icon-glyph socials-1_logo-linkedin' => 'socials-1_logo-linkedin' ),
					 array( 'nc-icon-glyph socials-1_logo-meetup' => 'socials-1_logo-meetup' ),
					 array( 'nc-icon-glyph socials-1_logo-myspace' => 'socials-1_logo-myspace' ),
					 array( 'nc-icon-glyph socials-1_logo-paypal' => 'socials-1_logo-paypal' ),
					 array( 'nc-icon-glyph socials-1_logo-pinterest' => 'socials-1_logo-pinterest' ),
					 array( 'nc-icon-glyph socials-1_logo-product-hunt' => 'socials-1_logo-product-hunt' ),
					 array( 'nc-icon-glyph socials-1_logo-reddit' => 'socials-1_logo-reddit' ),
					 array( 'nc-icon-glyph socials-1_logo-rss' => 'socials-1_logo-rss' ),
					 array( 'nc-icon-glyph socials-1_logo-shopify' => 'socials-1_logo-shopify' ),
					 array( 'nc-icon-glyph socials-1_logo-skype' => 'socials-1_logo-skype' ),
					 array( 'nc-icon-glyph socials-1_logo-slack' => 'socials-1_logo-slack' ),
					 array( 'nc-icon-glyph socials-1_logo-soundcloud' => 'socials-1_logo-soundcloud' ),
					 array( 'nc-icon-glyph socials-1_logo-spotify' => 'socials-1_logo-spotify' ),
					 array( 'nc-icon-glyph socials-1_logo-trello' => 'socials-1_logo-trello' ),
					 array( 'nc-icon-glyph socials-1_logo-tumblr' => 'socials-1_logo-tumblr' ),
					 array( 'nc-icon-glyph socials-1_logo-twitter' => 'socials-1_logo-twitter' ),
					 array( 'nc-icon-glyph socials-1_logo-vimeo' => 'socials-1_logo-vimeo' ),
					 array( 'nc-icon-glyph socials-1_logo-vine' => 'socials-1_logo-vine' ),
					 array( 'nc-icon-glyph socials-1_logo-whatsapp' => 'socials-1_logo-whatsapp' ),
					 array( 'nc-icon-glyph socials-1_logo-wordpress' => 'socials-1_logo-wordpress' ),
					 array( 'nc-icon-glyph socials-1_logo-yelp' => 'socials-1_logo-yelp' ),
					 array( 'nc-icon-glyph socials-1_logo-youtube' => 'socials-1_logo-youtube' ),
				),
				'Sport' => array( 
					 array( 'nc-icon-glyph sport_badminton' => 'sport_badminton' ),
					 array( 'nc-icon-glyph sport_baseball-ball' => 'sport_baseball-ball' ),
					 array( 'nc-icon-glyph sport_baseball-bat' => 'sport_baseball-bat' ),
					 array( 'nc-icon-glyph sport_baseball' => 'sport_baseball' ),
					 array( 'nc-icon-glyph sport_basketball-12' => 'sport_basketball-12' ),
					 array( 'nc-icon-glyph sport_basketball-13' => 'sport_basketball-13' ),
					 array( 'nc-icon-glyph sport_boxing' => 'sport_boxing' ),
					 array( 'nc-icon-glyph sport_cardio' => 'sport_cardio' ),
					 array( 'nc-icon-glyph sport_cricket' => 'sport_cricket' ),
					 array( 'nc-icon-glyph sport_crown' => 'sport_crown' ),
					 array( 'nc-icon-glyph sport_dart' => 'sport_dart' ),
					 array( 'nc-icon-glyph sport_dumbbells' => 'sport_dumbbells' ),
					 array( 'nc-icon-glyph sport_energy-drink' => 'sport_energy-drink' ),
					 array( 'nc-icon-glyph sport_energy-supplement' => 'sport_energy-supplement' ),
					 array( 'nc-icon-glyph sport_fencing' => 'sport_fencing' ),
					 array( 'nc-icon-glyph sport_fishing' => 'sport_fishing' ),
					 array( 'nc-icon-glyph sport_flag-finish' => 'sport_flag-finish' ),
					 array( 'nc-icon-glyph sport_football-headguard' => 'sport_football-headguard' ),
					 array( 'nc-icon-glyph sport_golf' => 'sport_golf' ),
					 array( 'nc-icon-glyph sport_helmet' => 'sport_helmet' ),
					 array( 'nc-icon-glyph sport_hockey' => 'sport_hockey' ),
					 array( 'nc-icon-glyph sport_kettlebell' => 'sport_kettlebell' ),
					 array( 'nc-icon-glyph sport_ping-pong' => 'sport_ping-pong' ),
					 array( 'nc-icon-glyph sport_podium-trophy' => 'sport_podium-trophy' ),
					 array( 'nc-icon-glyph sport_podium' => 'sport_podium' ),
					 array( 'nc-icon-glyph sport_rope' => 'sport_rope' ),
					 array( 'nc-icon-glyph sport_rugby' => 'sport_rugby' ),
					 array( 'nc-icon-glyph sport_shaker' => 'sport_shaker' ),
					 array( 'nc-icon-glyph sport_shoe-run' => 'sport_shoe-run' ),
					 array( 'nc-icon-glyph sport_skateboard' => 'sport_skateboard' ),
					 array( 'nc-icon-glyph sport_snowboard' => 'sport_snowboard' ),
					 array( 'nc-icon-glyph sport_soccer-field' => 'sport_soccer-field' ),
					 array( 'nc-icon-glyph sport_steering-wheel' => 'sport_steering-wheel' ),
					 array( 'nc-icon-glyph sport_supplement' => 'sport_supplement' ),
					 array( 'nc-icon-glyph sport_surf' => 'sport_surf' ),
					 array( 'nc-icon-glyph sport_tactic' => 'sport_tactic' ),
					 array( 'nc-icon-glyph sport_tennis-ball' => 'sport_tennis-ball' ),
					 array( 'nc-icon-glyph sport_tennis' => 'sport_tennis' ),
					 array( 'nc-icon-glyph sport_trophy' => 'sport_trophy' ),
					 array( 'nc-icon-glyph sport_user-balance' => 'sport_user-balance' ),
					 array( 'nc-icon-glyph sport_user-climb' => 'sport_user-climb' ),
					 array( 'nc-icon-glyph sport_user-meditation' => 'sport_user-meditation' ),
					 array( 'nc-icon-glyph sport_user-run' => 'sport_user-run' ),
					 array( 'nc-icon-glyph sport_user-snowboard' => 'sport_user-snowboard' ),
					 array( 'nc-icon-glyph sport_user-swim' => 'sport_user-swim' ),
					 array( 'nc-icon-glyph sport_volleyball' => 'sport_volleyball' ),
					 array( 'nc-icon-glyph sport_whistle' => 'sport_whistle' ),
				),
				'Technology' => array( 
					 array( 'nc-icon-glyph tech_cable-49' => 'tech_cable-49' ),
					 array( 'nc-icon-glyph tech_cable-50' => 'tech_cable-50' ),
					 array( 'nc-icon-glyph tech_cd-reader' => 'tech_cd-reader' ),
					 array( 'nc-icon-glyph tech_computer-monitor' => 'tech_computer-monitor' ),
					 array( 'nc-icon-glyph tech_computer-old' => 'tech_computer-old' ),
					 array( 'nc-icon-glyph tech_computer' => 'tech_computer' ),
					 array( 'nc-icon-glyph tech_controller-modern' => 'tech_controller-modern' ),
					 array( 'nc-icon-glyph tech_controller' => 'tech_controller' ),
					 array( 'nc-icon-glyph tech_desktop-screen' => 'tech_desktop-screen' ),
					 array( 'nc-icon-glyph tech_desktop' => 'tech_desktop' ),
					 array( 'nc-icon-glyph tech_disk-reader' => 'tech_disk-reader' ),
					 array( 'nc-icon-glyph tech_disk' => 'tech_disk' ),
					 array( 'nc-icon-glyph tech_gopro' => 'tech_gopro' ),
					 array( 'nc-icon-glyph tech_headphones' => 'tech_headphones' ),
					 array( 'nc-icon-glyph tech_keyboard-mouse' => 'tech_keyboard-mouse' ),
					 array( 'nc-icon-glyph tech_keyboard-wifi' => 'tech_keyboard-wifi' ),
					 array( 'nc-icon-glyph tech_keyboard' => 'tech_keyboard' ),
					 array( 'nc-icon-glyph tech_laptop-camera' => 'tech_laptop-camera' ),
					 array( 'nc-icon-glyph tech_laptop-front' => 'tech_laptop-front' ),
					 array( 'nc-icon-glyph tech_laptop' => 'tech_laptop' ),
					 array( 'nc-icon-glyph tech_mobile-button' => 'tech_mobile-button' ),
					 array( 'nc-icon-glyph tech_mobile-camera' => 'tech_mobile-camera' ),
					 array( 'nc-icon-glyph tech_mobile-recharger-08' => 'tech_mobile-recharger-08' ),
					 array( 'nc-icon-glyph tech_mobile-recharger-09' => 'tech_mobile-recharger-09' ),
					 array( 'nc-icon-glyph tech_mobile-toolbar' => 'tech_mobile-toolbar' ),
					 array( 'nc-icon-glyph tech_mobile' => 'tech_mobile' ),
					 array( 'nc-icon-glyph tech_music' => 'tech_music' ),
					 array( 'nc-icon-glyph tech_navigation' => 'tech_navigation' ),
					 array( 'nc-icon-glyph tech_player-19' => 'tech_player-19' ),
					 array( 'nc-icon-glyph tech_player-48' => 'tech_player-48' ),
					 array( 'nc-icon-glyph tech_print-fold' => 'tech_print-fold' ),
					 array( 'nc-icon-glyph tech_print-round-fold' => 'tech_print-round-fold' ),
					 array( 'nc-icon-glyph tech_print-round' => 'tech_print-round' ),
					 array( 'nc-icon-glyph tech_print' => 'tech_print' ),
					 array( 'nc-icon-glyph tech_ram' => 'tech_ram' ),
					 array( 'nc-icon-glyph tech_remote' => 'tech_remote' ),
					 array( 'nc-icon-glyph tech_signal' => 'tech_signal' ),
					 array( 'nc-icon-glyph tech_socket' => 'tech_socket' ),
					 array( 'nc-icon-glyph tech_sync' => 'tech_sync' ),
					 array( 'nc-icon-glyph tech_tablet-button' => 'tech_tablet-button' ),
					 array( 'nc-icon-glyph tech_tablet-reader-31' => 'tech_tablet-reader-31' ),
					 array( 'nc-icon-glyph tech_tablet-reader-42' => 'tech_tablet-reader-42' ),
					 array( 'nc-icon-glyph tech_tablet-toolbar' => 'tech_tablet-toolbar' ),
					 array( 'nc-icon-glyph tech_tablet' => 'tech_tablet' ),
					 array( 'nc-icon-glyph tech_tv-old' => 'tech_tv-old' ),
					 array( 'nc-icon-glyph tech_tv' => 'tech_tv' ),
					 array( 'nc-icon-glyph tech_watch-circle' => 'tech_watch-circle' ),
					 array( 'nc-icon-glyph tech_watch-time' => 'tech_watch-time' ),
					 array( 'nc-icon-glyph tech_watch' => 'tech_watch' ),
					 array( 'nc-icon-glyph tech_webcam-38' => 'tech_webcam-38' ),
					 array( 'nc-icon-glyph tech_webcam-39' => 'tech_webcam-39' ),
					 array( 'nc-icon-glyph tech_wifi-router' => 'tech_wifi-router' ),
					 array( 'nc-icon-glyph tech_wifi' => 'tech_wifi' ),
				),
				'Text Editing' => array( 
					 array( 'nc-icon-glyph text_align-center' => 'text_align-center' ),
					 array( 'nc-icon-glyph text_align-justify' => 'text_align-justify' ),
					 array( 'nc-icon-glyph text_align-left' => 'text_align-left' ),
					 array( 'nc-icon-glyph text_align-right' => 'text_align-right' ),
					 array( 'nc-icon-glyph text_background' => 'text_background' ),
					 array( 'nc-icon-glyph text_bold' => 'text_bold' ),
					 array( 'nc-icon-glyph text_capitalize' => 'text_capitalize' ),
					 array( 'nc-icon-glyph text_caps-all' => 'text_caps-all' ),
					 array( 'nc-icon-glyph text_caps-small' => 'text_caps-small' ),
					 array( 'nc-icon-glyph text_color' => 'text_color' ),
					 array( 'nc-icon-glyph text_edit' => 'text_edit' ),
					 array( 'nc-icon-glyph text_italic' => 'text_italic' ),
					 array( 'nc-icon-glyph text_line-height' => 'text_line-height' ),
					 array( 'nc-icon-glyph text_list-bullet' => 'text_list-bullet' ),
					 array( 'nc-icon-glyph text_list-numbers' => 'text_list-numbers' ),
					 array( 'nc-icon-glyph text_margin-left' => 'text_margin-left' ),
					 array( 'nc-icon-glyph text_margin-right' => 'text_margin-right' ),
					 array( 'nc-icon-glyph text_quote' => 'text_quote' ),
					 array( 'nc-icon-glyph text_scale-horizontal' => 'text_scale-horizontal' ),
					 array( 'nc-icon-glyph text_scale-vertical' => 'text_scale-vertical' ),
					 array( 'nc-icon-glyph text_size' => 'text_size' ),
					 array( 'nc-icon-glyph text_strikethrough' => 'text_strikethrough' ),
					 array( 'nc-icon-glyph text_subscript' => 'text_subscript' ),
					 array( 'nc-icon-glyph text_superscript' => 'text_superscript' ),
					 array( 'nc-icon-glyph text_tracking' => 'text_tracking' ),
					 array( 'nc-icon-glyph text_underline' => 'text_underline' ),
				),
				'Touch Gestures' => array( 
					 array( 'nc-icon-glyph gestures_2x-drag-down' => 'gestures_2x-drag-down' ),
					 array( 'nc-icon-glyph gestures_2x-drag-up' => 'gestures_2x-drag-up' ),
					 array( 'nc-icon-glyph gestures_2x-swipe-down' => 'gestures_2x-swipe-down' ),
					 array( 'nc-icon-glyph gestures_2x-swipe-left' => 'gestures_2x-swipe-left' ),
					 array( 'nc-icon-glyph gestures_2x-swipe-right' => 'gestures_2x-swipe-right' ),
					 array( 'nc-icon-glyph gestures_2x-swipe-up' => 'gestures_2x-swipe-up' ),
					 array( 'nc-icon-glyph gestures_2x-tap' => 'gestures_2x-tap' ),
					 array( 'nc-icon-glyph gestures_3x-swipe-left' => 'gestures_3x-swipe-left' ),
					 array( 'nc-icon-glyph gestures_3x-swipe-right' => 'gestures_3x-swipe-right' ),
					 array( 'nc-icon-glyph gestures_3x-swipe-up' => 'gestures_3x-swipe-up' ),
					 array( 'nc-icon-glyph gestures_3x-tap' => 'gestures_3x-tap' ),
					 array( 'nc-icon-glyph gestures_4x-swipe-left' => 'gestures_4x-swipe-left' ),
					 array( 'nc-icon-glyph gestures_4x-swipe-right' => 'gestures_4x-swipe-right' ),
					 array( 'nc-icon-glyph gestures_4x-swipe-up' => 'gestures_4x-swipe-up' ),
					 array( 'nc-icon-glyph gestures_active-38' => 'gestures_active-38' ),
					 array( 'nc-icon-glyph gestures_active-40' => 'gestures_active-40' ),
					 array( 'nc-icon-glyph gestures_camera' => 'gestures_camera' ),
					 array( 'nc-icon-glyph gestures_double-tap' => 'gestures_double-tap' ),
					 array( 'nc-icon-glyph gestures_drag-21' => 'gestures_drag-21' ),
					 array( 'nc-icon-glyph gestures_drag-31' => 'gestures_drag-31' ),
					 array( 'nc-icon-glyph gestures_drag-down' => 'gestures_drag-down' ),
					 array( 'nc-icon-glyph gestures_drag-left' => 'gestures_drag-left' ),
					 array( 'nc-icon-glyph gestures_drag-right' => 'gestures_drag-right' ),
					 array( 'nc-icon-glyph gestures_drag-up' => 'gestures_drag-up' ),
					 array( 'nc-icon-glyph gestures_flick-down' => 'gestures_flick-down' ),
					 array( 'nc-icon-glyph gestures_flick-left' => 'gestures_flick-left' ),
					 array( 'nc-icon-glyph gestures_flick-right' => 'gestures_flick-right' ),
					 array( 'nc-icon-glyph gestures_flick-up' => 'gestures_flick-up' ),
					 array( 'nc-icon-glyph gestures_grab' => 'gestures_grab' ),
					 array( 'nc-icon-glyph gestures_hold' => 'gestures_hold' ),
					 array( 'nc-icon-glyph gestures_pin' => 'gestures_pin' ),
					 array( 'nc-icon-glyph gestures_pinch' => 'gestures_pinch' ),
					 array( 'nc-icon-glyph gestures_rotate-22' => 'gestures_rotate-22' ),
					 array( 'nc-icon-glyph gestures_rotate-23' => 'gestures_rotate-23' ),
					 array( 'nc-icon-glyph gestures_scan' => 'gestures_scan' ),
					 array( 'nc-icon-glyph gestures_scroll-horitontal' => 'gestures_scroll-horitontal' ),
					 array( 'nc-icon-glyph gestures_scroll-vertical' => 'gestures_scroll-vertical' ),
					 array( 'nc-icon-glyph gestures_stretch' => 'gestures_stretch' ),
					 array( 'nc-icon-glyph gestures_swipe-bottom' => 'gestures_swipe-bottom' ),
					 array( 'nc-icon-glyph gestures_swipe-left' => 'gestures_swipe-left' ),
					 array( 'nc-icon-glyph gestures_swipe-right' => 'gestures_swipe-right' ),
					 array( 'nc-icon-glyph gestures_swipe-up' => 'gestures_swipe-up' ),
					 array( 'nc-icon-glyph gestures_tap-01' => 'gestures_tap-01' ),
					 array( 'nc-icon-glyph gestures_tap-02' => 'gestures_tap-02' ),
				),
				'Transportation' => array( 
					 array( 'nc-icon-glyph transportation_air-baloon' => 'transportation_air-baloon' ),
					 array( 'nc-icon-glyph transportation_bike-sport' => 'transportation_bike-sport' ),
					 array( 'nc-icon-glyph transportation_bike' => 'transportation_bike' ),
					 array( 'nc-icon-glyph transportation_boat-front' => 'transportation_boat-front' ),
					 array( 'nc-icon-glyph transportation_boat-small-02' => 'transportation_boat-small-02' ),
					 array( 'nc-icon-glyph transportation_boat-small-03' => 'transportation_boat-small-03' ),
					 array( 'nc-icon-glyph transportation_boat' => 'transportation_boat' ),
					 array( 'nc-icon-glyph transportation_bus-front-10' => 'transportation_bus-front-10' ),
					 array( 'nc-icon-glyph transportation_bus-front-12' => 'transportation_bus-front-12' ),
					 array( 'nc-icon-glyph transportation_bus' => 'transportation_bus' ),
					 array( 'nc-icon-glyph transportation_car-front' => 'transportation_car-front' ),
					 array( 'nc-icon-glyph transportation_car-simple' => 'transportation_car-simple' ),
					 array( 'nc-icon-glyph transportation_car-sport' => 'transportation_car-sport' ),
					 array( 'nc-icon-glyph transportation_car-taxi' => 'transportation_car-taxi' ),
					 array( 'nc-icon-glyph transportation_car' => 'transportation_car' ),
					 array( 'nc-icon-glyph transportation_helicopter' => 'transportation_helicopter' ),
					 array( 'nc-icon-glyph transportation_helmet' => 'transportation_helmet' ),
					 array( 'nc-icon-glyph transportation_light-traffic' => 'transportation_light-traffic' ),
					 array( 'nc-icon-glyph transportation_moto' => 'transportation_moto' ),
					 array( 'nc-icon-glyph transportation_plane-17' => 'transportation_plane-17' ),
					 array( 'nc-icon-glyph transportation_plane-18' => 'transportation_plane-18' ),
					 array( 'nc-icon-glyph transportation_road' => 'transportation_road' ),
					 array( 'nc-icon-glyph transportation_skateboard' => 'transportation_skateboard' ),
					 array( 'nc-icon-glyph transportation_tractor' => 'transportation_tractor' ),
					 array( 'nc-icon-glyph transportation_train-speed' => 'transportation_train-speed' ),
					 array( 'nc-icon-glyph transportation_train' => 'transportation_train' ),
					 array( 'nc-icon-glyph transportation_tram' => 'transportation_tram"' ),
					 array( 'nc-icon-glyph transportation_truck-front' => 'transportation_truck-front' ),
					 array( 'nc-icon-glyph transportation_vespa-front' => 'transportation_vespa-front' ),
					 array( 'nc-icon-glyph transportation_vespa' => 'transportation_vespa' ),
				),
				'Travel' => array( 
					 array( 'nc-icon-glyph travel_axe' => 'travel_axe' ),
					 array( 'nc-icon-glyph travel_backpack' => 'travel_backpack' ),
					 array( 'nc-icon-glyph travel_bag' => 'travel_bag' ),
					 array( 'nc-icon-glyph travel_barbecue' => 'travel_barbecue' ),
					 array( 'nc-icon-glyph travel_beach-umbrella' => 'travel_beach-umbrella' ),
					 array( 'nc-icon-glyph travel_berlin' => 'travel_berlin' ),
					 array( 'nc-icon-glyph travel_binocular' => 'travel_binocular' ),
					 array( 'nc-icon-glyph travel_camper' => 'travel_camper' ),
					 array( 'nc-icon-glyph travel_camping' => 'travel_camping' ),
					 array( 'nc-icon-glyph travel_castle' => 'travel_castle' ),
					 array( 'nc-icon-glyph travel_china' => 'travel_china' ),
					 array( 'nc-icon-glyph travel_church' => 'travel_church' ),
					 array( 'nc-icon-glyph travel_drink' => 'travel_drink' ),
					 array( 'nc-icon-glyph travel_explore' => 'travel_explore' ),
					 array( 'nc-icon-glyph travel_fire' => 'travel_fire' ),
					 array( 'nc-icon-glyph travel_hotel-bell' => 'travel_hotel-bell' ),
					 array( 'nc-icon-glyph travel_hotel-symbol' => 'travel_hotel-symbol' ),
					 array( 'nc-icon-glyph travel_hotel' => 'travel_hotel' ),
					 array( 'nc-icon-glyph travel_hut' => 'travel_hut' ),
					 array( 'nc-icon-glyph travel_igloo' => 'travel_igloo' ),
					 array( 'nc-icon-glyph travel_info' => 'travel_info' ),
					 array( 'nc-icon-glyph travel_istanbul' => 'travel_istanbul' ),
					 array( 'nc-icon-glyph travel_jellyfish' => 'travel_jellyfish' ),
					 array( 'nc-icon-glyph travel_lamp' => 'travel_lamp' ),
					 array( 'nc-icon-glyph travel_lighthouse' => 'travel_lighthouse' ),
					 array( 'nc-icon-glyph travel_london' => 'travel_london' ),
					 array( 'nc-icon-glyph travel_luggage' => 'travel_luggage' ),
					 array( 'nc-icon-glyph travel_mosque' => 'travel_mosque' ),
					 array( 'nc-icon-glyph travel_ny' => 'travel_ny' ),
					 array( 'nc-icon-glyph travel_octopus' => 'travel_octopus' ),
					 array( 'nc-icon-glyph travel_paris-tower' => 'travel_paris-tower' ),
					 array( 'nc-icon-glyph travel_passport' => 'travel_passport' ),
					 array( 'nc-icon-glyph travel_pickaxe' => 'travel_pickaxe' ),
					 array( 'nc-icon-glyph travel_pool' => 'travel_pool' ),
					 array( 'nc-icon-glyph travel_pyramid' => 'travel_pyramid' ),
					 array( 'nc-icon-glyph travel_rackets' => 'travel_rackets' ),
					 array( 'nc-icon-glyph travel_rio' => 'travel_rio' ),
					 array( 'nc-icon-glyph travel_road-sign-left' => 'travel_road-sign-left' ),
					 array( 'nc-icon-glyph travel_road-sign-right' => 'travel_road-sign-right' ),
					 array( 'nc-icon-glyph travel_rome' => 'travel_rome' ),
					 array( 'nc-icon-glyph travel_rowing' => 'travel_rowing' ),
					 array( 'nc-icon-glyph travel_sea-mask' => 'travel_sea-mask' ),
					 array( 'nc-icon-glyph travel_sf-bridge' => 'travel_sf-bridge' ),
					 array( 'nc-icon-glyph travel_shark' => 'travel_shark' ),
					 array( 'nc-icon-glyph travel_spa' => 'travel_spa' ),
					 array( 'nc-icon-glyph travel_sunglasses' => 'travel_sunglasses' ),
					 array( 'nc-icon-glyph travel_surf' => 'travel_surf' ),
					 array( 'nc-icon-glyph travel_swimsuit' => 'travel_swimsuit' ),
					 array( 'nc-icon-glyph travel_swimwear' => 'travel_swimwear' ),
					 array( 'nc-icon-glyph travel_swiss-knife' => 'travel_swiss-knife' ),
					 array( 'nc-icon-glyph travel_temple-02' => 'travel_temple-02' ),
					 array( 'nc-icon-glyph travel_temple-25' => 'travel_temple-25' ),
					 array( 'nc-icon-glyph travel_trolley' => 'travel_trolley' ),
					 array( 'nc-icon-glyph travel_white-house' => 'travel_white-house' ),
					 array( 'nc-icon-glyph travel_world' => 'travel_world' ),
					 array( 'nc-icon-glyph travel_worldmap' => 'travel_worldmap' ),
				),
				'User Interface' => array( 
					 array( 'nc-icon-glyph ui-1_analytics-88' => 'ui-1_analytics-88' ),
					 array( 'nc-icon-glyph ui-1_analytics-89' => 'ui-1_analytics-89' ),
					 array( 'nc-icon-glyph ui-1_attach-86' => 'ui-1_attach-86' ),
					 array( 'nc-icon-glyph ui-1_attach-87' => 'ui-1_attach-87' ),
					 array( 'nc-icon-glyph ui-1_bell-53' => 'ui-1_bell-53' ),
					 array( 'nc-icon-glyph ui-1_bell-54' => 'ui-1_bell-54' ),
					 array( 'nc-icon-glyph ui-1_bell-55' => 'ui-1_bell-55' ),
					 array( 'nc-icon-glyph ui-1_bold-add' => 'ui-1_bold-add' ),
					 array( 'nc-icon-glyph ui-1_bold-delete' => 'ui-1_bold-delete' ),
					 array( 'nc-icon-glyph ui-1_bold-remove' => 'ui-1_bold-remove' ),
					 array( 'nc-icon-glyph ui-1_bookmark-add' => 'ui-1_bookmark-add' ),
					 array( 'nc-icon-glyph ui-1_bookmark-remove' => 'ui-1_bookmark-remove' ),
					 array( 'nc-icon-glyph ui-1_calendar-57' => 'ui-1_calendar-57' ),
					 array( 'nc-icon-glyph ui-1_calendar-60' => 'ui-1_calendar-60' ),
					 array( 'nc-icon-glyph ui-1_calendar-check-59' => 'ui-1_calendar-check-59' ),
					 array( 'nc-icon-glyph ui-1_calendar-check-62' => 'ui-1_calendar-check-62' ),
					 array( 'nc-icon-glyph ui-1_calendar-grid-58' => 'ui-1_calendar-grid-58' ),
					 array( 'nc-icon-glyph ui-1_calendar-grid-61' => 'ui-1_calendar-grid-61' ),
					 array( 'nc-icon-glyph ui-1_check-bold' => 'ui-1_check-bold' ),
					 array( 'nc-icon-glyph ui-1_check-circle-07' => 'ui-1_check-circle-07' ),
					 array( 'nc-icon-glyph ui-1_check-circle-08' => 'ui-1_check-circle-08' ),
					 array( 'nc-icon-glyph ui-1_check-curve' => 'ui-1_check-curve' ),
					 array( 'nc-icon-glyph ui-1_check-simple' => 'ui-1_check-simple' ),
					 array( 'nc-icon-glyph ui-1_check-small' => 'ui-1_check-small' ),
					 array( 'nc-icon-glyph ui-1_check-square-09' => 'ui-1_check-square-09' ),
					 array( 'nc-icon-glyph ui-1_check-square-11' => 'ui-1_check-square-11' ),
					 array( 'nc-icon-glyph ui-1_check' => 'ui-1_check' ),
					 array( 'nc-icon-glyph ui-1_circle-add' => 'ui-1_circle-add' ),
					 array( 'nc-icon-glyph ui-1_circle-bold-add' => 'ui-1_circle-bold-add' ),
					 array( 'nc-icon-glyph ui-1_circle-bold-remove' => 'ui-1_circle-bold-remove' ),
					 array( 'nc-icon-glyph ui-1_circle-delete' => 'ui-1_circle-delete' ),
					 array( 'nc-icon-glyph ui-1_circle-remove' => 'ui-1_circle-remove' ),
					 array( 'nc-icon-glyph ui-1_dashboard-29' => 'ui-1_dashboard-29' ),
					 array( 'nc-icon-glyph ui-1_dashboard-30' => 'ui-1_dashboard-30' ),
					 array( 'nc-icon-glyph ui-1_dashboard-half' => 'ui-1_dashboard-half' ),
					 array( 'nc-icon-glyph ui-1_dashboard-level' => 'ui-1_dashboard-level' ),
					 array( 'nc-icon-glyph ui-1_database' => 'ui-1_database' ),
					 array( 'nc-icon-glyph ui-1_drop' => 'ui-1_drop' ),
					 array( 'nc-icon-glyph ui-1_edit-71' => 'ui-1_edit-71' ),
					 array( 'nc-icon-glyph ui-1_edit-72' => 'ui-1_edit-72' ),
					 array( 'nc-icon-glyph ui-1_edit-73' => 'ui-1_edit-73' ),
					 array( 'nc-icon-glyph ui-1_edit-74' => 'ui-1_edit-74' ),
					 array( 'nc-icon-glyph ui-1_edit-75' => 'ui-1_edit-75' ),
					 array( 'nc-icon-glyph ui-1_edit-76' => 'ui-1_edit-76' ),
					 array( 'nc-icon-glyph ui-1_edit-77' => 'ui-1_edit-77' ),
					 array( 'nc-icon-glyph ui-1_edit-78' => 'ui-1_edit-78' ),
					 array( 'nc-icon-glyph ui-1_email-83' => 'ui-1_email-83' ),
					 array( 'nc-icon-glyph ui-1_email-84' => 'ui-1_email-84' ),
					 array( 'nc-icon-glyph ui-1_email-85' => 'ui-1_email-85' ),
					 array( 'nc-icon-glyph ui-1_eye-17' => 'ui-1_eye-17' ),
					 array( 'nc-icon-glyph ui-1_eye-19' => 'ui-1_eye-19' ),
					 array( 'nc-icon-glyph ui-1_eye-ban-18' => 'ui-1_eye-ban-18' ),
					 array( 'nc-icon-glyph ui-1_eye-ban-20' => 'ui-1_eye-ban-20' ),
					 array( 'nc-icon-glyph ui-1_flame' => 'ui-1_flame' ),
					 array( 'nc-icon-glyph ui-1_home-51' => 'ui-1_home-51' ),
					 array( 'nc-icon-glyph ui-1_home-52' => 'ui-1_home-52' ),
					 array( 'nc-icon-glyph ui-1_home-minimal' => 'ui-1_home-minimal' ),
					 array( 'nc-icon-glyph ui-1_home-simple' => 'ui-1_home-simple' ),
					 array( 'nc-icon-glyph ui-1_leaf-80' => 'ui-1_leaf-80' ),
					 array( 'nc-icon-glyph ui-1_leaf-81' => 'ui-1_leaf-81' ),
					 array( 'nc-icon-glyph ui-1_leaf-edit' => 'ui-1_leaf-edit' ),
					 array( 'nc-icon-glyph ui-1_lock-circle-open' => 'ui-1_lock-circle-open' ),
					 array( 'nc-icon-glyph ui-1_lock-circle' => 'ui-1_lock-circle' ),
					 array( 'nc-icon-glyph ui-1_lock-open' => 'ui-1_lock-open' ),
					 array( 'nc-icon-glyph ui-1_lock' => 'ui-1_lock' ),
					 array( 'nc-icon-glyph ui-1_notification-69' => 'ui-1_notification-69' ),
					 array( 'nc-icon-glyph ui-1_notification-70' => 'ui-1_notification-70' ),
					 array( 'nc-icon-glyph ui-1_pencil' => 'ui-1_pencil' ),
					 array( 'nc-icon-glyph ui-1_preferences-circle-rotate' => 'ui-1_preferences-circle-rotate' ),
					 array( 'nc-icon-glyph ui-1_preferences-circle' => 'ui-1_preferences-circle' ),
					 array( 'nc-icon-glyph ui-1_preferences-container-circle-rotate' => 'ui-1_preferences-container-circle-rotate' ),
					 array( 'nc-icon-glyph ui-1_preferences-container-circle' => 'ui-1_preferences-container-circle' ),
					 array( 'nc-icon-glyph ui-1_preferences-container-rotate' => 'ui-1_preferences-container-rotate' ),
					 array( 'nc-icon-glyph ui-1_preferences-container' => 'ui-1_preferences-container' ),
					 array( 'nc-icon-glyph ui-1_preferences-rotate' => 'ui-1_preferences-rotate' ),
					 array( 'nc-icon-glyph ui-1_preferences' => 'ui-1_preferences' ),
					 array( 'nc-icon-glyph ui-1_send' => 'ui-1_send' ),
					 array( 'nc-icon-glyph ui-1_settings-gear-63' => 'ui-1_settings-gear-63' ),
					 array( 'nc-icon-glyph ui-1_settings-gear-64' => 'ui-1_settings-gear-64' ),
					 array( 'nc-icon-glyph ui-1_settings-gear-65' => 'ui-1_settings-gear-65' ),
					 array( 'nc-icon-glyph ui-1_settings-tool-66' => 'ui-1_settings-tool-66' ),
					 array( 'nc-icon-glyph ui-1_settings-tool-67' => 'ui-1_settings-tool-67' ),
					 array( 'nc-icon-glyph ui-1_settings' => 'ui-1_settings' ),
					 array( 'nc-icon-glyph ui-1_simple-add' => 'ui-1_simple-add' ),
					 array( 'nc-icon-glyph ui-1_simple-delete' => 'ui-1_simple-delete' ),
					 array( 'nc-icon-glyph ui-1_simple-remove' => 'ui-1_simple-remove' ),
					 array( 'nc-icon-glyph ui-1_trash-round' => 'ui-1_trash-round' ),
					 array( 'nc-icon-glyph ui-1_trash-simple' => 'ui-1_trash-simple' ),
					 array( 'nc-icon-glyph ui-1_trash' => 'ui-1_trash' ),
					 array( 'nc-icon-glyph ui-1_ui-03' => 'ui-1_ui-03' ),
					 array( 'nc-icon-glyph ui-1_ui-04' => 'ui-1_ui-04' ),
					 array( 'nc-icon-glyph ui-1_zoom-bold-in' => 'ui-1_zoom-bold-in' ),
					 array( 'nc-icon-glyph ui-1_zoom-bold-out' => 'ui-1_zoom-bold-out' ),
					 array( 'nc-icon-glyph ui-1_zoom-bold' => 'ui-1_zoom-bold' ),
					 array( 'nc-icon-glyph ui-1_zoom-in' => 'ui-1_zoom-in' ),
					 array( 'nc-icon-glyph ui-1_zoom-out' => 'ui-1_zoom-out' ),
					 array( 'nc-icon-glyph ui-1_zoom-split-in' => 'ui-1_zoom-split-in' ),
					 array( 'nc-icon-glyph ui-1_zoom-split-out' => 'ui-1_zoom-split-out' ),
					 array( 'nc-icon-glyph ui-1_zoom-split' => 'ui-1_zoom-split' ),
					 array( 'nc-icon-glyph ui-1_zoom' => 'ui-1_zoom' ),
					 array( 'nc-icon-glyph ui-2_alert' => 'ui-2_alert' ),
					 array( 'nc-icon-glyph ui-2_alert-' => 'ui-2_alert-' ),
					 array( 'nc-icon-glyph ui-2_alert-circle' => 'ui-2_alert-circle' ),
					 array( 'nc-icon-glyph ui-2_alert-circle-' => 'ui-2_alert-circle-' ),
					 array( 'nc-icon-glyph ui-2_alert-circle-i' => 'ui-2_alert-circle-i' ),
					 array( 'nc-icon-glyph ui-2_alert-i' => 'ui-2_alert-i' ),
					 array( 'nc-icon-glyph ui-2_alert-square' => 'ui-2_alert-square' ),
					 array( 'nc-icon-glyph ui-2_alert-square-' => 'ui-2_alert-square-' ),
					 array( 'nc-icon-glyph ui-2_alert-square-i' => 'ui-2_alert-square-i' ),
					 array( 'nc-icon-glyph ui-2_archive' => 'ui-2_archive' ),
					 array( 'nc-icon-glyph ui-2_ban-bold' => 'ui-2_ban-bold' ),
					 array( 'nc-icon-glyph ui-2_ban' => 'ui-2_ban' ),
					 array( 'nc-icon-glyph ui-2_battery-81' => 'ui-2_battery-81' ),
					 array( 'nc-icon-glyph ui-2_battery-83' => 'ui-2_battery-83' ),
					 array( 'nc-icon-glyph ui-2_battery-half' => 'ui-2_battery-half' ),
					 array( 'nc-icon-glyph ui-2_battery-low' => 'ui-2_battery-low' ),
					 array( 'nc-icon-glyph ui-2_bluetooth' => 'ui-2_bluetooth' ),
					 array( 'nc-icon-glyph ui-2_book' => 'ui-2_book' ),
					 array( 'nc-icon-glyph ui-2_chart-bar-52' => 'ui-2_chart-bar-52' ),
					 array( 'nc-icon-glyph ui-2_chart-bar-53' => 'ui-2_chart-bar-53' ),
					 array( 'nc-icon-glyph ui-2_chat-content' => 'ui-2_chat-content' ),
					 array( 'nc-icon-glyph ui-2_chat-round-content' => 'ui-2_chat-round-content' ),
					 array( 'nc-icon-glyph ui-2_chat-round' => 'ui-2_chat-round' ),
					 array( 'nc-icon-glyph ui-2_chat' => 'ui-2_chat' ),
					 array( 'nc-icon-glyph ui-2_circle-bold-delete' => 'ui-2_circle-bold-delete' ),
					 array( 'nc-icon-glyph ui-2_cloud-25' => 'ui-2_cloud-25' ),
					 array( 'nc-icon-glyph ui-2_cloud-26' => 'ui-2_cloud-26' ),
					 array( 'nc-icon-glyph ui-2_disk' => 'ui-2_disk' ),
					 array( 'nc-icon-glyph ui-2_enlarge-57' => 'ui-2_enlarge-57' ),
					 array( 'nc-icon-glyph ui-2_enlarge-58' => 'ui-2_enlarge-58' ),
					 array( 'nc-icon-glyph ui-2_enlarge-59' => 'ui-2_enlarge-59' ),
					 array( 'nc-icon-glyph ui-2_fat-add' => 'ui-2_fat-add' ),
					 array( 'nc-icon-glyph ui-2_fat-delete' => 'ui-2_fat-delete' ),
					 array( 'nc-icon-glyph ui-2_fat-remove' => 'ui-2_fat-remove' ),
					 array( 'nc-icon-glyph ui-2_favourite-28' => 'ui-2_favourite-28' ),
					 array( 'nc-icon-glyph ui-2_favourite-31' => 'ui-2_favourite-31' ),
					 array( 'nc-icon-glyph ui-2_favourite-add-29' => 'ui-2_favourite-add-29' ),
					 array( 'nc-icon-glyph ui-2_favourite-add-32' => 'ui-2_favourite-add-32' ),
					 array( 'nc-icon-glyph ui-2_favourite-remove-30' => 'ui-2_favourite-remove-30' ),
					 array( 'nc-icon-glyph ui-2_favourite-remove-33' => 'ui-2_favourite-remove-33' ),
					 array( 'nc-icon-glyph ui-2_filter' => 'ui-2_filter' ),
					 array( 'nc-icon-glyph ui-2_fullsize' => 'ui-2_fullsize' ),
					 array( 'nc-icon-glyph ui-2_grid-45' => 'ui-2_grid-45' ),
					 array( 'nc-icon-glyph ui-2_grid-46' => 'ui-2_grid-46' ),
					 array( 'nc-icon-glyph ui-2_grid-48' => 'ui-2_grid-48' ),
					 array( 'nc-icon-glyph ui-2_grid-49' => 'ui-2_grid-49' ),
					 array( 'nc-icon-glyph ui-2_grid-50' => 'ui-2_grid-50' ),
					 array( 'nc-icon-glyph ui-2_grid-square' => 'ui-2_grid-square' ),
					 array( 'nc-icon-glyph ui-2_hourglass' => 'ui-2_hourglass' ),
					 array( 'nc-icon-glyph ui-2_lab' => 'ui-2_lab' ),
					 array( 'nc-icon-glyph ui-2_layers' => 'ui-2_layers' ),
					 array( 'nc-icon-glyph ui-2_like' => 'ui-2_like' ),
					 array( 'nc-icon-glyph ui-2_link-66' => 'ui-2_link-66' ),
					 array( 'nc-icon-glyph ui-2_link-67' => 'ui-2_link-67' ),
					 array( 'nc-icon-glyph ui-2_link-68' => 'ui-2_link-68' ),
					 array( 'nc-icon-glyph ui-2_link-69' => 'ui-2_link-69' ),
					 array( 'nc-icon-glyph ui-2_link-71' => 'ui-2_link-71' ),
					 array( 'nc-icon-glyph ui-2_link-72' => 'ui-2_link-72' ),
					 array( 'nc-icon-glyph ui-2_link-broken-70' => 'ui-2_link-broken-70' ),
					 array( 'nc-icon-glyph ui-2_link-broken-73' => 'ui-2_link-broken-73' ),
					 array( 'nc-icon-glyph ui-2_menu-34' => 'ui-2_menu-34' ),
					 array( 'nc-icon-glyph ui-2_menu-35' => 'ui-2_menu-35' ),
					 array( 'nc-icon-glyph ui-2_menu-bold' => 'ui-2_menu-bold' ),
					 array( 'nc-icon-glyph ui-2_menu-dots' => 'ui-2_menu-dots' ),
					 array( 'nc-icon-glyph ui-2_menu-square' => 'ui-2_menu-square' ),
					 array( 'nc-icon-glyph ui-2_node' => 'ui-2_node' ),
					 array( 'nc-icon-glyph ui-2_paragraph' => 'ui-2_paragraph' ),
					 array( 'nc-icon-glyph ui-2_phone' => 'ui-2_phone' ),
					 array( 'nc-icon-glyph ui-2_settings-90' => 'ui-2_settings-90' ),
					 array( 'nc-icon-glyph ui-2_settings-91' => 'ui-2_settings-91' ),
					 array( 'nc-icon-glyph ui-2_share-bold' => 'ui-2_share-bold' ),
					 array( 'nc-icon-glyph ui-2_share' => 'ui-2_share' ),
					 array( 'nc-icon-glyph ui-2_small-add' => 'ui-2_small-add' ),
					 array( 'nc-icon-glyph ui-2_small-delete' => 'ui-2_small-delete' ),
					 array( 'nc-icon-glyph ui-2_small-remove' => 'ui-2_small-remove' ),
					 array( 'nc-icon-glyph ui-2_square-add-08' => 'ui-2_square-add-08' ),
					 array( 'nc-icon-glyph ui-2_square-add-11' => 'ui-2_square-add-11' ),
					 array( 'nc-icon-glyph ui-2_square-delete-10' => 'ui-2_square-delete-10' ),
					 array( 'nc-icon-glyph ui-2_square-delete-13' => 'ui-2_square-delete-13' ),
					 array( 'nc-icon-glyph ui-2_square-remove-09' => 'ui-2_square-remove-09' ),
					 array( 'nc-icon-glyph ui-2_square-remove-12' => 'ui-2_square-remove-12' ),
					 array( 'nc-icon-glyph ui-2_target' => 'ui-2_target' ),
					 array( 'nc-icon-glyph ui-2_tile-55' => 'ui-2_tile-55' ),
					 array( 'nc-icon-glyph ui-2_tile-56' => 'ui-2_tile-56' ),
					 array( 'nc-icon-glyph ui-2_time-alarm' => 'ui-2_time-alarm' ),
					 array( 'nc-icon-glyph ui-2_time-clock' => 'ui-2_time-clock' ),
					 array( 'nc-icon-glyph ui-2_time-countdown' => 'ui-2_time-countdown' ),
					 array( 'nc-icon-glyph ui-2_time' => 'ui-2_time' ),
					 array( 'nc-icon-glyph ui-2_webpage' => 'ui-2_webpage' ),
					 array( 'nc-icon-glyph ui-2_window-add' => 'ui-2_window-add' ),
					 array( 'nc-icon-glyph ui-2_window-delete' => 'ui-2_window-delete' ),
					 array( 'nc-icon-glyph ui-3_alert' => 'ui-3_alert' ),
					 array( 'nc-icon-glyph ui-3_backward' => 'ui-3_backward' ),
					 array( 'nc-icon-glyph ui-3_bolt' => 'ui-3_bolt' ),
					 array( 'nc-icon-glyph ui-3_bullet-list' => 'ui-3_bullet-list' ),
					 array( 'nc-icon-glyph ui-3_calendar-add' => 'ui-3_calendar-add' ),
					 array( 'nc-icon-glyph ui-3_card-add' => 'ui-3_card-add' ),
					 array( 'nc-icon-glyph ui-3_card-alert' => 'ui-3_card-alert' ),
					 array( 'nc-icon-glyph ui-3_chart-bars' => 'ui-3_chart-bars' ),
					 array( 'nc-icon-glyph ui-3_chart' => 'ui-3_chart' ),
					 array( 'nc-icon-glyph ui-3_chat-33' => 'ui-3_chat-33' ),
					 array( 'nc-icon-glyph ui-3_chat-45' => 'ui-3_chat-45' ),
					 array( 'nc-icon-glyph ui-3_chat-46' => 'ui-3_chat-46' ),
					 array( 'nc-icon-glyph ui-3_chat-reply' => 'ui-3_chat-reply' ),
					 array( 'nc-icon-glyph ui-3_check-in' => 'ui-3_check-in' ),
					 array( 'nc-icon-glyph ui-3_check-out' => 'ui-3_check-out' ),
					 array( 'nc-icon-glyph ui-3_dock-bottom' => 'ui-3_dock-bottom' ),
					 array( 'nc-icon-glyph ui-3_dock-left' => 'ui-3_dock-left' ),
					 array( 'nc-icon-glyph ui-3_dock-right' => 'ui-3_dock-right' ),
					 array( 'nc-icon-glyph ui-3_dock-top' => 'ui-3_dock-top' ),
					 array( 'nc-icon-glyph ui-3_filter-check' => 'ui-3_filter-check' ),
					 array( 'nc-icon-glyph ui-3_filter-remove' => 'ui-3_filter-remove' ),
					 array( 'nc-icon-glyph ui-3_forward' => 'ui-3_forward' ),
					 array( 'nc-icon-glyph ui-3_funnel-39' => 'ui-3_funnel-39' ),
					 array( 'nc-icon-glyph ui-3_funnel-40' => 'ui-3_funnel-40' ),
					 array( 'nc-icon-glyph ui-3_funnel-41' => 'ui-3_funnel-41' ),
					 array( 'nc-icon-glyph ui-3_heart-add' => 'ui-3_heart-add' ),
					 array( 'nc-icon-glyph ui-3_heart-remove' => 'ui-3_heart-remove' ),
					 array( 'nc-icon-glyph ui-3_heart' => 'ui-3_heart' ),
					 array( 'nc-icon-glyph ui-3_infinite' => 'ui-3_infinite' ),
					 array( 'nc-icon-glyph ui-3_link' => 'ui-3_link' ),
					 array( 'nc-icon-glyph ui-3_menu-left' => 'ui-3_menu-left' ),
					 array( 'nc-icon-glyph ui-3_menu-right' => 'ui-3_menu-right' ),
					 array( 'nc-icon-glyph ui-3_menu' => 'ui-3_menu' ),
					 array( 'nc-icon-glyph ui-3_metrics' => 'ui-3_metrics' ),
					 array( 'nc-icon-glyph ui-3_phone-call-end' => 'ui-3_phone-call-end' ),
					 array( 'nc-icon-glyph ui-3_phone-call' => 'ui-3_phone-call' ),
					 array( 'nc-icon-glyph ui-3_phone' => 'ui-3_phone' ),
					 array( 'nc-icon-glyph ui-3_playlist' => 'ui-3_playlist' ),
					 array( 'nc-icon-glyph ui-3_search' => 'ui-3_search' ),
					 array( 'nc-icon-glyph ui-3_security' => 'ui-3_security' ),
					 array( 'nc-icon-glyph ui-3_segmentation' => 'ui-3_segmentation' ),
					 array( 'nc-icon-glyph ui-3_select' => 'ui-3_select' ),
					 array( 'nc-icon-glyph ui-3_send' => 'ui-3_send' ),
					 array( 'nc-icon-glyph ui-3_signal' => 'ui-3_signal' ),
					 array( 'nc-icon-glyph ui-3_slide-left' => 'ui-3_slide-left' ),
					 array( 'nc-icon-glyph ui-3_slide-right' => 'ui-3_slide-right' ),
					 array( 'nc-icon-glyph ui-3_table-left' => 'ui-3_table-left' ),
					 array( 'nc-icon-glyph ui-3_table-right' => 'ui-3_table-right' ),
					 array( 'nc-icon-glyph ui-3_tag' => 'ui-3_tag' ),
					 array( 'nc-icon-glyph ui-3_widget' => 'ui-3_widget' ),
				),
				'Users' => array( 
					 array( 'nc-icon-glyph users_add-27' => 'users_add-27' ),
					 array( 'nc-icon-glyph users_add-29' => 'users_add-29' ),
					 array( 'nc-icon-glyph users_badge-13' => 'users_badge-13' ),
					 array( 'nc-icon-glyph users_badge-14' => 'users_badge-14' ),
					 array( 'nc-icon-glyph users_badge-15' => 'users_badge-15' ),
					 array( 'nc-icon-glyph users_circle-08' => 'users_circle-08' ),
					 array( 'nc-icon-glyph users_circle-09' => 'users_circle-09' ),
					 array( 'nc-icon-glyph users_circle-10' => 'users_circle-10' ),
					 array( 'nc-icon-glyph users_contacts' => 'users_contacts' ),
					 array( 'nc-icon-glyph users_delete-28' => 'users_delete-28' ),
					 array( 'nc-icon-glyph users_delete-30' => 'users_delete-30' ),
					 array( 'nc-icon-glyph users_man-20' => 'users_man-20' ),
					 array( 'nc-icon-glyph users_man-23' => 'users_man-23' ),
					 array( 'nc-icon-glyph users_man-glasses' => 'users_man-glasses' ),
					 array( 'nc-icon-glyph users_mobile-contact' => 'users_mobile-contact' ),
					 array( 'nc-icon-glyph users_multiple-11' => 'users_multiple-11' ),
					 array( 'nc-icon-glyph users_multiple-19' => 'users_multiple-19' ),
					 array( 'nc-icon-glyph users_network' => 'users_network' ),
					 array( 'nc-icon-glyph users_parent' => 'users_parent' ),
					 array( 'nc-icon-glyph users_single-01' => 'users_single-01' ),
					 array( 'nc-icon-glyph users_single-02' => 'users_single-02' ),
					 array( 'nc-icon-glyph users_single-03' => 'users_single-03' ),
					 array( 'nc-icon-glyph users_single-04' => 'users_single-04' ),
					 array( 'nc-icon-glyph users_single-05' => 'users_single-05' ),
					 array( 'nc-icon-glyph users_single-body' => 'users_single-body' ),
					 array( 'nc-icon-glyph users_single-position' => 'users_single-position' ),
					 array( 'nc-icon-glyph users_square-31' => 'users_square-31' ),
					 array( 'nc-icon-glyph users_square-32' => 'users_square-32' ),
					 array( 'nc-icon-glyph users_square-33' => 'users_square-33' ),
					 array( 'nc-icon-glyph users_woman-21' => 'users_woman-21' ),
					 array( 'nc-icon-glyph users_woman-24' => 'users_woman-24' ),
					 array( 'nc-icon-glyph users_woman-25' => 'users_woman-25' ),
					 array( 'nc-icon-glyph users_woman-34' => 'users_woman-34' ),
					 array( 'nc-icon-glyph users_woman-35' => 'users_woman-35' ),
					 array( 'nc-icon-glyph users_woman-man' => 'users_woman-man' ),
				),
				'Weather' => array( 
					 array( 'nc-icon-glyph weather_celsius' => 'weather_celsius' ),
					 array( 'nc-icon-glyph weather_cloud-13' => 'weather_cloud-13' ),
					 array( 'nc-icon-glyph weather_cloud-14' => 'weather_cloud-14' ),
					 array( 'nc-icon-glyph weather_cloud-drop' => 'weather_cloud-drop' ),
					 array( 'nc-icon-glyph weather_cloud-fog-31' => 'weather_cloud-fog-31' ),
					 array( 'nc-icon-glyph weather_cloud-fog-32' => 'weather_cloud-fog-32' ),
					 array( 'nc-icon-glyph weather_cloud-hail' => 'weather_cloud-hail' ),
					 array( 'nc-icon-glyph weather_cloud-light' => 'weather_cloud-light' ),
					 array( 'nc-icon-glyph weather_cloud-moon' => 'weather_cloud-moon' ),
					 array( 'nc-icon-glyph weather_cloud-rain' => 'weather_cloud-rain' ),
					 array( 'nc-icon-glyph weather_cloud-rainbow' => 'weather_cloud-rainbow' ),
					 array( 'nc-icon-glyph weather_cloud-snow-34' => 'weather_cloud-snow-34' ),
					 array( 'nc-icon-glyph weather_cloud-snow-42' => 'weather_cloud-snow-42' ),
					 array( 'nc-icon-glyph weather_cloud-sun-17' => 'weather_cloud-sun-17' ),
					 array( 'nc-icon-glyph weather_cloud-sun-19' => 'weather_cloud-sun-19' ),
					 array( 'nc-icon-glyph weather_compass' => 'weather_compass' ),
					 array( 'nc-icon-glyph weather_drop-12' => 'weather_drop-12' ),
					 array( 'nc-icon-glyph weather_drop-15' => 'weather_drop-15' ),
					 array( 'nc-icon-glyph weather_drops' => 'weather_drops' ),
					 array( 'nc-icon-glyph weather_eclipse' => 'weather_eclipse' ),
					 array( 'nc-icon-glyph weather_fahrenheit' => 'weather_fahrenheit' ),
					 array( 'nc-icon-glyph weather_fog' => 'weather_fog' ),
					 array( 'nc-icon-glyph weather_forecast' => 'weather_forecast' ),
					 array( 'nc-icon-glyph weather_hurricane-44' => 'weather_hurricane-44' ),
					 array( 'nc-icon-glyph weather_hurricane-45' => 'weather_hurricane-45' ),
					 array( 'nc-icon-glyph weather_moon-cloud-drop' => 'weather_moon-cloud-drop' ),
					 array( 'nc-icon-glyph weather_moon-cloud-fog' => 'weather_moon-cloud-fog' ),
					 array( 'nc-icon-glyph weather_moon-cloud-hail' => 'weather_moon-cloud-hail' ),
					 array( 'nc-icon-glyph weather_moon-cloud-light' => 'weather_moon-cloud-light' ),
					 array( 'nc-icon-glyph weather_moon-cloud-rain' => 'weather_moon-cloud-rain' ),
					 array( 'nc-icon-glyph weather_moon-cloud-snow-61' => 'weather_moon-cloud-snow-61' ),
					 array( 'nc-icon-glyph weather_moon-cloud-snow-62' => 'weather_moon-cloud-snow-62' ),
					 array( 'nc-icon-glyph weather_moon-fog' => 'weather_moon-fog' ),
					 array( 'nc-icon-glyph weather_moon-full' => 'weather_moon-full' ),
					 array( 'nc-icon-glyph weather_moon-stars' => 'weather_moon-stars' ),
					 array( 'nc-icon-glyph weather_moon' => 'weather_moon' ),
					 array( 'nc-icon-glyph weather_rain-hail' => 'weather_rain-hail' ),
					 array( 'nc-icon-glyph weather_rain' => 'weather_rain' ),
					 array( 'nc-icon-glyph weather_rainbow' => 'weather_rainbow' ),
					 array( 'nc-icon-glyph weather_snow' => 'weather_snow' ),
					 array( 'nc-icon-glyph weather_sun-cloud-drop' => 'weather_sun-cloud-drop' ),
					 array( 'nc-icon-glyph weather_sun-cloud-fog' => 'weather_sun-cloud-fog' ),
					 array( 'nc-icon-glyph weather_sun-cloud-hail' => 'weather_sun-cloud-hail' ),
					 array( 'nc-icon-glyph weather_sun-cloud-light' => 'weather_sun-cloud-light' ),
					 array( 'nc-icon-glyph weather_sun-cloud-rain' => 'weather_sun-cloud-rain' ),
					 array( 'nc-icon-glyph weather_sun-cloud-snow-54' => 'weather_sun-cloud-snow-54' ),
					 array( 'nc-icon-glyph weather_sun-cloud-snow-55' => 'weather_sun-cloud-snow-55' ),
					 array( 'nc-icon-glyph weather_sun-cloud' => 'weather_sun-cloud' ),
					 array( 'nc-icon-glyph weather_sun-fog-29' => 'weather_sun-fog-29' ),
					 array( 'nc-icon-glyph weather_sun-fog-30' => 'weather_sun-fog-30' ),
					 array( 'nc-icon-glyph weather_sun-fog-43' => 'weather_sun-fog-43' ),
					 array( 'nc-icon-glyph weather_sun' => 'weather_sun' ),
					 array( 'nc-icon-glyph weather_wind' => 'weather_wind' ),
				),
			);
		
			return array_merge( $icons, $nucleo_icons );
		}		
	}